module StringInflection
  PLURALS = {
    "atpases" => [1, "", ""],
    "actaea" => [1, "on", "ON"],
    "adelies" => [1, "", ""],
    "aggies" => [1, "", ""],
    "alpini" => [1, "o", "O"],
    "anseres" => [2, "", ""],
    "apaches" => [1, "", ""],
    "apia" => [1, "um", "UM"],
    "aquila" => [1, "on", "ON"],
    "arapahoes" => [1, "", ""],
    "aston" => [0, "", ""],
    "atlantes" => [2, "is", "IS"],
    "aussies" => [1, "", ""],
    "barbies" => [1, "", ""],
    "barotses" => [1, "", ""],
    "blackfeet" => [3, "oot", "OOT"],
    "bluenoses" => [1, "", ""],
    "boches" => [1, "", ""],
    "bries" => [1, "", ""],
    "brummies" => [1, "", ""],
    "brya" => [1, "um", "UM"],
    "calla" => [1, "um", "UM"],
    "cara" => [1, "um", "UM"],
    "cayuses" => [1, "", ""],
    "charadrii" => [1, "us", "US"],
    "charlies" => [1, "", ""],
    "chara" => [1, "on", "ON"],
    "charterhouses" => [1, "", ""],
    "chartreuses" => [1, "", ""],
    "chesterton" => [0, "", ""],
    "christless" => [0, "", ""],
    "cincinnati" => [1, "us", "US"],
    "ci" => [1, "o", "O"],
    "comanches" => [1, "", ""],
    "comneni" => [1, "us", "US"],
    "dnaases" => [1, "", ""],
    "dnases" => [1, "", ""],
    "dama" => [1, "on", "ON"],
    "danton" => [0, "", ""],
    "darlington" => [0, "", ""],
    "dayton" => [0, "", ""],
    "deepfreezes" => [1, "", ""],
    "downies" => [1, "", ""],
    "druses" => [1, "", ""],
    "druzes" => [1, "", ""],
    "ealing" => [0, "", ""],
    "echinodermata" => [2, "", ""],
    "eli" => [1, "o", "O"],
    "eries" => [1, "", ""],
    "eroses" => [1, "", ""],
    "eyeties" => [1, "", ""],
    "eyties" => [1, "", ""],
    "fenriswolf" => [0, "", ""],
    "frances" => [2, "is", "IS"],
    "fredericton" => [0, "", ""],
    "genii" => [1, "us", "US"],
    "geordies" => [1, "", ""],
    "gerres" => [2, "is", "IS"],
    "giles" => [2, "", ""],
    "greekless" => [0, "", ""],
    "greekling" => [0, "", ""],
    "hanses" => [1, "", ""],
    "hesperides" => [2, "", ""],
    "hindi" => [1, "us", "US"],
    "huicholes" => [2, "", ""],
    "idola" => [1, "um", "UM"],
    "ireland" => [0, "", ""],
    "ixia" => [1, "on", "ON"],
    "jacqueries" => [1, "", ""],
    "japaneses" => [1, "", ""],
    "japonaiseries" => [1, "", ""],
    "joes" => [1, "", ""],
    "johnsoneses" => [1, "", ""],
    "kewpies" => [1, "", ""],
    "ka" => [1, "on", "ON"],
    "kyries" => [1, "", ""],
    "lamazes" => [1, "", ""],
    "lares" => [2, "is", "IS"],
    "lari" => [1, "us", "US"],
    "laski" => [0, "", ""],
    "leda" => [1, "um", "UM"],
    "leighton" => [0, "", ""],
    "limbi" => [1, "us", "US"],
    "luton" => [0, "", ""],
    "magi" => [1, "us", "US"],
    "mahabharata" => [1, "um", "UM"],
    "mali" => [1, "us", "US"],
    "maratha" => [1, "on", "ON"],
    "maria" => [1, "on", "ON"],
    "marses" => [1, "", ""],
    "marseillaises" => [1, "", ""],
    "masses" => [1, "", ""],
    "middleton" => [0, "", ""],
    "minton" => [0, "", ""],
    "miri" => [1, "o", "O"],
    "mithraea" => [1, "um", "UM"],
    "moonies" => [1, "", ""],
    "morta" => [1, "on", "ON"],
    "mudejares" => [2, "", ""],
    "nairobi" => [0, "", ""],
    "neski" => [0, "", ""],
    "newfies" => [1, "", ""],
    "newton" => [0, "", ""],
    "ni" => [1, "o", "O"],
    "oses" => [1, "", ""],
    "obies" => [1, "", ""],
    "okies" => [1, "", ""],
    "ossies" => [1, "", ""],
    "ozzies" => [1, "", ""],
    "passeres" => [2, "", ""],
    "pekineses" => [1, "", ""],
    "pekingeses" => [1, "", ""],
    "pentagoneses" => [1, "", ""],
    "pisa" => [1, "um", "UM"],
    "poles" => [2, "is", "IS"],
    "pomacanthus" => [0, "", ""],
    "ptloris" => [0, "", ""],
    "quashies" => [1, "", ""],
    "rnaases" => [1, "", ""],
    "rnases" => [1, "", ""],
    "rajes" => [2, "", ""],
    "ramilies" => [1, "", ""],
    "ramillies" => [1, "", ""],
    "rhea" => [1, "um", "UM"],
    "ra" => [1, "on", "ON"],
    "sabbathless" => [0, "", ""],
    "sara" => [1, "um", "UM"],
    "scouses" => [1, "", ""],
    "seeland" => [0, "", ""],
    "shoshones" => [2, "is", "IS"],
    "sida" => [1, "on", "ON"],
    "sileni" => [1, "us", "US"],
    "statehouses" => [1, "", ""],
    "sunfish" => [0, "", ""],
    "si" => [1, "us", "US"],
    "tehuelches" => [1, "", ""],
    "thanatoses" => [2, "is", "IS"],
    "troyes" => [2, "", ""],
    "twinkies" => [1, "", ""],
    "typha" => [1, "on", "ON"],
    "tyranni" => [1, "us", "US"],
    "valkyries" => [1, "", ""],
    "veneti" => [1, "o", "O"],
    "walkyries" => [1, "", ""],
    "westies" => [1, "", ""],
    "winnies" => [1, "", ""],
    "xes" => [1, "", ""],
    "yardies" => [1, "", ""],
    "yorkies" => [1, "", ""],
    "zingani" => [1, "o", "O"],
    "zingari" => [1, "o", "O"],
    "aardwolves" => [3, "f", "F"],
    "abashless" => [0, "", ""],
    "abiogeneses" => [2, "is", "IS"],
    "abioses" => [2, "is", "IS"],
    "abomasa" => [1, "um", "UM"],
    "abscisses" => [1, "", ""],
    "absinthes" => [1, "", ""],
    "abuses" => [1, "", ""],
    "acalephes" => [1, "", ""],
    "acariases" => [2, "is", "IS"],
    "acaridomatia" => [1, "um", "UM"],
    "acari" => [1, "us", "US"],
    "accentless" => [0, "", ""],
    "accidies" => [1, "", ""],
    "accoucheuses" => [1, "", ""],
    "acervuli" => [1, "us", "US"],
    "acetylcholinesterases" => [1, "", ""],
    "aches" => [1, "", ""],
    "acidoses" => [2, "is", "IS"],
    "acini" => [1, "us", "US"],
    "acroteria" => [1, "on", "ON"],
    "actinobacilli" => [1, "us", "US"],
    "actinomycoses" => [2, "is", "IS"],
    "actionless" => [0, "", ""],
    "aculei" => [1, "us", "US"],
    "addenda" => [1, "um", "UM"],
    "addling" => [0, "", ""],
    "adenohypophyses" => [2, "is", "IS"],
    "adenoses" => [2, "is", "IS"],
    "adiaphora" => [1, "on", "ON"],
    "adiposes" => [2, "is", "IS"],
    "adyta" => [1, "um", "UM"],
    "adzes" => [1, "", ""],
    "aecidia" => [1, "um", "UM"],
    "aecia" => [1, "um", "UM"],
    "aerobioses" => [2, "is", "IS"],
    "aerobia" => [1, "um", "UM"],
    "aeroneuroses" => [2, "is", "IS"],
    "aeropauses" => [1, "", ""],
    "affectionless" => [0, "", ""],
    "affectless" => [0, "", ""],
    "affiches" => [1, "", ""],
    "afterlives" => [3, "fe", "FE"],
    "agamogeneses" => [2, "is", "IS"],
    "agapae" => [2, "e", "E"],
    "agaroses" => [1, "", ""],
    "ageless" => [0, "", ""],
    "agendaless" => [0, "", ""],
    "ageneses" => [2, "is", "IS"],
    "ageratum" => [0, "", ""],
    "agranulocytoses" => [2, "is", "IS"],
    "aidless" => [0, "", ""],
    "ailing" => [0, "", ""],
    "aimless" => [0, "", ""],
    "airbases" => [1, "", ""],
    "aircraft" => [0, "", ""],
    "airless" => [0, "", ""],
    "aisling" => [0, "", ""],
    "albacore" => [0, "", ""],
    "albatross" => [0, "", ""],
    "albumoses" => [1, "", ""],
    "aldolases" => [1, "", ""],
    "aldoses" => [1, "", ""],
    "alehouses" => [1, "", ""],
    "alewives" => [3, "fe", "FE"],
    "alibis" => [0, "", ""],
    "alkalies" => [2, "", ""],
    "alkaloses" => [2, "is", "IS"],
    "alligatorfish" => [0, "", ""],
    "almsfolk" => [0, "", ""],
    "almshouses" => [1, "", ""],
    "aloes" => [1, "", ""],
    "alphoses" => [2, "is", "IS"],
    "altocumuli" => [1, "us", "US"],
    "altostrati" => [1, "us", "US"],
    "alumni" => [1, "us", "US"],
    "alveoli" => [1, "us", "US"],
    "amanuenses" => [2, "is", "IS"],
    "amauroses" => [2, "is", "IS"],
    "amazes" => [1, "", ""],
    "amberfish" => [0, "", ""],
    "ambitionless" => [0, "", ""],
    "ambulacra" => [1, "um", "UM"],
    "amebiases" => [2, "is", "IS"],
    "amenta" => [1, "um", "UM"],
    "amici" => [1, "us", "US"],
    "amidases" => [1, "", ""],
    "amies" => [1, "", ""],
    "aminopeptidases" => [1, "", ""],
    "aminotransferases" => [1, "", ""],
    "amitoses" => [2, "is", "IS"],
    "amniocenteses" => [2, "is", "IS"],
    "amoebiases" => [2, "is", "IS"],
    "amorini" => [1, "o", "O"],
    "ampelopses" => [2, "is", "IS"],
    "amphiarthroses" => [2, "is", "IS"],
    "amphigastria" => [1, "um", "UM"],
    "amphimixes" => [2, "is", "IS"],
    "amphithecia" => [1, "um", "UM"],
    "amylases" => [1, "", ""],
    "amyloidoses" => [2, "is", "IS"],
    "amylolyses" => [2, "is", "IS"],
    "amyloses" => [1, "", ""],
    "anabases" => [2, "is", "IS"],
    "anabioses" => [2, "is", "IS"],
    "anaclises" => [2, "is", "IS"],
    "anacruses" => [2, "is", "IS"],
    "anadiploses" => [2, "is", "IS"],
    "anaerobioses" => [2, "is", "IS"],
    "anageneses" => [2, "is", "IS"],
    "anagnorises" => [2, "is", "IS"],
    "analyses" => [2, "is", "IS"],
    "anamneses" => [2, "is", "IS"],
    "anamorphoses" => [2, "is", "IS"],
    "anaphases" => [1, "", ""],
    "anaphylaxes" => [2, "is", "IS"],
    "anaplasmoses" => [2, "is", "IS"],
    "anaptyxes" => [2, "is", "IS"],
    "anastomoses" => [2, "is", "IS"],
    "anastrophes" => [1, "", ""],
    "anatases" => [1, "", ""],
    "anchorless" => [0, "", ""],
    "anchorpeople" => [4, "rson", "RSON"],
    "anchyloses" => [2, "is", "IS"],
    "ancylostomiases" => [2, "is", "IS"],
    "androecia" => [1, "um", "UM"],
    "androgeneses" => [2, "is", "IS"],
    "aneling" => [0, "", ""],
    "anemoses" => [2, "is", "IS"],
    "angelfish" => [0, "", ""],
    "angerless" => [0, "", ""],
    "angiogeneses" => [2, "is", "IS"],
    "anglepoises" => [1, "", ""],
    "anglerfish" => [0, "", ""],
    "animalcula" => [1, "um", "UM"],
    "animes" => [2, "is", "IS"],
    "anises" => [1, "", ""],
    "ankyloses" => [2, "is", "IS"],
    "ankylostomiases" => [2, "is", "IS"],
    "annexes" => [1, "", ""],
    "annulling" => [0, "", ""],
    "anoeses" => [2, "is", "IS"],
    "anopheles" => [0, "", ""],
    "answerless" => [0, "", ""],
    "antalkalies" => [2, "", ""],
    "antes" => [2, "is", "IS"],
    "antelope" => [0, "", ""],
    "anthelices" => [3, "x", "X"],
    "anthemia" => [1, "on", "ON"],
    "antheses" => [2, "is", "IS"],
    "anthodia" => [1, "um", "UM"],
    "anthracnoses" => [1, "", ""],
    "anthracoses" => [2, "is", "IS"],
    "anthraces" => [3, "x", "X"],
    "anthropogeneses" => [2, "is", "IS"],
    "anthropophagi" => [1, "us", "US"],
    "antiaircraft" => [0, "", ""],
    "antibioses" => [2, "is", "IS"],
    "antibourgeois" => [0, "", ""],
    "anticholinesterases" => [1, "", ""],
    "anticling" => [0, "", ""],
    "antifreezes" => [1, "", ""],
    "antihelices" => [3, "x", "X"],
    "antimilitary" => [0, "", ""],
    "antiperistalses" => [2, "is", "IS"],
    "antiphrases" => [2, "is", "IS"],
    "antipolice" => [0, "", ""],
    "antipyreses" => [2, "is", "IS"],
    "antirabies" => [0, "", ""],
    "antireligious" => [0, "", ""],
    "antisepses" => [2, "is", "IS"],
    "antistrophes" => [1, "", ""],
    "antitheses" => [2, "is", "IS"],
    "antitragi" => [1, "us", "US"],
    "anureses" => [2, "is", "IS"],
    "anvilling" => [0, "", ""],
    "aphaereses" => [2, "is", "IS"],
    "aphelia" => [1, "on", "ON"],
    "aphereses" => [2, "is", "IS"],
    "apheses" => [2, "is", "IS"],
    "apiculi" => [1, "us", "US"],
    "apneuses" => [2, "is", "IS"],
    "apocalypses" => [1, "", ""],
    "apocrypha" => [1, "on", "ON"],
    "apodoses" => [2, "is", "IS"],
    "aponeuroses" => [2, "is", "IS"],
    "apophases" => [2, "is", "IS"],
    "apophyses" => [2, "is", "IS"],
    "apoptoses" => [2, "is", "IS"],
    "aposiopeses" => [2, "is", "IS"],
    "apostrophes" => [1, "", ""],
    "apothecia" => [1, "um", "UM"],
    "apotheoses" => [2, "is", "IS"],
    "appalling" => [0, "", ""],
    "appalti" => [1, "o", "O"],
    "apparelling" => [0, "", ""],
    "appendices" => [3, "x", "X"],
    "applauses" => [1, "", ""],
    "appressoria" => [1, "um", "UM"],
    "appulses" => [1, "", ""],
    "apses" => [2, "is", "IS"],
    "apteria" => [1, "um", "UM"],
    "apyrases" => [1, "", ""],
    "arabinoses" => [1, "", ""],
    "archaebacteria" => [1, "um", "UM"],
    "archdioceses" => [1, "", ""],
    "archegonia" => [1, "um", "UM"],
    "archerfish" => [0, "", ""],
    "archesporia" => [1, "um", "UM"],
    "arginases" => [1, "", ""],
    "arguli" => [1, "us", "US"],
    "argumenta" => [1, "um", "UM"],
    "ariboflavinoses" => [2, "is", "IS"],
    "arilli" => [1, "us", "US"],
    "arkoses" => [1, "", ""],
    "arling" => [0, "", ""],
    "armless" => [0, "", ""],
    "armorless" => [0, "", ""],
    "arses" => [2, "is", "IS"],
    "arterioscleroses" => [2, "is", "IS"],
    "arthritides" => [3, "s", "S"],
    "arthrodeses" => [2, "is", "IS"],
    "arthroses" => [2, "is", "IS"],
    "articling" => [0, "", ""],
    "artless" => [0, "", ""],
    "aruspices" => [4, "ex", "EX"],
    "asbestoses" => [2, "is", "IS"],
    "ascariases" => [2, "is", "IS"],
    "asceses" => [2, "is", "IS"],
    "ascidia" => [1, "um", "UM"],
    "ascogonia" => [1, "um", "UM"],
    "ascomata" => [2, "", ""],
    "asci" => [1, "us", "US"],
    "asepses" => [2, "is", "IS"],
    "ashake" => [0, "", ""],
    "ashless" => [0, "", ""],
    "askeses" => [2, "is", "IS"],
    "asparaginases" => [1, "", ""],
    "aspergilloses" => [2, "is", "IS"],
    "aspergilli" => [1, "us", "US"],
    "aspidia" => [1, "um", "UM"],
    "assailing" => [0, "", ""],
    "assizes" => [1, "", ""],
    "asteriskless" => [0, "", ""],
    "asynapses" => [2, "is", "IS"],
    "atelectases" => [2, "is", "IS"],
    "atherogeneses" => [2, "is", "IS"],
    "atheromatoses" => [2, "is", "IS"],
    "atheroscleroses" => [2, "is", "IS"],
    "athetoses" => [2, "is", "IS"],
    "athrocytoses" => [2, "is", "IS"],
    "atmolyses" => [2, "is", "IS"],
    "atria" => [1, "um", "UM"],
    "attaches" => [1, "", ""],
    "aurei" => [1, "us", "US"],
    "aures" => [2, "is", "IS"],
    "ausleses" => [1, "", ""],
    "australes" => [2, "", ""],
    "authorless" => [0, "", ""],
    "autocatalyses" => [2, "is", "IS"],
    "autogeneses" => [2, "is", "IS"],
    "autohypnoses" => [2, "is", "IS"],
    "autolyses" => [2, "is", "IS"],
    "auxeses" => [2, "is", "IS"],
    "avalanches" => [1, "", ""],
    "avitaminoses" => [2, "is", "IS"],
    "aweless" => [0, "", ""],
    "awless" => [0, "", ""],
    "awnless" => [0, "", ""],
    "axes" => [1, "", ""],
    "axilemmata" => [2, "", ""],
    "ayries" => [1, "", ""],
    "babesiases" => [2, "is", "IS"],
    "babesioses" => [2, "is", "IS"],
    "babiches" => [1, "", ""],
    "babouches" => [1, "", ""],
    "babuches" => [1, "", ""],
    "bacchanalia" => [0, "", ""],
    "bacchii" => [1, "us", "US"],
    "bacilli" => [1, "us", "US"],
    "backaches" => [1, "", ""],
    "backboneless" => [0, "", ""],
    "backhoes" => [1, "", ""],
    "backhouses" => [1, "", ""],
    "backless" => [0, "", ""],
    "backpedalling" => [0, "", ""],
    "bacteriolyses" => [2, "is", "IS"],
    "bacteriostases" => [2, "is", "IS"],
    "bacteria" => [1, "um", "UM"],
    "baffling" => [0, "", ""],
    "bagasses" => [1, "", ""],
    "baghouses" => [1, "", ""],
    "bailies" => [1, "", ""],
    "baillies" => [1, "", ""],
    "baitfish" => [0, "", ""],
    "baizes" => [1, "", ""],
    "bakehouses" => [1, "", ""],
    "baling" => [0, "", ""],
    "balling" => [0, "", ""],
    "balloonfish" => [0, "", ""],
    "bandfish" => [0, "", ""],
    "bandless" => [0, "", ""],
    "banshies" => [1, "", ""],
    "bantling" => [0, "", ""],
    "barbless" => [0, "", ""],
    "bardling" => [0, "", ""],
    "barkless" => [0, "", ""],
    "barless" => [0, "", ""],
    "barouches" => [1, "", ""],
    "barracks" => [0, "", ""],
    "barrelfish" => [0, "", ""],
    "barrelhouses" => [1, "", ""],
    "barreling" => [0, "", ""],
    "barrelling" => [0, "", ""],
    "bases" => [2, "is", "IS"],
    "baseless" => [0, "", ""],
    "basementless" => [0, "", ""],
    "bashless" => [0, "", ""],
    "basidia" => [1, "um", "UM"],
    "basses" => [1, "", ""],
    "batfish" => [0, "", ""],
    "bathes" => [1, "", ""],
    "bathhouses" => [1, "", ""],
    "bathless" => [0, "", ""],
    "bathorses" => [1, "", ""],
    "bathyscaphes" => [1, "", ""],
    "battleaxes" => [1, "", ""],
    "battling" => [0, "", ""],
    "baud" => [0, "", ""],
    "bawdyhouses" => [1, "", ""],
    "bayadeer" => [0, "", ""],
    "beakless" => [0, "", ""],
    "beamless" => [0, "", ""],
    "beardies" => [1, "", ""],
    "beardless" => [0, "", ""],
    "bearnaises" => [1, "", ""],
    "beasties" => [1, "", ""],
    "beatless" => [0, "", ""],
    "becasses" => [1, "", ""],
    "becudgelling" => [0, "", ""],
    "bedevilling" => [0, "", ""],
    "bedless" => [0, "", ""],
    "bedrivelling" => [0, "", ""],
    "beeves" => [3, "f", "F"],
    "beefless" => [0, "", ""],
    "beetling" => [0, "", ""],
    "begirdling" => [0, "", ""],
    "behalves" => [3, "f", "F"],
    "beingless" => [0, "", ""],
    "bejewelling" => [0, "", ""],
    "beliefless" => [0, "", ""],
    "belling" => [0, "", ""],
    "bellyaches" => [1, "", ""],
    "bellyless" => [0, "", ""],
    "beltless" => [0, "", ""],
    "benes" => [2, "is", "IS"],
    "bennes" => [2, "is", "IS"],
    "berceuses" => [1, "", ""],
    "berdaches" => [1, "", ""],
    "betises" => [1, "", ""],
    "betrothed" => [0, "", ""],
    "bevelling" => [0, "", ""],
    "bhisties" => [1, "", ""],
    "bibless" => [0, "", ""],
    "biceps" => [0, "", ""],
    "bickies" => [1, "", ""],
    "bijouteries" => [1, "", ""],
    "bikies" => [1, "", ""],
    "bilharziases" => [2, "is", "IS"],
    "billfish" => [0, "", ""],
    "billibis" => [0, "", ""],
    "biocenoses" => [2, "is", "IS"],
    "biocoenoses" => [2, "is", "IS"],
    "biogeneses" => [2, "is", "IS"],
    "biolyses" => [2, "is", "IS"],
    "biosyntheses" => [2, "is", "IS"],
    "birdhouses" => [1, "", ""],
    "birdies" => [1, "", ""],
    "birkies" => [1, "", ""],
    "birses" => [1, "", ""],
    "bises" => [1, "", ""],
    "biscotti" => [1, "o", "O"],
    "bison" => [0, "", ""],
    "bitless" => [0, "", ""],
    "bitterling" => [0, "", ""],
    "bizzes" => [3, "", ""],
    "bizarreries" => [1, "", ""],
    "bizes" => [1, "", ""],
    "blackfish" => [0, "", ""],
    "bladdernoses" => [1, "", ""],
    "blameless" => [0, "", ""],
    "blastogeneses" => [2, "is", "IS"],
    "blastomycoses" => [2, "is", "IS"],
    "blazes" => [1, "", ""],
    "blepharitides" => [3, "s", "S"],
    "blindfish" => [0, "", ""],
    "blindless" => [0, "", ""],
    "blintzes" => [1, "", ""],
    "blissless" => [0, "", ""],
    "blockhouses" => [1, "", ""],
    "bloodless" => [0, "", ""],
    "bloomless" => [0, "", ""],
    "blotless" => [0, "", ""],
    "blouses" => [1, "", ""],
    "blowfish" => [0, "", ""],
    "blowses" => [1, "", ""],
    "blowzes" => [1, "", ""],
    "bluebuck" => [0, "", ""],
    "blushless" => [0, "", ""],
    "boardinghouses" => [1, "", ""],
    "boarfish" => [0, "", ""],
    "boastless" => [0, "", ""],
    "boathouses" => [1, "", ""],
    "boaties" => [1, "", ""],
    "bobeches" => [1, "", ""],
    "bocces" => [2, "is", "IS"],
    "boccies" => [1, "", ""],
    "bodgies" => [1, "", ""],
    "bodyless" => [0, "", ""],
    "boiseries" => [1, "", ""],
    "boltless" => [0, "", ""],
    "bondless" => [0, "", ""],
    "bonefish" => [0, "", ""],
    "boneless" => [0, "", ""],
    "bonhomies" => [1, "", ""],
    "bonxies" => [1, "", ""],
    "bonzes" => [1, "", ""],
    "booboisies" => [1, "", ""],
    "boogies" => [1, "", ""],
    "bookcases" => [1, "", ""],
    "bookless" => [0, "", ""],
    "bookshelves" => [3, "f", "F"],
    "boomless" => [0, "", ""],
    "boonless" => [0, "", ""],
    "bootless" => [0, "", ""],
    "boozes" => [1, "", ""],
    "borborygmi" => [1, "us", "US"],
    "borderless" => [0, "", ""],
    "bottlenoses" => [1, "", ""],
    "bottling" => [0, "", ""],
    "bottomless" => [0, "", ""],
    "boughless" => [0, "", ""],
    "bougies" => [1, "", ""],
    "bouillabaisses" => [1, "", ""],
    "boundless" => [0, "", ""],
    "bourgeois" => [0, "", ""],
    "bourgeoises" => [1, "", ""],
    "bourgeoisies" => [1, "", ""],
    "bourses" => [1, "", ""],
    "bowelless" => [0, "", ""],
    "bowelling" => [0, "", ""],
    "bowless" => [0, "", ""],
    "bowling" => [0, "", ""],
    "boxfish" => [0, "", ""],
    "brachia" => [1, "um", "UM"],
    "bractless" => [0, "", ""],
    "bragless" => [0, "", ""],
    "brailling" => [0, "", ""],
    "braincases" => [1, "", ""],
    "brainchildren" => [3, "", ""],
    "braindead" => [0, "", ""],
    "brainless" => [0, "", ""],
    "braizes" => [1, "", ""],
    "brakeless" => [0, "", ""],
    "braless" => [0, "", ""],
    "branchless" => [0, "", ""],
    "brandises" => [1, "", ""],
    "brandling" => [0, "", ""],
    "brasseries" => [1, "", ""],
    "bratling" => [0, "", ""],
    "brawling" => [0, "", ""],
    "breastless" => [0, "", ""],
    "breathless" => [0, "", ""],
    "brees" => [2, "is", "IS"],
    "breechless" => [0, "", ""],
    "breezes" => [1, "", ""],
    "breezeless" => [0, "", ""],
    "bregmata" => [2, "", ""],
    "bridgeless" => [0, "", ""],
    "bridies" => [1, "", ""],
    "briefcases" => [1, "", ""],
    "briefless" => [0, "", ""],
    "brimless" => [0, "", ""],
    "brioches" => [1, "", ""],
    "brises" => [1, "", ""],
    "brisling" => [0, "", ""],
    "brittling" => [0, "", ""],
    "broadaxes" => [1, "", ""],
    "broadleaves" => [3, "f", "F"],
    "broches" => [1, "", ""],
    "bronchiectases" => [2, "is", "IS"],
    "bronchia" => [1, "um", "UM"],
    "bronchi" => [1, "us", "US"],
    "bronzes" => [1, "", ""],
    "brookies" => [1, "", ""],
    "brooses" => [1, "", ""],
    "broses" => [1, "", ""],
    "browless" => [0, "", ""],
    "browses" => [1, "", ""],
    "brucelloses" => [2, "is", "IS"],
    "bruises" => [1, "", ""],
    "brulyies" => [1, "", ""],
    "brulzies" => [1, "", ""],
    "brushless" => [0, "", ""],
    "brusqueries" => [1, "", ""],
    "buazes" => [1, "", ""],
    "buckies" => [1, "", ""],
    "buckling" => [0, "", ""],
    "buckteeth" => [4, "ooth", "OOTH"],
    "budgies" => [1, "", ""],
    "budless" => [0, "", ""],
    "buffalofish" => [0, "", ""],
    "bughouses" => [1, "", ""],
    "bugling" => [0, "", ""],
    "bulbless" => [0, "", ""],
    "bullnoses" => [1, "", ""],
    "bulses" => [1, "", ""],
    "bundling" => [0, "", ""],
    "bungling" => [0, "", ""],
    "bunkhouses" => [1, "", ""],
    "burbling" => [0, "", ""],
    "burdies" => [1, "", ""],
    "bureaucrateses" => [1, "", ""],
    "burgling" => [0, "", ""],
    "burling" => [0, "", ""],
    "burnies" => [1, "", ""],
    "burnooses" => [1, "", ""],
    "burnouses" => [1, "", ""],
    "burrfish" => [0, "", ""],
    "burses" => [1, "", ""],
    "bushelling" => [0, "", ""],
    "bushless" => [0, "", ""],
    "businesspeople" => [4, "rson", "RSON"],
    "bustling" => [0, "", ""],
    "butling" => [0, "", ""],
    "butterfish" => [0, "", ""],
    "butterflyfish" => [0, "", ""],
    "butterless" => [0, "", ""],
    "buttling" => [0, "", ""],
    "buttonless" => [0, "", ""],
    "buttonquail" => [0, "", ""],
    "byrnies" => [1, "", ""],
    "byssinoses" => [2, "is", "IS"],
    "caballing" => [0, "", ""],
    "cabling" => [0, "", ""],
    "cabooses" => [1, "", ""],
    "cabries" => [1, "", ""],
    "caches" => [1, "", ""],
    "cacti" => [1, "us", "US"],
    "cades" => [2, "is", "IS"],
    "cadies" => [1, "", ""],
    "caducei" => [1, "us", "US"],
    "caeca" => [1, "um", "UM"],
    "cageling" => [0, "", ""],
    "calabooses" => [1, "", ""],
    "calabreses" => [1, "", ""],
    "calanthes" => [1, "", ""],
    "calathi" => [1, "us", "US"],
    "calcanei" => [1, "us", "US"],
    "calcinoses" => [2, "is", "IS"],
    "calculi" => [1, "us", "US"],
    "caldaria" => [1, "um", "UM"],
    "caleches" => [1, "", ""],
    "calves" => [3, "f", "F"],
    "calfless" => [0, "", ""],
    "caliches" => [1, "", ""],
    "calices" => [3, "x", "X"],
    "calloses" => [1, "", ""],
    "calyculi" => [1, "us", "US"],
    "camaraderies" => [1, "", ""],
    "camises" => [1, "", ""],
    "cammies" => [1, "", ""],
    "camogies" => [1, "", ""],
    "cami" => [1, "us", "US"],
    "canaliculi" => [1, "us", "US"],
    "canalling" => [0, "", ""],
    "cancelling" => [0, "", ""],
    "candelabra" => [1, "um", "UM"],
    "candidiases" => [2, "is", "IS"],
    "candlefish" => [0, "", ""],
    "cangling" => [0, "", ""],
    "canoes" => [1, "", ""],
    "canthi" => [1, "us", "US"],
    "cantling" => [0, "", ""],
    "capellines" => [2, "is", "IS"],
    "capercaillies" => [1, "", ""],
    "capercailzies" => [1, "", ""],
    "capitula" => [1, "um", "UM"],
    "capless" => [0, "", ""],
    "captionless" => [0, "", ""],
    "capuches" => [1, "", ""],
    "caracolling" => [0, "", ""],
    "carbohydrases" => [1, "", ""],
    "carbonless" => [0, "", ""],
    "carboxylases" => [1, "", ""],
    "carboxymethylcelluloses" => [1, "", ""],
    "carboxypeptidases" => [1, "", ""],
    "carcases" => [1, "", ""],
    "carcinogeneses" => [2, "is", "IS"],
    "carcinomatoses" => [2, "is", "IS"],
    "cardcases" => [1, "", ""],
    "cardinalfish" => [0, "", ""],
    "careless" => [0, "", ""],
    "carices" => [4, "ex", "EX"],
    "caribou" => [0, "", ""],
    "carless" => [0, "", ""],
    "carling" => [0, "", ""],
    "caroches" => [1, "", ""],
    "carolling" => [0, "", ""],
    "carouses" => [1, "", ""],
    "carp" => [0, "", ""],
    "carpi" => [1, "us", "US"],
    "carses" => [1, "", ""],
    "carthorses" => [1, "", ""],
    "cartouches" => [1, "", ""],
    "caryopses" => [2, "is", "IS"],
    "cases" => [1, "", ""],
    "caseases" => [1, "", ""],
    "caseoses" => [1, "", ""],
    "cashless" => [0, "", ""],
    "casteless" => [0, "", ""],
    "castling" => [0, "", ""],
    "catabases" => [2, "is", "IS"],
    "catachreses" => [2, "is", "IS"],
    "cataclases" => [2, "is", "IS"],
    "catalases" => [1, "", ""],
    "catalexes" => [2, "is", "IS"],
    "catalyses" => [2, "is", "IS"],
    "cataphoreses" => [2, "is", "IS"],
    "catastases" => [2, "is", "IS"],
    "catastrophes" => [1, "", ""],
    "catchphrases" => [1, "", ""],
    "catecheses" => [2, "is", "IS"],
    "catfish" => [0, "", ""],
    "catharses" => [2, "is", "IS"],
    "cathexes" => [2, "is", "IS"],
    "cathouses" => [1, "", ""],
    "catling" => [0, "", ""],
    "caules" => [2, "is", "IS"],
    "causes" => [1, "", ""],
    "causeless" => [0, "", ""],
    "causeries" => [1, "", ""],
    "cavefish" => [0, "", ""],
    "cavilling" => [0, "", ""],
    "ceases" => [1, "", ""],
    "ceaseless" => [0, "", ""],
    "ceca" => [1, "um", "UM"],
    "cedes" => [2, "is", "IS"],
    "celling" => [0, "", ""],
    "cellobioses" => [1, "", ""],
    "cellulases" => [1, "", ""],
    "celluloses" => [1, "", ""],
    "celomata" => [2, "", ""],
    "cementa" => [1, "um", "UM"],
    "cenogeneses" => [2, "is", "IS"],
    "centerless" => [0, "", ""],
    "centeses" => [2, "is", "IS"],
    "centipoises" => [1, "", ""],
    "cerises" => [1, "", ""],
    "ceruses" => [1, "", ""],
    "cervices" => [3, "x", "X"],
    "ceviches" => [1, "", ""],
    "chadless" => [0, "", ""],
    "chaffless" => [0, "", ""],
    "chainless" => [0, "", ""],
    "chaises" => [1, "", ""],
    "chamises" => [1, "", ""],
    "chamois" => [0, "", ""],
    "chanceless" => [0, "", ""],
    "changeless" => [0, "", ""],
    "changeling" => [0, "", ""],
    "chanteuses" => [1, "", ""],
    "chapeless" => [0, "", ""],
    "chapeling" => [0, "", ""],
    "chapelling" => [0, "", ""],
    "chapless" => [0, "", ""],
    "chapterhouses" => [1, "", ""],
    "characterless" => [0, "", ""],
    "charcuteries" => [1, "", ""],
    "chargeless" => [0, "", ""],
    "chargenurses" => [1, "", ""],
    "charismata" => [2, "", ""],
    "charmeuses" => [1, "", ""],
    "charmless" => [0, "", ""],
    "charpies" => [1, "", ""],
    "charthouses" => [1, "", ""],
    "chartless" => [0, "", ""],
    "chases" => [1, "", ""],
    "chasses" => [1, "", ""],
    "chassis" => [0, "", ""],
    "chauffeuses" => [1, "", ""],
    "checkless" => [0, "", ""],
    "cheekless" => [0, "", ""],
    "cheerless" => [0, "", ""],
    "cheeses" => [1, "", ""],
    "chegoes" => [1, "", ""],
    "chemises" => [1, "", ""],
    "chemokineses" => [2, "is", "IS"],
    "chemoprophylaxes" => [2, "is", "IS"],
    "chemosmoses" => [2, "is", "IS"],
    "chemosyntheses" => [2, "is", "IS"],
    "chemotaxes" => [2, "is", "IS"],
    "chersoneses" => [1, "", ""],
    "chickling" => [0, "", ""],
    "chiefless" => [0, "", ""],
    "chiefling" => [0, "", ""],
    "chigoes" => [1, "", ""],
    "children" => [3, "", ""],
    "childless" => [0, "", ""],
    "chiles" => [2, "is", "IS"],
    "chilies" => [2, "", ""],
    "chinchilla" => [1, "on", "ON"],
    "chinless" => [0, "", ""],
    "chinoiseries" => [1, "", ""],
    "chiselling" => [0, "", ""],
    "chitling" => [0, "", ""],
    "chitterling" => [0, "", ""],
    "chloraloses" => [1, "", ""],
    "chloroses" => [2, "is", "IS"],
    "cholecystitides" => [3, "s", "S"],
    "cholelithiases" => [2, "is", "IS"],
    "cholestases" => [2, "is", "IS"],
    "cholinesterases" => [1, "", ""],
    "cha" => [1, "on", "ON"],
    "chondrites" => [2, "is", "IS"],
    "chondri" => [1, "us", "US"],
    "chookies" => [1, "", ""],
    "chophouses" => [1, "", ""],
    "choses" => [1, "", ""],
    "chromatolyses" => [2, "is", "IS"],
    "chromidia" => [1, "um", "UM"],
    "chromonemata" => [2, "", ""],
    "chronicling" => [0, "", ""],
    "chrysoprases" => [1, "", ""],
    "chub" => [0, "", ""],
    "chuckling" => [0, "", ""],
    "chuffling" => [0, "", ""],
    "churchless" => [0, "", ""],
    "ciboria" => [1, "um", "UM"],
    "cicatrices" => [3, "x", "X"],
    "ciceroni" => [1, "e", "E"],
    "cigarfish" => [0, "", ""],
    "cilia" => [1, "um", "UM"],
    "cimices" => [4, "ex", "EX"],
    "cineraria" => [1, "um", "UM"],
    "cingula" => [1, "um", "UM"],
    "cippi" => [1, "us", "US"],
    "cirrhoses" => [2, "is", "IS"],
    "cirrocumuli" => [1, "us", "US"],
    "cirrostrati" => [1, "us", "US"],
    "cirri" => [1, "us", "US"],
    "civies" => [1, "", ""],
    "cladogeneses" => [2, "is", "IS"],
    "cladophylla" => [1, "um", "UM"],
    "clankless" => [0, "", ""],
    "clanless" => [0, "", ""],
    "classes" => [2, "is", "IS"],
    "classless" => [0, "", ""],
    "clauses" => [1, "", ""],
    "claustra" => [1, "um", "UM"],
    "claves" => [2, "is", "IS"],
    "clavi" => [1, "us", "US"],
    "clawless" => [0, "", ""],
    "clearinghouses" => [1, "", ""],
    "cliches" => [1, "", ""],
    "clientless" => [0, "", ""],
    "climaxless" => [0, "", ""],
    "clinandria" => [1, "um", "UM"],
    "clingfish" => [0, "", ""],
    "clinoaxes" => [2, "is", "IS"],
    "clippies" => [1, "", ""],
    "clitella" => [1, "um", "UM"],
    "cloches" => [1, "", ""],
    "closes" => [1, "", ""],
    "clotheshorses" => [1, "", ""],
    "clothesless" => [0, "", ""],
    "cloudless" => [0, "", ""],
    "cloyless" => [0, "", ""],
    "clozes" => [1, "", ""],
    "clubfeet" => [3, "oot", "OOT"],
    "clubhouses" => [1, "", ""],
    "cludgies" => [1, "", ""],
    "clueless" => [0, "", ""],
    "coagulases" => [1, "", ""],
    "coalfish" => [0, "", ""],
    "coalhouses" => [1, "", ""],
    "coalless" => [0, "", ""],
    "coatless" => [0, "", ""],
    "cobbling" => [0, "", ""],
    "cobloaves" => [3, "f", "F"],
    "cocarboxylases" => [1, "", ""],
    "coccidioidomycoses" => [2, "is", "IS"],
    "coccidioses" => [2, "is", "IS"],
    "coccidia" => [1, "um", "UM"],
    "cocci" => [1, "us", "US"],
    "coccyges" => [3, "x", "X"],
    "cockaleekies" => [1, "", ""],
    "cockhorses" => [1, "", ""],
    "cockieleekies" => [1, "", ""],
    "cockling" => [0, "", ""],
    "cocounselling" => [0, "", ""],
    "cod" => [0, "", ""],
    "codeless" => [0, "", ""],
    "codices" => [4, "ex", "EX"],
    "codfish" => [0, "", ""],
    "codling" => [0, "", ""],
    "coelentera" => [1, "on", "ON"],
    "coenuri" => [1, "us", "US"],
    "coffeehouses" => [1, "", ""],
    "cofferfish" => [0, "", ""],
    "coffling" => [0, "", ""],
    "coggies" => [1, "", ""],
    "cogies" => [1, "", ""],
    "cognoscenti" => [1, "e", "E"],
    "cohesionless" => [0, "", ""],
    "coho" => [0, "", ""],
    "cohoes" => [1, "", ""],
    "coiffeuses" => [1, "", ""],
    "coleoptera" => [1, "on", "ON"],
    "collagenases" => [1, "", ""],
    "collapses" => [1, "", ""],
    "collarless" => [0, "", ""],
    "colliculi" => [1, "us", "US"],
    "collies" => [1, "", ""],
    "collieshangies" => [1, "", ""],
    "colling" => [0, "", ""],
    "colobi" => [0, "", ""],
    "colobomata" => [2, "", ""],
    "coloni" => [1, "us", "US"],
    "colorless" => [0, "", ""],
    "colossi" => [1, "us", "US"],
    "colourless" => [0, "", ""],
    "columbaria" => [1, "um", "UM"],
    "combless" => [0, "", ""],
    "comfortless" => [0, "", ""],
    "comingling" => [0, "", ""],
    "commesses" => [1, "", ""],
    "companionless" => [0, "", ""],
    "compassionless" => [0, "", ""],
    "compelling" => [0, "", ""],
    "complexionless" => [0, "", ""],
    "compromises" => [1, "", ""],
    "computereses" => [1, "", ""],
    "computerless" => [0, "", ""],
    "conaria" => [1, "um", "UM"],
    "concauses" => [1, "", ""],
    "conceitless" => [0, "", ""],
    "concetti" => [1, "o", "O"],
    "conchfish" => [0, "", ""],
    "concourses" => [1, "", ""],
    "condoling" => [0, "", ""],
    "conducti" => [1, "us", "US"],
    "conenoses" => [1, "", ""],
    "confetti" => [1, "o", "O"],
    "confineless" => [0, "", ""],
    "confreries" => [1, "", ""],
    "congii" => [1, "us", "US"],
    "congresspeople" => [4, "rson", "RSON"],
    "conidia" => [1, "um", "UM"],
    "conioses" => [2, "is", "IS"],
    "conscienceless" => [0, "", ""],
    "consortia" => [1, "um", "UM"],
    "constitutionless" => [0, "", ""],
    "contadini" => [1, "o", "O"],
    "containerless" => [0, "", ""],
    "contentless" => [0, "", ""],
    "contextless" => [0, "", ""],
    "continua" => [1, "um", "UM"],
    "contradanses" => [1, "", ""],
    "contredanses" => [1, "", ""],
    "contretemps" => [0, "", ""],
    "controlling" => [0, "", ""],
    "coni" => [1, "us", "US"],
    "converses" => [1, "", ""],
    "convictfish" => [0, "", ""],
    "cookhouses" => [1, "", ""],
    "cookless" => [0, "", ""],
    "cooling" => [0, "", ""],
    "coonties" => [1, "", ""],
    "cooties" => [1, "", ""],
    "copses" => [1, "", ""],
    "coralla" => [1, "um", "UM"],
    "corbeling" => [0, "", ""],
    "corbelling" => [0, "", ""],
    "cordites" => [2, "is", "IS"],
    "cordless" => [0, "", ""],
    "coreless" => [0, "", ""],
    "coremia" => [1, "um", "UM"],
    "corves" => [3, "f", "F"],
    "cornemuses" => [1, "", ""],
    "cornetfish" => [0, "", ""],
    "cornetti" => [1, "o", "O"],
    "cornea" => [1, "um", "UM"],
    "corniches" => [1, "", ""],
    "corni" => [1, "o", "O"],
    "corps" => [0, "", ""],
    "corpses" => [1, "", ""],
    "corpora" => [3, "us", "US"],
    "corralling" => [0, "", ""],
    "corries" => [1, "", ""],
    "corrigenda" => [1, "um", "UM"],
    "corses" => [1, "", ""],
    "cortices" => [4, "ex", "EX"],
    "corynebacteria" => [1, "um", "UM"],
    "coryphaei" => [1, "us", "US"],
    "cossies" => [1, "", ""],
    "costless" => [0, "", ""],
    "coteries" => [1, "", ""],
    "cotterless" => [0, "", ""],
    "coulisses" => [1, "", ""],
    "counterbases" => [1, "", ""],
    "counterhypotheses" => [2, "is", "IS"],
    "counterpoises" => [1, "", ""],
    "counterresponses" => [1, "", ""],
    "counterscarp" => [0, "", ""],
    "countinghouses" => [1, "", ""],
    "countless" => [0, "", ""],
    "countryfolk" => [0, "", ""],
    "coupling" => [0, "", ""],
    "courses" => [1, "", ""],
    "courthouses" => [1, "", ""],
    "courtling" => [0, "", ""],
    "coverless" => [0, "", ""],
    "cowfish" => [0, "", ""],
    "cowhouses" => [1, "", ""],
    "cowling" => [0, "", ""],
    "cowpies" => [1, "", ""],
    "coxitides" => [3, "s", "S"],
    "coxless" => [0, "", ""],
    "crackling" => [0, "", ""],
    "craftless" => [0, "", ""],
    "craftspeople" => [4, "rson", "RSON"],
    "crampfish" => [0, "", ""],
    "crankcases" => [1, "", ""],
    "crankling" => [0, "", ""],
    "crappie" => [0, "", ""],
    "crases" => [2, "is", "IS"],
    "crawfish" => [0, "", ""],
    "crawling" => [0, "", ""],
    "crayfish" => [0, "", ""],
    "crazes" => [1, "", ""],
    "creases" => [1, "", ""],
    "creaseless" => [0, "", ""],
    "creches" => [1, "", ""],
    "credenda" => [1, "um", "UM"],
    "credentialling" => [0, "", ""],
    "creeling" => [0, "", ""],
    "crenelling" => [0, "", ""],
    "creperies" => [1, "", ""],
    "crestless" => [0, "", ""],
    "crevasses" => [1, "", ""],
    "crewless" => [0, "", ""],
    "crimeless" => [0, "", ""],
    "crimpling" => [0, "", ""],
    "cringeling" => [0, "", ""],
    "crises" => [2, "is", "IS"],
    "crissa" => [1, "um", "UM"],
    "criteria" => [1, "on", "ON"],
    "croches" => [1, "", ""],
    "crombies" => [1, "", ""],
    "cropless" => [0, "", ""],
    "crosses" => [1, "", ""],
    "crossbuck" => [0, "", ""],
    "crossfish" => [0, "", ""],
    "crossties" => [1, "", ""],
    "crowfeet" => [3, "oot", "OOT"],
    "crownless" => [0, "", ""],
    "crozes" => [1, "", ""],
    "cruises" => [1, "", ""],
    "crumbling" => [0, "", ""],
    "crumpling" => [0, "", ""],
    "cruses" => [1, "", ""],
    "crusies" => [1, "", ""],
    "crustless" => [0, "", ""],
    "cryptanalyses" => [2, "is", "IS"],
    "cryptococcoses" => [2, "is", "IS"],
    "cryptococci" => [1, "us", "US"],
    "cryptosporidioses" => [2, "is", "IS"],
    "crystalling" => [0, "", ""],
    "crystallites" => [2, "is", "IS"],
    "ctenidia" => [1, "um", "UM"],
    "cubicula" => [1, "um", "UM"],
    "cudgelling" => [0, "", ""],
    "cuffless" => [0, "", ""],
    "cuisses" => [1, "", ""],
    "culchies" => [1, "", ""],
    "culling" => [0, "", ""],
    "cumberless" => [0, "", ""],
    "cumulonimbi" => [1, "us", "US"],
    "cumuli" => [1, "us", "US"],
    "cupelling" => [0, "", ""],
    "curbless" => [0, "", ""],
    "curdling" => [0, "", ""],
    "cureless" => [0, "", ""],
    "curies" => [1, "", ""],
    "curliewurlies" => [1, "", ""],
    "curling" => [0, "", ""],
    "curricula" => [1, "um", "UM"],
    "curses" => [1, "", ""],
    "cursi" => [1, "us", "US"],
    "curtainless" => [0, "", ""],
    "curtalaxes" => [1, "", ""],
    "cushionless" => [0, "", ""],
    "customhouses" => [1, "", ""],
    "customshouses" => [1, "", ""],
    "cuties" => [1, "", ""],
    "cutlassfish" => [0, "", ""],
    "cutling" => [0, "", ""],
    "cutpurses" => [1, "", ""],
    "cuttlefish" => [0, "", ""],
    "cuttoes" => [1, "", ""],
    "cyanobacteria" => [1, "um", "UM"],
    "cyanogeneses" => [2, "is", "IS"],
    "cyanoses" => [2, "is", "IS"],
    "cyclases" => [1, "", ""],
    "cyclogeneses" => [2, "is", "IS"],
    "cyclops" => [0, "", ""],
    "cycloses" => [2, "is", "IS"],
    "cyeses" => [2, "is", "IS"],
    "cylices" => [3, "x", "X"],
    "cypres" => [2, "is", "IS"],
    "cysticercoses" => [2, "is", "IS"],
    "cysticerci" => [1, "us", "US"],
    "cystitides" => [3, "s", "S"],
    "cytisi" => [1, "us", "US"],
    "cytogeneses" => [2, "is", "IS"],
    "cytokineses" => [2, "is", "IS"],
    "cytolyses" => [2, "is", "IS"],
    "dace" => [0, "", ""],
    "dacquoises" => [1, "", ""],
    "dactyli" => [1, "us", "US"],
    "dales" => [2, "is", "IS"],
    "dali" => [1, "o", "O"],
    "damselfish" => [0, "", ""],
    "dancercises" => [1, "", ""],
    "dangling" => [0, "", ""],
    "danseuses" => [1, "", ""],
    "dapperling" => [0, "", ""],
    "dares" => [2, "is", "IS"],
    "darkling" => [0, "", ""],
    "dartling" => [0, "", ""],
    "dashes" => [2, "is", "IS"],
    "dassies" => [1, "", ""],
    "databases" => [1, "", ""],
    "dateless" => [0, "", ""],
    "data" => [1, "um", "UM"],
    "daughterless" => [0, "", ""],
    "daughterling" => [0, "", ""],
    "dauntless" => [0, "", ""],
    "dauties" => [1, "", ""],
    "dawties" => [1, "", ""],
    "dazes" => [1, "", ""],
    "dead" => [0, "", ""],
    "deaves" => [3, "f", "F"],
    "dealfish" => [0, "", ""],
    "deaminases" => [1, "", ""],
    "dearling" => [0, "", ""],
    "deathless" => [0, "", ""],
    "debelling" => [0, "", ""],
    "debris" => [0, "", ""],
    "debtless" => [0, "", ""],
    "decalling" => [0, "", ""],
    "decarboxylases" => [1, "", ""],
    "deccies" => [1, "", ""],
    "deceases" => [1, "", ""],
    "deckhouses" => [1, "", ""],
    "decontrolling" => [0, "", ""],
    "decreases" => [1, "", ""],
    "deedless" => [0, "", ""],
    "deer" => [0, "", ""],
    "defenceless" => [0, "", ""],
    "defenses" => [1, "", ""],
    "defenseless" => [0, "", ""],
    "defiling" => [0, "", ""],
    "definienda" => [1, "um", "UM"],
    "defuelling" => [0, "", ""],
    "degames" => [2, "is", "IS"],
    "dehydrochlorinases" => [1, "", ""],
    "dehydrogenases" => [1, "", ""],
    "delightless" => [0, "", ""],
    "deles" => [2, "is", "IS"],
    "deltoidei" => [1, "us", "US"],
    "demarches" => [1, "", ""],
    "demises" => [1, "", ""],
    "demitasses" => [1, "", ""],
    "denarii" => [1, "us", "US"],
    "denies" => [2, "", ""],
    "deoxyribonucleases" => [1, "", ""],
    "deoxyriboses" => [1, "", ""],
    "depthless" => [0, "", ""],
    "dermatophytoses" => [2, "is", "IS"],
    "dermatoses" => [2, "is", "IS"],
    "desertless" => [0, "", ""],
    "desiderata" => [1, "um", "UM"],
    "designless" => [0, "", ""],
    "desireless" => [0, "", ""],
    "desses" => [1, "", ""],
    "detasselling" => [0, "", ""],
    "detritus" => [0, "", ""],
    "develling" => [0, "", ""],
    "devilfish" => [0, "", ""],
    "devilling" => [0, "", ""],
    "devises" => [1, "", ""],
    "dewless" => [0, "", ""],
    "dextranases" => [1, "", ""],
    "dextroglucoses" => [1, "", ""],
    "dextroses" => [1, "", ""],
    "dhooties" => [1, "", ""],
    "dhurries" => [1, "", ""],
    "diabases" => [1, "", ""],
    "diabetes" => [0, "", ""],
    "diaereses" => [2, "is", "IS"],
    "diageneses" => [2, "is", "IS"],
    "diagnoses" => [2, "is", "IS"],
    "diakineses" => [2, "is", "IS"],
    "dialling" => [0, "", ""],
    "dialyses" => [2, "is", "IS"],
    "diapedeses" => [2, "is", "IS"],
    "diaphorases" => [1, "", ""],
    "diaphoreses" => [2, "is", "IS"],
    "diaphyses" => [2, "is", "IS"],
    "diapophyses" => [2, "is", "IS"],
    "diapyeses" => [2, "is", "IS"],
    "diarthroses" => [2, "is", "IS"],
    "diastases" => [2, "is", "IS"],
    "diastemata" => [2, "", ""],
    "diatheses" => [2, "is", "IS"],
    "dichasia" => [1, "um", "UM"],
    "dicta" => [1, "um", "UM"],
    "dice" => [2, "e", "E"],
    "diegeses" => [2, "is", "IS"],
    "diereses" => [2, "is", "IS"],
    "dieses" => [2, "is", "IS"],
    "dildoes" => [1, "", ""],
    "dimensionless" => [0, "", ""],
    "dinnerless" => [0, "", ""],
    "dintless" => [0, "", ""],
    "dioceses" => [1, "", ""],
    "dioptases" => [1, "", ""],
    "diorthoses" => [2, "is", "IS"],
    "dipeptidases" => [1, "", ""],
    "diplococci" => [1, "us", "US"],
    "diploes" => [1, "", ""],
    "diplophases" => [1, "", ""],
    "diploses" => [2, "is", "IS"],
    "diplozoa" => [1, "on", "ON"],
    "diptera" => [1, "on", "ON"],
    "directionless" => [0, "", ""],
    "disses" => [3, "", ""],
    "disaccharidases" => [1, "", ""],
    "disannulling" => [0, "", ""],
    "disbowelling" => [0, "", ""],
    "discoboli" => [1, "us", "US"],
    "discourses" => [1, "", ""],
    "diseases" => [1, "", ""],
    "disembowelling" => [0, "", ""],
    "disenthralling" => [0, "", ""],
    "diseuses" => [1, "", ""],
    "disguises" => [1, "", ""],
    "disguiseless" => [0, "", ""],
    "dishevelling" => [0, "", ""],
    "diskless" => [0, "", ""],
    "dispelling" => [0, "", ""],
    "disposes" => [1, "", ""],
    "dispraises" => [1, "", ""],
    "disregardless" => [0, "", ""],
    "distanceless" => [0, "", ""],
    "distilling" => [0, "", ""],
    "disuses" => [1, "", ""],
    "diureses" => [2, "is", "IS"],
    "diverticuloses" => [2, "is", "IS"],
    "diverticula" => [1, "um", "UM"],
    "divies" => [2, "", ""],
    "dividendless" => [0, "", ""],
    "dockmackies" => [1, "", ""],
    "doctorfish" => [0, "", ""],
    "doctorless" => [0, "", ""],
    "doe" => [0, "", ""],
    "doghouses" => [1, "", ""],
    "dogteeth" => [4, "ooth", "OOTH"],
    "doling" => [0, "", ""],
    "dolia" => [1, "um", "UM"],
    "dollarfish" => [0, "", ""],
    "dollhouses" => [1, "", ""],
    "dolling" => [0, "", ""],
    "dolphinfish" => [0, "", ""],
    "domatia" => [1, "um", "UM"],
    "dominatrices" => [3, "x", "X"],
    "dominies" => [1, "", ""],
    "dong" => [0, "", ""],
    "doorless" => [0, "", ""],
    "dormice" => [3, "ouse", "OUSE"],
    "dorses" => [1, "", ""],
    "doses" => [1, "", ""],
    "dosshouses" => [1, "", ""],
    "doubtless" => [0, "", ""],
    "douches" => [1, "", ""],
    "douses" => [1, "", ""],
    "dovekies" => [1, "", ""],
    "dowelling" => [0, "", ""],
    "dowerless" => [0, "", ""],
    "downless" => [0, "", ""],
    "dowses" => [1, "", ""],
    "dozes" => [1, "", ""],
    "dragonfish" => [0, "", ""],
    "drappies" => [1, "", ""],
    "drawknives" => [3, "fe", "FE"],
    "drawling" => [0, "", ""],
    "dreadless" => [0, "", ""],
    "dreamless" => [0, "", ""],
    "driftfish" => [0, "", ""],
    "driftless" => [0, "", ""],
    "dripless" => [0, "", ""],
    "driveling" => [0, "", ""],
    "drivelling" => [0, "", ""],
    "driverless" => [0, "", ""],
    "drowses" => [1, "", ""],
    "drugless" => [0, "", ""],
    "drumfish" => [0, "", ""],
    "duchesses" => [1, "", ""],
    "duckling" => [0, "", ""],
    "ductless" => [0, "", ""],
    "dueling" => [0, "", ""],
    "duelling" => [0, "", ""],
    "dukeling" => [0, "", ""],
    "duloses" => [2, "is", "IS"],
    "dulses" => [1, "", ""],
    "dumpling" => [0, "", ""],
    "duneland" => [0, "", ""],
    "dunfish" => [0, "", ""],
    "duodena" => [1, "um", "UM"],
    "durries" => [1, "", ""],
    "dustless" => [0, "", ""],
    "dybbukim" => [2, "", ""],
    "dysgeneses" => [2, "is", "IS"],
    "eanling" => [0, "", ""],
    "earaches" => [1, "", ""],
    "earless" => [0, "", ""],
    "earthling" => [0, "", ""],
    "earthrises" => [1, "", ""],
    "earthwolves" => [3, "f", "F"],
    "eases" => [1, "", ""],
    "easeless" => [0, "", ""],
    "easterling" => [0, "", ""],
    "ecchymoses" => [2, "is", "IS"],
    "ecdyses" => [2, "is", "IS"],
    "eceses" => [2, "is", "IS"],
    "echinococcoses" => [2, "is", "IS"],
    "echinococci" => [1, "us", "US"],
    "echoless" => [0, "", ""],
    "eclipses" => [1, "", ""],
    "ecocatastrophes" => [1, "", ""],
    "ecorches" => [1, "", ""],
    "ecossaises" => [1, "", ""],
    "ecphoneses" => [2, "is", "IS"],
    "ectases" => [2, "is", "IS"],
    "ecthlipses" => [2, "is", "IS"],
    "ecthymata" => [2, "", ""],
    "ectogeneses" => [2, "is", "IS"],
    "ectozoa" => [1, "on", "ON"],
    "ecuries" => [1, "", ""],
    "edgeless" => [0, "", ""],
    "educationeses" => [1, "", ""],
    "effectless" => [0, "", ""],
    "effluvia" => [1, "um", "UM"],
    "effortless" => [0, "", ""],
    "eggcases" => [1, "", ""],
    "eggless" => [0, "", ""],
    "eggshake" => [0, "", ""],
    "egoless" => [0, "", ""],
    "eisegeses" => [2, "is", "IS"],
    "eland" => [0, "", ""],
    "elastases" => [1, "", ""],
    "elect" => [0, "", ""],
    "electroanalyses" => [2, "is", "IS"],
    "electrodialyses" => [2, "is", "IS"],
    "electrogeneses" => [2, "is", "IS"],
    "electroless" => [0, "", ""],
    "electrolyses" => [2, "is", "IS"],
    "electroosmoses" => [2, "is", "IS"],
    "electrophoreses" => [2, "is", "IS"],
    "electrophori" => [1, "us", "US"],
    "elenchi" => [1, "us", "US"],
    "elephantiases" => [2, "is", "IS"],
    "elves" => [3, "f", "F"],
    "elfish" => [0, "", ""],
    "ellipses" => [2, "is", "IS"],
    "elytra" => [1, "um", "UM"],
    "emblemata" => [2, "", ""],
    "embowelling" => [0, "", ""],
    "embryogeneses" => [2, "is", "IS"],
    "emeriti" => [1, "us", "US"],
    "emeses" => [2, "is", "IS"],
    "emotionless" => [0, "", ""],
    "empanelling" => [0, "", ""],
    "emphases" => [2, "is", "IS"],
    "emphlyses" => [2, "is", "IS"],
    "emprises" => [1, "", ""],
    "emprizes" => [1, "", ""],
    "enamelling" => [0, "", ""],
    "enarthroses" => [2, "is", "IS"],
    "encephalitides" => [3, "s", "S"],
    "encephalomyelitides" => [3, "s", "S"],
    "enclises" => [2, "is", "IS"],
    "endleaves" => [3, "f", "F"],
    "endless" => [0, "", ""],
    "endocarp" => [0, "", ""],
    "endocrania" => [1, "um", "UM"],
    "endocytoses" => [2, "is", "IS"],
    "endometrioses" => [2, "is", "IS"],
    "endomitoses" => [2, "is", "IS"],
    "endonucleases" => [1, "", ""],
    "endopeptidases" => [1, "", ""],
    "endosmoses" => [2, "is", "IS"],
    "endosporia" => [1, "um", "UM"],
    "endosymbioses" => [2, "is", "IS"],
    "endothecia" => [1, "um", "UM"],
    "endothelia" => [1, "um", "UM"],
    "endozoa" => [1, "on", "ON"],
    "engirdling" => [0, "", ""],
    "enolases" => [1, "", ""],
    "enoses" => [2, "is", "IS"],
    "enrolling" => [0, "", ""],
    "ensorcelling" => [0, "", ""],
    "entases" => [2, "is", "IS"],
    "enterobacteria" => [1, "um", "UM"],
    "enterobiases" => [2, "is", "IS"],
    "enterococci" => [1, "us", "US"],
    "enterokinases" => [1, "", ""],
    "enterprises" => [1, "", ""],
    "enthralling" => [0, "", ""],
    "entozoa" => [1, "on", "ON"],
    "entrammelling" => [0, "", ""],
    "entrepreneuses" => [1, "", ""],
    "enureses" => [2, "is", "IS"],
    "epanadiploses" => [2, "is", "IS"],
    "epanalepses" => [2, "is", "IS"],
    "epanorthoses" => [2, "is", "IS"],
    "epentheses" => [2, "is", "IS"],
    "epexegeses" => [2, "is", "IS"],
    "ephebi" => [1, "us", "US"],
    "epicardia" => [1, "um", "UM"],
    "epicedia" => [1, "um", "UM"],
    "epicleses" => [2, "is", "IS"],
    "epigeneses" => [2, "is", "IS"],
    "epigoni" => [1, "us", "US"],
    "epimerases" => [1, "", ""],
    "epimysia" => [1, "um", "UM"],
    "epiphyses" => [2, "is", "IS"],
    "epiplastra" => [1, "on", "ON"],
    "epistases" => [2, "is", "IS"],
    "epistaxes" => [2, "is", "IS"],
    "episterna" => [1, "um", "UM"],
    "epistrophes" => [1, "", ""],
    "epitases" => [2, "is", "IS"],
    "epithalamia" => [1, "on", "ON"],
    "epitheses" => [2, "is", "IS"],
    "epizeuxes" => [2, "is", "IS"],
    "epizoa" => [1, "on", "ON"],
    "equalling" => [0, "", ""],
    "equipoises" => [1, "", ""],
    "eremuri" => [1, "us", "US"],
    "eroteses" => [2, "is", "IS"],
    "errata" => [1, "um", "UM"],
    "errorless" => [0, "", ""],
    "erythroblastoses" => [2, "is", "IS"],
    "erythropoieses" => [2, "is", "IS"],
    "escapeless" => [0, "", ""],
    "escarmouches" => [1, "", ""],
    "esophagi" => [1, "us", "US"],
    "espiegleries" => [1, "", ""],
    "esquisses" => [1, "", ""],
    "esses" => [1, "", ""],
    "esterases" => [1, "", ""],
    "estheses" => [2, "is", "IS"],
    "eubacteria" => [1, "um", "UM"],
    "euclases" => [1, "", ""],
    "euphorbia" => [1, "um", "UM"],
    "euphroes" => [1, "", ""],
    "eventless" => [0, "", ""],
    "evhoes" => [1, "", ""],
    "evoes" => [1, "", ""],
    "evohes" => [1, "", ""],
    "excelling" => [0, "", ""],
    "exceptless" => [0, "", ""],
    "excises" => [1, "", ""],
    "excuses" => [1, "", ""],
    "executrices" => [3, "x", "X"],
    "exegeses" => [2, "is", "IS"],
    "exempla" => [1, "um", "UM"],
    "exercises" => [1, "", ""],
    "exhaustless" => [0, "", ""],
    "exitless" => [0, "", ""],
    "exocytoses" => [2, "is", "IS"],
    "exonucleases" => [1, "", ""],
    "exopeptidases" => [1, "", ""],
    "exosmoses" => [2, "is", "IS"],
    "exostoses" => [2, "is", "IS"],
    "expanses" => [1, "", ""],
    "expelling" => [0, "", ""],
    "expenses" => [1, "", ""],
    "experienceless" => [0, "", ""],
    "expertises" => [1, "", ""],
    "exposes" => [1, "", ""],
    "expressionless" => [0, "", ""],
    "extolling" => [0, "", ""],
    "extrema" => [1, "um", "UM"],
    "exuvia" => [1, "um", "UM"],
    "eyeless" => [0, "", ""],
    "eyeteeth" => [4, "ooth", "OOTH"],
    "fabling" => [0, "", ""],
    "faceless" => [0, "", ""],
    "fadeless" => [0, "", ""],
    "fagotti" => [1, "o", "O"],
    "faithless" => [0, "", ""],
    "fallfish" => [0, "", ""],
    "falsies" => [1, "", ""],
    "fameless" => [0, "", ""],
    "fangless" => [0, "", ""],
    "farceuses" => [1, "", ""],
    "farmhouses" => [1, "", ""],
    "farmwives" => [3, "fe", "FE"],
    "farthingless" => [0, "", ""],
    "fasciculi" => [1, "us", "US"],
    "fascioliases" => [2, "is", "IS"],
    "fatherless" => [0, "", ""],
    "fathomless" => [0, "", ""],
    "fatless" => [0, "", ""],
    "fatling" => [0, "", ""],
    "faultless" => [0, "", ""],
    "fauces" => [3, "x", "X"],
    "favorless" => [0, "", ""],
    "favourless" => [0, "", ""],
    "fearless" => [0, "", ""],
    "featherless" => [0, "", ""],
    "featureless" => [0, "", ""],
    "feckless" => [0, "", ""],
    "federaleses" => [1, "", ""],
    "fees" => [2, "is", "IS"],
    "feeless" => [0, "", ""],
    "feeling" => [0, "", ""],
    "feelingless" => [0, "", ""],
    "feetless" => [0, "", ""],
    "felloes" => [1, "", ""],
    "fella" => [1, "on", "ON"],
    "fenceless" => [0, "", ""],
    "fenderless" => [0, "", ""],
    "fernless" => [0, "", ""],
    "ferrelling" => [0, "", ""],
    "ferromanganeses" => [1, "", ""],
    "fesses" => [1, "", ""],
    "fetiales" => [2, "is", "IS"],
    "fetterless" => [0, "", ""],
    "fezzes" => [3, "", ""],
    "fiberless" => [0, "", ""],
    "fibreless" => [0, "", ""],
    "fibrinolyses" => [2, "is", "IS"],
    "fibroses" => [2, "is", "IS"],
    "fiches" => [1, "", ""],
    "ficus" => [0, "", ""],
    "fies" => [1, "", ""],
    "fieldmice" => [3, "ouse", "OUSE"],
    "filariases" => [2, "is", "IS"],
    "filefish" => [0, "", ""],
    "filling" => [0, "", ""],
    "filopodia" => [1, "um", "UM"],
    "filterless" => [0, "", ""],
    "fila" => [1, "um", "UM"],
    "fineless" => [0, "", ""],
    "finesses" => [1, "", ""],
    "finfish" => [0, "", ""],
    "fingerless" => [0, "", ""],
    "fingerling" => [0, "", ""],
    "finless" => [0, "", ""],
    "firebases" => [1, "", ""],
    "firehoses" => [1, "", ""],
    "firehouses" => [1, "", ""],
    "fireless" => [0, "", ""],
    "firmless" => [0, "", ""],
    "firstborn" => [0, "", ""],
    "firstling" => [0, "", ""],
    "fish" => [0, "", ""],
    "fisherfolk" => [0, "", ""],
    "fishless" => [0, "", ""],
    "fishwives" => [3, "fe", "FE"],
    "fitches" => [1, "", ""],
    "fizzling" => [0, "", ""],
    "flagella" => [1, "um", "UM"],
    "flagfish" => [0, "", ""],
    "flagless" => [0, "", ""],
    "flak" => [0, "", ""],
    "flamefish" => [0, "", ""],
    "flameless" => [0, "", ""],
    "flaneries" => [1, "", ""],
    "flannelling" => [0, "", ""],
    "flapless" => [0, "", ""],
    "flatfish" => [0, "", ""],
    "flatling" => [0, "", ""],
    "flatties" => [1, "", ""],
    "flavorless" => [0, "", ""],
    "flavourless" => [0, "", ""],
    "flawless" => [0, "", ""],
    "fleches" => [1, "", ""],
    "fleckless" => [0, "", ""],
    "fledgeless" => [0, "", ""],
    "fledgeling" => [0, "", ""],
    "fleeceless" => [0, "", ""],
    "fleshless" => [0, "", ""],
    "fleshling" => [0, "", ""],
    "flightless" => [0, "", ""],
    "flocculi" => [1, "us", "US"],
    "flocci" => [1, "us", "US"],
    "floes" => [1, "", ""],
    "flophouses" => [1, "", ""],
    "florilegia" => [1, "um", "UM"],
    "flounder" => [0, "", ""],
    "flourless" => [0, "", ""],
    "flowerless" => [0, "", ""],
    "fluoroses" => [2, "is", "IS"],
    "flyleaves" => [3, "f", "F"],
    "flyless" => [0, "", ""],
    "foamless" => [0, "", ""],
    "focusless" => [0, "", ""],
    "foes" => [1, "", ""],
    "fogless" => [0, "", ""],
    "foisonless" => [0, "", ""],
    "folklives" => [3, "fe", "FE"],
    "folles" => [2, "is", "IS"],
    "fondling" => [0, "", ""],
    "foodless" => [0, "", ""],
    "foolfish" => [0, "", ""],
    "fooling" => [0, "", ""],
    "feet" => [3, "oot", "OOT"],
    "footless" => [0, "", ""],
    "footling" => [0, "", ""],
    "fopling" => [0, "", ""],
    "forceless" => [0, "", ""],
    "forceps" => [0, "", ""],
    "fordless" => [0, "", ""],
    "forecaddies" => [1, "", ""],
    "forecourses" => [1, "", ""],
    "forefeet" => [3, "oot", "OOT"],
    "foreland" => [0, "", ""],
    "forepeople" => [4, "rson", "RSON"],
    "foresightless" => [0, "", ""],
    "forestalling" => [0, "", ""],
    "foreteeth" => [4, "ooth", "OOTH"],
    "forkless" => [0, "", ""],
    "formicaria" => [1, "um", "UM"],
    "formless" => [0, "", ""],
    "fortes" => [2, "is", "IS"],
    "fortuneless" => [0, "", ""],
    "fosses" => [1, "", ""],
    "fosterling" => [0, "", ""],
    "fougasses" => [1, "", ""],
    "fouling" => [0, "", ""],
    "foundationless" => [0, "", ""],
    "foundling" => [0, "", ""],
    "fountainless" => [0, "", ""],
    "fowl" => [0, "", ""],
    "foxfish" => [0, "", ""],
    "fracti" => [1, "us", "US"],
    "fraises" => [1, "", ""],
    "framboises" => [1, "", ""],
    "franchises" => [1, "", ""],
    "frangipanes" => [2, "is", "IS"],
    "frankincenses" => [1, "", ""],
    "freebases" => [1, "", ""],
    "freebies" => [1, "", ""],
    "freezes" => [1, "", ""],
    "fretless" => [0, "", ""],
    "frictionless" => [0, "", ""],
    "friendless" => [0, "", ""],
    "friezes" => [1, "", ""],
    "fringeless" => [0, "", ""],
    "frises" => [1, "", ""],
    "frivolling" => [0, "", ""],
    "frizzling" => [0, "", ""],
    "frockless" => [0, "", ""],
    "froes" => [1, "", ""],
    "frogfish" => [0, "", ""],
    "frogling" => [0, "", ""],
    "froises" => [1, "", ""],
    "frontless" => [0, "", ""],
    "frontogeneses" => [2, "is", "IS"],
    "frontolyses" => [2, "is", "IS"],
    "frosh" => [0, "", ""],
    "frostfish" => [0, "", ""],
    "frostless" => [0, "", ""],
    "frothless" => [0, "", ""],
    "fructoses" => [1, "", ""],
    "fruitless" => [0, "", ""],
    "frutices" => [4, "ex", "EX"],
    "fry" => [0, "", ""],
    "fucoses" => [1, "", ""],
    "fuelling" => [0, "", ""],
    "fugies" => [1, "", ""],
    "fugling" => [0, "", ""],
    "fulfilling" => [0, "", ""],
    "fumarases" => [1, "", ""],
    "fumeless" => [0, "", ""],
    "fumuli" => [1, "us", "US"],
    "functionless" => [0, "", ""],
    "fundless" => [0, "", ""],
    "fundi" => [1, "us", "US"],
    "fungi" => [1, "us", "US"],
    "funhouses" => [1, "", ""],
    "funiculi" => [1, "us", "US"],
    "funnelling" => [0, "", ""],
    "furanoses" => [1, "", ""],
    "furcula" => [1, "um", "UM"],
    "furless" => [0, "", ""],
    "furling" => [0, "", ""],
    "furunculoses" => [2, "is", "IS"],
    "furzes" => [1, "", ""],
    "fusaria" => [1, "um", "UM"],
    "fuses" => [1, "", ""],
    "fuseless" => [0, "", ""],
    "fusionless" => [0, "", ""],
    "futureless" => [0, "", ""],
    "fuzes" => [1, "", ""],
    "fuzz" => [0, "", ""],
    "gaberlunzies" => [1, "", ""],
    "gabling" => [0, "", ""],
    "gades" => [2, "is", "IS"],
    "gadling" => [0, "", ""],
    "gainless" => [0, "", ""],
    "gairfowl" => [0, "", ""],
    "galactopoieses" => [2, "is", "IS"],
    "galactoses" => [2, "is", "IS"],
    "galactosidases" => [1, "", ""],
    "galliardises" => [1, "", ""],
    "galling" => [0, "", ""],
    "gallows" => [0, "", ""],
    "galoshes" => [1, "", ""],
    "gambling" => [0, "", ""],
    "gamboling" => [0, "", ""],
    "gambolling" => [0, "", ""],
    "gameless" => [0, "", ""],
    "gametangia" => [1, "um", "UM"],
    "gametogeneses" => [2, "is", "IS"],
    "gamogeneses" => [2, "is", "IS"],
    "ganaches" => [1, "", ""],
    "gangling" => [0, "", ""],
    "ganglia" => [1, "on", "ON"],
    "gapless" => [0, "", ""],
    "garbless" => [0, "", ""],
    "garbling" => [0, "", ""],
    "garefowl" => [0, "", ""],
    "garfish" => [0, "", ""],
    "garlandless" => [0, "", ""],
    "garmentless" => [0, "", ""],
    "garvies" => [1, "", ""],
    "gashouses" => [1, "", ""],
    "gasless" => [0, "", ""],
    "gastritides" => [3, "s", "S"],
    "gastrocnemii" => [1, "us", "US"],
    "gastroenteritides" => [3, "s", "S"],
    "gatehouses" => [1, "", ""],
    "gateless" => [0, "", ""],
    "gaucheries" => [1, "", ""],
    "gaumless" => [0, "", ""],
    "gauzes" => [1, "", ""],
    "gaveling" => [0, "", ""],
    "gavelling" => [0, "", ""],
    "gazes" => [1, "", ""],
    "gazeless" => [0, "", ""],
    "gearcases" => [1, "", ""],
    "gearless" => [0, "", ""],
    "geisha" => [0, "", ""],
    "gelates" => [2, "is", "IS"],
    "gelling" => [0, "", ""],
    "gemfish" => [0, "", ""],
    "gemless" => [0, "", ""],
    "genderless" => [0, "", ""],
    "generatrices" => [3, "x", "X"],
    "geneses" => [2, "is", "IS"],
    "genies" => [1, "", ""],
    "genoises" => [1, "", ""],
    "gentilesses" => [1, "", ""],
    "gentling" => [0, "", ""],
    "genera" => [3, "us", "US"],
    "geotaxes" => [2, "is", "IS"],
    "gerontomorphoses" => [2, "is", "IS"],
    "ghillies" => [1, "", ""],
    "ghostfish" => [0, "", ""],
    "ghoulies" => [1, "", ""],
    "giardiases" => [2, "is", "IS"],
    "giftless" => [0, "", ""],
    "gigahertz" => [0, "", ""],
    "gillies" => [1, "", ""],
    "gimballing" => [0, "", ""],
    "gimmies" => [1, "", ""],
    "ginhouses" => [1, "", ""],
    "girdling" => [0, "", ""],
    "glabella" => [1, "um", "UM"],
    "gladdies" => [1, "", ""],
    "gladioli" => [1, "us", "US"],
    "glamourless" => [0, "", ""],
    "glandless" => [0, "", ""],
    "glandes" => [3, "s", "S"],
    "glassfish" => [0, "", ""],
    "glasshouses" => [1, "", ""],
    "glassless" => [0, "", ""],
    "glazes" => [1, "", ""],
    "glees" => [2, "is", "IS"],
    "glimpses" => [1, "", ""],
    "glioses" => [2, "is", "IS"],
    "glissandi" => [1, "o", "O"],
    "globefish" => [0, "", ""],
    "glochidia" => [1, "um", "UM"],
    "glomerulonephritides" => [3, "s", "S"],
    "glomeruli" => [1, "us", "US"],
    "gloveless" => [0, "", ""],
    "glucokinases" => [1, "", ""],
    "gluconeogeneses" => [2, "is", "IS"],
    "glucoses" => [1, "", ""],
    "glucosidases" => [1, "", ""],
    "glucuronidases" => [1, "", ""],
    "glutaei" => [1, "us", "US"],
    "glutaminases" => [1, "", ""],
    "glutei" => [1, "us", "US"],
    "glycogeneses" => [2, "is", "IS"],
    "glycogenolyses" => [2, "is", "IS"],
    "glycolyses" => [2, "is", "IS"],
    "glycosidases" => [1, "", ""],
    "gnarling" => [0, "", ""],
    "gnatling" => [0, "", ""],
    "gnoses" => [2, "is", "IS"],
    "gnu" => [0, "", ""],
    "goalies" => [1, "", ""],
    "goaling" => [0, "", ""],
    "goalless" => [0, "", ""],
    "goatfish" => [0, "", ""],
    "goatling" => [0, "", ""],
    "gobbi" => [1, "o", "O"],
    "gobemouches" => [1, "", ""],
    "godchildren" => [3, "", ""],
    "godless" => [0, "", ""],
    "godling" => [0, "", ""],
    "goes" => [1, "", ""],
    "goldfish" => [0, "", ""],
    "goldless" => [0, "", ""],
    "goloshes" => [1, "", ""],
    "gomphoses" => [2, "is", "IS"],
    "gonidia" => [1, "um", "UM"],
    "gonia" => [1, "um", "UM"],
    "gonococci" => [1, "us", "US"],
    "goodwives" => [3, "fe", "FE"],
    "googling" => [0, "", ""],
    "geese" => [4, "oose", "OOSE"],
    "goosefish" => [0, "", ""],
    "gorgoneia" => [1, "on", "ON"],
    "gormandizes" => [1, "", ""],
    "gormless" => [0, "", ""],
    "gorses" => [1, "", ""],
    "gosling" => [0, "", ""],
    "gospelling" => [0, "", ""],
    "gouaches" => [1, "", ""],
    "gourmandises" => [1, "", ""],
    "governmenteses" => [1, "", ""],
    "graceless" => [0, "", ""],
    "graciles" => [2, "is", "IS"],
    "gradeless" => [0, "", ""],
    "gradini" => [1, "o", "O"],
    "graffiti" => [1, "o", "O"],
    "grand" => [0, "", ""],
    "grandchildren" => [3, "", ""],
    "granitizes" => [1, "", ""],
    "granulocytopoieses" => [2, "is", "IS"],
    "granuloses" => [2, "is", "IS"],
    "grana" => [1, "um", "UM"],
    "grapeless" => [0, "", ""],
    "graspless" => [0, "", ""],
    "grassless" => [0, "", ""],
    "grates" => [2, "is", "IS"],
    "graveless" => [0, "", ""],
    "graveling" => [0, "", ""],
    "gravelling" => [0, "", ""],
    "grayfish" => [0, "", ""],
    "grayling" => [0, "", ""],
    "grazes" => [1, "", ""],
    "greases" => [1, "", ""],
    "greaseless" => [0, "", ""],
    "greenhouses" => [1, "", ""],
    "greenling" => [0, "", ""],
    "greeses" => [1, "", ""],
    "greses" => [1, "", ""],
    "griefless" => [0, "", ""],
    "grilses" => [1, "", ""],
    "grinnies" => [1, "", ""],
    "gripless" => [0, "", ""],
    "grises" => [1, "", ""],
    "gritless" => [0, "", ""],
    "grizes" => [1, "", ""],
    "gross" => [0, "", ""],
    "groundfish" => [0, "", ""],
    "groundless" => [0, "", ""],
    "groundling" => [0, "", ""],
    "groupies" => [1, "", ""],
    "grouse" => [0, "", ""],
    "groveling" => [0, "", ""],
    "grovelling" => [0, "", ""],
    "growling" => [0, "", ""],
    "grueling" => [0, "", ""],
    "gruelling" => [0, "", ""],
    "gruntling" => [0, "", ""],
    "gruppetti" => [1, "o", "O"],
    "guanases" => [1, "", ""],
    "guardhouses" => [1, "", ""],
    "guardless" => [0, "", ""],
    "gubernacula" => [1, "um", "UM"],
    "guelderroses" => [1, "", ""],
    "guesthouses" => [1, "", ""],
    "guffies" => [1, "", ""],
    "guideless" => [0, "", ""],
    "guileless" => [0, "", ""],
    "guilloches" => [1, "", ""],
    "guiltless" => [0, "", ""],
    "guises" => [1, "", ""],
    "guitarfish" => [0, "", ""],
    "gulling" => [0, "", ""],
    "gumless" => [0, "", ""],
    "gummoses" => [2, "is", "IS"],
    "gumshoes" => [1, "", ""],
    "gunless" => [0, "", ""],
    "gi" => [1, "us", "US"],
    "gustless" => [0, "", ""],
    "gutless" => [0, "", ""],
    "guttersnipe" => [0, "", ""],
    "gynaecea" => [1, "um", "UM"],
    "gynaecia" => [1, "um", "UM"],
    "gynecia" => [1, "um", "UM"],
    "gynogeneses" => [2, "is", "IS"],
    "gyrases" => [1, "", ""],
    "hackies" => [1, "", ""],
    "hackling" => [0, "", ""],
    "haddies" => [1, "", ""],
    "hadjes" => [2, "is", "IS"],
    "haemodialyses" => [2, "is", "IS"],
    "hagfish" => [0, "", ""],
    "haiku" => [0, "", ""],
    "hairless" => [0, "", ""],
    "hajes" => [2, "is", "IS"],
    "hajjes" => [2, "is", "IS"],
    "hake" => [0, "", ""],
    "halalling" => [0, "", ""],
    "halves" => [3, "f", "F"],
    "halflives" => [3, "fe", "FE"],
    "halfling" => [0, "", ""],
    "halfpence" => [2, "ny", "NY"],
    "halibut" => [0, "", ""],
    "haling" => [0, "", ""],
    "halitoses" => [2, "is", "IS"],
    "hallalling" => [0, "", ""],
    "hallucinoses" => [2, "is", "IS"],
    "halluces" => [3, "x", "X"],
    "halobacteria" => [1, "um", "UM"],
    "haltless" => [0, "", ""],
    "hammerfish" => [0, "", ""],
    "hammerless" => [0, "", ""],
    "hammertoes" => [1, "", ""],
    "hamuli" => [1, "us", "US"],
    "handleless" => [0, "", ""],
    "handless" => [0, "", ""],
    "handling" => [0, "", ""],
    "handselling" => [0, "", ""],
    "handshake" => [0, "", ""],
    "hanseling" => [0, "", ""],
    "hanselling" => [0, "", ""],
    "hapless" => [0, "", ""],
    "haploses" => [2, "is", "IS"],
    "harborless" => [0, "", ""],
    "harbourless" => [0, "", ""],
    "hardnoses" => [1, "", ""],
    "harmless" => [0, "", ""],
    "haruspices" => [4, "ex", "EX"],
    "harvestfish" => [0, "", ""],
    "hatchelling" => [0, "", ""],
    "hatchling" => [0, "", ""],
    "hateless" => [0, "", ""],
    "hatless" => [0, "", ""],
    "haustella" => [1, "um", "UM"],
    "haustoria" => [1, "um", "UM"],
    "hawknoses" => [1, "", ""],
    "hawses" => [1, "", ""],
    "hazes" => [1, "", ""],
    "hazeless" => [0, "", ""],
    "hes" => [1, "", ""],
    "headaches" => [1, "", ""],
    "headcases" => [1, "", ""],
    "headcheeses" => [1, "", ""],
    "headfish" => [0, "", ""],
    "headless" => [0, "", ""],
    "headscarves" => [3, "f", "F"],
    "headshake" => [0, "", ""],
    "healthless" => [0, "", ""],
    "hearses" => [1, "", ""],
    "heartaches" => [1, "", ""],
    "heartless" => [0, "", ""],
    "heartling" => [0, "", ""],
    "heartseases" => [1, "", ""],
    "heathfowl" => [0, "", ""],
    "heathless" => [0, "", ""],
    "heatless" => [0, "", ""],
    "heckling" => [0, "", ""],
    "hectocotyli" => [1, "us", "US"],
    "heedless" => [0, "", ""],
    "heelless" => [0, "", ""],
    "heezies" => [1, "", ""],
    "heinies" => [1, "", ""],
    "heirless" => [0, "", ""],
    "heles" => [2, "is", "IS"],
    "heling" => [0, "", ""],
    "heliotaxes" => [2, "is", "IS"],
    "helices" => [3, "x", "X"],
    "helminthiases" => [2, "is", "IS"],
    "helmless" => [0, "", ""],
    "helpless" => [0, "", ""],
    "hemaphereses" => [2, "is", "IS"],
    "hematogeneses" => [2, "is", "IS"],
    "hematopoieses" => [2, "is", "IS"],
    "hematozoa" => [1, "on", "ON"],
    "hemelytra" => [1, "on", "ON"],
    "hemicelluloses" => [1, "", ""],
    "hemochromatoses" => [2, "is", "IS"],
    "hemodialyses" => [2, "is", "IS"],
    "hemolyses" => [2, "is", "IS"],
    "hemopoieses" => [2, "is", "IS"],
    "hemoptyses" => [2, "is", "IS"],
    "hemostases" => [2, "is", "IS"],
    "henhouses" => [1, "", ""],
    "hepatitides" => [3, "s", "S"],
    "heptoses" => [1, "", ""],
    "herbless" => [0, "", ""],
    "herling" => [0, "", ""],
    "herring" => [0, "", ""],
    "hertz" => [0, "", ""],
    "heterogeneses" => [2, "is", "IS"],
    "heterokaryoses" => [2, "is", "IS"],
    "heterolyses" => [2, "is", "IS"],
    "heteroses" => [2, "is", "IS"],
    "heterotaxes" => [2, "is", "IS"],
    "heterozygoses" => [2, "is", "IS"],
    "hexokinases" => [1, "", ""],
    "hexosaminidases" => [1, "", ""],
    "hexoses" => [1, "", ""],
    "hibernacula" => [1, "um", "UM"],
    "hickies" => [1, "", ""],
    "hideless" => [0, "", ""],
    "hidling" => [0, "", ""],
    "hidroses" => [2, "is", "IS"],
    "hiera" => [1, "on", "ON"],
    "highrises" => [1, "", ""],
    "hiltless" => [0, "", ""],
    "hila" => [1, "um", "UM"],
    "hili" => [1, "us", "US"],
    "hipless" => [0, "", ""],
    "hippocampi" => [1, "us", "US"],
    "hireling" => [0, "", ""],
    "hirselling" => [0, "", ""],
    "histaminases" => [1, "", ""],
    "histodialyses" => [2, "is", "IS"],
    "histogeneses" => [2, "is", "IS"],
    "histolyses" => [2, "is", "IS"],
    "histoplasmoses" => [2, "is", "IS"],
    "hithes" => [1, "", ""],
    "hitless" => [0, "", ""],
    "hiveless" => [0, "", ""],
    "hobbyhorses" => [1, "", ""],
    "hobbyless" => [0, "", ""],
    "hoes" => [1, "", ""],
    "hogfish" => [0, "", ""],
    "hognoses" => [1, "", ""],
    "holeless" => [0, "", ""],
    "hollandaises" => [1, "", ""],
    "holophrases" => [1, "", ""],
    "homefolk" => [0, "", ""],
    "homeless" => [0, "", ""],
    "homeostases" => [2, "is", "IS"],
    "homolyses" => [2, "is", "IS"],
    "homotaxes" => [2, "is", "IS"],
    "homozygoses" => [2, "is", "IS"],
    "homunculi" => [1, "us", "US"],
    "hondling" => [0, "", ""],
    "honeyless" => [0, "", ""],
    "honorless" => [0, "", ""],
    "honourless" => [0, "", ""],
    "hoodless" => [0, "", ""],
    "hoofless" => [0, "", ""],
    "hookless" => [0, "", ""],
    "hooknoses" => [1, "", ""],
    "hoopless" => [0, "", ""],
    "hoopoes" => [1, "", ""],
    "hopeless" => [0, "", ""],
    "hordeola" => [1, "um", "UM"],
    "horizonless" => [0, "", ""],
    "hormogonia" => [1, "um", "UM"],
    "hornless" => [0, "", ""],
    "horses" => [1, "", ""],
    "horsefish" => [0, "", ""],
    "horseflesh" => [0, "", ""],
    "horseless" => [0, "", ""],
    "horsepower" => [0, "", ""],
    "horseshoes" => [1, "", ""],
    "hoses" => [1, "", ""],
    "hostelling" => [0, "", ""],
    "hoteling" => [0, "", ""],
    "hothouses" => [1, "", ""],
    "hotties" => [1, "", ""],
    "houndfish" => [0, "", ""],
    "hourless" => [0, "", ""],
    "houses" => [1, "", ""],
    "houseless" => [0, "", ""],
    "houseling" => [0, "", ""],
    "houselling" => [0, "", ""],
    "housewives" => [3, "fe", "FE"],
    "hoveling" => [0, "", ""],
    "hovelling" => [0, "", ""],
    "hovercraft" => [0, "", ""],
    "howling" => [0, "", ""],
    "howtowdies" => [1, "", ""],
    "huaraches" => [1, "", ""],
    "hueless" => [0, "", ""],
    "huies" => [2, "", ""],
    "huisaches" => [1, "", ""],
    "humeri" => [1, "us", "US"],
    "humlies" => [1, "", ""],
    "humorless" => [0, "", ""],
    "humourless" => [0, "", ""],
    "humpless" => [0, "", ""],
    "hurtless" => [0, "", ""],
    "hurtling" => [0, "", ""],
    "husbandless" => [0, "", ""],
    "hyaluronidases" => [1, "", ""],
    "hydrases" => [1, "", ""],
    "hydrocephali" => [1, "us", "US"],
    "hydrogenases" => [1, "", ""],
    "hydrogenolyses" => [2, "is", "IS"],
    "hydrolases" => [1, "", ""],
    "hydrolyses" => [2, "is", "IS"],
    "hydrosomata" => [2, "", ""],
    "hydrotaxes" => [2, "is", "IS"],
    "hydroxylases" => [1, "", ""],
    "hymnless" => [0, "", ""],
    "hypercatalexes" => [2, "is", "IS"],
    "hyperhidroses" => [2, "is", "IS"],
    "hyperkeratoses" => [2, "is", "IS"],
    "hyperkineses" => [2, "is", "IS"],
    "hyperostoses" => [2, "is", "IS"],
    "hypervitaminoses" => [2, "is", "IS"],
    "hyphenless" => [0, "", ""],
    "hypnoanalyses" => [2, "is", "IS"],
    "hypnogeneses" => [2, "is", "IS"],
    "hypnoses" => [2, "is", "IS"],
    "hypochondriases" => [2, "is", "IS"],
    "hypochondria" => [1, "um", "UM"],
    "hypogea" => [1, "um", "UM"],
    "hypopharynges" => [3, "x", "X"],
    "hypophyses" => [2, "is", "IS"],
    "hypostrophes" => [1, "", ""],
    "hypotaxes" => [2, "is", "IS"],
    "hypotenuses" => [1, "", ""],
    "hypothalami" => [1, "us", "US"],
    "hypothenuses" => [1, "", ""],
    "hypotheses" => [2, "is", "IS"],
    "hystereses" => [2, "is", "IS"],
    "hythes" => [1, "", ""],
    "ibex" => [0, "", ""],
    "ibis" => [0, "", ""],
    "icefish" => [0, "", ""],
    "icefloes" => [1, "", ""],
    "icehouses" => [1, "", ""],
    "iceless" => [0, "", ""],
    "ichthyoses" => [2, "is", "IS"],
    "iconostases" => [2, "is", "IS"],
    "icositetrahedra" => [1, "on", "ON"],
    "idealess" => [0, "", ""],
    "idealless" => [0, "", ""],
    "idlesses" => [1, "", ""],
    "idling" => [0, "", ""],
    "idocrases" => [1, "", ""],
    "ileitides" => [3, "s", "S"],
    "ilea" => [1, "um", "UM"],
    "ilia" => [1, "um", "UM"],
    "illuminati" => [1, "us", "US"],
    "imageless" => [0, "", ""],
    "imbrices" => [4, "ex", "EX"],
    "immunodiagnoses" => [2, "is", "IS"],
    "immunoelectrophoreses" => [2, "is", "IS"],
    "immunogeneses" => [2, "is", "IS"],
    "impanelling" => [0, "", ""],
    "impasses" => [1, "", ""],
    "impatiens" => [0, "", ""],
    "impelling" => [0, "", ""],
    "imperilling" => [0, "", ""],
    "impluvia" => [1, "um", "UM"],
    "importless" => [0, "", ""],
    "impreses" => [1, "", ""],
    "impulses" => [1, "", ""],
    "incenses" => [1, "", ""],
    "increases" => [1, "", ""],
    "incunabula" => [1, "um", "UM"],
    "indexless" => [0, "", ""],
    "indies" => [1, "", ""],
    "indusia" => [1, "um", "UM"],
    "inflectionless" => [0, "", ""],
    "infundibula" => [1, "um", "UM"],
    "initialling" => [0, "", ""],
    "inkfish" => [0, "", ""],
    "inkless" => [0, "", ""],
    "inkling" => [0, "", ""],
    "innless" => [0, "", ""],
    "insignia" => [2, "e", "E"],
    "installing" => [0, "", ""],
    "instilling" => [0, "", ""],
    "interambulacra" => [1, "um", "UM"],
    "intercourses" => [1, "", ""],
    "interkineses" => [2, "is", "IS"],
    "interleaves" => [3, "f", "F"],
    "intermissionless" => [0, "", ""],
    "interphases" => [1, "", ""],
    "interradii" => [1, "us", "US"],
    "interreligious" => [0, "", ""],
    "interstimuli" => [1, "us", "US"],
    "interties" => [1, "", ""],
    "inthralling" => [0, "", ""],
    "inti" => [1, "o", "O"],
    "intuses" => [1, "", ""],
    "inulases" => [1, "", ""],
    "inverses" => [1, "", ""],
    "invertases" => [1, "", ""],
    "iontophoreses" => [2, "is", "IS"],
    "ireless" => [0, "", ""],
    "ischia" => [1, "um", "UM"],
    "isleless" => [0, "", ""],
    "isling" => [0, "", ""],
    "isobases" => [1, "", ""],
    "isodoma" => [1, "um", "UM"],
    "isodoses" => [1, "", ""],
    "isomerases" => [1, "", ""],
    "issueless" => [0, "", ""],
    "ithyphalli" => [1, "us", "US"],
    "jacinthes" => [1, "", ""],
    "jacketless" => [0, "", ""],
    "jackfish" => [0, "", ""],
    "jackknives" => [3, "fe", "FE"],
    "jacksnipe" => [0, "", ""],
    "jagless" => [0, "", ""],
    "jailhouses" => [1, "", ""],
    "jalouses" => [1, "", ""],
    "jalousies" => [1, "", ""],
    "jarless" => [0, "", ""],
    "jarvies" => [1, "", ""],
    "jawfish" => [0, "", ""],
    "jawless" => [0, "", ""],
    "jejuna" => [1, "um", "UM"],
    "jellyfish" => [0, "", ""],
    "jessies" => [1, "", ""],
    "jewelfish" => [0, "", ""],
    "jewelling" => [0, "", ""],
    "jewfish" => [0, "", ""],
    "jobless" => [0, "", ""],
    "jodelling" => [0, "", ""],
    "jointless" => [0, "", ""],
    "jokeless" => [0, "", ""],
    "joling" => [0, "", ""],
    "journaleses" => [1, "", ""],
    "journalling" => [0, "", ""],
    "joyless" => [0, "", ""],
    "jugula" => [1, "um", "UM"],
    "juiceless" => [0, "", ""],
    "juryless" => [0, "", ""],
    "justling" => [0, "", ""],
    "kalanchoes" => [1, "", ""],
    "kales" => [2, "is", "IS"],
    "kalewives" => [3, "fe", "FE"],
    "kamikazes" => [1, "", ""],
    "karyokineses" => [2, "is", "IS"],
    "katabases" => [2, "is", "IS"],
    "katharses" => [2, "is", "IS"],
    "kebbies" => [1, "", ""],
    "keckling" => [0, "", ""],
    "keelies" => [1, "", ""],
    "keelless" => [0, "", ""],
    "keeperless" => [0, "", ""],
    "kegling" => [0, "", ""],
    "kennelling" => [0, "", ""],
    "kenoses" => [2, "is", "IS"],
    "keratitides" => [3, "s", "S"],
    "keratoses" => [2, "is", "IS"],
    "kermesses" => [1, "", ""],
    "kerneling" => [0, "", ""],
    "kernelling" => [0, "", ""],
    "ketogeneses" => [2, "is", "IS"],
    "ketoses" => [2, "is", "IS"],
    "keyless" => [0, "", ""],
    "kibbes" => [2, "is", "IS"],
    "kibbutzim" => [2, "", ""],
    "kickless" => [0, "", ""],
    "kiddiewinkies" => [1, "", ""],
    "kidling" => [0, "", ""],
    "killies" => [1, "", ""],
    "killogies" => [1, "", ""],
    "kilobases" => [1, "", ""],
    "kilobaud" => [0, "", ""],
    "kilocalories" => [1, "", ""],
    "kilocuries" => [1, "", ""],
    "kilohertz" => [0, "", ""],
    "kin" => [0, "", ""],
    "kinases" => [1, "", ""],
    "kindless" => [0, "", ""],
    "kindling" => [0, "", ""],
    "kineses" => [2, "is", "IS"],
    "kinestheses" => [2, "is", "IS"],
    "kingdomless" => [0, "", ""],
    "kingfish" => [0, "", ""],
    "kingless" => [0, "", ""],
    "kingling" => [0, "", ""],
    "kinless" => [0, "", ""],
    "kip" => [0, "", ""],
    "kitling" => [0, "", ""],
    "kneeling" => [0, "", ""],
    "knives" => [3, "fe", "FE"],
    "knifeless" => [0, "", ""],
    "knightless" => [0, "", ""],
    "knotless" => [0, "", ""],
    "knurling" => [0, "", ""],
    "kohlrabies" => [0, "", ""],
    "koories" => [2, "", ""],
    "koppies" => [1, "", ""],
    "kronur" => [2, "a", "A"],
    "kuchen" => [0, "", ""],
    "kurtoses" => [2, "is", "IS"],
    "kuri" => [1, "us", "US"],
    "kylies" => [1, "", ""],
    "kylices" => [3, "x", "X"],
    "kyloes" => [1, "", ""],
    "kyphoses" => [2, "is", "IS"],
    "labelling" => [0, "", ""],
    "labella" => [1, "um", "UM"],
    "labia" => [1, "um", "UM"],
    "laceless" => [0, "", ""],
    "lacrosses" => [1, "", ""],
    "lactases" => [1, "", ""],
    "lacteal" => [0, "", ""],
    "lactobacilli" => [1, "us", "US"],
    "lactoses" => [1, "", ""],
    "laddies" => [1, "", ""],
    "ladling" => [0, "", ""],
    "ladyfish" => [0, "", ""],
    "ladyless" => [0, "", ""],
    "lambling" => [0, "", ""],
    "lampless" => [0, "", ""],
    "lancetfish" => [0, "", ""],
    "landless" => [0, "", ""],
    "languageless" => [0, "", ""],
    "lanternfish" => [0, "", ""],
    "lapilli" => [1, "us", "US"],
    "lapses" => [1, "", ""],
    "laquei" => [1, "us", "US"],
    "largesses" => [1, "", ""],
    "laryngitides" => [3, "s", "S"],
    "larynges" => [3, "x", "X"],
    "lassies" => [1, "", ""],
    "lassi" => [1, "us", "US"],
    "lateralling" => [0, "", ""],
    "latices" => [4, "ex", "EX"],
    "lathes" => [2, "is", "IS"],
    "latifundia" => [1, "um", "UM"],
    "latticini" => [1, "o", "O"],
    "laurelling" => [0, "", ""],
    "lawless" => [0, "", ""],
    "laypeople" => [4, "rson", "RSON"],
    "lazes" => [1, "", ""],
    "leaderless" => [0, "", ""],
    "leadfeet" => [3, "oot", "OOT"],
    "leadless" => [0, "", ""],
    "leafless" => [0, "", ""],
    "leakless" => [0, "", ""],
    "leases" => [1, "", ""],
    "leatherfish" => [0, "", ""],
    "leatherleaves" => [3, "f", "F"],
    "lecithinases" => [1, "", ""],
    "lecythi" => [1, "us", "US"],
    "lees" => [2, "is", "IS"],
    "legaleses" => [1, "", ""],
    "legless" => [0, "", ""],
    "leishmaniases" => [2, "is", "IS"],
    "leishmanioses" => [2, "is", "IS"],
    "lekythi" => [1, "us", "US"],
    "lemnisci" => [1, "us", "US"],
    "lemonfish" => [0, "", ""],
    "lenes" => [2, "is", "IS"],
    "lensless" => [0, "", ""],
    "lepidoptera" => [1, "on", "ON"],
    "lepta" => [1, "on", "ON"],
    "leptospiroses" => [2, "is", "IS"],
    "less" => [0, "", ""],
    "lethes" => [1, "", ""],
    "letterless" => [0, "", ""],
    "leucocytoses" => [2, "is", "IS"],
    "leucoses" => [2, "is", "IS"],
    "leukaemogeneses" => [2, "is", "IS"],
    "leukemogeneses" => [2, "is", "IS"],
    "leukocytoses" => [2, "is", "IS"],
    "leukopoieses" => [2, "is", "IS"],
    "leukoses" => [2, "is", "IS"],
    "leveling" => [0, "", ""],
    "levelling" => [0, "", ""],
    "levuloses" => [1, "", ""],
    "lezzes" => [3, "", ""],
    "libelling" => [0, "", ""],
    "licenses" => [1, "", ""],
    "liches" => [2, "is", "IS"],
    "lidless" => [0, "", ""],
    "lies" => [1, "", ""],
    "lieder" => [2, "", ""],
    "liegeless" => [0, "", ""],
    "lives" => [3, "fe", "FE"],
    "lifeless" => [0, "", ""],
    "ligases" => [1, "", ""],
    "lighthouses" => [1, "", ""],
    "lightless" => [0, "", ""],
    "lignocelluloses" => [1, "", ""],
    "limbless" => [0, "", ""],
    "limeless" => [0, "", ""],
    "limitless" => [0, "", ""],
    "lineless" => [0, "", ""],
    "linerless" => [0, "", ""],
    "ling" => [0, "", ""],
    "lingeries" => [1, "", ""],
    "linguine" => [0, "", ""],
    "linguini" => [0, "", ""],
    "linguines" => [2, "is", "IS"],
    "lintless" => [0, "", ""],
    "lionfish" => [0, "", ""],
    "lipases" => [1, "", ""],
    "lipless" => [0, "", ""],
    "lipogeneses" => [2, "is", "IS"],
    "lipolyses" => [2, "is", "IS"],
    "lire" => [1, "a", "A"],
    "lisses" => [3, "", ""],
    "listerioses" => [2, "is", "IS"],
    "listless" => [0, "", ""],
    "literati" => [1, "us", "US"],
    "lithiases" => [2, "is", "IS"],
    "liverleaves" => [3, "f", "F"],
    "lizardfish" => [0, "", ""],
    "loadless" => [0, "", ""],
    "loaves" => [3, "f", "F"],
    "loamless" => [0, "", ""],
    "lobscouses" => [1, "", ""],
    "lobster" => [0, "", ""],
    "lobuli" => [1, "us", "US"],
    "lobi" => [1, "us", "US"],
    "localing" => [0, "", ""],
    "localling" => [0, "", ""],
    "lockless" => [0, "", ""],
    "loculi" => [1, "us", "US"],
    "loci" => [1, "us", "US"],
    "loftless" => [0, "", ""],
    "longhouses" => [1, "", ""],
    "longleaves" => [3, "f", "F"],
    "looies" => [1, "", ""],
    "lordless" => [0, "", ""],
    "lordling" => [0, "", ""],
    "lordoses" => [2, "is", "IS"],
    "loreless" => [0, "", ""],
    "louies" => [1, "", ""],
    "lice" => [3, "ouse", "OUSE"],
    "lovechildren" => [3, "", ""],
    "loveless" => [0, "", ""],
    "loverless" => [0, "", ""],
    "lowercases" => [1, "", ""],
    "lox" => [0, "", ""],
    "luciferases" => [1, "", ""],
    "luckless" => [0, "", ""],
    "luggies" => [1, "", ""],
    "lumpfish" => [0, "", ""],
    "lunges" => [2, "is", "IS"],
    "lungies" => [1, "", ""],
    "lusterless" => [0, "", ""],
    "lustless" => [0, "", ""],
    "lustreless" => [0, "", ""],
    "lutea" => [1, "um", "UM"],
    "luxes" => [1, "", ""],
    "lyases" => [1, "", ""],
    "lymphocytoses" => [2, "is", "IS"],
    "lymphogranulomatoses" => [2, "is", "IS"],
    "lymphomatoses" => [2, "is", "IS"],
    "lymphopoieses" => [2, "is", "IS"],
    "lynx" => [0, "", ""],
    "lyolyses" => [2, "is", "IS"],
    "lyses" => [2, "is", "IS"],
    "lythes" => [1, "", ""],
    "maches" => [1, "", ""],
    "machineless" => [0, "", ""],
    "mackerel" => [0, "", ""],
    "mackling" => [0, "", ""],
    "macroaxes" => [2, "is", "IS"],
    "macrocytoses" => [2, "is", "IS"],
    "macronuclei" => [1, "us", "US"],
    "macrosporangia" => [1, "um", "UM"],
    "mesdames" => [7, "adame", "ADAME"],
    "madhouses" => [1, "", ""],
    "madling" => [0, "", ""],
    "mafiosi" => [1, "o", "O"],
    "magnetopauses" => [1, "", ""],
    "magnetotaxes" => [2, "is", "IS"],
    "magpies" => [1, "", ""],
    "mahoes" => [1, "", ""],
    "mailless" => [0, "", ""],
    "mainprises" => [1, "", ""],
    "maises" => [1, "", ""],
    "maizes" => [1, "", ""],
    "makeless" => [0, "", ""],
    "malaises" => [1, "", ""],
    "males" => [2, "is", "IS"],
    "malleoli" => [1, "us", "US"],
    "malling" => [0, "", ""],
    "maltases" => [1, "", ""],
    "maltoses" => [1, "", ""],
    "malvoisies" => [1, "", ""],
    "mamies" => [1, "", ""],
    "mammati" => [1, "us", "US"],
    "mammitides" => [3, "s", "S"],
    "manches" => [1, "", ""],
    "maneless" => [0, "", ""],
    "manganeses" => [1, "", ""],
    "mangling" => [0, "", ""],
    "manless" => [0, "", ""],
    "mannerless" => [0, "", ""],
    "mannoses" => [1, "", ""],
    "manses" => [1, "", ""],
    "menservants" => [10, "anservant", "ANSERVANT"],
    "mantelshelves" => [3, "f", "F"],
    "marcelling" => [0, "", ""],
    "marcheses" => [1, "", ""],
    "marlin" => [0, "", ""],
    "marling" => [0, "", ""],
    "marmoses" => [1, "", ""],
    "marqueteries" => [1, "", ""],
    "marquises" => [1, "", ""],
    "marries" => [2, "", ""],
    "marrowless" => [0, "", ""],
    "marsupia" => [1, "um", "UM"],
    "mara" => [1, "um", "UM"],
    "marvelling" => [0, "", ""],
    "masseuses" => [1, "", ""],
    "massless" => [0, "", ""],
    "masterless" => [0, "", ""],
    "mastiches" => [1, "", ""],
    "mastitides" => [3, "s", "S"],
    "mastless" => [0, "", ""],
    "mastoiditides" => [3, "s", "S"],
    "matchless" => [0, "", ""],
    "matelasses" => [1, "", ""],
    "mateless" => [0, "", ""],
    "matless" => [0, "", ""],
    "matrices" => [3, "x", "X"],
    "matterless" => [0, "", ""],
    "matzoth" => [2, "", ""],
    "mavies" => [1, "", ""],
    "maxes" => [2, "is", "IS"],
    "maxixes" => [1, "", ""],
    "mayfish" => [0, "", ""],
    "mayonnaises" => [1, "", ""],
    "mazaedia" => [1, "um", "UM"],
    "mazes" => [1, "", ""],
    "mealless" => [0, "", ""],
    "meaningless" => [0, "", ""],
    "measureless" => [0, "", ""],
    "meathes" => [1, "", ""],
    "meatless" => [0, "", ""],
    "meatloaves" => [3, "f", "F"],
    "meconopses" => [2, "is", "IS"],
    "medalling" => [0, "", ""],
    "mediastina" => [1, "um", "UM"],
    "media" => [1, "um", "UM"],
    "meemies" => [1, "", ""],
    "meetinghouses" => [1, "", ""],
    "megadoses" => [1, "", ""],
    "megahertz" => [0, "", ""],
    "megasporangia" => [1, "um", "UM"],
    "megasporogeneses" => [2, "is", "IS"],
    "megasses" => [1, "", ""],
    "meioses" => [2, "is", "IS"],
    "melanogeneses" => [2, "is", "IS"],
    "melanoses" => [2, "is", "IS"],
    "melling" => [0, "", ""],
    "memberless" => [0, "", ""],
    "menageries" => [1, "", ""],
    "menarches" => [1, "", ""],
    "menhaden" => [0, "", ""],
    "meningitides" => [3, "s", "S"],
    "meningococci" => [1, "us", "US"],
    "meningoencephalitides" => [3, "s", "S"],
    "meninges" => [3, "x", "X"],
    "menisci" => [1, "us", "US"],
    "menopauses" => [1, "", ""],
    "menseless" => [0, "", ""],
    "merchandises" => [1, "", ""],
    "mericarp" => [0, "", ""],
    "merises" => [2, "is", "IS"],
    "meritless" => [0, "", ""],
    "meses" => [1, "", ""],
    "mesogastria" => [1, "um", "UM"],
    "mesopauses" => [1, "", ""],
    "mesothelia" => [1, "um", "UM"],
    "metabases" => [2, "is", "IS"],
    "metacarpi" => [1, "us", "US"],
    "metageneses" => [2, "is", "IS"],
    "metairies" => [1, "", ""],
    "metalepses" => [2, "is", "IS"],
    "metaling" => [0, "", ""],
    "metamorphoses" => [2, "is", "IS"],
    "metanalyses" => [2, "is", "IS"],
    "metaphases" => [1, "", ""],
    "metaphrases" => [2, "is", "IS"],
    "metasomatoses" => [2, "is", "IS"],
    "metastases" => [2, "is", "IS"],
    "metatarsi" => [1, "us", "US"],
    "metatheses" => [2, "is", "IS"],
    "metempsychoses" => [2, "is", "IS"],
    "methylases" => [1, "", ""],
    "methylcelluloses" => [1, "", ""],
    "metisses" => [1, "", ""],
    "mewling" => [0, "", ""],
    "mezes" => [1, "", ""],
    "mezzes" => [1, "", ""],
    "microanalyses" => [2, "is", "IS"],
    "micrococci" => [1, "us", "US"],
    "microcuries" => [1, "", ""],
    "microelectrophoreses" => [2, "is", "IS"],
    "microfiche" => [0, "", ""],
    "microfungi" => [1, "us", "US"],
    "micronuclei" => [1, "us", "US"],
    "microsporangia" => [1, "um", "UM"],
    "microsporogeneses" => [2, "is", "IS"],
    "microvilli" => [1, "us", "US"],
    "midcourses" => [1, "", ""],
    "midlives" => [3, "fe", "FE"],
    "midwives" => [3, "fe", "FE"],
    "military" => [0, "", ""],
    "milia" => [1, "um", "UM"],
    "milkfish" => [0, "", ""],
    "milkless" => [0, "", ""],
    "milkshake" => [0, "", ""],
    "millicuries" => [1, "", ""],
    "milling" => [0, "", ""],
    "mimeses" => [2, "is", "IS"],
    "minauderies" => [1, "", ""],
    "mindless" => [0, "", ""],
    "mines" => [2, "is", "IS"],
    "mingling" => [0, "", ""],
    "minicourses" => [1, "", ""],
    "miniseries" => [0, "", ""],
    "ministeria" => [1, "um", "UM"],
    "mink" => [0, "", ""],
    "mioses" => [2, "is", "IS"],
    "miracidia" => [1, "um", "UM"],
    "mirthless" => [0, "", ""],
    "misanalyses" => [2, "is", "IS"],
    "mischannelling" => [0, "", ""],
    "miscounselling" => [0, "", ""],
    "misdiagnoses" => [2, "is", "IS"],
    "misdialling" => [0, "", ""],
    "mises" => [1, "", ""],
    "miseases" => [1, "", ""],
    "misemphases" => [2, "is", "IS"],
    "misenrolling" => [0, "", ""],
    "misfuelling" => [0, "", ""],
    "mislabelling" => [0, "", ""],
    "missenses" => [1, "", ""],
    "mistletoes" => [1, "", ""],
    "mistling" => [0, "", ""],
    "mistressless" => [0, "", ""],
    "mistrustless" => [0, "", ""],
    "misuses" => [1, "", ""],
    "mitochondria" => [1, "on", "ON"],
    "mitoses" => [2, "is", "IS"],
    "mitrailleuses" => [1, "", ""],
    "mizmazes" => [1, "", ""],
    "mizzling" => [0, "", ""],
    "modeling" => [0, "", ""],
    "modelling" => [0, "", ""],
    "modii" => [1, "us", "US"],
    "moduli" => [1, "us", "US"],
    "modi" => [1, "us", "US"],
    "moiling" => [0, "", ""],
    "moistureless" => [0, "", ""],
    "molasses" => [3, "", ""],
    "mollusca" => [1, "um", "UM"],
    "molossi" => [1, "us", "US"],
    "momenta" => [1, "um", "UM"],
    "moneyless" => [0, "", ""],
    "mongoes" => [1, "", ""],
    "mongooses" => [1, "", ""],
    "moniliases" => [2, "is", "IS"],
    "monkfish" => [0, "", ""],
    "monocarp" => [0, "", ""],
    "monochasia" => [1, "um", "UM"],
    "monocytoses" => [2, "is", "IS"],
    "monogeneses" => [2, "is", "IS"],
    "monokines" => [2, "is", "IS"],
    "mononucleoses" => [2, "is", "IS"],
    "monostrophes" => [1, "", ""],
    "messeigneurs" => [11, "onseigneur", "ONSEIGNEUR"],
    "messieurs" => [8, "onsieur", "ONSIEUR"],
    "moolvies" => [1, "", ""],
    "mooncalves" => [3, "f", "F"],
    "moonfish" => [0, "", ""],
    "moonless" => [0, "", ""],
    "moonrises" => [1, "", ""],
    "moorfowl" => [0, "", ""],
    "moose" => [0, "", ""],
    "moothouses" => [1, "", ""],
    "moralling" => [0, "", ""],
    "moriches" => [1, "", ""],
    "morling" => [0, "", ""],
    "morphallaxes" => [2, "is", "IS"],
    "morphogeneses" => [2, "is", "IS"],
    "morphoses" => [2, "is", "IS"],
    "morses" => [1, "", ""],
    "morseling" => [0, "", ""],
    "morselling" => [0, "", ""],
    "mortarless" => [0, "", ""],
    "mortises" => [1, "", ""],
    "mortling" => [0, "", ""],
    "mosasauri" => [1, "us", "US"],
    "mosquitofish" => [0, "", ""],
    "motherhouses" => [1, "", ""],
    "motherless" => [0, "", ""],
    "motionless" => [0, "", ""],
    "motiveless" => [0, "", ""],
    "motorless" => [0, "", ""],
    "motoscafi" => [1, "o", "O"],
    "mottling" => [0, "", ""],
    "mice" => [3, "ouse", "OUSE"],
    "mousling" => [0, "", ""],
    "mousses" => [1, "", ""],
    "moustaches" => [1, "", ""],
    "mouthless" => [0, "", ""],
    "moveless" => [0, "", ""],
    "movies" => [1, "", ""],
    "moxies" => [1, "", ""],
    "mozzies" => [1, "", ""],
    "mucoviscidoses" => [2, "is", "IS"],
    "mudfish" => [0, "", ""],
    "muffling" => [0, "", ""],
    "muling" => [0, "", ""],
    "multicourses" => [1, "", ""],
    "multireligious" => [0, "", ""],
    "multiton" => [0, "", ""],
    "mungooses" => [1, "", ""],
    "muppies" => [1, "", ""],
    "muses" => [1, "", ""],
    "muskellunge" => [0, "", ""],
    "muskoxen" => [2, "", ""],
    "mustaches" => [1, "", ""],
    "mutageneses" => [2, "is", "IS"],
    "mutases" => [1, "", ""],
    "muttonfish" => [0, "", ""],
    "myases" => [2, "is", "IS"],
    "mycelia" => [1, "um", "UM"],
    "mycobacteria" => [1, "um", "UM"],
    "mycodomatia" => [1, "um", "UM"],
    "mycoses" => [2, "is", "IS"],
    "mydriases" => [2, "is", "IS"],
    "myelitides" => [3, "s", "S"],
    "myelofibroses" => [2, "is", "IS"],
    "myiases" => [2, "is", "IS"],
    "myoses" => [2, "is", "IS"],
    "mythopoeses" => [2, "is", "IS"],
    "myxobacteria" => [1, "um", "UM"],
    "myxomatoses" => [2, "is", "IS"],
    "nabes" => [2, "is", "IS"],
    "naches" => [1, "", ""],
    "naevi" => [1, "us", "US"],
    "nailless" => [0, "", ""],
    "nameless" => [0, "", ""],
    "napless" => [0, "", ""],
    "narcissus" => [0, "", ""],
    "narcoanalyses" => [2, "is", "IS"],
    "narcoses" => [2, "is", "IS"],
    "narcosyntheses" => [2, "is", "IS"],
    "nares" => [2, "is", "IS"],
    "nartjies" => [1, "", ""],
    "nationless" => [0, "", ""],
    "natriureses" => [2, "is", "IS"],
    "nauplii" => [1, "us", "US"],
    "nazes" => [2, "is", "IS"],
    "neat" => [0, "", ""],
    "nebbishes" => [1, "", ""],
    "neckless" => [0, "", ""],
    "neckties" => [1, "", ""],
    "necrobioses" => [2, "is", "IS"],
    "necroses" => [2, "is", "IS"],
    "nectocalyces" => [3, "x", "X"],
    "needlefish" => [0, "", ""],
    "needless" => [0, "", ""],
    "needling" => [0, "", ""],
    "neighborless" => [0, "", ""],
    "neighbourless" => [0, "", ""],
    "nemeses" => [2, "is", "IS"],
    "neocortices" => [4, "ex", "EX"],
    "neogeneses" => [2, "is", "IS"],
    "nepenthes" => [1, "", ""],
    "nephritides" => [3, "s", "S"],
    "nephroses" => [2, "is", "IS"],
    "nerveless" => [0, "", ""],
    "nestling" => [0, "", ""],
    "netless" => [0, "", ""],
    "nettlefish" => [0, "", ""],
    "nettling" => [0, "", ""],
    "neuraminidases" => [1, "", ""],
    "neuritides" => [3, "s", "S"],
    "neurofibromatoses" => [2, "is", "IS"],
    "neurogeneses" => [2, "is", "IS"],
    "neurohypophyses" => [2, "is", "IS"],
    "neuroses" => [2, "is", "IS"],
    "neutrinoless" => [0, "", ""],
    "nevelling" => [0, "", ""],
    "nevi" => [1, "us", "US"],
    "newbies" => [1, "", ""],
    "newies" => [1, "", ""],
    "newsless" => [0, "", ""],
    "newspeople" => [4, "rson", "RSON"],
    "niches" => [1, "", ""],
    "nickelling" => [0, "", ""],
    "nickling" => [0, "", ""],
    "niggerling" => [0, "", ""],
    "nightfowl" => [0, "", ""],
    "nightless" => [0, "", ""],
    "nilgai" => [1, "us", "US"],
    "nilghai" => [1, "us", "US"],
    "nilling" => [0, "", ""],
    "nimbostrati" => [1, "us", "US"],
    "nimbi" => [1, "us", "US"],
    "nisses" => [1, "", ""],
    "nisei" => [0, "", ""],
    "nitchies" => [1, "", ""],
    "nitrobacteria" => [1, "um", "UM"],
    "nitrocelluloses" => [1, "", ""],
    "nitrogenases" => [1, "", ""],
    "noblesses" => [1, "", ""],
    "nodi" => [1, "us", "US"],
    "noeses" => [2, "is", "IS"],
    "noises" => [1, "", ""],
    "noiseless" => [0, "", ""],
    "na" => [1, "on", "ON"],
    "noncrises" => [2, "is", "IS"],
    "nonelect" => [0, "", ""],
    "nonintercourses" => [1, "", ""],
    "nonlives" => [3, "fe", "FE"],
    "nonmilitary" => [0, "", ""],
    "nonpolice" => [0, "", ""],
    "nonreligious" => [0, "", ""],
    "nonresponses" => [1, "", ""],
    "nonselves" => [3, "f", "F"],
    "nonsenses" => [1, "", ""],
    "nonuses" => [1, "", ""],
    "nooses" => [1, "", ""],
    "normless" => [0, "", ""],
    "noses" => [1, "", ""],
    "noseless" => [0, "", ""],
    "notanda" => [1, "um", "UM"],
    "notchelling" => [0, "", ""],
    "notecases" => [1, "", ""],
    "noteless" => [0, "", ""],
    "notturni" => [1, "o", "O"],
    "noumena" => [1, "on", "ON"],
    "nounless" => [0, "", ""],
    "nousling" => [0, "", ""],
    "noveleses" => [1, "", ""],
    "nova" => [1, "um", "UM"],
    "nucleases" => [1, "", ""],
    "nucleoli" => [1, "us", "US"],
    "nucleosyntheses" => [2, "is", "IS"],
    "nucleotidases" => [1, "", ""],
    "nuclei" => [1, "us", "US"],
    "nudies" => [1, "", ""],
    "numberless" => [0, "", ""],
    "numbfish" => [0, "", ""],
    "nurdling" => [0, "", ""],
    "nurling" => [0, "", ""],
    "nurses" => [1, "", ""],
    "nurseling" => [0, "", ""],
    "nursling" => [0, "", ""],
    "nutcases" => [1, "", ""],
    "nuthouses" => [1, "", ""],
    "nylghai" => [1, "us", "US"],
    "oakling" => [0, "", ""],
    "oarfish" => [0, "", ""],
    "oarless" => [0, "", ""],
    "oases" => [2, "is", "IS"],
    "oasthouses" => [1, "", ""],
    "obes" => [2, "is", "IS"],
    "obeches" => [1, "", ""],
    "obeli" => [1, "us", "US"],
    "objectless" => [0, "", ""],
    "oboes" => [1, "", ""],
    "oboli" => [1, "us", "US"],
    "obverses" => [1, "", ""],
    "ocelli" => [1, "us", "US"],
    "octonarii" => [1, "us", "US"],
    "oculi" => [1, "us", "US"],
    "odorless" => [0, "", ""],
    "odourless" => [0, "", ""],
    "oesophagi" => [1, "us", "US"],
    "offenceless" => [0, "", ""],
    "offenses" => [1, "", ""],
    "offenseless" => [0, "", ""],
    "officialeses" => [1, "", ""],
    "offish" => [0, "", ""],
    "offspring" => [0, "", ""],
    "oidia" => [1, "um", "UM"],
    "oilfish" => [0, "", ""],
    "oiling" => [0, "", ""],
    "oes" => [2, "is", "IS"],
    "oldwives" => [3, "fe", "FE"],
    "oligoclases" => [1, "", ""],
    "omasa" => [1, "um", "UM"],
    "ommatea" => [1, "um", "UM"],
    "ommatidia" => [1, "um", "UM"],
    "omphaloskepses" => [2, "is", "IS"],
    "omphali" => [1, "us", "US"],
    "onchocerciases" => [2, "is", "IS"],
    "oncogeneses" => [2, "is", "IS"],
    "onomatopoeses" => [2, "is", "IS"],
    "onomatopoieses" => [2, "is", "IS"],
    "ontogeneses" => [2, "is", "IS"],
    "onychia" => [1, "um", "UM"],
    "onycholyses" => [2, "is", "IS"],
    "oogeneses" => [2, "is", "IS"],
    "ooses" => [1, "", ""],
    "oozes" => [1, "", ""],
    "operatorless" => [0, "", ""],
    "opposeless" => [0, "", ""],
    "optima" => [1, "um", "UM"],
    "opera" => [3, "us", "US"],
    "opuscula" => [1, "um", "UM"],
    "oraches" => [1, "", ""],
    "orbiculares" => [2, "is", "IS"],
    "orbless" => [0, "", ""],
    "orderless" => [0, "", ""],
    "organogeneses" => [2, "is", "IS"],
    "oribis" => [0, "", ""],
    "ornithoses" => [2, "is", "IS"],
    "orogeneses" => [2, "is", "IS"],
    "orthoaxes" => [2, "is", "IS"],
    "orthoclases" => [1, "", ""],
    "orthogeneses" => [2, "is", "IS"],
    "orthopraxes" => [2, "is", "IS"],
    "orthoses" => [2, "is", "IS"],
    "orthotoneses" => [2, "is", "IS"],
    "osmeteria" => [1, "um", "UM"],
    "osmoses" => [2, "is", "IS"],
    "osteal" => [0, "", ""],
    "osteitides" => [3, "s", "S"],
    "ostensoria" => [1, "um", "UM"],
    "osteoarthritides" => [3, "s", "S"],
    "osteoclases" => [2, "is", "IS"],
    "osteogeneses" => [2, "is", "IS"],
    "osteomyelitides" => [3, "s", "S"],
    "osteoporoses" => [2, "is", "IS"],
    "osteoses" => [2, "is", "IS"],
    "ostia" => [1, "um", "UM"],
    "ostoses" => [2, "is", "IS"],
    "ostraca" => [1, "on", "ON"],
    "ostraka" => [1, "on", "ON"],
    "otitides" => [3, "s", "S"],
    "otoscleroses" => [2, "is", "IS"],
    "ouphes" => [1, "", ""],
    "ourselves" => [3, "f", "F"],
    "oi" => [1, "us", "US"],
    "outcavilling" => [0, "", ""],
    "outduelling" => [0, "", ""],
    "outgeneralling" => [0, "", ""],
    "outhouses" => [1, "", ""],
    "outrivalling" => [0, "", ""],
    "outsizes" => [1, "", ""],
    "outtravelling" => [0, "", ""],
    "outwrestling" => [0, "", ""],
    "ovaritides" => [3, "s", "S"],
    "overanalyses" => [2, "is", "IS"],
    "overblouses" => [1, "", ""],
    "overcontrolling" => [0, "", ""],
    "overdoses" => [1, "", ""],
    "overemphases" => [2, "is", "IS"],
    "overhandling" => [0, "", ""],
    "overneat" => [0, "", ""],
    "overpedalling" => [0, "", ""],
    "overpraises" => [1, "", ""],
    "overshoes" => [1, "", ""],
    "oversizes" => [1, "", ""],
    "overuses" => [1, "", ""],
    "ovotestes" => [2, "is", "IS"],
    "ova" => [1, "um", "UM"],
    "owches" => [1, "", ""],
    "owling" => [0, "", ""],
    "ownerless" => [0, "", ""],
    "oxen" => [2, "", ""],
    "oxidases" => [1, "", ""],
    "oxidoreductases" => [1, "", ""],
    "oxygenases" => [1, "", ""],
    "oxygenless" => [0, "", ""],
    "oxymora" => [1, "on", "ON"],
    "oxyuriases" => [2, "is", "IS"],
    "oysterfish" => [0, "", ""],
    "packhorses" => [1, "", ""],
    "packinghouses" => [1, "", ""],
    "paddlefish" => [0, "", ""],
    "padless" => [0, "", ""],
    "paedogeneses" => [2, "is", "IS"],
    "paedomorphoses" => [2, "is", "IS"],
    "pahoehoes" => [1, "", ""],
    "paillasses" => [1, "", ""],
    "painless" => [0, "", ""],
    "palingeneses" => [2, "is", "IS"],
    "palliasses" => [1, "", ""],
    "palling" => [0, "", ""],
    "palmhouses" => [1, "", ""],
    "palpi" => [1, "us", "US"],
    "panaches" => [1, "", ""],
    "pancreatitides" => [3, "s", "S"],
    "paneling" => [0, "", ""],
    "panelling" => [0, "", ""],
    "panfish" => [0, "", ""],
    "pangeneses" => [2, "is", "IS"],
    "pangless" => [0, "", ""],
    "panini" => [1, "o", "O"],
    "panoches" => [1, "", ""],
    "paoli" => [1, "o", "O"],
    "paparazzi" => [1, "o", "O"],
    "paperknives" => [3, "fe", "FE"],
    "paperless" => [0, "", ""],
    "papeteries" => [1, "", ""],
    "papooses" => [1, "", ""],
    "pappooses" => [1, "", ""],
    "papyri" => [1, "us", "US"],
    "parabases" => [2, "is", "IS"],
    "parabemata" => [2, "", ""],
    "parabioses" => [2, "is", "IS"],
    "paracenteses" => [2, "is", "IS"],
    "paradises" => [1, "", ""],
    "parageneses" => [2, "is", "IS"],
    "paraleipses" => [2, "is", "IS"],
    "paralepses" => [2, "is", "IS"],
    "paralipomena" => [1, "on", "ON"],
    "paralipses" => [2, "is", "IS"],
    "parallelling" => [0, "", ""],
    "paralyses" => [2, "is", "IS"],
    "paramecia" => [1, "um", "UM"],
    "parameses" => [1, "", ""],
    "paramoecia" => [1, "um", "UM"],
    "paranthelia" => [1, "on", "ON"],
    "parapareses" => [2, "is", "IS"],
    "paraphrases" => [2, "is", "IS"],
    "paraphyses" => [2, "is", "IS"],
    "parapodia" => [1, "um", "UM"],
    "parapophyses" => [2, "is", "IS"],
    "parapraxes" => [2, "is", "IS"],
    "parascenia" => [1, "um", "UM"],
    "parasitoses" => [2, "is", "IS"],
    "parasyntheses" => [2, "is", "IS"],
    "parasyntheta" => [1, "on", "ON"],
    "parataxes" => [2, "is", "IS"],
    "parcelling" => [0, "", ""],
    "parcloses" => [1, "", ""],
    "pardonless" => [0, "", ""],
    "parentheses" => [2, "is", "IS"],
    "parentless" => [0, "", ""],
    "pareses" => [2, "is", "IS"],
    "parfleches" => [1, "", ""],
    "parhelia" => [1, "on", "ON"],
    "parling" => [0, "", ""],
    "parrotfish" => [0, "", ""],
    "parthenogeneses" => [2, "is", "IS"],
    "partnerless" => [0, "", ""],
    "parvises" => [1, "", ""],
    "pases" => [1, "", ""],
    "passes" => [1, "", ""],
    "passementeries" => [1, "", ""],
    "passersby" => [3, "by", "BY"],
    "passionless" => [0, "", ""],
    "passless" => [0, "", ""],
    "pastiches" => [1, "", ""],
    "pastless" => [0, "", ""],
    "pastureless" => [0, "", ""],
    "patagia" => [1, "um", "UM"],
    "patresfamilias" => [11, "erfamilias", "ERFAMILIAS"],
    "pathless" => [0, "", ""],
    "pathogeneses" => [2, "is", "IS"],
    "patisseries" => [1, "", ""],
    "patois" => [0, "", ""],
    "patooties" => [1, "", ""],
    "patrolling" => [0, "", ""],
    "patronless" => [0, "", ""],
    "patternless" => [0, "", ""],
    "pauses" => [1, "", ""],
    "pauseless" => [0, "", ""],
    "pavises" => [1, "", ""],
    "pavisses" => [1, "", ""],
    "peaceless" => [0, "", ""],
    "peakless" => [0, "", ""],
    "pealing" => [0, "", ""],
    "pearlfish" => [0, "", ""],
    "pearling" => [0, "", ""],
    "pectases" => [1, "", ""],
    "pectinesterases" => [1, "", ""],
    "pedalling" => [0, "", ""],
    "pedestalling" => [0, "", ""],
    "pediculoses" => [2, "is", "IS"],
    "pedogeneses" => [2, "is", "IS"],
    "pedomorphoses" => [2, "is", "IS"],
    "peeling" => [0, "", ""],
    "peerless" => [0, "", ""],
    "pegless" => [0, "", ""],
    "pekinese" => [0, "", ""],
    "pekingese" => [0, "", ""],
    "pekoes" => [1, "", ""],
    "pelisses" => [1, "", ""],
    "pela" => [1, "on", "ON"],
    "pelota" => [1, "on", "ON"],
    "peltless" => [0, "", ""],
    "pencilling" => [0, "", ""],
    "penicillinases" => [1, "", ""],
    "penknives" => [3, "fe", "FE"],
    "penniless" => [0, "", ""],
    "penoches" => [1, "", ""],
    "pensionless" => [0, "", ""],
    "penthouses" => [1, "", ""],
    "pentimenti" => [1, "o", "O"],
    "pentoses" => [1, "", ""],
    "penuches" => [2, "is", "IS"],
    "peopleless" => [0, "", ""],
    "peptidases" => [1, "", ""],
    "perch" => [0, "", ""],
    "peres" => [2, "is", "IS"],
    "pereia" => [1, "on", "ON"],
    "perea" => [1, "on", "ON"],
    "perfumeless" => [0, "", ""],
    "pericarditides" => [3, "s", "S"],
    "pericardia" => [1, "um", "UM"],
    "pericarp" => [0, "", ""],
    "periclases" => [1, "", ""],
    "periegeses" => [2, "is", "IS"],
    "perihelia" => [1, "on", "ON"],
    "perikarya" => [1, "on", "ON"],
    "periling" => [0, "", ""],
    "perilling" => [0, "", ""],
    "perinea" => [1, "um", "UM"],
    "periostea" => [1, "um", "UM"],
    "periphrases" => [2, "is", "IS"],
    "peristalses" => [2, "is", "IS"],
    "perithecia" => [1, "um", "UM"],
    "periti" => [1, "us", "US"],
    "permeases" => [1, "", ""],
    "peroxidases" => [1, "", ""],
    "perradii" => [1, "us", "US"],
    "perses" => [1, "", ""],
    "people" => [4, "rson", "RSON"],
    "pessimaling" => [0, "", ""],
    "pessima" => [1, "um", "UM"],
    "pesthouses" => [1, "", ""],
    "pestling" => [0, "", ""],
    "petalless" => [0, "", ""],
    "petrogeneses" => [2, "is", "IS"],
    "petroleuses" => [1, "", ""],
    "petrolling" => [0, "", ""],
    "petti" => [1, "o", "O"],
    "petuntses" => [1, "", ""],
    "petuntzes" => [1, "", ""],
    "phaenomena" => [1, "on", "ON"],
    "phagocytoses" => [2, "is", "IS"],
    "phalli" => [1, "us", "US"],
    "phantasmata" => [2, "", ""],
    "pharyngitides" => [3, "s", "S"],
    "pharynges" => [3, "x", "X"],
    "phases" => [2, "is", "IS"],
    "phaseless" => [0, "", ""],
    "phereses" => [2, "is", "IS"],
    "phialling" => [0, "", ""],
    "philosophes" => [1, "", ""],
    "philtra" => [1, "um", "UM"],
    "phimoses" => [2, "is", "IS"],
    "phizzes" => [3, "", ""],
    "phlebitides" => [3, "s", "S"],
    "phleboscleroses" => [2, "is", "IS"],
    "phlox" => [0, "", ""],
    "phosphatases" => [1, "", ""],
    "phosphodiesterases" => [1, "", ""],
    "phosphofructokinases" => [1, "", ""],
    "phosphoglucomutases" => [1, "", ""],
    "phosphokinases" => [1, "", ""],
    "phospholipases" => [1, "", ""],
    "phosphomonoesterases" => [1, "", ""],
    "phosphorolyses" => [2, "is", "IS"],
    "phosphorylases" => [1, "", ""],
    "photokineses" => [2, "is", "IS"],
    "photolyses" => [2, "is", "IS"],
    "photomorphogeneses" => [2, "is", "IS"],
    "photophases" => [1, "", ""],
    "photosyntheses" => [2, "is", "IS"],
    "phototaxes" => [2, "is", "IS"],
    "phrases" => [1, "", ""],
    "phraseless" => [0, "", ""],
    "phthiriases" => [2, "is", "IS"],
    "phthises" => [2, "is", "IS"],
    "phyleses" => [2, "is", "IS"],
    "phyllodia" => [1, "um", "UM"],
    "phyllotaxes" => [2, "is", "IS"],
    "phylogeneses" => [2, "is", "IS"],
    "phyla" => [1, "um", "UM"],
    "physes" => [2, "is", "IS"],
    "phytogeneses" => [2, "is", "IS"],
    "phytoses" => [2, "is", "IS"],
    "pickaxes" => [1, "", ""],
    "pickerel" => [0, "", ""],
    "pickling" => [0, "", ""],
    "pictarnies" => [1, "", ""],
    "pies" => [1, "", ""],
    "pieceless" => [0, "", ""],
    "pierogies" => [2, "", ""],
    "pifferari" => [1, "o", "O"],
    "pigfish" => [0, "", ""],
    "pigling" => [0, "", ""],
    "pikes" => [2, "is", "IS"],
    "pikeperch" => [0, "", ""],
    "piles" => [2, "is", "IS"],
    "pileless" => [0, "", ""],
    "pilea" => [1, "um", "UM"],
    "pilei" => [1, "us", "US"],
    "pillarless" => [0, "", ""],
    "pillowcases" => [1, "", ""],
    "pilotfish" => [0, "", ""],
    "pilothouses" => [1, "", ""],
    "pilotless" => [0, "", ""],
    "pila" => [1, "um", "UM"],
    "pili" => [1, "us", "US"],
    "pinches" => [1, "", ""],
    "pineland" => [0, "", ""],
    "pineta" => [1, "um", "UM"],
    "pinfish" => [0, "", ""],
    "pingling" => [0, "", ""],
    "pinocytoses" => [2, "is", "IS"],
    "pinyin" => [0, "", ""],
    "pipes" => [2, "is", "IS"],
    "pipefish" => [0, "", ""],
    "pipeless" => [0, "", ""],
    "pipless" => [0, "", ""],
    "piranha" => [0, "", ""],
    "pirnies" => [1, "", ""],
    "pirogies" => [2, "", ""],
    "piroplasmata" => [2, "", ""],
    "pistaches" => [1, "", ""],
    "pistolling" => [0, "", ""],
    "pithecanthropi" => [1, "us", "US"],
    "pithless" => [0, "", ""],
    "pityriases" => [2, "is", "IS"],
    "pizes" => [1, "", ""],
    "pizzicati" => [1, "o", "O"],
    "placeless" => [0, "", ""],
    "plackless" => [0, "", ""],
    "plagioclases" => [1, "", ""],
    "plaintless" => [0, "", ""],
    "planless" => [0, "", ""],
    "plantless" => [0, "", ""],
    "plantling" => [0, "", ""],
    "plasmaphereses" => [2, "is", "IS"],
    "plasmolyses" => [2, "is", "IS"],
    "platyfish" => [0, "", ""],
    "playhouses" => [1, "", ""],
    "playless" => [0, "", ""],
    "pleasureless" => [0, "", ""],
    "pleatless" => [0, "", ""],
    "plectra" => [1, "um", "UM"],
    "pleurapophyses" => [2, "is", "IS"],
    "pleura" => [1, "on", "ON"],
    "plisses" => [1, "", ""],
    "plotless" => [0, "", ""],
    "plugless" => [0, "", ""],
    "plumbless" => [0, "", ""],
    "plumeless" => [0, "", ""],
    "pneumatolyses" => [2, "is", "IS"],
    "pneumobacilli" => [1, "us", "US"],
    "pneumococci" => [1, "us", "US"],
    "pneumoconioses" => [2, "is", "IS"],
    "pneumonitides" => [3, "s", "S"],
    "pocketknives" => [3, "fe", "FE"],
    "pocketless" => [0, "", ""],
    "pockmanties" => [1, "", ""],
    "podetia" => [1, "um", "UM"],
    "poetless" => [0, "", ""],
    "poi" => [1, "o", "O"],
    "pointless" => [0, "", ""],
    "poises" => [1, "", ""],
    "poleaxes" => [1, "", ""],
    "poleless" => [0, "", ""],
    "police" => [0, "", ""],
    "poliomyelitides" => [3, "s", "S"],
    "politesses" => [1, "", ""],
    "pollack" => [0, "", ""],
    "pollenoses" => [2, "is", "IS"],
    "pollices" => [4, "ex", "EX"],
    "polling" => [0, "", ""],
    "pollinia" => [1, "um", "UM"],
    "pollinoses" => [2, "is", "IS"],
    "pollock" => [0, "", ""],
    "pollyfish" => [0, "", ""],
    "polonaises" => [1, "", ""],
    "poltfeet" => [3, "oot", "OOT"],
    "polygeneses" => [2, "is", "IS"],
    "polyhedroses" => [2, "is", "IS"],
    "polymerases" => [1, "", ""],
    "polyneuritides" => [3, "s", "S"],
    "polyparia" => [1, "um", "UM"],
    "polyposes" => [2, "is", "IS"],
    "polysaccharoses" => [1, "", ""],
    "pommelling" => [0, "", ""],
    "pompano" => [0, "", ""],
    "pompelmooses" => [1, "", ""],
    "pondokkies" => [1, "", ""],
    "pooling" => [0, "", ""],
    "poorhouses" => [1, "", ""],
    "popeless" => [0, "", ""],
    "popeling" => [0, "", ""],
    "poplitei" => [1, "us", "US"],
    "porcini" => [1, "o", "O"],
    "porcupinefish" => [0, "", ""],
    "porgies" => [1, "", ""],
    "porgy" => [0, "", ""],
    "porkfish" => [0, "", ""],
    "porkling" => [0, "", ""],
    "porkpies" => [1, "", ""],
    "poroses" => [2, "is", "IS"],
    "porpesses" => [1, "", ""],
    "porpoise" => [0, "", ""],
    "porterhouses" => [1, "", ""],
    "portionless" => [0, "", ""],
    "portless" => [0, "", ""],
    "poses" => [1, "", ""],
    "poseuses" => [1, "", ""],
    "posses" => [1, "", ""],
    "possessionless" => [0, "", ""],
    "possies" => [1, "", ""],
    "postbourgeois" => [0, "", ""],
    "postchaises" => [1, "", ""],
    "postcrises" => [2, "is", "IS"],
    "posthorses" => [1, "", ""],
    "posthouses" => [1, "", ""],
    "postiches" => [1, "", ""],
    "posties" => [1, "", ""],
    "postilling" => [0, "", ""],
    "pothouses" => [1, "", ""],
    "potiches" => [1, "", ""],
    "potlaches" => [1, "", ""],
    "potpies" => [1, "", ""],
    "pouries" => [1, "", ""],
    "poussies" => [1, "", ""],
    "powderless" => [0, "", ""],
    "powerhouses" => [1, "", ""],
    "powerless" => [0, "", ""],
    "pownies" => [1, "", ""],
    "practises" => [1, "", ""],
    "prairies" => [1, "", ""],
    "praises" => [1, "", ""],
    "praiseless" => [0, "", ""],
    "prankling" => [0, "", ""],
    "prases" => [1, "", ""],
    "prattling" => [0, "", ""],
    "prayerless" => [0, "", ""],
    "precalculi" => [1, "us", "US"],
    "precancelling" => [0, "", ""],
    "precieuses" => [1, "", ""],
    "precis" => [0, "", ""],
    "predeceases" => [1, "", ""],
    "prediabetes" => [0, "", ""],
    "preemies" => [1, "", ""],
    "prelives" => [3, "fe", "FE"],
    "premises" => [1, "", ""],
    "prepubes" => [2, "is", "IS"],
    "prereleases" => [1, "", ""],
    "preses" => [1, "", ""],
    "presidia" => [1, "um", "UM"],
    "pressies" => [1, "", ""],
    "pressureless" => [0, "", ""],
    "pretenses" => [1, "", ""],
    "pretensionless" => [0, "", ""],
    "prezzies" => [1, "", ""],
    "priceless" => [0, "", ""],
    "prickling" => [0, "", ""],
    "prideless" => [0, "", ""],
    "priestling" => [0, "", ""],
    "primroses" => [1, "", ""],
    "princeling" => [0, "", ""],
    "princesses" => [1, "", ""],
    "principia" => [1, "um", "UM"],
    "printless" => [0, "", ""],
    "prises" => [1, "", ""],
    "prizes" => [1, "", ""],
    "procarp" => [0, "", ""],
    "proctodea" => [1, "um", "UM"],
    "prodromi" => [1, "us", "US"],
    "profitless" => [0, "", ""],
    "proglottides" => [3, "s", "S"],
    "prognoses" => [2, "is", "IS"],
    "prolapses" => [1, "", ""],
    "prolegomena" => [1, "on", "ON"],
    "prolepses" => [2, "is", "IS"],
    "promises" => [1, "", ""],
    "promiseless" => [0, "", ""],
    "pronota" => [1, "um", "UM"],
    "pronuclei" => [1, "us", "US"],
    "proofless" => [0, "", ""],
    "propelling" => [0, "", ""],
    "propertyless" => [0, "", ""],
    "prophases" => [1, "", ""],
    "prophylaxes" => [2, "is", "IS"],
    "proportionless" => [0, "", ""],
    "propositi" => [1, "us", "US"],
    "proptoses" => [2, "is", "IS"],
    "propylaea" => [1, "um", "UM"],
    "prosciutti" => [1, "o", "O"],
    "proses" => [1, "", ""],
    "prossies" => [1, "", ""],
    "prostheses" => [2, "is", "IS"],
    "prosties" => [1, "", ""],
    "protases" => [2, "is", "IS"],
    "proteases" => [1, "", ""],
    "protectorless" => [0, "", ""],
    "proteinases" => [1, "", ""],
    "proteolyses" => [2, "is", "IS"],
    "proteoses" => [1, "", ""],
    "prothalamia" => [1, "um", "UM"],
    "protheses" => [2, "is", "IS"],
    "protocolling" => [0, "", ""],
    "protozoa" => [1, "on", "ON"],
    "prowling" => [0, "", ""],
    "prytanea" => [1, "um", "UM"],
    "psalteria" => [1, "um", "UM"],
    "pseudaxes" => [2, "is", "IS"],
    "pseudepigrapha" => [1, "on", "ON"],
    "pseudocarp" => [0, "", ""],
    "pseudocholinesterases" => [1, "", ""],
    "pseudocyeses" => [2, "is", "IS"],
    "pseudopodia" => [1, "um", "UM"],
    "pseudotuberculoses" => [2, "is", "IS"],
    "psiloses" => [2, "is", "IS"],
    "psittacoses" => [2, "is", "IS"],
    "psoriases" => [2, "is", "IS"],
    "psyches" => [1, "", ""],
    "psychoanalyses" => [2, "is", "IS"],
    "psychogeneses" => [2, "is", "IS"],
    "psychokineses" => [2, "is", "IS"],
    "psychoneuroses" => [2, "is", "IS"],
    "psychoses" => [2, "is", "IS"],
    "psychosyntheses" => [2, "is", "IS"],
    "ptarmigan" => [0, "", ""],
    "pteria" => [1, "on", "ON"],
    "ptoses" => [2, "is", "IS"],
    "pubes" => [2, "is", "IS"],
    "pudenda" => [1, "um", "UM"],
    "pules" => [2, "is", "IS"],
    "pulling" => [0, "", ""],
    "pulpless" => [0, "", ""],
    "pulses" => [1, "", ""],
    "pulseless" => [0, "", ""],
    "pulvilli" => [1, "us", "US"],
    "pulvini" => [1, "us", "US"],
    "pummelling" => [0, "", ""],
    "pumpless" => [0, "", ""],
    "punchless" => [0, "", ""],
    "puncta" => [1, "um", "UM"],
    "punctureless" => [0, "", ""],
    "pundonores" => [2, "", ""],
    "pungling" => [0, "", ""],
    "puparia" => [1, "um", "UM"],
    "pupfish" => [0, "", ""],
    "purchases" => [1, "", ""],
    "pures" => [2, "is", "IS"],
    "purling" => [0, "", ""],
    "purportless" => [0, "", ""],
    "purposes" => [1, "", ""],
    "purposeless" => [0, "", ""],
    "purses" => [1, "", ""],
    "putti" => [1, "o", "O"],
    "puttyless" => [0, "", ""],
    "pycnoses" => [2, "is", "IS"],
    "pyelonephritides" => [3, "s", "S"],
    "pyknoses" => [2, "is", "IS"],
    "pylori" => [1, "us", "US"],
    "pyogeneses" => [2, "is", "IS"],
    "pyoses" => [2, "is", "IS"],
    "pyranoses" => [1, "", ""],
    "pyrocelluloses" => [1, "", ""],
    "pyrolyses" => [2, "is", "IS"],
    "pyroses" => [2, "is", "IS"],
    "pyxes" => [2, "is", "IS"],
    "pyxidia" => [1, "um", "UM"],
    "pyxies" => [1, "", ""],
    "quackling" => [0, "", ""],
    "quadriennia" => [1, "um", "UM"],
    "quadrivia" => [1, "um", "UM"],
    "quail" => [0, "", ""],
    "quailing" => [0, "", ""],
    "quanta" => [1, "um", "UM"],
    "quarterstaves" => [3, "ff", "FF"],
    "quatorzes" => [1, "", ""],
    "queenfish" => [0, "", ""],
    "queenies" => [1, "", ""],
    "queenless" => [0, "", ""],
    "quenchless" => [0, "", ""],
    "questionless" => [0, "", ""],
    "quiches" => [1, "", ""],
    "quid" => [0, "", ""],
    "quizzes" => [3, "", ""],
    "rabbitfish" => [0, "", ""],
    "rabies" => [0, "", ""],
    "racecourses" => [1, "", ""],
    "racehorses" => [1, "", ""],
    "raches" => [1, "", ""],
    "rachitides" => [3, "s", "S"],
    "raconteuses" => [1, "", ""],
    "radiationless" => [0, "", ""],
    "radiolabelling" => [0, "", ""],
    "radiolyses" => [2, "is", "IS"],
    "radii" => [1, "us", "US"],
    "raffinoses" => [1, "", ""],
    "raffling" => [0, "", ""],
    "rages" => [2, "is", "IS"],
    "ragfish" => [0, "", ""],
    "raggling" => [0, "", ""],
    "railing" => [0, "", ""],
    "railless" => [0, "", ""],
    "raimentless" => [0, "", ""],
    "rainless" => [0, "", ""],
    "raises" => [1, "", ""],
    "rakes" => [2, "is", "IS"],
    "raki" => [1, "us", "US"],
    "ramenta" => [1, "um", "UM"],
    "ramies" => [1, "", ""],
    "ramuli" => [1, "us", "US"],
    "rami" => [1, "us", "US"],
    "rancheries" => [1, "", ""],
    "rangeland" => [0, "", ""],
    "rankless" => [0, "", ""],
    "rankling" => [0, "", ""],
    "ransomless" => [0, "", ""],
    "raphes" => [2, "is", "IS"],
    "rapines" => [2, "is", "IS"],
    "rappelling" => [0, "", ""],
    "raptureless" => [0, "", ""],
    "rasses" => [1, "", ""],
    "ratfish" => [0, "", ""],
    "raveling" => [0, "", ""],
    "ravelling" => [0, "", ""],
    "rayless" => [0, "", ""],
    "razorfish" => [0, "", ""],
    "reachless" => [0, "", ""],
    "realmless" => [0, "", ""],
    "reanalyses" => [2, "is", "IS"],
    "reapparelling" => [0, "", ""],
    "rearhorses" => [1, "", ""],
    "rearmice" => [3, "ouse", "OUSE"],
    "reasonless" => [0, "", ""],
    "rebelling" => [0, "", ""],
    "receptacula" => [1, "um", "UM"],
    "rechannelling" => [0, "", ""],
    "reckless" => [0, "", ""],
    "reckling" => [0, "", ""],
    "recluses" => [1, "", ""],
    "recoilless" => [0, "", ""],
    "recomfortless" => [0, "", ""],
    "recompenses" => [1, "", ""],
    "recoupling" => [0, "", ""],
    "recourses" => [1, "", ""],
    "rectrices" => [3, "x", "X"],
    "recti" => [1, "us", "US"],
    "recureless" => [0, "", ""],
    "reddenda" => [1, "um", "UM"],
    "reddling" => [0, "", ""],
    "redeemless" => [0, "", ""],
    "redeless" => [0, "", ""],
    "redfish" => [0, "", ""],
    "redhorses" => [1, "", ""],
    "redialing" => [0, "", ""],
    "redialling" => [0, "", ""],
    "redistilling" => [0, "", ""],
    "reductases" => [1, "", ""],
    "reduces" => [3, "x", "X"],
    "reedling" => [0, "", ""],
    "reeling" => [0, "", ""],
    "reemphases" => [2, "is", "IS"],
    "reexpelling" => [0, "", ""],
    "refelling" => [0, "", ""],
    "reflectionless" => [0, "", ""],
    "refuelling" => [0, "", ""],
    "refugia" => [1, "um", "UM"],
    "refuses" => [1, "", ""],
    "regardless" => [0, "", ""],
    "regmata" => [2, "", ""],
    "regna" => [1, "um", "UM"],
    "reguli" => [1, "o", "O"],
    "reindeer" => [0, "", ""],
    "reinless" => [0, "", ""],
    "rejoneadores" => [2, "", ""],
    "relabelling" => [0, "", ""],
    "relapses" => [1, "", ""],
    "relationless" => [0, "", ""],
    "releases" => [1, "", ""],
    "relentless" => [0, "", ""],
    "reliefless" => [0, "", ""],
    "religieuses" => [1, "", ""],
    "religionless" => [0, "", ""],
    "religious" => [0, "", ""],
    "remodelling" => [0, "", ""],
    "remorses" => [1, "", ""],
    "remorseless" => [0, "", ""],
    "rendezvous" => [0, "", ""],
    "rennases" => [1, "", ""],
    "repanelling" => [0, "", ""],
    "repelling" => [0, "", ""],
    "replicases" => [1, "", ""],
    "repla" => [1, "um", "UM"],
    "reposes" => [1, "", ""],
    "repousses" => [1, "", ""],
    "reprises" => [1, "", ""],
    "reproachless" => [0, "", ""],
    "reptilia" => [1, "um", "UM"],
    "repulses" => [1, "", ""],
    "repurchases" => [1, "", ""],
    "reputeless" => [0, "", ""],
    "residua" => [1, "um", "UM"],
    "resistless" => [0, "", ""],
    "resourceless" => [0, "", ""],
    "respectless" => [0, "", ""],
    "responses" => [1, "", ""],
    "responseless" => [0, "", ""],
    "responsa" => [1, "um", "UM"],
    "restless" => [0, "", ""],
    "restyling" => [0, "", ""],
    "resultless" => [0, "", ""],
    "resyntheses" => [2, "is", "IS"],
    "retackling" => [0, "", ""],
    "retchless" => [0, "", ""],
    "retinacula" => [1, "um", "UM"],
    "retinitides" => [3, "s", "S"],
    "retotalling" => [0, "", ""],
    "returnless" => [0, "", ""],
    "revanches" => [1, "", ""],
    "revelling" => [0, "", ""],
    "revengeless" => [0, "", ""],
    "revers" => [0, "", ""],
    "reverses" => [2, "is", "IS"],
    "reverseless" => [0, "", ""],
    "reveuses" => [1, "", ""],
    "revictualling" => [0, "", ""],
    "revises" => [1, "", ""],
    "rewardless" => [0, "", ""],
    "rewon" => [0, "", ""],
    "rhamnoses" => [1, "", ""],
    "rhaphes" => [2, "is", "IS"],
    "rheobases" => [1, "", ""],
    "rheotaxes" => [2, "is", "IS"],
    "rheumatizes" => [1, "", ""],
    "rhexes" => [2, "is", "IS"],
    "rhinitides" => [3, "s", "S"],
    "rhinopharyngitides" => [3, "s", "S"],
    "rhizobia" => [1, "um", "UM"],
    "rhizomata" => [2, "", ""],
    "rhomboidei" => [1, "us", "US"],
    "rhonchi" => [1, "us", "US"],
    "rhymeless" => [0, "", ""],
    "rhythmless" => [0, "", ""],
    "ribbonfish" => [0, "", ""],
    "ribless" => [0, "", ""],
    "ribonucleases" => [1, "", ""],
    "riboses" => [1, "", ""],
    "riderless" => [0, "", ""],
    "ridgeling" => [0, "", ""],
    "riempies" => [1, "", ""],
    "rifacimenti" => [1, "o", "O"],
    "rives" => [3, "fe", "FE"],
    "riffling" => [0, "", ""],
    "rifling" => [0, "", ""],
    "riftless" => [0, "", ""],
    "rigatoni" => [0, "", ""],
    "rightless" => [0, "", ""],
    "rigling" => [0, "", ""],
    "rigwiddies" => [1, "", ""],
    "rigwoodies" => [1, "", ""],
    "rimeless" => [0, "", ""],
    "rimless" => [0, "", ""],
    "rindless" => [0, "", ""],
    "ringless" => [0, "", ""],
    "rinses" => [1, "", ""],
    "rises" => [1, "", ""],
    "riskless" => [0, "", ""],
    "riteless" => [0, "", ""],
    "rivaless" => [0, "", ""],
    "rivaling" => [0, "", ""],
    "rivalless" => [0, "", ""],
    "rivalling" => [0, "", ""],
    "rivelling" => [0, "", ""],
    "riverless" => [0, "", ""],
    "roadhouses" => [1, "", ""],
    "roadless" => [0, "", ""],
    "rockfish" => [0, "", ""],
    "rockless" => [0, "", ""],
    "rockling" => [0, "", ""],
    "rockroses" => [1, "", ""],
    "rodless" => [0, "", ""],
    "roe" => [0, "", ""],
    "rondaches" => [1, "", ""],
    "roofless" => [0, "", ""],
    "rootless" => [0, "", ""],
    "rootling" => [0, "", ""],
    "roscoes" => [1, "", ""],
    "roses" => [1, "", ""],
    "rosefish" => [0, "", ""],
    "roseless" => [0, "", ""],
    "rotches" => [1, "", ""],
    "rotes" => [2, "is", "IS"],
    "rotisseries" => [1, "", ""],
    "rouches" => [1, "", ""],
    "roughhouses" => [1, "", ""],
    "roundfish" => [0, "", ""],
    "roundhouses" => [1, "", ""],
    "rowelling" => [0, "", ""],
    "rubasses" => [1, "", ""],
    "ruckling" => [0, "", ""],
    "rudderfish" => [0, "", ""],
    "rudderless" => [0, "", ""],
    "ruddling" => [0, "", ""],
    "rudies" => [1, "", ""],
    "ruffling" => [0, "", ""],
    "ruleless" => [0, "", ""],
    "rumpless" => [0, "", ""],
    "rumpling" => [0, "", ""],
    "rungless" => [0, "", ""],
    "runless" => [0, "", ""],
    "ruses" => [1, "", ""],
    "rustless" => [0, "", ""],
    "rustling" => [0, "", ""],
    "ruthless" => [0, "", ""],
    "sable" => [0, "", ""],
    "sablefish" => [0, "", ""],
    "sabling" => [0, "", ""],
    "sabretaches" => [1, "", ""],
    "saccharases" => [1, "", ""],
    "saccharoses" => [1, "", ""],
    "sacculi" => [1, "us", "US"],
    "sacella" => [1, "um", "UM"],
    "sackless" => [0, "", ""],
    "sacless" => [0, "", ""],
    "sacra" => [1, "um", "UM"],
    "saddleless" => [0, "", ""],
    "sades" => [2, "is", "IS"],
    "sadhes" => [1, "", ""],
    "saga" => [1, "um", "UM"],
    "sailfish" => [0, "", ""],
    "sailing" => [0, "", ""],
    "sailless" => [0, "", ""],
    "sailorless" => [0, "", ""],
    "saintling" => [0, "", ""],
    "saithes" => [1, "", ""],
    "sakes" => [2, "is", "IS"],
    "salespeople" => [4, "rson", "RSON"],
    "salices" => [3, "x", "X"],
    "salmon" => [0, "", ""],
    "salmonelloses" => [2, "is", "IS"],
    "salses" => [1, "", ""],
    "saltfish" => [0, "", ""],
    "saltless" => [0, "", ""],
    "samites" => [2, "is", "IS"],
    "sampling" => [0, "", ""],
    "samurai" => [0, "", ""],
    "sancoches" => [1, "", ""],
    "sanctionless" => [0, "", ""],
    "sandalling" => [0, "", ""],
    "sanderling" => [0, "", ""],
    "sandfish" => [0, "", ""],
    "sandgrouse" => [0, "", ""],
    "sandless" => [0, "", ""],
    "sandling" => [0, "", ""],
    "sandshoes" => [1, "", ""],
    "sapidless" => [0, "", ""],
    "sapless" => [0, "", ""],
    "sapling" => [0, "", ""],
    "sarcocystes" => [2, "is", "IS"],
    "sarcoidoses" => [2, "is", "IS"],
    "sarcomatoses" => [2, "is", "IS"],
    "sarcophagi" => [1, "us", "US"],
    "sarmenta" => [1, "um", "UM"],
    "sarnies" => [1, "", ""],
    "sartorii" => [1, "us", "US"],
    "sashless" => [0, "", ""],
    "sateless" => [0, "", ""],
    "sates" => [2, "is", "IS"],
    "satyriases" => [2, "is", "IS"],
    "saucisses" => [1, "", ""],
    "saulies" => [1, "", ""],
    "savorless" => [0, "", ""],
    "savourless" => [0, "", ""],
    "sawbones" => [0, "", ""],
    "sawfish" => [0, "", ""],
    "sawhorses" => [1, "", ""],
    "sawteeth" => [4, "ooth", "OOTH"],
    "sbirri" => [1, "o", "O"],
    "scabbardless" => [0, "", ""],
    "scaffies" => [1, "", ""],
    "scaldfish" => [0, "", ""],
    "scaldini" => [1, "o", "O"],
    "scalefish" => [0, "", ""],
    "scaleless" => [0, "", ""],
    "scaleni" => [1, "us", "US"],
    "scaloppines" => [2, "is", "IS"],
    "scalpless" => [0, "", ""],
    "scampi" => [1, "o", "O"],
    "scandalling" => [0, "", ""],
    "scantling" => [0, "", ""],
    "scapegallows" => [0, "", ""],
    "scapeless" => [0, "", ""],
    "scapi" => [1, "us", "US"],
    "scaramouches" => [1, "", ""],
    "scarves" => [3, "f", "F"],
    "scarless" => [0, "", ""],
    "scathes" => [1, "", ""],
    "scatheless" => [0, "", ""],
    "scatterling" => [0, "", ""],
    "scentless" => [0, "", ""],
    "scepses" => [2, "is", "IS"],
    "scepterless" => [0, "", ""],
    "schemata" => [2, "", ""],
    "schistosomiases" => [2, "is", "IS"],
    "schizocarp" => [0, "", ""],
    "schizogeneses" => [2, "is", "IS"],
    "schmelzes" => [1, "", ""],
    "schmoes" => [1, "", ""],
    "schmoozes" => [1, "", ""],
    "schnapps" => [0, "", ""],
    "schnaps" => [0, "", ""],
    "scholia" => [1, "on", "ON"],
    "schoolchildren" => [3, "", ""],
    "schoolhouses" => [1, "", ""],
    "schoolies" => [1, "", ""],
    "schottisches" => [1, "", ""],
    "schrod" => [0, "", ""],
    "scleroses" => [2, "is", "IS"],
    "sclerotia" => [1, "um", "UM"],
    "scolices" => [4, "ex", "EX"],
    "scolia" => [1, "on", "ON"],
    "scolioses" => [2, "is", "IS"],
    "scoreless" => [0, "", ""],
    "scorpionfish" => [0, "", ""],
    "scowling" => [0, "", ""],
    "scrapies" => [1, "", ""],
    "scratchless" => [0, "", ""],
    "scrawling" => [0, "", ""],
    "scrod" => [0, "", ""],
    "scroogies" => [1, "", ""],
    "scrota" => [1, "um", "UM"],
    "scrumpling" => [0, "", ""],
    "scudi" => [1, "o", "O"],
    "scuffling" => [0, "", ""],
    "sculling" => [0, "", ""],
    "scumless" => [0, "", ""],
    "scutella" => [1, "um", "UM"],
    "scuta" => [1, "um", "UM"],
    "scybala" => [1, "um", "UM"],
    "scyphi" => [1, "us", "US"],
    "scythes" => [1, "", ""],
    "seafolk" => [0, "", ""],
    "seafowl" => [0, "", ""],
    "seahorses" => [1, "", ""],
    "sealing" => [0, "", ""],
    "seamless" => [0, "", ""],
    "searchless" => [0, "", ""],
    "seasonless" => [0, "", ""],
    "seatless" => [0, "", ""],
    "secaloses" => [1, "", ""],
    "secondi" => [1, "o", "O"],
    "sedilia" => [1, "um", "UM"],
    "seedcases" => [1, "", ""],
    "seedless" => [0, "", ""],
    "seedling" => [0, "", ""],
    "seeling" => [0, "", ""],
    "seemless" => [0, "", ""],
    "seethes" => [1, "", ""],
    "seiches" => [1, "", ""],
    "seiling" => [0, "", ""],
    "selves" => [3, "f", "F"],
    "selfish" => [0, "", ""],
    "selfless" => [0, "", ""],
    "selkies" => [1, "", ""],
    "selling" => [0, "", ""],
    "semantra" => [1, "on", "ON"],
    "semeia" => [1, "on", "ON"],
    "semioses" => [2, "is", "IS"],
    "semireligious" => [0, "", ""],
    "senarii" => [1, "us", "US"],
    "sennachies" => [1, "", ""],
    "senses" => [1, "", ""],
    "senseless" => [0, "", ""],
    "sensilla" => [1, "um", "UM"],
    "sensa" => [1, "um", "UM"],
    "sentinelling" => [0, "", ""],
    "sepses" => [2, "is", "IS"],
    "septaria" => [1, "um", "UM"],
    "septennia" => [1, "um", "UM"],
    "septa" => [1, "um", "UM"],
    "seraphim" => [0, "", ""],
    "serfish" => [0, "", ""],
    "sergeantfish" => [0, "", ""],
    "sericteria" => [1, "um", "UM"],
    "serodiagnoses" => [2, "is", "IS"],
    "servantless" => [0, "", ""],
    "serviceless" => [0, "", ""],
    "servicepeople" => [4, "rson", "RSON"],
    "sestertia" => [1, "um", "UM"],
    "settling" => [0, "", ""],
    "seviches" => [1, "", ""],
    "sexless" => [0, "", ""],
    "sextarii" => [1, "us", "US"],
    "sgraffiti" => [1, "o", "O"],
    "shackling" => [0, "", ""],
    "shad" => [0, "", ""],
    "shadeless" => [0, "", ""],
    "shadowless" => [0, "", ""],
    "shaftless" => [0, "", ""],
    "shameless" => [0, "", ""],
    "shanachies" => [1, "", ""],
    "shapeless" => [0, "", ""],
    "shaveling" => [0, "", ""],
    "shavies" => [1, "", ""],
    "shawlies" => [1, "", ""],
    "shawling" => [0, "", ""],
    "shawlless" => [0, "", ""],
    "shes" => [1, "", ""],
    "shealing" => [0, "", ""],
    "shearling" => [0, "", ""],
    "sheathfish" => [0, "", ""],
    "sheathless" => [0, "", ""],
    "sheep" => [0, "", ""],
    "shelves" => [3, "f", "F"],
    "shellfish" => [0, "", ""],
    "shelterless" => [0, "", ""],
    "shepherdless" => [0, "", ""],
    "shepherdling" => [0, "", ""],
    "shieldless" => [0, "", ""],
    "shieldling" => [0, "", ""],
    "shiftless" => [0, "", ""],
    "shigelloses" => [2, "is", "IS"],
    "shikses" => [1, "", ""],
    "shillingless" => [0, "", ""],
    "shineless" => [0, "", ""],
    "shinleaves" => [3, "f", "F"],
    "shipless" => [0, "", ""],
    "shirtless" => [0, "", ""],
    "shitless" => [0, "", ""],
    "shoes" => [1, "", ""],
    "shoeless" => [0, "", ""],
    "shooling" => [0, "", ""],
    "shoreless" => [0, "", ""],
    "shoveling" => [0, "", ""],
    "shovelling" => [0, "", ""],
    "shovelnoses" => [1, "", ""],
    "showbizzes" => [3, "", ""],
    "showcases" => [1, "", ""],
    "showerless" => [0, "", ""],
    "showghes" => [1, "", ""],
    "shredless" => [0, "", ""],
    "shrewdies" => [1, "", ""],
    "shrewmice" => [3, "ouse", "OUSE"],
    "shrimp" => [0, "", ""],
    "shrimpfish" => [0, "", ""],
    "shriveling" => [0, "", ""],
    "shrivelling" => [0, "", ""],
    "shroudless" => [0, "", ""],
    "shrubless" => [0, "", ""],
    "shunless" => [0, "", ""],
    "shutterless" => [0, "", ""],
    "shuttleless" => [0, "", ""],
    "shvartses" => [1, "", ""],
    "shvartzes" => [1, "", ""],
    "sibling" => [0, "", ""],
    "sickies" => [1, "", ""],
    "sickling" => [0, "", ""],
    "sideling" => [0, "", ""],
    "sideroses" => [2, "is", "IS"],
    "siffleuses" => [1, "", ""],
    "sighless" => [0, "", ""],
    "sightless" => [0, "", ""],
    "sigla" => [1, "um", "UM"],
    "signalling" => [0, "", ""],
    "signless" => [0, "", ""],
    "signori" => [1, "e", "E"],
    "silicoses" => [2, "is", "IS"],
    "siling" => [0, "", ""],
    "silverfish" => [0, "", ""],
    "silverling" => [0, "", ""],
    "simpling" => [0, "", ""],
    "sinewless" => [0, "", ""],
    "singling" => [0, "", ""],
    "sinless" => [0, "", ""],
    "sires" => [2, "is", "IS"],
    "sireless" => [0, "", ""],
    "siriases" => [2, "is", "IS"],
    "sises" => [1, "", ""],
    "sisterless" => [0, "", ""],
    "sithes" => [1, "", ""],
    "sixpence" => [0, "", ""],
    "sizes" => [1, "", ""],
    "sizzling" => [0, "", ""],
    "skiffling" => [0, "", ""],
    "skilletfish" => [0, "", ""],
    "skinless" => [0, "", ""],
    "skirtless" => [0, "", ""],
    "skolia" => [1, "on", "ON"],
    "slakeless" => [0, "", ""],
    "slaughterhouses" => [1, "", ""],
    "slaveless" => [0, "", ""],
    "sleazes" => [1, "", ""],
    "sleepless" => [0, "", ""],
    "sleevefish" => [0, "", ""],
    "sleeveless" => [0, "", ""],
    "slipcases" => [1, "", ""],
    "slipless" => [0, "", ""],
    "slitless" => [0, "", ""],
    "sloes" => [1, "", ""],
    "slumberless" => [0, "", ""],
    "smartarses" => [1, "", ""],
    "smartypants" => [0, "", ""],
    "smazes" => [1, "", ""],
    "smearcases" => [1, "", ""],
    "smiercases" => [1, "", ""],
    "smileless" => [0, "", ""],
    "smogless" => [0, "", ""],
    "smokehouses" => [1, "", ""],
    "smokeless" => [0, "", ""],
    "smytries" => [1, "", ""],
    "snailfish" => [0, "", ""],
    "snakefish" => [0, "", ""],
    "snapless" => [0, "", ""],
    "snathes" => [1, "", ""],
    "sneezes" => [1, "", ""],
    "sniffling" => [0, "", ""],
    "snipe" => [0, "", ""],
    "snipefish" => [0, "", ""],
    "snirtling" => [0, "", ""],
    "snivelling" => [0, "", ""],
    "snobling" => [0, "", ""],
    "snoozes" => [1, "", ""],
    "snorkelling" => [0, "", ""],
    "snowless" => [0, "", ""],
    "snowshoes" => [1, "", ""],
    "snuffling" => [0, "", ""],
    "soapfish" => [0, "", ""],
    "soapless" => [0, "", ""],
    "sociologeses" => [1, "", ""],
    "sockless" => [0, "", ""],
    "sodaless" => [0, "", ""],
    "sodless" => [0, "", ""],
    "softling" => [0, "", ""],
    "soilless" => [0, "", ""],
    "solaria" => [1, "um", "UM"],
    "solatia" => [1, "um", "UM"],
    "soldierfish" => [0, "", ""],
    "soldi" => [1, "o", "O"],
    "sole" => [0, "", ""],
    "soleless" => [0, "", ""],
    "solidi" => [1, "us", "US"],
    "soling" => [0, "", ""],
    "soli" => [1, "us", "US"],
    "solventless" => [0, "", ""],
    "solvolyses" => [2, "is", "IS"],
    "songless" => [0, "", ""],
    "sonless" => [0, "", ""],
    "sootless" => [0, "", ""],
    "sorboses" => [1, "", ""],
    "sordini" => [1, "o", "O"],
    "soredia" => [1, "um", "UM"],
    "soroches" => [1, "", ""],
    "soroses" => [2, "is", "IS"],
    "sorrowless" => [0, "", ""],
    "sorties" => [1, "", ""],
    "sori" => [1, "us", "US"],
    "sosaties" => [1, "", ""],
    "soubises" => [1, "", ""],
    "soulless" => [0, "", ""],
    "soundless" => [0, "", ""],
    "soupless" => [0, "", ""],
    "soupling" => [0, "", ""],
    "sourceless" => [0, "", ""],
    "souses" => [1, "", ""],
    "soutaches" => [1, "", ""],
    "sowling" => [0, "", ""],
    "spaceless" => [0, "", ""],
    "spadefish" => [0, "", ""],
    "spadices" => [3, "x", "X"],
    "spaewives" => [3, "fe", "FE"],
    "spancelling" => [0, "", ""],
    "spangling" => [0, "", ""],
    "spanielling" => [0, "", ""],
    "spanless" => [0, "", ""],
    "spareless" => [0, "", ""],
    "sparkless" => [0, "", ""],
    "sparkling" => [0, "", ""],
    "sparling" => [0, "", ""],
    "spathes" => [1, "", ""],
    "spatleses" => [1, "", ""],
    "spavies" => [1, "", ""],
    "spazzes" => [3, "", ""],
    "spearfish" => [0, "", ""],
    "species" => [1, "", ""],
    "speckless" => [0, "", ""],
    "speckling" => [0, "", ""],
    "spectra" => [1, "um", "UM"],
    "speechless" => [0, "", ""],
    "speedless" => [0, "", ""],
    "speises" => [1, "", ""],
    "spenses" => [1, "", ""],
    "spermagonia" => [1, "um", "UM"],
    "spermaria" => [1, "um", "UM"],
    "spermatia" => [1, "um", "UM"],
    "spermatogeneses" => [2, "is", "IS"],
    "spermatozoa" => [1, "on", "ON"],
    "spermiogeneses" => [2, "is", "IS"],
    "spermogonia" => [1, "um", "UM"],
    "sphaeridia" => [1, "um", "UM"],
    "sphereless" => [0, "", ""],
    "spiceless" => [0, "", ""],
    "spicula" => [1, "um", "UM"],
    "spikefish" => [0, "", ""],
    "spineless" => [0, "", ""],
    "spinless" => [0, "", ""],
    "spiracula" => [1, "um", "UM"],
    "spiralling" => [0, "", ""],
    "spireless" => [0, "", ""],
    "spirilla" => [1, "um", "UM"],
    "spiritless" => [0, "", ""],
    "spirochetoses" => [2, "is", "IS"],
    "splayfeet" => [3, "oot", "OOT"],
    "spleenless" => [0, "", ""],
    "splinterless" => [0, "", ""],
    "spokespeople" => [4, "rson", "RSON"],
    "spondyloses" => [2, "is", "IS"],
    "sporangiola" => [1, "um", "UM"],
    "sporangia" => [1, "um", "UM"],
    "sporidia" => [1, "um", "UM"],
    "sporogeneses" => [2, "is", "IS"],
    "sporotrichoses" => [2, "is", "IS"],
    "sporozoa" => [1, "on", "ON"],
    "sportless" => [0, "", ""],
    "spotless" => [0, "", ""],
    "spouses" => [1, "", ""],
    "spouseless" => [0, "", ""],
    "spoutless" => [0, "", ""],
    "sprackling" => [0, "", ""],
    "sprangling" => [0, "", ""],
    "springbok" => [0, "", ""],
    "springhouses" => [1, "", ""],
    "springless" => [0, "", ""],
    "spumones" => [2, "is", "IS"],
    "spurless" => [0, "", ""],
    "spurling" => [0, "", ""],
    "sputa" => [1, "um", "UM"],
    "squab" => [0, "", ""],
    "squawfish" => [0, "", ""],
    "squeezes" => [1, "", ""],
    "squid" => [0, "", ""],
    "squireling" => [0, "", ""],
    "squirrelfish" => [0, "", ""],
    "squirrelling" => [0, "", ""],
    "squizzes" => [3, "", ""],
    "stabling" => [0, "", ""],
    "staircases" => [1, "", ""],
    "staithes" => [1, "", ""],
    "stalkless" => [0, "", ""],
    "stampless" => [0, "", ""],
    "stanchelling" => [0, "", ""],
    "stanchless" => [0, "", ""],
    "standardless" => [0, "", ""],
    "stanzes" => [1, "", ""],
    "staphylococci" => [1, "us", "US"],
    "stapling" => [0, "", ""],
    "starchless" => [0, "", ""],
    "starfish" => [0, "", ""],
    "starless" => [0, "", ""],
    "starling" => [0, "", ""],
    "starnies" => [1, "", ""],
    "starnoses" => [1, "", ""],
    "startling" => [0, "", ""],
    "starveling" => [0, "", ""],
    "stasima" => [1, "on", "ON"],
    "stases" => [2, "is", "IS"],
    "stateless" => [0, "", ""],
    "statespeople" => [4, "rson", "RSON"],
    "stayless" => [0, "", ""],
    "steakhouses" => [1, "", ""],
    "steatolyses" => [2, "is", "IS"],
    "steeplechases" => [1, "", ""],
    "steerling" => [0, "", ""],
    "steles" => [2, "is", "IS"],
    "stemless" => [0, "", ""],
    "stenoses" => [2, "is", "IS"],
    "stepchildren" => [3, "", ""],
    "steptoes" => [1, "", ""],
    "stereopses" => [2, "is", "IS"],
    "stereotaxes" => [2, "is", "IS"],
    "steroidogeneses" => [2, "is", "IS"],
    "stichidia" => [1, "um", "UM"],
    "stickling" => [0, "", ""],
    "stimuli" => [1, "us", "US"],
    "stingfish" => [0, "", ""],
    "stingless" => [0, "", ""],
    "stintless" => [0, "", ""],
    "stirless" => [0, "", ""],
    "stockfish" => [0, "", ""],
    "stockingless" => [0, "", ""],
    "stockless" => [0, "", ""],
    "stomachaches" => [1, "", ""],
    "stomachless" => [0, "", ""],
    "stompies" => [1, "", ""],
    "stonefish" => [0, "", ""],
    "stonehorses" => [1, "", ""],
    "stoneless" => [0, "", ""],
    "stoolies" => [1, "", ""],
    "stopless" => [0, "", ""],
    "storehouses" => [1, "", ""],
    "stormless" => [0, "", ""],
    "stornelli" => [1, "o", "O"],
    "stracchini" => [1, "o", "O"],
    "strandwolf" => [0, "", ""],
    "strangling" => [0, "", ""],
    "stratocumuli" => [1, "us", "US"],
    "stratopauses" => [1, "", ""],
    "strata" => [1, "um", "UM"],
    "strati" => [1, "us", "US"],
    "strawless" => [0, "", ""],
    "strayling" => [0, "", ""],
    "streamless" => [0, "", ""],
    "streamling" => [0, "", ""],
    "strengthless" => [0, "", ""],
    "streptobacilli" => [1, "us", "US"],
    "streptococci" => [1, "us", "US"],
    "streptodornases" => [1, "", ""],
    "streptokinases" => [1, "", ""],
    "stressless" => [0, "", ""],
    "strickling" => [0, "", ""],
    "stridling" => [0, "", ""],
    "strifeless" => [0, "", ""],
    "stringcourses" => [1, "", ""],
    "stringless" => [0, "", ""],
    "stripeless" => [0, "", ""],
    "stripling" => [0, "", ""],
    "stripteases" => [1, "", ""],
    "strobili" => [1, "us", "US"],
    "stromata" => [2, "", ""],
    "strongyloidiases" => [2, "is", "IS"],
    "strongyloidoses" => [2, "is", "IS"],
    "strongyloses" => [2, "is", "IS"],
    "strophes" => [1, "", ""],
    "structureless" => [0, "", ""],
    "studdies" => [1, "", ""],
    "studfish" => [0, "", ""],
    "studhorses" => [1, "", ""],
    "stuffless" => [0, "", ""],
    "sturgeon" => [0, "", ""],
    "styleless" => [0, "", ""],
    "styling" => [0, "", ""],
    "subbases" => [1, "", ""],
    "subcauses" => [1, "", ""],
    "subclauses" => [1, "", ""],
    "subcortices" => [4, "ex", "EX"],
    "subgenera" => [3, "us", "US"],
    "subimagines" => [4, "o", "O"],
    "subjectless" => [0, "", ""],
    "subleases" => [1, "", ""],
    "subniches" => [1, "", ""],
    "subphases" => [1, "", ""],
    "subphyla" => [1, "um", "UM"],
    "subsellia" => [1, "um", "UM"],
    "subsenses" => [1, "", ""],
    "subspecies" => [0, "", ""],
    "substanceless" => [0, "", ""],
    "substrata" => [1, "um", "UM"],
    "subtenses" => [1, "", ""],
    "subtotalling" => [0, "", ""],
    "successionless" => [0, "", ""],
    "successless" => [0, "", ""],
    "succourless" => [0, "", ""],
    "succusses" => [3, "", ""],
    "suckerfish" => [0, "", ""],
    "suckfish" => [0, "", ""],
    "suckless" => [0, "", ""],
    "suckling" => [0, "", ""],
    "sucrases" => [1, "", ""],
    "sucroses" => [1, "", ""],
    "sudsless" => [0, "", ""],
    "sugarhouses" => [1, "", ""],
    "sugarless" => [0, "", ""],
    "sugarloaves" => [3, "f", "F"],
    "suitcases" => [1, "", ""],
    "sulci" => [1, "us", "US"],
    "sulfatases" => [1, "", ""],
    "sumless" => [0, "", ""],
    "summerhouses" => [1, "", ""],
    "summitless" => [0, "", ""],
    "sunless" => [0, "", ""],
    "sunrises" => [1, "", ""],
    "superhelices" => [3, "x", "X"],
    "superphenomena" => [1, "on", "ON"],
    "superstrata" => [1, "um", "UM"],
    "superwives" => [3, "fe", "FE"],
    "suppedanea" => [1, "um", "UM"],
    "supperless" => [0, "", ""],
    "supportless" => [0, "", ""],
    "surbases" => [1, "", ""],
    "surceases" => [1, "", ""],
    "surfaceless" => [0, "", ""],
    "surffish" => [0, "", ""],
    "surfperch" => [0, "", ""],
    "surgeless" => [0, "", ""],
    "surgeonfish" => [0, "", ""],
    "surmises" => [1, "", ""],
    "surprises" => [1, "", ""],
    "surveilling" => [0, "", ""],
    "suspectless" => [0, "", ""],
    "suspenses" => [1, "", ""],
    "suspenseless" => [0, "", ""],
    "suspicionless" => [0, "", ""],
    "svarajes" => [2, "", ""],
    "swaggies" => [1, "", ""],
    "swarajes" => [2, "", ""],
    "swathes" => [1, "", ""],
    "sweetfish" => [0, "", ""],
    "sweetiewives" => [3, "fe", "FE"],
    "swelchies" => [1, "", ""],
    "swellfish" => [0, "", ""],
    "swerveless" => [0, "", ""],
    "swifties" => [1, "", ""],
    "swine" => [0, "", ""],
    "swingling" => [0, "", ""],
    "swiveling" => [0, "", ""],
    "swivelling" => [0, "", ""],
    "swizzling" => [0, "", ""],
    "swordfish" => [0, "", ""],
    "swordless" => [0, "", ""],
    "syboes" => [1, "", ""],
    "sycoses" => [2, "is", "IS"],
    "syllepses" => [2, "is", "IS"],
    "symbioses" => [2, "is", "IS"],
    "symbolling" => [0, "", ""],
    "symphyses" => [2, "is", "IS"],
    "sympodia" => [1, "um", "UM"],
    "symptomless" => [0, "", ""],
    "synaereses" => [2, "is", "IS"],
    "synaestheses" => [2, "is", "IS"],
    "synapses" => [2, "is", "IS"],
    "synarthroses" => [2, "is", "IS"],
    "synaxes" => [2, "is", "IS"],
    "syncarp" => [0, "", ""],
    "synchondroses" => [2, "is", "IS"],
    "synchoreses" => [2, "is", "IS"],
    "syndeses" => [2, "is", "IS"],
    "syndesmoses" => [2, "is", "IS"],
    "synecdoches" => [1, "", ""],
    "synedria" => [1, "um", "UM"],
    "synereses" => [2, "is", "IS"],
    "syneses" => [2, "is", "IS"],
    "syngeneses" => [2, "is", "IS"],
    "synizeses" => [2, "is", "IS"],
    "synkineses" => [2, "is", "IS"],
    "synoecioses" => [2, "is", "IS"],
    "synopses" => [2, "is", "IS"],
    "synostoses" => [2, "is", "IS"],
    "synovia" => [1, "um", "UM"],
    "syntenoses" => [2, "is", "IS"],
    "syntheses" => [2, "is", "IS"],
    "synthetases" => [1, "", ""],
    "syrtes" => [2, "is", "IS"],
    "syssarcoses" => [2, "is", "IS"],
    "systemless" => [0, "", ""],
    "tabes" => [2, "is", "IS"],
    "tabling" => [0, "", ""],
    "tabi" => [1, "us", "US"],
    "taches" => [1, "", ""],
    "tackless" => [0, "", ""],
    "tackling" => [0, "", ""],
    "tactless" => [0, "", ""],
    "taeniases" => [2, "is", "IS"],
    "tagmata" => [2, "", ""],
    "taigling" => [0, "", ""],
    "tailing" => [0, "", ""],
    "tailless" => [0, "", ""],
    "taillies" => [1, "", ""],
    "tailzies" => [1, "", ""],
    "taintless" => [0, "", ""],
    "tajes" => [2, "", ""],
    "takahes" => [1, "", ""],
    "talcaries" => [1, "", ""],
    "talentless" => [0, "", ""],
    "tali" => [1, "us", "US"],
    "tameless" => [0, "", ""],
    "tamises" => [1, "", ""],
    "tangling" => [0, "", ""],
    "tankless" => [0, "", ""],
    "tanling" => [0, "", ""],
    "tanties" => [1, "", ""],
    "tanti" => [1, "o", "O"],
    "tapeless" => [0, "", ""],
    "tapeta" => [1, "um", "UM"],
    "taphouses" => [1, "", ""],
    "tariffless" => [0, "", ""],
    "tarpon" => [0, "", ""],
    "tarsometatarsi" => [1, "us", "US"],
    "tarsi" => [1, "us", "US"],
    "tasses" => [1, "", ""],
    "taskless" => [0, "", ""],
    "tasseling" => [0, "", ""],
    "tassies" => [1, "", ""],
    "tasteless" => [0, "", ""],
    "tatami" => [0, "", ""],
    "taties" => [1, "", ""],
    "tattling" => [0, "", ""],
    "tai" => [1, "us", "US"],
    "tawpies" => [1, "", ""],
    "tawses" => [1, "", ""],
    "taxes" => [2, "is", "IS"],
    "taxless" => [0, "", ""],
    "taxi" => [1, "us", "US"],
    "tes" => [2, "is", "IS"],
    "teacherless" => [0, "", ""],
    "teachless" => [0, "", ""],
    "teahouses" => [1, "", ""],
    "teal" => [0, "", ""],
    "tearless" => [0, "", ""],
    "teases" => [1, "", ""],
    "teaseling" => [0, "", ""],
    "teaselling" => [0, "", ""],
    "teazeling" => [0, "", ""],
    "teazelling" => [0, "", ""],
    "tectrices" => [3, "x", "X"],
    "teemless" => [0, "", ""],
    "teetotalling" => [0, "", ""],
    "tegmenta" => [1, "um", "UM"],
    "tekkies" => [1, "", ""],
    "telangiectases" => [2, "is", "IS"],
    "telecourses" => [1, "", ""],
    "telegrapheses" => [1, "", ""],
    "telekineses" => [2, "is", "IS"],
    "teleses" => [2, "is", "IS"],
    "telia" => [1, "um", "UM"],
    "telling" => [0, "", ""],
    "telophases" => [1, "", ""],
    "telotaxes" => [2, "is", "IS"],
    "tenantless" => [0, "", ""],
    "tenderling" => [0, "", ""],
    "tendresses" => [1, "", ""],
    "teniases" => [2, "is", "IS"],
    "tenses" => [1, "", ""],
    "tenseless" => [0, "", ""],
    "tensionless" => [0, "", ""],
    "tentacula" => [1, "um", "UM"],
    "tentless" => [0, "", ""],
    "tenues" => [2, "is", "IS"],
    "teratogeneses" => [2, "is", "IS"],
    "terga" => [1, "um", "UM"],
    "termini" => [1, "us", "US"],
    "termless" => [0, "", ""],
    "terpeneless" => [0, "", ""],
    "terrorless" => [0, "", ""],
    "testatrices" => [3, "x", "X"],
    "testes" => [2, "is", "IS"],
    "tetrasporangia" => [1, "um", "UM"],
    "textless" => [0, "", ""],
    "textureless" => [0, "", ""],
    "thalami" => [1, "us", "US"],
    "thankless" => [0, "", ""],
    "thatchless" => [0, "", ""],
    "thawless" => [0, "", ""],
    "themata" => [2, "", ""],
    "themeless" => [0, "", ""],
    "theologoumena" => [1, "on", "ON"],
    "therapeuses" => [2, "is", "IS"],
    "thermogeneses" => [2, "is", "IS"],
    "thermolyses" => [2, "is", "IS"],
    "thermotaxes" => [2, "is", "IS"],
    "theses" => [2, "is", "IS"],
    "thewless" => [0, "", ""],
    "thiaminases" => [1, "", ""],
    "thieves" => [3, "f", "F"],
    "thigmotaxes" => [2, "is", "IS"],
    "thirling" => [0, "", ""],
    "thirstless" => [0, "", ""],
    "tholing" => [0, "", ""],
    "tholi" => [1, "us", "US"],
    "thornless" => [0, "", ""],
    "thoughtless" => [0, "", ""],
    "threadfish" => [0, "", ""],
    "threadless" => [0, "", ""],
    "threepence" => [0, "", ""],
    "thriftless" => [0, "", ""],
    "thriveless" => [0, "", ""],
    "throes" => [1, "", ""],
    "throbless" => [0, "", ""],
    "thrombokinases" => [1, "", ""],
    "thrombolyses" => [2, "is", "IS"],
    "thrombophlebitides" => [3, "s", "S"],
    "thromboses" => [2, "is", "IS"],
    "thrombi" => [1, "us", "US"],
    "throneless" => [0, "", ""],
    "thumbless" => [0, "", ""],
    "thunderless" => [0, "", ""],
    "thyrotoxicoses" => [2, "is", "IS"],
    "thyrses" => [1, "", ""],
    "thyrsi" => [1, "us", "US"],
    "ticketless" => [0, "", ""],
    "tickling" => [0, "", ""],
    "ticktacktoes" => [1, "", ""],
    "tideland" => [0, "", ""],
    "tideless" => [0, "", ""],
    "ties" => [1, "", ""],
    "tieless" => [0, "", ""],
    "tifosi" => [1, "o", "O"],
    "tigerfish" => [0, "", ""],
    "tikes" => [2, "is", "IS"],
    "tilefish" => [0, "", ""],
    "tillerless" => [0, "", ""],
    "tilling" => [0, "", ""],
    "timeless" => [0, "", ""],
    "timpani" => [1, "o", "O"],
    "tingling" => [0, "", ""],
    "tinkling" => [0, "", ""],
    "tinselling" => [0, "", ""],
    "tintinnabula" => [1, "um", "UM"],
    "tintless" => [0, "", ""],
    "tipless" => [0, "", ""],
    "tiptoes" => [1, "", ""],
    "tirasses" => [1, "", ""],
    "tireless" => [0, "", ""],
    "tireling" => [0, "", ""],
    "tithes" => [1, "", ""],
    "titleless" => [0, "", ""],
    "titling" => [0, "", ""],
    "titmice" => [3, "ouse", "OUSE"],
    "tmeses" => [2, "is", "IS"],
    "toadfish" => [0, "", ""],
    "toadless" => [0, "", ""],
    "tocherless" => [0, "", ""],
    "toes" => [1, "", ""],
    "toeless" => [0, "", ""],
    "toeshoes" => [1, "", ""],
    "toilless" => [0, "", ""],
    "tollhouses" => [1, "", ""],
    "tombless" => [0, "", ""],
    "tomenta" => [1, "um", "UM"],
    "toneless" => [0, "", ""],
    "tonguefish" => [0, "", ""],
    "tongueless" => [0, "", ""],
    "toolhouses" => [1, "", ""],
    "tooling" => [0, "", ""],
    "toolless" => [0, "", ""],
    "toonies" => [1, "", ""],
    "toories" => [1, "", ""],
    "teeth" => [4, "ooth", "OOTH"],
    "toothaches" => [1, "", ""],
    "toothless" => [0, "", ""],
    "tootling" => [0, "", ""],
    "tophes" => [1, "", ""],
    "tophi" => [1, "us", "US"],
    "topes" => [2, "is", "IS"],
    "topless" => [0, "", ""],
    "topoi" => [0, "", ""],
    "torses" => [1, "", ""],
    "tortoises" => [1, "", ""],
    "tori" => [1, "us", "US"],
    "totalling" => [0, "", ""],
    "touchless" => [0, "", ""],
    "touries" => [1, "", ""],
    "towelling" => [0, "", ""],
    "towerless" => [0, "", ""],
    "townfolk" => [0, "", ""],
    "townhouses" => [1, "", ""],
    "townless" => [0, "", ""],
    "townling" => [0, "", ""],
    "townsfolk" => [0, "", ""],
    "toxicoses" => [2, "is", "IS"],
    "toxoplasmoses" => [2, "is", "IS"],
    "toyless" => [0, "", ""],
    "traceless" => [0, "", ""],
    "trackless" => [0, "", ""],
    "tractrices" => [3, "x", "X"],
    "tradeless" => [0, "", ""],
    "tradespeople" => [4, "rson", "RSON"],
    "traditionless" => [0, "", ""],
    "trafficless" => [0, "", ""],
    "tragi" => [1, "us", "US"],
    "trailless" => [0, "", ""],
    "trainless" => [0, "", ""],
    "traipses" => [1, "", ""],
    "tramelling" => [0, "", ""],
    "tramless" => [0, "", ""],
    "trammelling" => [0, "", ""],
    "trampling" => [0, "", ""],
    "tranches" => [1, "", ""],
    "transaminases" => [1, "", ""],
    "transcriptases" => [1, "", ""],
    "transferases" => [1, "", ""],
    "transverses" => [1, "", ""],
    "trapezes" => [1, "", ""],
    "traveling" => [0, "", ""],
    "travelling" => [0, "", ""],
    "traverses" => [1, "", ""],
    "travoises" => [1, "", ""],
    "treadless" => [0, "", ""],
    "treadling" => [0, "", ""],
    "treatises" => [1, "", ""],
    "treehouses" => [1, "", ""],
    "treeless" => [0, "", ""],
    "trehalases" => [1, "", ""],
    "trehaloses" => [1, "", ""],
    "tremies" => [1, "", ""],
    "tremorless" => [0, "", ""],
    "treponematoses" => [2, "is", "IS"],
    "trialling" => [0, "", ""],
    "tribeless" => [0, "", ""],
    "triceps" => [0, "", ""],
    "triceratops" => [0, "", ""],
    "trichiases" => [2, "is", "IS"],
    "trichinoses" => [2, "is", "IS"],
    "trichomoniases" => [2, "is", "IS"],
    "trichoses" => [2, "is", "IS"],
    "trichuriases" => [2, "is", "IS"],
    "trickless" => [0, "", ""],
    "trickling" => [0, "", ""],
    "tricoteuses" => [1, "", ""],
    "triforia" => [1, "um", "UM"],
    "triggerfish" => [0, "", ""],
    "trioses" => [1, "", ""],
    "tripewives" => [3, "fe", "FE"],
    "tripling" => [0, "", ""],
    "tripses" => [2, "is", "IS"],
    "triquetra" => [1, "um", "UM"],
    "trivia" => [1, "um", "UM"],
    "troches" => [1, "", ""],
    "trombiculiases" => [2, "is", "IS"],
    "trombidiases" => [2, "is", "IS"],
    "troolies" => [1, "", ""],
    "troparia" => [1, "on", "ON"],
    "trophallaxes" => [2, "is", "IS"],
    "tropopauses" => [1, "", ""],
    "tropotaxes" => [2, "is", "IS"],
    "trothless" => [0, "", ""],
    "trouses" => [1, "", ""],
    "trout" => [0, "", ""],
    "troutless" => [0, "", ""],
    "troutling" => [0, "", ""],
    "troutperch" => [0, "", ""],
    "trowelling" => [0, "", ""],
    "truceless" => [0, "", ""],
    "truckies" => [1, "", ""],
    "truckling" => [0, "", ""],
    "trumpetfish" => [0, "", ""],
    "trunkfish" => [0, "", ""],
    "trustless" => [0, "", ""],
    "truthless" => [0, "", ""],
    "trymata" => [2, "", ""],
    "trypanosomiases" => [2, "is", "IS"],
    "tsades" => [2, "is", "IS"],
    "tsetses" => [1, "", ""],
    "tsores" => [2, "is", "IS"],
    "tubeless" => [0, "", ""],
    "tubenoses" => [1, "", ""],
    "tuberculoses" => [2, "is", "IS"],
    "tuberoses" => [1, "", ""],
    "tubfish" => [0, "", ""],
    "tuckahoes" => [1, "", ""],
    "tugless" => [0, "", ""],
    "tumorigeneses" => [2, "is", "IS"],
    "tuna" => [0, "", ""],
    "tuneless" => [0, "", ""],
    "tunnelling" => [0, "", ""],
    "turfless" => [0, "", ""],
    "turquoises" => [1, "", ""],
    "tusches" => [1, "", ""],
    "tuskless" => [0, "", ""],
    "twangling" => [0, "", ""],
    "tweedling" => [0, "", ""],
    "tweeling" => [0, "", ""],
    "twigless" => [0, "", ""],
    "twinkling" => [0, "", ""],
    "twinleaves" => [3, "f", "F"],
    "twinling" => [0, "", ""],
    "twopence" => [0, "", ""],
    "tyloses" => [2, "is", "IS"],
    "tympani" => [1, "o", "O"],
    "typecases" => [1, "", ""],
    "tyrosinases" => [1, "", ""],
    "tzetzes" => [1, "", ""],
    "tzitzes" => [2, "is", "IS"],
    "udderless" => [0, "", ""],
    "ukases" => [1, "", ""],
    "ultrafiches" => [1, "", ""],
    "umbilici" => [1, "us", "US"],
    "unai" => [1, "us", "US"],
    "uncharnelling" => [0, "", ""],
    "uncinariases" => [2, "is", "IS"],
    "uncini" => [1, "us", "US"],
    "uncleless" => [0, "", ""],
    "unci" => [1, "us", "US"],
    "undead" => [0, "", ""],
    "underemphases" => [2, "is", "IS"],
    "underglazes" => [1, "", ""],
    "underling" => [0, "", ""],
    "undersealing" => [0, "", ""],
    "undersenses" => [1, "", ""],
    "understrata" => [1, "um", "UM"],
    "uneases" => [1, "", ""],
    "unguenta" => [1, "um", "UM"],
    "ungues" => [2, "is", "IS"],
    "universes" => [1, "", ""],
    "unkennelling" => [0, "", ""],
    "unless" => [0, "", ""],
    "unlevelling" => [0, "", ""],
    "unmilitary" => [0, "", ""],
    "unpanelling" => [0, "", ""],
    "unpeople" => [4, "rson", "RSON"],
    "unravelling" => [0, "", ""],
    "unreligious" => [0, "", ""],
    "untackling" => [0, "", ""],
    "unwon" => [0, "", ""],
    "unyoung" => [0, "", ""],
    "uphroes" => [1, "", ""],
    "uppercases" => [1, "", ""],
    "urares" => [2, "is", "IS"],
    "urases" => [1, "", ""],
    "ureases" => [1, "", ""],
    "uredinia" => [1, "um", "UM"],
    "uredia" => [1, "um", "UM"],
    "ureses" => [2, "is", "IS"],
    "urinalyses" => [2, "is", "IS"],
    "urokinases" => [1, "", ""],
    "urolithiases" => [2, "is", "IS"],
    "uses" => [1, "", ""],
    "useless" => [0, "", ""],
    "uteri" => [1, "us", "US"],
    "utriculi" => [1, "us", "US"],
    "utterless" => [0, "", ""],
    "vacationless" => [0, "", ""],
    "vaginitides" => [3, "s", "S"],
    "vagi" => [1, "us", "US"],
    "valises" => [1, "", ""],
    "valses" => [1, "", ""],
    "valueless" => [0, "", ""],
    "valveless" => [0, "", ""],
    "vaneless" => [0, "", ""],
    "vantageless" => [0, "", ""],
    "vareuses" => [1, "", ""],
    "varicoses" => [2, "is", "IS"],
    "varices" => [3, "x", "X"],
    "vases" => [1, "", ""],
    "vasculitides" => [3, "s", "S"],
    "veges" => [2, "", ""],
    "veggies" => [1, "", ""],
    "vegies" => [1, "", ""],
    "veilless" => [0, "", ""],
    "veinless" => [0, "", ""],
    "vela" => [1, "um", "UM"],
    "vendeuses" => [1, "", ""],
    "ventless" => [0, "", ""],
    "ventriculi" => [1, "us", "US"],
    "ventures" => [2, "is", "IS"],
    "verballing" => [0, "", ""],
    "verbless" => [0, "", ""],
    "verdureless" => [0, "", ""],
    "vermicelli" => [0, "", ""],
    "vermin" => [0, "", ""],
    "verses" => [1, "", ""],
    "vestigia" => [1, "um", "UM"],
    "vestless" => [0, "", ""],
    "vetchling" => [0, "", ""],
    "vetturini" => [1, "o", "O"],
    "vexilla" => [1, "um", "UM"],
    "vialing" => [0, "", ""],
    "vialling" => [0, "", ""],
    "vibices" => [4, "ex", "EX"],
    "vibracularia" => [1, "um", "UM"],
    "vibracula" => [1, "um", "UM"],
    "vibrationless" => [0, "", ""],
    "vibratoless" => [0, "", ""],
    "vibrioses" => [2, "is", "IS"],
    "viceless" => [0, "", ""],
    "vichyssoises" => [1, "", ""],
    "vicomtesses" => [1, "", ""],
    "victimless" => [0, "", ""],
    "victoryless" => [0, "", ""],
    "victualless" => [0, "", ""],
    "victualling" => [0, "", ""],
    "videnda" => [1, "um", "UM"],
    "viewless" => [0, "", ""],
    "villi" => [1, "us", "US"],
    "vinasses" => [1, "", ""],
    "virginia" => [1, "um", "UM"],
    "viroses" => [2, "is", "IS"],
    "virtueless" => [0, "", ""],
    "viscoses" => [1, "", ""],
    "viscera" => [3, "us", "US"],
    "vises" => [1, "", ""],
    "visies" => [1, "", ""],
    "visionless" => [0, "", ""],
    "visorless" => [0, "", ""],
    "vistaless" => [0, "", ""],
    "vitellogeneses" => [2, "is", "IS"],
    "vitesses" => [1, "", ""],
    "vitriolling" => [0, "", ""],
    "vocaleses" => [1, "", ""],
    "voes" => [1, "", ""],
    "voiceless" => [0, "", ""],
    "volitionless" => [0, "", ""],
    "volkslieder" => [2, "", ""],
    "voteless" => [0, "", ""],
    "vowelless" => [0, "", ""],
    "vowelling" => [0, "", ""],
    "vowless" => [0, "", ""],
    "voces" => [3, "x", "X"],
    "vulsella" => [1, "um", "UM"],
    "vulvovaginitides" => [3, "s", "S"],
    "wades" => [2, "is", "IS"],
    "waffies" => [1, "", ""],
    "waffling" => [0, "", ""],
    "wageless" => [0, "", ""],
    "waistless" => [0, "", ""],
    "waitpeople" => [4, "rson", "RSON"],
    "wakeless" => [0, "", ""],
    "wales" => [2, "is", "IS"],
    "walleye" => [0, "", ""],
    "wallless" => [0, "", ""],
    "wangling" => [0, "", ""],
    "wantless" => [0, "", ""],
    "wardless" => [0, "", ""],
    "warehouses" => [1, "", ""],
    "wareless" => [0, "", ""],
    "warhorses" => [1, "", ""],
    "warless" => [0, "", ""],
    "warling" => [0, "", ""],
    "warrantises" => [1, "", ""],
    "warrantless" => [0, "", ""],
    "warsling" => [0, "", ""],
    "warstling" => [0, "", ""],
    "wartless" => [0, "", ""],
    "warwolves" => [3, "f", "F"],
    "wases" => [1, "", ""],
    "washhouses" => [1, "", ""],
    "wasteland" => [0, "", ""],
    "watchcases" => [1, "", ""],
    "watercannon" => [0, "", ""],
    "watercourses" => [1, "", ""],
    "watercraft" => [0, "", ""],
    "waterfowl" => [0, "", ""],
    "waterless" => [0, "", ""],
    "wattless" => [0, "", ""],
    "wattling" => [0, "", ""],
    "waveless" => [0, "", ""],
    "wawling" => [0, "", ""],
    "waygooses" => [1, "", ""],
    "wayless" => [0, "", ""],
    "wayzgooses" => [1, "", ""],
    "weakfish" => [0, "", ""],
    "weakling" => [0, "", ""],
    "weanling" => [0, "", ""],
    "weaponless" => [0, "", ""],
    "weaselling" => [0, "", ""],
    "webfeet" => [3, "oot", "OOT"],
    "webless" => [0, "", ""],
    "weedless" => [0, "", ""],
    "weetless" => [0, "", ""],
    "weightless" => [0, "", ""],
    "weldless" => [0, "", ""],
    "werewolves" => [3, "f", "F"],
    "werwolves" => [3, "f", "F"],
    "whaling" => [0, "", ""],
    "wharfies" => [1, "", ""],
    "wheatsheaves" => [3, "f", "F"],
    "wheelbases" => [1, "", ""],
    "wheelhorses" => [1, "", ""],
    "wheelhouses" => [1, "", ""],
    "wheeling" => [0, "", ""],
    "wheelless" => [0, "", ""],
    "wheepling" => [0, "", ""],
    "wheezes" => [1, "", ""],
    "whereabouts" => [0, "", ""],
    "whiffling" => [0, "", ""],
    "whirling" => [0, "", ""],
    "whiskerless" => [0, "", ""],
    "whistlefish" => [0, "", ""],
    "whistling" => [0, "", ""],
    "whitefish" => [0, "", ""],
    "whitling" => [0, "", ""],
    "whoopies" => [1, "", ""],
    "whorehouses" => [1, "", ""],
    "wickless" => [0, "", ""],
    "widgies" => [1, "", ""],
    "wienies" => [1, "", ""],
    "wives" => [3, "fe", "FE"],
    "wifeless" => [0, "", ""],
    "wifies" => [1, "", ""],
    "wigless" => [0, "", ""],
    "wildfowl" => [0, "", ""],
    "wildling" => [0, "", ""],
    "wimpling" => [0, "", ""],
    "windless" => [0, "", ""],
    "windling" => [0, "", ""],
    "windowless" => [0, "", ""],
    "windroses" => [1, "", ""],
    "windshake" => [0, "", ""],
    "wineless" => [0, "", ""],
    "wingless" => [0, "", ""],
    "winkling" => [0, "", ""],
    "winless" => [0, "", ""],
    "winzes" => [1, "", ""],
    "wises" => [1, "", ""],
    "wiseling" => [0, "", ""],
    "wishless" => [0, "", ""],
    "witeless" => [0, "", ""],
    "withes" => [1, "", ""],
    "witless" => [0, "", ""],
    "witling" => [0, "", ""],
    "wizzes" => [3, "", ""],
    "woes" => [1, "", ""],
    "wolves" => [3, "f", "F"],
    "wolffish" => [0, "", ""],
    "wolfling" => [0, "", ""],
    "womanless" => [0, "", ""],
    "won" => [0, "", ""],
    "wontless" => [0, "", ""],
    "woodgrouse" => [0, "", ""],
    "woodhouses" => [1, "", ""],
    "woodless" => [0, "", ""],
    "woodmice" => [3, "ouse", "OUSE"],
    "woodwoses" => [1, "", ""],
    "wordless" => [0, "", ""],
    "workhorses" => [1, "", ""],
    "workhouses" => [1, "", ""],
    "workless" => [0, "", ""],
    "worldling" => [0, "", ""],
    "wormfish" => [0, "", ""],
    "worses" => [1, "", ""],
    "worshipless" => [0, "", ""],
    "worthless" => [0, "", ""],
    "woundless" => [0, "", ""],
    "wrangling" => [0, "", ""],
    "wrasses" => [1, "", ""],
    "wreakless" => [0, "", ""],
    "wreathless" => [0, "", ""],
    "wreckfish" => [0, "", ""],
    "wrestling" => [0, "", ""],
    "wrinkleless" => [0, "", ""],
    "writhes" => [1, "", ""],
    "xanthomatoses" => [2, "is", "IS"],
    "xenia" => [1, "um", "UM"],
    "xenodiagnoses" => [2, "is", "IS"],
    "xenogeneses" => [2, "is", "IS"],
    "xeroses" => [2, "is", "IS"],
    "xoana" => [1, "on", "ON"],
    "xyloses" => [1, "", ""],
    "yachties" => [1, "", ""],
    "yawling" => [0, "", ""],
    "yealing" => [0, "", ""],
    "yeanling" => [0, "", ""],
    "yearling" => [0, "", ""],
    "yersinioses" => [2, "is", "IS"],
    "yippies" => [1, "", ""],
    "yodeling" => [0, "", ""],
    "yodelling" => [0, "", ""],
    "yodling" => [0, "", ""],
    "yokeless" => [0, "", ""],
    "ya" => [1, "um", "UM"],
    "young" => [0, "", ""],
    "youngling" => [0, "", ""],
    "yourselves" => [3, "f", "F"],
    "yowies" => [1, "", ""],
    "yowling" => [0, "", ""],
    "yuan" => [0, "", ""],
    "zamouses" => [1, "", ""],
    "zanzes" => [1, "", ""],
    "zealless" => [0, "", ""],
    "zelatrices" => [3, "x", "X"],
    "zestless" => [0, "", ""],
    "zipless" => [0, "", ""],
    "zizzling" => [0, "", ""],
    "zoecia" => [1, "um", "UM"],
    "zombies" => [1, "", ""],
    "zoneless" => [0, "", ""],
    "zoocytia" => [1, "um", "UM"],
    "zooecia" => [1, "um", "UM"],
    "zoogonidia" => [1, "um", "UM"],
    "zoonoses" => [2, "is", "IS"],
    "zoothecia" => [1, "um", "UM"],
    "zygapophyses" => [2, "is", "IS"],
    "zygogeneses" => [2, "is", "IS"],
    "zygoses" => [2, "is", "IS"],
    "zymases" => [1, "", ""],
    "zymogeneses" => [2, "is", "IS"],
    "zymolyses" => [2, "is", "IS"],
    "zymoses" => [2, "is", "IS"],
  }
end
