module StringInflection
  SINGULARS = {
    "acalepha" => [0, "e", "E"],
    "acarida" => [0, "e", "E"],
    "actaeon" => [2, "a", "A"],
    "alabaman" => [0, "s", "S"],
    "alderney" => [0, "s", "S"],
    "alpino" => [1, "i", "I"],
    "anser" => [0, "es", "ES"],
    "apium" => [2, "a", "A"],
    "aquilon" => [2, "a", "A"],
    "ar" => [0, "es", "ES"],
    "aranea" => [0, "e", "E"],
    "arapaho" => [0, "es", "ES"],
    "aston" => [0, "", ""],
    "atlantis" => [2, "es", "ES"],
    "atman" => [0, "s", "S"],
    "birman" => [0, "s", "S"],
    "blackfoot" => [3, "eet", "EET"],
    "bradbury" => [0, "s", "S"],
    "brahman" => [0, "s", "S"],
    "bramley" => [0, "s", "S"],
    "broadway" => [0, "s", "S"],
    "bryum" => [2, "a", "A"],
    "burley" => [0, "s", "S"],
    "burman" => [0, "s", "S"],
    "callum" => [2, "a", "A"],
    "carum" => [2, "a", "A"],
    "cestida" => [0, "e", "E"],
    "charadrius" => [2, "i", "I"],
    "chardonnay" => [0, "s", "S"],
    "charley" => [0, "s", "S"],
    "charon" => [2, "a", "A"],
    "chesterton" => [0, "", ""],
    "chippeway" => [0, "s", "S"],
    "christless" => [0, "", ""],
    "chumash" => [0, "es", "ES"],
    "church" => [0, "es", "ES"],
    "cincinnatus" => [2, "i", "I"],
    "co" => [1, "i", "I"],
    "cockney" => [0, "s", "S"],
    "comnenus" => [2, "i", "I"],
    "congressperson" => [4, "ople", "OPLE"],
    "cornish" => [0, "es", "ES"],
    "curia" => [0, "e", "E"],
    "dahoman" => [0, "s", "S"],
    "damon" => [2, "a", "A"],
    "dana" => [0, "e", "E"],
    "danton" => [0, "", ""],
    "darlington" => [0, "", ""],
    "day" => [0, "s", "S"],
    "dayton" => [0, "", ""],
    "denis" => [2, "es", "ES"],
    "doberman" => [0, "s", "S"],
    "ealing" => [0, "", ""],
    "echinoderma" => [0, "ta", "TA"],
    "elo" => [1, "i", "I"],
    "english" => [0, "es", "ES"],
    "ephemerida" => [0, "e", "E"],
    "fenriswolf" => [0, "", ""],
    "francis" => [2, "es", "ES"],
    "fredericton" => [0, "", ""],
    "french" => [0, "es", "ES"],
    "friday" => [0, "s", "S"],
    "galloway" => [0, "s", "S"],
    "gamay" => [0, "s", "S"],
    "german" => [0, "s", "S"],
    "gerris" => [2, "es", "ES"],
    "gil" => [0, "es", "ES"],
    "graf" => [1, "ves", "VES"],
    "gray" => [0, "s", "S"],
    "greekless" => [0, "", ""],
    "greekling" => [0, "", ""],
    "guernsey" => [0, "s", "S"],
    "guy" => [0, "s", "S"],
    "hackney" => [0, "s", "S"],
    "herero" => [0, "es", "ES"],
    "hindus" => [2, "i", "I"],
    "hogmanay" => [0, "s", "S"],
    "huichol" => [0, "es", "ES"],
    "hunkey" => [0, "s", "S"],
    "idaho" => [0, "es", "ES"],
    "idolum" => [2, "a", "A"],
    "ireland" => [0, "", ""],
    "ixion" => [2, "a", "A"],
    "jersey" => [0, "s", "S"],
    "kaddish" => [0, "es", "ES"],
    "kaffeeklatsch" => [0, "es", "ES"],
    "kerman" => [0, "s", "S"],
    "kirman" => [0, "s", "S"],
    "kum" => [2, "a", "A"],
    "kutenay" => [0, "s", "S"],
    "larus" => [2, "i", "I"],
    "laski" => [0, "", ""],
    "lavabo" => [0, "es", "ES"],
    "leighton" => [0, "", ""],
    "limey" => [0, "s", "S"],
    "luton" => [0, "", ""],
    "mach" => [0, "es", "ES"],
    "mafioso" => [1, "i", "I"],
    "magus" => [2, "i", "I"],
    "mahabharatum" => [2, "a", "A"],
    "malay" => [0, "s", "S"],
    "malmsey" => [0, "s", "S"],
    "malus" => [2, "i", "I"],
    "mandingo" => [0, "es", "ES"],
    "manis" => [2, "es", "ES"],
    "march" => [0, "es", "ES"],
    "marion" => [2, "a", "A"],
    "may" => [0, "s", "S"],
    "mayday" => [0, "s", "S"],
    "mccoy" => [0, "s", "S"],
    "mcintosh" => [0, "es", "ES"],
    "menura" => [0, "e", "E"],
    "mickey" => [0, "s", "S"],
    "middleton" => [0, "", ""],
    "minton" => [0, "", ""],
    "miro" => [1, "i", "I"],
    "mithraeum" => [2, "a", "A"],
    "moira" => [0, "e", "E"],
    "monday" => [0, "s", "S"],
    "moresco" => [0, "es", "ES"],
    "morisco" => [0, "es", "ES"],
    "morton" => [2, "a", "A"],
    "mudejar" => [0, "es", "ES"],
    "mussalman" => [0, "s", "S"],
    "mussulman" => [0, "s", "S"],
    "myanman" => [0, "s", "S"],
    "nairobi" => [0, "", ""],
    "navaho" => [0, "es", "ES"],
    "navajo" => [0, "es", "ES"],
    "negrillo" => [0, "es", "ES"],
    "negrito" => [0, "es", "ES"],
    "negro" => [0, "es", "ES"],
    "neski" => [0, "", ""],
    "nimby" => [0, "s", "S"],
    "nisei" => [0, "", ""],
    "no" => [0, "es", "ES"],
    "norman" => [0, "s", "S"],
    "ojibway" => [0, "s", "S"],
    "oklahoman" => [0, "s", "S"],
    "ophiurida" => [0, "e", "E"],
    "orkney" => [0, "s", "S"],
    "othman" => [0, "s", "S"],
    "ottoman" => [0, "s", "S"],
    "paisley" => [0, "s", "S"],
    "palma" => [0, "e", "E"],
    "parca" => [0, "e", "E"],
    "pekinese" => [0, "", ""],
    "pekingese" => [0, "", ""],
    "phasmida" => [0, "e", "E"],
    "pisum" => [2, "a", "A"],
    "pollack" => [0, "", ""],
    "pollock" => [0, "", ""],
    "pomacanthus" => [0, "", ""],
    "potlatch" => [0, "es", "ES"],
    "presidium" => [2, "a", "A"],
    "ptloris" => [0, "", ""],
    "pullman" => [0, "s", "S"],
    "ra" => [0, "e", "E"],
    "raj" => [0, "es", "ES"],
    "rhenish" => [0, "es", "ES"],
    "roman" => [0, "s", "S"],
    "romney" => [0, "s", "S"],
    "ron" => [2, "a", "A"],
    "sabbathless" => [0, "", ""],
    "sarum" => [2, "a", "A"],
    "sasquatch" => [0, "es", "ES"],
    "saturday" => [0, "s", "S"],
    "sawney" => [0, "s", "S"],
    "scotch" => [0, "es", "ES"],
    "seeland" => [0, "", ""],
    "sertoman" => [0, "s", "S"],
    "shoshonis" => [2, "es", "ES"],
    "sidon" => [2, "a", "A"],
    "siwash" => [0, "es", "ES"],
    "spanglish" => [0, "es", "ES"],
    "sunday" => [0, "s", "S"],
    "sunfish" => [0, "", ""],
    "sus" => [2, "i", "I"],
    "tannoy" => [0, "s", "S"],
    "thursday" => [0, "s", "S"],
    "tinkertoy" => [0, "s", "S"],
    "tokay" => [0, "s", "S"],
    "troy" => [0, "s", "S"],
    "tuesday" => [0, "s", "S"],
    "turcoman" => [0, "s", "S"],
    "turkoman" => [0, "s", "S"],
    "tyrannus" => [2, "i", "I"],
    "veneto" => [1, "i", "I"],
    "vouvray" => [0, "s", "S"],
    "walkman" => [0, "s", "S"],
    "wednesday" => [0, "s", "S"],
    "whitey" => [0, "s", "S"],
    "whitmonday" => [0, "s", "S"],
    "whitsunday" => [0, "s", "S"],
    "winnebago" => [0, "es", "ES"],
    "yinglish" => [0, "es", "ES"],
    "yuman" => [0, "s", "S"],
    "zingano" => [1, "i", "I"],
    "zingaro" => [1, "i", "I"],
    "zircaloy" => [0, "s", "S"],
    "aardwolf" => [1, "ves", "VES"],
    "abashless" => [0, "", ""],
    "abbes" => [0, "ses", "SES"],
    "abbey" => [0, "s", "S"],
    "abiogenesis" => [2, "es", "ES"],
    "abiosis" => [2, "es", "ES"],
    "abomasum" => [2, "a", "A"],
    "abrash" => [0, "es", "ES"],
    "acariasis" => [2, "es", "ES"],
    "acaridomatium" => [2, "a", "A"],
    "acarus" => [2, "i", "I"],
    "accentless" => [0, "", ""],
    "acervulus" => [2, "i", "I"],
    "acidosis" => [2, "es", "ES"],
    "acinus" => [2, "i", "I"],
    "acroterion" => [2, "a", "A"],
    "actinobacillus" => [2, "i", "I"],
    "actinomycosis" => [2, "es", "ES"],
    "actionless" => [0, "", ""],
    "aculeus" => [2, "i", "I"],
    "addendum" => [2, "a", "A"],
    "addling" => [0, "", ""],
    "adenohypophysis" => [2, "es", "ES"],
    "adenosis" => [2, "es", "ES"],
    "adiaphoron" => [2, "a", "A"],
    "adiposis" => [2, "es", "ES"],
    "adventures" => [0, "ses", "SES"],
    "adytum" => [2, "a", "A"],
    "aecidium" => [2, "a", "A"],
    "aecium" => [2, "a", "A"],
    "aerobiosis" => [2, "es", "ES"],
    "aerobium" => [2, "a", "A"],
    "aeroneurosis" => [2, "es", "ES"],
    "affectionless" => [0, "", ""],
    "affectless" => [0, "", ""],
    "affray" => [0, "s", "S"],
    "afterlife" => [2, "ves", "VES"],
    "agamogenesis" => [2, "es", "ES"],
    "agape" => [1, "ae", "AE"],
    "ageless" => [0, "", ""],
    "agendaless" => [0, "", ""],
    "agenesis" => [2, "es", "ES"],
    "ageratum" => [0, "", ""],
    "agranulocytosis" => [2, "es", "ES"],
    "ahoy" => [0, "s", "S"],
    "aidless" => [0, "", ""],
    "ailing" => [0, "", ""],
    "aimless" => [0, "", ""],
    "airbrush" => [0, "es", "ES"],
    "aircoach" => [0, "es", "ES"],
    "aircraft" => [0, "", ""],
    "airless" => [0, "", ""],
    "airplay" => [0, "s", "S"],
    "airway" => [0, "s", "S"],
    "aisleway" => [0, "s", "S"],
    "aisling" => [0, "", ""],
    "aitch" => [0, "es", "ES"],
    "albacore" => [0, "", ""],
    "albatross" => [0, "", ""],
    "albedo" => [0, "es", "ES"],
    "alebench" => [0, "es", "ES"],
    "alewife" => [2, "ves", "VES"],
    "alga" => [0, "e", "E"],
    "alibis" => [0, "", ""],
    "alkali" => [0, "es", "ES"],
    "alkalosis" => [2, "es", "ES"],
    "alley" => [0, "s", "S"],
    "alleyway" => [0, "s", "S"],
    "alligatorfish" => [0, "", ""],
    "alloy" => [0, "s", "S"],
    "almsfolk" => [0, "", ""],
    "alnico" => [0, "es", "ES"],
    "alphosis" => [2, "es", "ES"],
    "altocumulus" => [2, "i", "I"],
    "altostratus" => [2, "i", "I"],
    "alumna" => [0, "e", "E"],
    "alumnus" => [2, "i", "I"],
    "alveola" => [0, "e", "E"],
    "alveolus" => [2, "i", "I"],
    "alway" => [0, "s", "S"],
    "amanuensis" => [2, "es", "ES"],
    "amaurosis" => [2, "es", "ES"],
    "ambatch" => [0, "es", "ES"],
    "amberfish" => [0, "", ""],
    "ambitionless" => [0, "", ""],
    "ambulacrum" => [2, "a", "A"],
    "ambuscado" => [0, "es", "ES"],
    "ambush" => [0, "es", "ES"],
    "amebiasis" => [2, "es", "ES"],
    "amentum" => [2, "a", "A"],
    "amicus" => [2, "i", "I"],
    "amitosis" => [2, "es", "ES"],
    "amman" => [0, "s", "S"],
    "amniocentesis" => [2, "es", "ES"],
    "amoebiasis" => [2, "es", "ES"],
    "amorino" => [1, "i", "I"],
    "ampelopsis" => [2, "es", "ES"],
    "amphiarthrosis" => [2, "es", "ES"],
    "amphigastrium" => [2, "a", "A"],
    "amphimixis" => [2, "es", "ES"],
    "amphithecium" => [2, "a", "A"],
    "amphora" => [0, "e", "E"],
    "ampulla" => [0, "e", "E"],
    "amtman" => [0, "s", "S"],
    "amyloidosis" => [2, "es", "ES"],
    "amylolysis" => [2, "es", "ES"],
    "anabasis" => [2, "es", "ES"],
    "anabiosis" => [2, "es", "ES"],
    "anabranch" => [0, "es", "ES"],
    "anaclisis" => [2, "es", "ES"],
    "anacrusis" => [2, "es", "ES"],
    "anadiplosis" => [2, "es", "ES"],
    "anaerobiosis" => [2, "es", "ES"],
    "anagenesis" => [2, "es", "ES"],
    "anagnorisis" => [2, "es", "ES"],
    "analysis" => [2, "es", "ES"],
    "anamnesis" => [2, "es", "ES"],
    "anamorphosis" => [2, "es", "ES"],
    "anaphylaxis" => [2, "es", "ES"],
    "anaplasmosis" => [2, "es", "ES"],
    "anaptyxis" => [2, "es", "ES"],
    "anastomosis" => [2, "es", "ES"],
    "anchorless" => [0, "", ""],
    "anchorperson" => [4, "ople", "OPLE"],
    "anchylosis" => [2, "es", "ES"],
    "ancylostomiasis" => [2, "es", "ES"],
    "androecium" => [2, "a", "A"],
    "androgenesis" => [2, "es", "ES"],
    "aneling" => [0, "", ""],
    "anemosis" => [2, "es", "ES"],
    "angelfish" => [0, "", ""],
    "angerless" => [0, "", ""],
    "angiogenesis" => [2, "es", "ES"],
    "anglerfish" => [0, "", ""],
    "anguish" => [0, "es", "ES"],
    "animalculum" => [2, "a", "A"],
    "animis" => [2, "es", "ES"],
    "ankush" => [0, "es", "ES"],
    "ankylosis" => [2, "es", "ES"],
    "ankylostomiasis" => [2, "es", "ES"],
    "annulling" => [0, "", ""],
    "anoesis" => [2, "es", "ES"],
    "anopheles" => [0, "", ""],
    "ansa" => [0, "e", "E"],
    "answerless" => [0, "", ""],
    "antalkali" => [0, "es", "ES"],
    "antefixa" => [0, "e", "E"],
    "antelope" => [0, "", ""],
    "anthelix" => [1, "ces", "CES"],
    "anthemion" => [2, "a", "A"],
    "anthesis" => [2, "es", "ES"],
    "anthodium" => [2, "a", "A"],
    "anthracosis" => [2, "es", "ES"],
    "anthrax" => [1, "ces", "CES"],
    "anthropogenesis" => [2, "es", "ES"],
    "anthropophagi" => [0, "es", "ES"],
    "anthropophagus" => [2, "i", "I"],
    "antiaircraft" => [0, "", ""],
    "antibiosis" => [2, "es", "ES"],
    "antibourgeois" => [0, "", ""],
    "anticling" => [0, "", ""],
    "antihelix" => [1, "ces", "CES"],
    "antihero" => [0, "es", "ES"],
    "antimilitary" => [0, "", ""],
    "antiperistalsis" => [2, "es", "ES"],
    "antiphrasis" => [2, "es", "ES"],
    "antipolice" => [0, "", ""],
    "antipyresis" => [2, "es", "ES"],
    "antirabies" => [0, "", ""],
    "antireligious" => [0, "", ""],
    "antis" => [2, "es", "ES"],
    "antisepsis" => [2, "es", "ES"],
    "antithesis" => [2, "es", "ES"],
    "antitragus" => [2, "i", "I"],
    "antlia" => [0, "e", "E"],
    "anuresis" => [2, "es", "ES"],
    "anvilling" => [0, "", ""],
    "anyway" => [0, "s", "S"],
    "apay" => [0, "s", "S"],
    "aphaeresis" => [2, "es", "ES"],
    "aphelion" => [2, "a", "A"],
    "apheresis" => [2, "es", "ES"],
    "aphesis" => [2, "es", "ES"],
    "aphtha" => [0, "e", "E"],
    "apiculus" => [2, "i", "I"],
    "apneusis" => [2, "es", "ES"],
    "apocryphon" => [2, "a", "A"],
    "apodosis" => [2, "es", "ES"],
    "aponeurosis" => [2, "es", "ES"],
    "apophasis" => [2, "es", "ES"],
    "apophysis" => [2, "es", "ES"],
    "apoptosis" => [2, "es", "ES"],
    "aposiopesis" => [2, "es", "ES"],
    "apothecium" => [2, "a", "A"],
    "apotheosis" => [2, "es", "ES"],
    "appalling" => [0, "", ""],
    "appalto" => [1, "i", "I"],
    "apparelling" => [0, "", ""],
    "appay" => [0, "s", "S"],
    "appendix" => [1, "ces", "CES"],
    "appressorium" => [2, "a", "A"],
    "approach" => [0, "es", "ES"],
    "apsis" => [2, "es", "ES"],
    "apterium" => [2, "a", "A"],
    "arch" => [0, "es", "ES"],
    "archaebacterium" => [2, "a", "A"],
    "archegonium" => [2, "a", "A"],
    "archerfish" => [0, "", ""],
    "archesporium" => [2, "a", "A"],
    "archway" => [0, "s", "S"],
    "areaway" => [0, "s", "S"],
    "argulus" => [2, "i", "I"],
    "argumentum" => [2, "a", "A"],
    "ariboflavinosis" => [2, "es", "ES"],
    "arillus" => [2, "i", "I"],
    "arish" => [0, "es", "ES"],
    "arling" => [0, "", ""],
    "armless" => [0, "", ""],
    "armorless" => [0, "", ""],
    "array" => [0, "s", "S"],
    "arrish" => [0, "es", "ES"],
    "arsis" => [2, "es", "ES"],
    "arteriosclerosis" => [2, "es", "ES"],
    "arthritis" => [1, "des", "DES"],
    "arthrodesis" => [2, "es", "ES"],
    "arthrosis" => [2, "es", "ES"],
    "articling" => [0, "", ""],
    "artless" => [0, "", ""],
    "aruspex" => [2, "ices", "ICES"],
    "asbestosis" => [2, "es", "ES"],
    "ascariasis" => [2, "es", "ES"],
    "ascesis" => [2, "es", "ES"],
    "ascidium" => [2, "a", "A"],
    "ascogonium" => [2, "a", "A"],
    "ascoma" => [0, "ta", "TA"],
    "ascus" => [2, "i", "I"],
    "asepsis" => [2, "es", "ES"],
    "ash" => [0, "es", "ES"],
    "ashake" => [0, "", ""],
    "ashless" => [0, "", ""],
    "ashtray" => [0, "s", "S"],
    "askesis" => [2, "es", "ES"],
    "aspergillosis" => [2, "es", "ES"],
    "aspergillus" => [2, "i", "I"],
    "aspidium" => [2, "a", "A"],
    "aspirata" => [0, "e", "E"],
    "assailing" => [0, "", ""],
    "assay" => [0, "s", "S"],
    "asteriskless" => [0, "", ""],
    "asynapsis" => [2, "es", "ES"],
    "ataman" => [0, "s", "S"],
    "atelectasis" => [2, "es", "ES"],
    "atherogenesis" => [2, "es", "ES"],
    "atheromatosis" => [2, "es", "ES"],
    "atherosclerosis" => [2, "es", "ES"],
    "athetosis" => [2, "es", "ES"],
    "athrocytosis" => [2, "es", "ES"],
    "atmolysis" => [2, "es", "ES"],
    "atrium" => [2, "a", "A"],
    "attaboy" => [0, "s", "S"],
    "attorney" => [0, "s", "S"],
    "aureus" => [2, "i", "I"],
    "auris" => [2, "es", "ES"],
    "auspex" => [2, "ices", "ICES"],
    "austral" => [0, "es", "ES"],
    "authorless" => [0, "", ""],
    "autocatalysis" => [2, "es", "ES"],
    "autogenesis" => [2, "es", "ES"],
    "autohypnosis" => [2, "es", "ES"],
    "autolysis" => [2, "es", "ES"],
    "auxesis" => [2, "es", "ES"],
    "avitaminosis" => [2, "es", "ES"],
    "away" => [0, "s", "S"],
    "aweless" => [0, "", ""],
    "awless" => [0, "", ""],
    "awnless" => [0, "", ""],
    "axilemma" => [0, "ta", "TA"],
    "ay" => [0, "es", "ES"],
    "babesiasis" => [2, "es", "ES"],
    "babesiosis" => [2, "es", "ES"],
    "bacchanalia" => [0, "", ""],
    "bacchius" => [2, "i", "I"],
    "bacillus" => [2, "i", "I"],
    "backbench" => [0, "es", "ES"],
    "backboneless" => [0, "", ""],
    "backlash" => [0, "es", "ES"],
    "backless" => [0, "", ""],
    "backpedalling" => [0, "", ""],
    "backrush" => [0, "es", "ES"],
    "backsey" => [0, "s", "S"],
    "backsheesh" => [0, "es", "ES"],
    "backshish" => [0, "es", "ES"],
    "backslash" => [0, "es", "ES"],
    "backsplash" => [0, "es", "ES"],
    "backstay" => [0, "s", "S"],
    "backstitch" => [0, "es", "ES"],
    "backstretch" => [0, "es", "ES"],
    "backwash" => [0, "es", "ES"],
    "bacteriolysis" => [2, "es", "ES"],
    "bacteriostasis" => [2, "es", "ES"],
    "bacterium" => [2, "a", "A"],
    "baffling" => [0, "", ""],
    "bagwash" => [0, "es", "ES"],
    "bailey" => [0, "s", "S"],
    "baitfish" => [0, "", ""],
    "bakhshish" => [0, "es", "ES"],
    "baksheesh" => [0, "es", "ES"],
    "bakshish" => [0, "es", "ES"],
    "balderdash" => [0, "es", "ES"],
    "baldmoney" => [0, "s", "S"],
    "baling" => [0, "", ""],
    "balling" => [0, "", ""],
    "balloonfish" => [0, "", ""],
    "baloney" => [0, "s", "S"],
    "ban" => [0, "i", "I"],
    "bandeau" => [0, "x", "X"],
    "bandersnatch" => [0, "es", "ES"],
    "bandfish" => [0, "", ""],
    "bandless" => [0, "", ""],
    "bantling" => [0, "", ""],
    "barbasco" => [0, "es", "ES"],
    "barbless" => [0, "", ""],
    "bardash" => [0, "es", "ES"],
    "bardling" => [0, "", ""],
    "barkless" => [0, "", ""],
    "barless" => [0, "", ""],
    "barley" => [0, "s", "S"],
    "barney" => [0, "s", "S"],
    "barracks" => [0, "", ""],
    "barrelfish" => [0, "", ""],
    "barreling" => [0, "", ""],
    "barrelling" => [0, "", ""],
    "barrico" => [0, "es", "ES"],
    "baseless" => [0, "", ""],
    "basementless" => [0, "", ""],
    "bash" => [0, "es", "ES"],
    "bashless" => [0, "", ""],
    "basidium" => [2, "a", "A"],
    "basis" => [2, "es", "ES"],
    "bastinado" => [0, "es", "ES"],
    "batboy" => [0, "s", "S"],
    "batch" => [0, "es", "ES"],
    "bateau" => [0, "x", "X"],
    "batfish" => [0, "", ""],
    "bathless" => [0, "", ""],
    "batteau" => [0, "x", "X"],
    "battling" => [0, "", ""],
    "baud" => [0, "", ""],
    "bawley" => [0, "s", "S"],
    "bay" => [0, "s", "S"],
    "bayadeer" => [0, "", ""],
    "beach" => [0, "es", "ES"],
    "beachboy" => [0, "s", "S"],
    "beakless" => [0, "", ""],
    "beamless" => [0, "", ""],
    "beardless" => [0, "", ""],
    "beatless" => [0, "", ""],
    "beautybush" => [0, "es", "ES"],
    "becudgelling" => [0, "", ""],
    "bedevilling" => [0, "", ""],
    "bedless" => [0, "", ""],
    "bedrivelling" => [0, "", ""],
    "beech" => [0, "es", "ES"],
    "beef" => [1, "ves", "VES"],
    "beefalo" => [0, "es", "ES"],
    "beefless" => [0, "", ""],
    "beetling" => [0, "", ""],
    "begirdling" => [0, "", ""],
    "behalf" => [1, "ves", "VES"],
    "beingless" => [0, "", ""],
    "bejewelling" => [0, "", ""],
    "belay" => [0, "s", "S"],
    "belch" => [0, "es", "ES"],
    "beliefless" => [0, "", ""],
    "bellboy" => [0, "s", "S"],
    "belling" => [0, "", ""],
    "bellpush" => [0, "es", "ES"],
    "bellyless" => [0, "", ""],
    "beltless" => [0, "", ""],
    "beltway" => [0, "s", "S"],
    "bench" => [0, "es", "ES"],
    "bendy" => [0, "s", "S"],
    "benis" => [2, "es", "ES"],
    "bennis" => [2, "es", "ES"],
    "berceau" => [0, "x", "X"],
    "berdash" => [0, "es", "ES"],
    "betrothed" => [0, "", ""],
    "bevelling" => [0, "", ""],
    "bey" => [0, "s", "S"],
    "bibless" => [0, "", ""],
    "biceps" => [0, "", ""],
    "biga" => [0, "e", "E"],
    "bijou" => [0, "x", "X"],
    "bikeway" => [0, "s", "S"],
    "bilbo" => [0, "es", "ES"],
    "bildungsroman" => [0, "s", "S"],
    "bilharziasis" => [2, "es", "ES"],
    "billfish" => [0, "", ""],
    "billibis" => [0, "", ""],
    "billionaires" => [0, "ses", "SES"],
    "billyboy" => [0, "s", "S"],
    "bioassay" => [0, "s", "S"],
    "biocenosis" => [2, "es", "ES"],
    "biocoenosis" => [2, "es", "ES"],
    "biogenesis" => [2, "es", "ES"],
    "biolysis" => [2, "es", "ES"],
    "biosynthesis" => [2, "es", "ES"],
    "birch" => [0, "es", "ES"],
    "birthday" => [0, "s", "S"],
    "biscotto" => [1, "i", "I"],
    "bish" => [0, "es", "ES"],
    "bison" => [0, "", ""],
    "bitch" => [0, "es", "ES"],
    "bitless" => [0, "", ""],
    "bitterbrush" => [0, "es", "ES"],
    "bitterling" => [0, "", ""],
    "biz" => [0, "zes", "ZES"],
    "blackboy" => [0, "s", "S"],
    "blackfish" => [0, "", ""],
    "blameless" => [0, "", ""],
    "blarney" => [0, "s", "S"],
    "blash" => [0, "es", "ES"],
    "blastogenesis" => [2, "es", "ES"],
    "blastomycosis" => [2, "es", "ES"],
    "blay" => [0, "s", "S"],
    "bleach" => [0, "es", "ES"],
    "blemish" => [0, "es", "ES"],
    "blepharitis" => [1, "des", "DES"],
    "blimey" => [0, "s", "S"],
    "blindfish" => [0, "", ""],
    "blindless" => [0, "", ""],
    "blissless" => [0, "", ""],
    "bloodless" => [0, "", ""],
    "bloomless" => [0, "", ""],
    "blotch" => [0, "es", "ES"],
    "blotless" => [0, "", ""],
    "blowby" => [0, "s", "S"],
    "blowfish" => [0, "", ""],
    "blowtorch" => [0, "es", "ES"],
    "bluebuck" => [0, "", ""],
    "bluefish" => [0, "es", "ES"],
    "bluejay" => [0, "s", "S"],
    "bluey" => [0, "s", "S"],
    "blush" => [0, "es", "ES"],
    "blushless" => [0, "", ""],
    "boarfish" => [0, "", ""],
    "boastless" => [0, "", ""],
    "bobstay" => [0, "s", "S"],
    "boccis" => [2, "es", "ES"],
    "bodyless" => [0, "", ""],
    "bogey" => [0, "s", "S"],
    "boloney" => [0, "s", "S"],
    "boltless" => [0, "", ""],
    "bondless" => [0, "", ""],
    "bonefish" => [0, "", ""],
    "boneless" => [0, "", ""],
    "bookless" => [0, "", ""],
    "bookshelf" => [1, "ves", "VES"],
    "boomless" => [0, "", ""],
    "boonless" => [0, "", ""],
    "bootboy" => [0, "s", "S"],
    "bootless" => [0, "", ""],
    "borborygmus" => [2, "i", "I"],
    "bordereau" => [0, "x", "X"],
    "borderless" => [0, "", ""],
    "borsch" => [0, "es", "ES"],
    "bortsch" => [0, "es", "ES"],
    "bosh" => [0, "es", "ES"],
    "botargo" => [0, "es", "ES"],
    "botch" => [0, "es", "ES"],
    "bottlebrush" => [0, "es", "ES"],
    "bottling" => [0, "", ""],
    "bottomless" => [0, "", ""],
    "boughless" => [0, "", ""],
    "boundless" => [0, "", ""],
    "bourgeois" => [0, "", ""],
    "bowelless" => [0, "", ""],
    "bowelling" => [0, "", ""],
    "bowless" => [0, "", ""],
    "bowling" => [0, "", ""],
    "boxfish" => [0, "", ""],
    "boy" => [0, "s", "S"],
    "brach" => [0, "es", "ES"],
    "brachium" => [2, "a", "A"],
    "bractless" => [0, "", ""],
    "bragless" => [0, "", ""],
    "brailling" => [0, "", ""],
    "brainchild" => [0, "ren", "REN"],
    "braindead" => [0, "", ""],
    "brainless" => [0, "", ""],
    "brakeless" => [0, "", ""],
    "braless" => [0, "", ""],
    "branch" => [0, "es", "ES"],
    "branchia" => [0, "e", "E"],
    "branchless" => [0, "", ""],
    "brandish" => [0, "es", "ES"],
    "brandling" => [0, "", ""],
    "brash" => [0, "es", "ES"],
    "bratling" => [0, "", ""],
    "bravado" => [0, "es", "ES"],
    "brawling" => [0, "", ""],
    "bray" => [0, "s", "S"],
    "breach" => [0, "es", "ES"],
    "breakaway" => [0, "s", "S"],
    "breastless" => [0, "", ""],
    "breathless" => [0, "", ""],
    "breech" => [0, "es", "ES"],
    "breechless" => [0, "", ""],
    "breezeless" => [0, "", ""],
    "breezeway" => [0, "s", "S"],
    "bregma" => [0, "ta", "TA"],
    "breis" => [2, "es", "ES"],
    "bridgeless" => [0, "", ""],
    "bridleway" => [0, "s", "S"],
    "briefless" => [0, "", ""],
    "brimless" => [0, "", ""],
    "brisling" => [0, "", ""],
    "brittlebush" => [0, "es", "ES"],
    "brittling" => [0, "", ""],
    "broach" => [0, "es", "ES"],
    "broadleaf" => [1, "ves", "VES"],
    "broch" => [0, "es", "ES"],
    "bronchiectasis" => [2, "es", "ES"],
    "bronchium" => [2, "a", "A"],
    "bronchus" => [2, "i", "I"],
    "brooch" => [0, "es", "ES"],
    "browless" => [0, "", ""],
    "brucellosis" => [2, "es", "ES"],
    "brunch" => [0, "es", "ES"],
    "brush" => [0, "es", "ES"],
    "brushless" => [0, "", ""],
    "bubo" => [0, "es", "ES"],
    "buckling" => [0, "", ""],
    "bucko" => [0, "es", "ES"],
    "bucktooth" => [4, "eeth", "EETH"],
    "budless" => [0, "", ""],
    "buffalo" => [0, "es", "ES"],
    "buffalofish" => [0, "", ""],
    "bugling" => [0, "", ""],
    "bulbless" => [0, "", ""],
    "bullfinch" => [0, "es", "ES"],
    "bullrush" => [0, "es", "ES"],
    "bullyboy" => [0, "s", "S"],
    "bulrush" => [0, "es", "ES"],
    "bunch" => [0, "es", "ES"],
    "bundling" => [0, "", ""],
    "bungey" => [0, "s", "S"],
    "bungling" => [0, "", ""],
    "buoy" => [0, "s", "S"],
    "burbling" => [0, "", ""],
    "burdash" => [0, "es", "ES"],
    "burgling" => [0, "", ""],
    "burling" => [0, "", ""],
    "burnish" => [0, "es", "ES"],
    "burrfish" => [0, "", ""],
    "bursa" => [0, "e", "E"],
    "busboy" => [0, "s", "S"],
    "bush" => [0, "es", "ES"],
    "bushelling" => [0, "", ""],
    "bushless" => [0, "", ""],
    "businessperson" => [4, "ople", "OPLE"],
    "bustling" => [0, "", ""],
    "butch" => [0, "es", "ES"],
    "butling" => [0, "", ""],
    "butterfish" => [0, "", ""],
    "butterflyfish" => [0, "", ""],
    "butterines" => [0, "ses", "SES"],
    "butterless" => [0, "", ""],
    "butterscotch" => [0, "es", "ES"],
    "buttling" => [0, "", ""],
    "buttonbush" => [0, "es", "ES"],
    "buttonless" => [0, "", ""],
    "buttonquail" => [0, "", ""],
    "buy" => [0, "s", "S"],
    "by" => [0, "es", "ES"],
    "byplay" => [0, "s", "S"],
    "byssinosis" => [2, "es", "ES"],
    "byway" => [0, "s", "S"],
    "caballing" => [0, "", ""],
    "cableway" => [0, "s", "S"],
    "cabling" => [0, "", ""],
    "cactus" => [2, "i", "I"],
    "cadeau" => [0, "x", "X"],
    "cadis" => [2, "es", "ES"],
    "caduceus" => [2, "i", "I"],
    "caecum" => [2, "a", "A"],
    "cageling" => [0, "", ""],
    "caiman" => [0, "s", "S"],
    "calabash" => [0, "es", "ES"],
    "calamanco" => [0, "es", "ES"],
    "calash" => [0, "es", "ES"],
    "calathus" => [2, "i", "I"],
    "calcaneus" => [2, "i", "I"],
    "calcinosis" => [2, "es", "ES"],
    "calculus" => [2, "i", "I"],
    "caldarium" => [2, "a", "A"],
    "calf" => [1, "ves", "VES"],
    "calfless" => [0, "", ""],
    "calico" => [0, "es", "ES"],
    "calipash" => [0, "es", "ES"],
    "calix" => [1, "ces", "CES"],
    "callboy" => [0, "s", "S"],
    "calyculus" => [2, "i", "I"],
    "camaieu" => [0, "x", "X"],
    "caman" => [0, "s", "S"],
    "camisado" => [0, "es", "ES"],
    "camus" => [2, "i", "I"],
    "canaliculus" => [2, "i", "I"],
    "canalling" => [0, "", ""],
    "cancelling" => [0, "", ""],
    "candelabrum" => [2, "a", "A"],
    "candidiasis" => [2, "es", "ES"],
    "candlefish" => [0, "", ""],
    "cangling" => [0, "", ""],
    "canthus" => [2, "i", "I"],
    "canticoy" => [0, "s", "S"],
    "cantling" => [0, "", ""],
    "capellinis" => [2, "es", "ES"],
    "capitulum" => [2, "a", "A"],
    "capless" => [0, "", ""],
    "capouch" => [0, "es", "ES"],
    "captionless" => [0, "", ""],
    "caracolling" => [0, "", ""],
    "caraway" => [0, "s", "S"],
    "carbonado" => [0, "es", "ES"],
    "carbonless" => [0, "", ""],
    "carboy" => [0, "s", "S"],
    "carcinogenesis" => [2, "es", "ES"],
    "carcinomatosis" => [2, "es", "ES"],
    "cardinalfish" => [0, "", ""],
    "cardpunch" => [0, "es", "ES"],
    "careless" => [0, "", ""],
    "carex" => [2, "ices", "ICES"],
    "cargo" => [0, "es", "ES"],
    "caribou" => [0, "", ""],
    "carless" => [0, "", ""],
    "carling" => [0, "", ""],
    "carney" => [0, "s", "S"],
    "caroach" => [0, "es", "ES"],
    "caroch" => [0, "es", "ES"],
    "carolling" => [0, "", ""],
    "carp" => [0, "", ""],
    "carpus" => [2, "i", "I"],
    "carraway" => [0, "s", "S"],
    "carriageway" => [0, "s", "S"],
    "carritch" => [0, "es", "ES"],
    "carroch" => [0, "es", "ES"],
    "carsey" => [0, "s", "S"],
    "cartouch" => [0, "es", "ES"],
    "cartway" => [0, "s", "S"],
    "carwash" => [0, "es", "ES"],
    "caryopsis" => [2, "es", "ES"],
    "cash" => [0, "es", "ES"],
    "cashless" => [0, "", ""],
    "castaway" => [0, "s", "S"],
    "casteless" => [0, "", ""],
    "castling" => [0, "", ""],
    "catabasis" => [2, "es", "ES"],
    "catachresis" => [2, "es", "ES"],
    "cataclasis" => [2, "es", "ES"],
    "catafalco" => [0, "es", "ES"],
    "catalexis" => [2, "es", "ES"],
    "catalo" => [0, "es", "ES"],
    "catalysis" => [2, "es", "ES"],
    "cataphoresis" => [2, "es", "ES"],
    "catastasis" => [2, "es", "ES"],
    "catch" => [0, "es", "ES"],
    "catechesis" => [2, "es", "ES"],
    "catfish" => [0, "", ""],
    "catharsis" => [2, "es", "ES"],
    "cathexis" => [2, "es", "ES"],
    "catling" => [0, "", ""],
    "cattalo" => [0, "es", "ES"],
    "caulis" => [2, "es", "ES"],
    "causeless" => [0, "", ""],
    "causeway" => [0, "s", "S"],
    "causey" => [0, "s", "S"],
    "cavefish" => [0, "", ""],
    "cavendish" => [0, "es", "ES"],
    "cavilling" => [0, "", ""],
    "cay" => [0, "s", "S"],
    "cayman" => [0, "s", "S"],
    "ceaseless" => [0, "", ""],
    "cecum" => [2, "a", "A"],
    "cedis" => [2, "es", "ES"],
    "cella" => [0, "e", "E"],
    "celling" => [0, "", ""],
    "celoma" => [0, "ta", "TA"],
    "cementum" => [2, "a", "A"],
    "cenogenesis" => [2, "es", "ES"],
    "centerless" => [0, "", ""],
    "centesis" => [2, "es", "ES"],
    "cervix" => [1, "ces", "CES"],
    "cesarevitch" => [0, "es", "ES"],
    "chadless" => [0, "", ""],
    "chaeta" => [0, "e", "E"],
    "chaffinch" => [0, "es", "ES"],
    "chaffless" => [0, "", ""],
    "chainless" => [0, "", ""],
    "chalumeau" => [0, "x", "X"],
    "chambray" => [0, "s", "S"],
    "chamois" => [0, "", ""],
    "chanceless" => [0, "", ""],
    "changeless" => [0, "", ""],
    "changeling" => [0, "", ""],
    "chantey" => [0, "s", "S"],
    "chapeless" => [0, "", ""],
    "chapeling" => [0, "", ""],
    "chapelling" => [0, "", ""],
    "chapes" => [0, "ses", "SES"],
    "chapless" => [0, "", ""],
    "characterless" => [0, "", ""],
    "chargeless" => [0, "", ""],
    "charisma" => [0, "ta", "TA"],
    "charmless" => [0, "", ""],
    "charpoy" => [0, "s", "S"],
    "chartless" => [0, "", ""],
    "chassis" => [0, "", ""],
    "chateau" => [0, "x", "X"],
    "chay" => [0, "s", "S"],
    "checkless" => [0, "", ""],
    "cheechako" => [0, "es", "ES"],
    "cheekless" => [0, "", ""],
    "cheerless" => [0, "", ""],
    "chelicera" => [0, "e", "E"],
    "chemokinesis" => [2, "es", "ES"],
    "chemoprophylaxis" => [2, "es", "ES"],
    "chemosmosis" => [2, "es", "ES"],
    "chemosynthesis" => [2, "es", "ES"],
    "chemotaxis" => [2, "es", "ES"],
    "chickling" => [0, "", ""],
    "chiefless" => [0, "", ""],
    "chiefling" => [0, "", ""],
    "child" => [0, "ren", "REN"],
    "childless" => [0, "", ""],
    "chili" => [0, "es", "ES"],
    "chilis" => [2, "es", "ES"],
    "chilli" => [0, "es", "ES"],
    "chimbley" => [0, "s", "S"],
    "chimley" => [0, "s", "S"],
    "chimney" => [0, "s", "S"],
    "chinch" => [0, "es", "ES"],
    "chinchillon" => [2, "a", "A"],
    "chinless" => [0, "", ""],
    "chiselling" => [0, "", ""],
    "chitling" => [0, "", ""],
    "chitterling" => [0, "", ""],
    "chlamydia" => [0, "e", "E"],
    "chlorosis" => [2, "es", "ES"],
    "choana" => [0, "e", "E"],
    "choirboy" => [0, "s", "S"],
    "chokey" => [0, "s", "S"],
    "cholecystitis" => [1, "des", "DES"],
    "cholelithiasis" => [2, "es", "ES"],
    "cholestasis" => [2, "es", "ES"],
    "chon" => [2, "a", "A"],
    "chondritis" => [2, "es", "ES"],
    "chondrus" => [2, "i", "I"],
    "chorda" => [0, "e", "E"],
    "choush" => [0, "es", "ES"],
    "chromatolysis" => [2, "es", "ES"],
    "chromidium" => [2, "a", "A"],
    "chromonema" => [0, "ta", "TA"],
    "chronicling" => [0, "", ""],
    "chub" => [0, "", ""],
    "chuckling" => [0, "", ""],
    "chuffling" => [0, "", ""],
    "chumley" => [0, "s", "S"],
    "churchless" => [0, "", ""],
    "churchway" => [0, "s", "S"],
    "chutney" => [0, "s", "S"],
    "ciborium" => [2, "a", "A"],
    "cicatrix" => [1, "ces", "CES"],
    "cicerone" => [1, "i", "I"],
    "cigarfish" => [0, "", ""],
    "cilium" => [2, "a", "A"],
    "cimex" => [2, "ices", "ICES"],
    "cinch" => [0, "es", "ES"],
    "cinerarium" => [2, "a", "A"],
    "cingulum" => [2, "a", "A"],
    "cippus" => [2, "i", "I"],
    "cirrhosis" => [2, "es", "ES"],
    "cirrocumulus" => [2, "i", "I"],
    "cirrostratus" => [2, "i", "I"],
    "cirrus" => [2, "i", "I"],
    "cisco" => [0, "es", "ES"],
    "cisterna" => [0, "e", "E"],
    "cites" => [0, "ses", "SES"],
    "cladogenesis" => [2, "es", "ES"],
    "cladophyllum" => [2, "a", "A"],
    "clankless" => [0, "", ""],
    "clanless" => [0, "", ""],
    "claro" => [0, "es", "ES"],
    "clash" => [0, "es", "ES"],
    "classis" => [2, "es", "ES"],
    "classless" => [0, "", ""],
    "claustrum" => [2, "a", "A"],
    "clausula" => [0, "e", "E"],
    "clavis" => [2, "es", "ES"],
    "clavus" => [2, "i", "I"],
    "clawless" => [0, "", ""],
    "clay" => [0, "s", "S"],
    "clearway" => [0, "s", "S"],
    "clench" => [0, "es", "ES"],
    "clientless" => [0, "", ""],
    "climaxless" => [0, "", ""],
    "clinandrium" => [2, "a", "A"],
    "clinch" => [0, "es", "ES"],
    "clingfish" => [0, "", ""],
    "clinoaxis" => [2, "es", "ES"],
    "clitellum" => [2, "a", "A"],
    "cloaca" => [0, "e", "E"],
    "clothesless" => [0, "", ""],
    "cloudless" => [0, "", ""],
    "cloyless" => [0, "", ""],
    "clubfoot" => [3, "eet", "EET"],
    "clueless" => [0, "", ""],
    "clunch" => [0, "es", "ES"],
    "clutch" => [0, "es", "ES"],
    "cnida" => [0, "e", "E"],
    "coach" => [0, "es", "ES"],
    "coalfish" => [0, "", ""],
    "coalless" => [0, "", ""],
    "coatless" => [0, "", ""],
    "cobbling" => [0, "", ""],
    "cobloaf" => [1, "ves", "VES"],
    "coccidioidomycosis" => [2, "es", "ES"],
    "coccidiosis" => [2, "es", "ES"],
    "coccidium" => [2, "a", "A"],
    "coccus" => [2, "i", "I"],
    "coccyx" => [1, "ges", "GES"],
    "cochlea" => [0, "e", "E"],
    "cockling" => [0, "", ""],
    "cockmatch" => [0, "es", "ES"],
    "cockroach" => [0, "es", "ES"],
    "cocounselling" => [0, "", ""],
    "cod" => [0, "", ""],
    "codeless" => [0, "", ""],
    "codex" => [2, "ices", "ICES"],
    "codfish" => [0, "", ""],
    "codling" => [0, "", ""],
    "coelenteron" => [2, "a", "A"],
    "coenurus" => [2, "i", "I"],
    "cofferfish" => [0, "", ""],
    "coffling" => [0, "", ""],
    "cognoscente" => [1, "i", "I"],
    "cogway" => [0, "s", "S"],
    "cohesionless" => [0, "", ""],
    "coho" => [0, "", ""],
    "cohosh" => [0, "es", "ES"],
    "coleopteron" => [2, "a", "A"],
    "coley" => [0, "s", "S"],
    "collarless" => [0, "", ""],
    "colliculus" => [2, "i", "I"],
    "colling" => [0, "", ""],
    "colobi" => [0, "", ""],
    "coloboma" => [0, "ta", "TA"],
    "coloni" => [0, "es", "ES"],
    "colonus" => [2, "i", "I"],
    "colorless" => [0, "", ""],
    "colorway" => [0, "s", "S"],
    "colossus" => [2, "i", "I"],
    "colourless" => [0, "", ""],
    "colourway" => [0, "s", "S"],
    "columbarium" => [2, "a", "A"],
    "comatula" => [0, "e", "E"],
    "combless" => [0, "", ""],
    "comfortless" => [0, "", ""],
    "comfrey" => [0, "s", "S"],
    "comingling" => [0, "", ""],
    "commoney" => [0, "s", "S"],
    "companionless" => [0, "", ""],
    "companionway" => [0, "s", "S"],
    "compassionless" => [0, "", ""],
    "compelling" => [0, "", ""],
    "complexionless" => [0, "", ""],
    "computerless" => [0, "", ""],
    "conarium" => [2, "a", "A"],
    "conceitless" => [0, "", ""],
    "concetto" => [1, "i", "I"],
    "conchfish" => [0, "", ""],
    "condoling" => [0, "", ""],
    "conductus" => [2, "i", "I"],
    "coney" => [0, "s", "S"],
    "confetto" => [1, "i", "I"],
    "confineless" => [0, "", ""],
    "congius" => [2, "i", "I"],
    "congo" => [0, "es", "ES"],
    "coni" => [0, "es", "ES"],
    "conidium" => [2, "a", "A"],
    "coniosis" => [2, "es", "ES"],
    "conscienceless" => [0, "", ""],
    "consortium" => [2, "a", "A"],
    "constitutionless" => [0, "", ""],
    "contadino" => [1, "i", "I"],
    "containerless" => [0, "", ""],
    "contentless" => [0, "", ""],
    "contextless" => [0, "", ""],
    "continuum" => [2, "a", "A"],
    "contretemps" => [0, "", ""],
    "controlling" => [0, "", ""],
    "conus" => [2, "i", "I"],
    "convictfish" => [0, "", ""],
    "convoy" => [0, "s", "S"],
    "cooch" => [0, "es", "ES"],
    "cookey" => [0, "s", "S"],
    "cookless" => [0, "", ""],
    "cooling" => [0, "", ""],
    "copay" => [0, "s", "S"],
    "copyboy" => [0, "s", "S"],
    "corallum" => [2, "a", "A"],
    "coranto" => [0, "es", "ES"],
    "corbeling" => [0, "", ""],
    "corbelling" => [0, "", ""],
    "corditis" => [2, "es", "ES"],
    "cordless" => [0, "", ""],
    "corduroy" => [0, "s", "S"],
    "coreless" => [0, "", ""],
    "coremium" => [2, "a", "A"],
    "corf" => [1, "ves", "VES"],
    "cornbrash" => [0, "es", "ES"],
    "cornetfish" => [0, "", ""],
    "cornetto" => [1, "i", "I"],
    "corneum" => [2, "a", "A"],
    "corno" => [1, "i", "I"],
    "cornstarch" => [0, "es", "ES"],
    "corps" => [0, "", ""],
    "corpus" => [2, "ora", "ORA"],
    "corralling" => [0, "", ""],
    "corrigendum" => [2, "a", "A"],
    "cortex" => [2, "ices", "ICES"],
    "corynebacterium" => [2, "a", "A"],
    "coryphaeus" => [2, "i", "I"],
    "cosey" => [0, "s", "S"],
    "cosh" => [0, "es", "ES"],
    "cosines" => [0, "ses", "SES"],
    "costa" => [0, "e", "E"],
    "costless" => [0, "", ""],
    "cotterless" => [0, "", ""],
    "couch" => [0, "es", "ES"],
    "counterhypothesis" => [2, "es", "ES"],
    "counterplay" => [0, "s", "S"],
    "counterploy" => [0, "s", "S"],
    "counterpunch" => [0, "es", "ES"],
    "counterscarp" => [0, "", ""],
    "countless" => [0, "", ""],
    "countryfolk" => [0, "", ""],
    "coupling" => [0, "", ""],
    "couranto" => [0, "es", "ES"],
    "courtling" => [0, "", ""],
    "couteau" => [0, "x", "X"],
    "coverless" => [0, "", ""],
    "covey" => [0, "s", "S"],
    "cowboy" => [0, "s", "S"],
    "cowfish" => [0, "", ""],
    "cowitch" => [0, "es", "ES"],
    "cowling" => [0, "", ""],
    "coxa" => [0, "e", "E"],
    "coxitis" => [1, "des", "DES"],
    "coxless" => [0, "", ""],
    "cozey" => [0, "s", "S"],
    "crackling" => [0, "", ""],
    "craftless" => [0, "", ""],
    "craftsperson" => [4, "ople", "OPLE"],
    "crambo" => [0, "es", "ES"],
    "crampfish" => [0, "", ""],
    "crankling" => [0, "", ""],
    "crappie" => [0, "", ""],
    "crash" => [0, "es", "ES"],
    "crasis" => [2, "es", "ES"],
    "cratch" => [0, "es", "ES"],
    "crawfish" => [0, "", ""],
    "crawling" => [0, "", ""],
    "crawlway" => [0, "s", "S"],
    "cray" => [0, "s", "S"],
    "crayfish" => [0, "", ""],
    "creaseless" => [0, "", ""],
    "credendum" => [2, "a", "A"],
    "credentialling" => [0, "", ""],
    "creeling" => [0, "", ""],
    "crenelling" => [0, "", ""],
    "crestless" => [0, "", ""],
    "crewless" => [0, "", ""],
    "crickey" => [0, "s", "S"],
    "crikey" => [0, "s", "S"],
    "crimeless" => [0, "", ""],
    "crimpling" => [0, "", ""],
    "cringeling" => [0, "", ""],
    "crisis" => [2, "es", "ES"],
    "crissum" => [2, "a", "A"],
    "criterion" => [2, "a", "A"],
    "cropless" => [0, "", ""],
    "crossbench" => [0, "es", "ES"],
    "crossbuck" => [0, "", ""],
    "crossfish" => [0, "", ""],
    "crosshatch" => [0, "es", "ES"],
    "crosspatch" => [0, "es", "ES"],
    "crossway" => [0, "s", "S"],
    "crotch" => [0, "es", "ES"],
    "crouch" => [0, "es", "ES"],
    "crowfoot" => [3, "eet", "EET"],
    "crownless" => [0, "", ""],
    "cruiseway" => [0, "s", "S"],
    "crumbling" => [0, "", ""],
    "crumpling" => [0, "", ""],
    "crunch" => [0, "es", "ES"],
    "crusado" => [0, "es", "ES"],
    "crush" => [0, "es", "ES"],
    "crusta" => [0, "e", "E"],
    "crustless" => [0, "", ""],
    "crutch" => [0, "es", "ES"],
    "cruzado" => [0, "es", "ES"],
    "cryptanalysis" => [2, "es", "ES"],
    "cryptococcosis" => [2, "es", "ES"],
    "cryptococcus" => [2, "i", "I"],
    "cryptosporidiosis" => [2, "es", "ES"],
    "crystalling" => [0, "", ""],
    "crystallitis" => [2, "es", "ES"],
    "ctenidium" => [2, "a", "A"],
    "cubiculum" => [2, "a", "A"],
    "cudgelling" => [0, "", ""],
    "cuffless" => [0, "", ""],
    "cuish" => [0, "es", "ES"],
    "culch" => [0, "es", "ES"],
    "cullay" => [0, "s", "S"],
    "culling" => [0, "", ""],
    "culpa" => [0, "e", "E"],
    "cultch" => [0, "es", "ES"],
    "cumberless" => [0, "", ""],
    "cumulonimbus" => [2, "i", "I"],
    "cumulus" => [2, "i", "I"],
    "cupelling" => [0, "", ""],
    "cupula" => [0, "e", "E"],
    "curbless" => [0, "", ""],
    "curch" => [0, "es", "ES"],
    "curdling" => [0, "", ""],
    "cureless" => [0, "", ""],
    "curling" => [0, "", ""],
    "curriculum" => [2, "a", "A"],
    "cursus" => [2, "i", "I"],
    "curtainless" => [0, "", ""],
    "curtsey" => [0, "s", "S"],
    "cush" => [0, "es", "ES"],
    "cushionless" => [0, "", ""],
    "cutaway" => [0, "s", "S"],
    "cutch" => [0, "es", "ES"],
    "cutey" => [0, "s", "S"],
    "cuticula" => [0, "e", "E"],
    "cutlassfish" => [0, "", ""],
    "cutling" => [0, "", ""],
    "cuttlefish" => [0, "", ""],
    "cyanobacterium" => [2, "a", "A"],
    "cyanogenesis" => [2, "es", "ES"],
    "cyanosis" => [2, "es", "ES"],
    "cycleway" => [0, "s", "S"],
    "cyclogenesis" => [2, "es", "ES"],
    "cyclops" => [0, "", ""],
    "cyclosis" => [2, "es", "ES"],
    "cyesis" => [2, "es", "ES"],
    "cylix" => [1, "ces", "CES"],
    "cymbalo" => [0, "es", "ES"],
    "cypris" => [2, "es", "ES"],
    "cypsela" => [0, "e", "E"],
    "cysticercosis" => [2, "es", "ES"],
    "cysticercus" => [2, "i", "I"],
    "cystitis" => [1, "des", "DES"],
    "cytisus" => [2, "i", "I"],
    "cytogenesis" => [2, "es", "ES"],
    "cytokinesis" => [2, "es", "ES"],
    "cytolysis" => [2, "es", "ES"],
    "czarevitch" => [0, "es", "ES"],
    "dace" => [0, "", ""],
    "dactylus" => [2, "i", "I"],
    "dado" => [0, "es", "ES"],
    "dago" => [0, "es", "ES"],
    "dalis" => [2, "es", "ES"],
    "dalo" => [1, "i", "I"],
    "daman" => [0, "s", "S"],
    "damselfish" => [0, "", ""],
    "dangling" => [0, "", ""],
    "danish" => [0, "es", "ES"],
    "dapperling" => [0, "", ""],
    "daris" => [2, "es", "ES"],
    "darkey" => [0, "s", "S"],
    "darkling" => [0, "", ""],
    "dartling" => [0, "", ""],
    "dash" => [0, "es", "ES"],
    "dashis" => [2, "es", "ES"],
    "dateless" => [0, "", ""],
    "datum" => [2, "a", "A"],
    "daughterless" => [0, "", ""],
    "daughterling" => [0, "", ""],
    "dauntless" => [0, "", ""],
    "dauphines" => [0, "ses", "SES"],
    "daycoach" => [0, "es", "ES"],
    "dead" => [0, "", ""],
    "deadlines" => [0, "ses", "SES"],
    "deaf" => [1, "ves", "VES"],
    "dealfish" => [0, "", ""],
    "dearling" => [0, "", ""],
    "deathless" => [0, "", ""],
    "deathwatch" => [0, "es", "ES"],
    "debauch" => [0, "es", "ES"],
    "debelling" => [0, "", ""],
    "debouch" => [0, "es", "ES"],
    "debris" => [0, "", ""],
    "debtless" => [0, "", ""],
    "decalling" => [0, "", ""],
    "decay" => [0, "s", "S"],
    "decontrolling" => [0, "", ""],
    "decoy" => [0, "s", "S"],
    "decuman" => [0, "s", "S"],
    "deedless" => [0, "", ""],
    "deejay" => [0, "s", "S"],
    "deer" => [0, "", ""],
    "defenceless" => [0, "", ""],
    "defenseless" => [0, "", ""],
    "defiling" => [0, "", ""],
    "definiendum" => [2, "a", "A"],
    "defuelling" => [0, "", ""],
    "degamis" => [2, "es", "ES"],
    "delay" => [0, "s", "S"],
    "delightless" => [0, "", ""],
    "delis" => [2, "es", "ES"],
    "deltoideus" => [2, "i", "I"],
    "denari" => [0, "es", "ES"],
    "denarius" => [2, "i", "I"],
    "deni" => [0, "es", "ES"],
    "depthless" => [0, "", ""],
    "deray" => [0, "s", "S"],
    "dermatophytosis" => [2, "es", "ES"],
    "dermatosis" => [2, "es", "ES"],
    "dervish" => [0, "es", "ES"],
    "desertless" => [0, "", ""],
    "desideratum" => [2, "a", "A"],
    "designless" => [0, "", ""],
    "desireless" => [0, "", ""],
    "desman" => [0, "s", "S"],
    "despatch" => [0, "es", "ES"],
    "desperado" => [0, "es", "ES"],
    "detasselling" => [0, "", ""],
    "detritus" => [0, "", ""],
    "develling" => [0, "", ""],
    "devilfish" => [0, "", ""],
    "devilling" => [0, "", ""],
    "dewless" => [0, "", ""],
    "dey" => [0, "s", "S"],
    "diabetes" => [0, "", ""],
    "diadochi" => [0, "es", "ES"],
    "diaeresis" => [2, "es", "ES"],
    "diagenesis" => [2, "es", "ES"],
    "diagnosis" => [2, "es", "ES"],
    "diakinesis" => [2, "es", "ES"],
    "dialling" => [0, "", ""],
    "dialysis" => [2, "es", "ES"],
    "diapedesis" => [2, "es", "ES"],
    "diaphoresis" => [2, "es", "ES"],
    "diaphysis" => [2, "es", "ES"],
    "diapophysis" => [2, "es", "ES"],
    "diapyesis" => [2, "es", "ES"],
    "diarthrosis" => [2, "es", "ES"],
    "diastasis" => [2, "es", "ES"],
    "diastema" => [0, "ta", "TA"],
    "diathesis" => [2, "es", "ES"],
    "diazo" => [0, "es", "ES"],
    "dichasium" => [2, "a", "A"],
    "dickey" => [0, "s", "S"],
    "dictum" => [2, "a", "A"],
    "diddicoy" => [0, "s", "S"],
    "diddley" => [0, "s", "S"],
    "diddycoy" => [0, "s", "S"],
    "didicoy" => [0, "s", "S"],
    "dido" => [0, "es", "ES"],
    "die" => [1, "ce", "CE"],
    "diegesis" => [2, "es", "ES"],
    "dieresis" => [2, "es", "ES"],
    "diesis" => [2, "es", "ES"],
    "differentia" => [0, "e", "E"],
    "dildo" => [0, "es", "ES"],
    "dimensionless" => [0, "", ""],
    "dingey" => [0, "s", "S"],
    "dingo" => [0, "es", "ES"],
    "dinkey" => [0, "s", "S"],
    "dinnerless" => [0, "", ""],
    "dintless" => [0, "", ""],
    "diorthosis" => [2, "es", "ES"],
    "diplococcus" => [2, "i", "I"],
    "diplosis" => [2, "es", "ES"],
    "diplozoon" => [2, "a", "A"],
    "dipteron" => [2, "a", "A"],
    "directionless" => [0, "", ""],
    "dis" => [0, "ses", "SES"],
    "disannulling" => [0, "", ""],
    "disarray" => [0, "s", "S"],
    "disbowelling" => [0, "", ""],
    "discobolus" => [2, "i", "I"],
    "disembowelling" => [0, "", ""],
    "disenthralling" => [0, "", ""],
    "disguiseless" => [0, "", ""],
    "dish" => [0, "es", "ES"],
    "dishevelling" => [0, "", ""],
    "diskless" => [0, "", ""],
    "dismay" => [0, "s", "S"],
    "dispatch" => [0, "es", "ES"],
    "dispelling" => [0, "", ""],
    "display" => [0, "s", "S"],
    "disregardless" => [0, "", ""],
    "distanceless" => [0, "", ""],
    "distilling" => [0, "", ""],
    "ditch" => [0, "es", "ES"],
    "dittay" => [0, "s", "S"],
    "diuresis" => [2, "es", "ES"],
    "diverticulosis" => [2, "es", "ES"],
    "diverticulum" => [2, "a", "A"],
    "divi" => [0, "es", "ES"],
    "dividendless" => [0, "", ""],
    "doctorfish" => [0, "", ""],
    "doctorless" => [0, "", ""],
    "dodman" => [0, "s", "S"],
    "doe" => [0, "", ""],
    "dogey" => [0, "s", "S"],
    "dogfish" => [0, "es", "ES"],
    "dogtooth" => [4, "eeth", "EETH"],
    "dogwatch" => [0, "es", "ES"],
    "doiley" => [0, "s", "S"],
    "doling" => [0, "", ""],
    "dolium" => [2, "a", "A"],
    "dollarfish" => [0, "", ""],
    "dolling" => [0, "", ""],
    "dolman" => [0, "s", "S"],
    "dolphinfish" => [0, "", ""],
    "domatium" => [2, "a", "A"],
    "domesday" => [0, "s", "S"],
    "dominatrix" => [1, "ces", "CES"],
    "domino" => [0, "es", "ES"],
    "dong" => [0, "", ""],
    "donkey" => [0, "s", "S"],
    "doohickey" => [0, "s", "S"],
    "doomsday" => [0, "s", "S"],
    "doomwatch" => [0, "es", "ES"],
    "doorless" => [0, "", ""],
    "doorway" => [0, "s", "S"],
    "dormouse" => [4, "ice", "ICE"],
    "doubtless" => [0, "", ""],
    "doughboy" => [0, "s", "S"],
    "dovekey" => [0, "s", "S"],
    "dowelling" => [0, "", ""],
    "dowerless" => [0, "", ""],
    "downless" => [0, "", ""],
    "downrush" => [0, "es", "ES"],
    "downwash" => [0, "es", "ES"],
    "doyley" => [0, "s", "S"],
    "dragoman" => [0, "s", "S"],
    "dragonfish" => [0, "", ""],
    "drawknife" => [2, "ves", "VES"],
    "drawling" => [0, "", ""],
    "dray" => [0, "s", "S"],
    "dreadless" => [0, "", ""],
    "dreamless" => [0, "", ""],
    "drench" => [0, "es", "ES"],
    "drey" => [0, "s", "S"],
    "driftfish" => [0, "", ""],
    "driftless" => [0, "", ""],
    "dripless" => [0, "", ""],
    "driveling" => [0, "", ""],
    "drivelling" => [0, "", ""],
    "driverless" => [0, "", ""],
    "driveway" => [0, "s", "S"],
    "drongo" => [0, "es", "ES"],
    "drugless" => [0, "", ""],
    "drumfish" => [0, "", ""],
    "dry" => [0, "s", "S"],
    "drybrush" => [0, "es", "ES"],
    "duckling" => [0, "", ""],
    "ductless" => [0, "", ""],
    "dueling" => [0, "", ""],
    "duelling" => [0, "", ""],
    "dukeling" => [0, "", ""],
    "dulosis" => [2, "es", "ES"],
    "dumpling" => [0, "", ""],
    "duneland" => [0, "", ""],
    "dunfish" => [0, "", ""],
    "duodenum" => [2, "a", "A"],
    "dures" => [0, "ses", "SES"],
    "dustless" => [0, "", ""],
    "dutch" => [0, "es", "ES"],
    "dybbuk" => [0, "im", "IM"],
    "dysgenesis" => [2, "es", "ES"],
    "eanling" => [0, "", ""],
    "earless" => [0, "", ""],
    "earthling" => [0, "", ""],
    "earthwolf" => [1, "ves", "VES"],
    "easeless" => [0, "", ""],
    "easterling" => [0, "", ""],
    "ecchymosis" => [2, "es", "ES"],
    "ecdysis" => [2, "es", "ES"],
    "ecesis" => [2, "es", "ES"],
    "echinococcosis" => [2, "es", "ES"],
    "echinococcus" => [2, "i", "I"],
    "echo" => [0, "es", "ES"],
    "echoless" => [0, "", ""],
    "ecphonesis" => [2, "es", "ES"],
    "ectasis" => [2, "es", "ES"],
    "ecthlipsis" => [2, "es", "ES"],
    "ecthyma" => [0, "ta", "TA"],
    "ectogenesis" => [2, "es", "ES"],
    "ectozoon" => [2, "a", "A"],
    "eddish" => [0, "es", "ES"],
    "eddo" => [0, "es", "ES"],
    "edgeless" => [0, "", ""],
    "effectless" => [0, "", ""],
    "effluvium" => [2, "a", "A"],
    "effortless" => [0, "", ""],
    "effray" => [0, "s", "S"],
    "eggless" => [0, "", ""],
    "eggshake" => [0, "", ""],
    "egoless" => [0, "", ""],
    "eisegesis" => [2, "es", "ES"],
    "eland" => [0, "", ""],
    "elect" => [0, "", ""],
    "electroanalysis" => [2, "es", "ES"],
    "electrodialysis" => [2, "es", "ES"],
    "electrogenesis" => [2, "es", "ES"],
    "electroless" => [0, "", ""],
    "electrolysis" => [2, "es", "ES"],
    "electroosmosis" => [2, "es", "ES"],
    "electrophoresis" => [2, "es", "ES"],
    "electrophorus" => [2, "i", "I"],
    "elenchus" => [2, "i", "I"],
    "elephantiasis" => [2, "es", "ES"],
    "elf" => [1, "ves", "VES"],
    "elfish" => [0, "", ""],
    "ellipsis" => [2, "es", "ES"],
    "elvish" => [0, "es", "ES"],
    "elytrum" => [2, "a", "A"],
    "embargo" => [0, "es", "ES"],
    "emblema" => [0, "ta", "TA"],
    "emboli" => [0, "es", "ES"],
    "embowelling" => [0, "", ""],
    "embryogenesis" => [2, "es", "ES"],
    "emerita" => [0, "e", "E"],
    "emeritus" => [2, "i", "I"],
    "emesis" => [2, "es", "ES"],
    "emotionless" => [0, "", ""],
    "empanelling" => [0, "", ""],
    "emphasis" => [2, "es", "ES"],
    "emphlysis" => [2, "es", "ES"],
    "employ" => [0, "s", "S"],
    "enamelling" => [0, "", ""],
    "enarthrosis" => [2, "es", "ES"],
    "encephalitis" => [1, "des", "DES"],
    "encephalomyelitis" => [1, "des", "DES"],
    "enclisis" => [2, "es", "ES"],
    "endleaf" => [1, "ves", "VES"],
    "endless" => [0, "", ""],
    "endocarp" => [0, "", ""],
    "endocranium" => [2, "a", "A"],
    "endocytosis" => [2, "es", "ES"],
    "endometriosis" => [2, "es", "ES"],
    "endomitosis" => [2, "es", "ES"],
    "endosmosis" => [2, "es", "ES"],
    "endosporium" => [2, "a", "A"],
    "endosymbiosis" => [2, "es", "ES"],
    "endothecium" => [2, "a", "A"],
    "endothelium" => [2, "a", "A"],
    "endozoon" => [2, "a", "A"],
    "engirdling" => [0, "", ""],
    "enosis" => [2, "es", "ES"],
    "enrolling" => [0, "", ""],
    "ensorcelling" => [0, "", ""],
    "entasis" => [2, "es", "ES"],
    "enterobacterium" => [2, "a", "A"],
    "enterobiasis" => [2, "es", "ES"],
    "enterococcus" => [2, "i", "I"],
    "enthralling" => [0, "", ""],
    "entozoon" => [2, "a", "A"],
    "entrammelling" => [0, "", ""],
    "entranceway" => [0, "s", "S"],
    "entryway" => [0, "s", "S"],
    "enuresis" => [2, "es", "ES"],
    "envoy" => [0, "s", "S"],
    "epanadiplosis" => [2, "es", "ES"],
    "epanalepsis" => [2, "es", "ES"],
    "epanorthosis" => [2, "es", "ES"],
    "epenthesis" => [2, "es", "ES"],
    "epexegesis" => [2, "es", "ES"],
    "ephebus" => [2, "i", "I"],
    "epicardium" => [2, "a", "A"],
    "epicedium" => [2, "a", "A"],
    "epiclesis" => [2, "es", "ES"],
    "epigenesis" => [2, "es", "ES"],
    "epigonus" => [2, "i", "I"],
    "epimysium" => [2, "a", "A"],
    "epiphysis" => [2, "es", "ES"],
    "epiplastron" => [2, "a", "A"],
    "epistasis" => [2, "es", "ES"],
    "epistaxis" => [2, "es", "ES"],
    "episternum" => [2, "a", "A"],
    "epitasis" => [2, "es", "ES"],
    "epithalamion" => [2, "a", "A"],
    "epithesis" => [2, "es", "ES"],
    "epizeuxis" => [2, "es", "ES"],
    "epizoon" => [2, "a", "A"],
    "equalling" => [0, "", ""],
    "eremurus" => [2, "i", "I"],
    "eringo" => [0, "es", "ES"],
    "erotesis" => [2, "es", "ES"],
    "erratum" => [2, "a", "A"],
    "errorless" => [0, "", ""],
    "eryngo" => [0, "es", "ES"],
    "erythroblastosis" => [2, "es", "ES"],
    "erythropoiesis" => [2, "es", "ES"],
    "escalado" => [0, "es", "ES"],
    "escapado" => [0, "es", "ES"],
    "escapeless" => [0, "", ""],
    "esophagus" => [2, "i", "I"],
    "essay" => [0, "s", "S"],
    "esthesis" => [2, "es", "ES"],
    "eubacterium" => [2, "a", "A"],
    "euphorbium" => [2, "a", "A"],
    "eventless" => [0, "", ""],
    "excelling" => [0, "", ""],
    "exceptless" => [0, "", ""],
    "executrix" => [1, "ces", "CES"],
    "exegesis" => [2, "es", "ES"],
    "exemplum" => [2, "a", "A"],
    "exhaustless" => [0, "", ""],
    "exhedra" => [0, "e", "E"],
    "exitless" => [0, "", ""],
    "exocytosis" => [2, "es", "ES"],
    "exosmosis" => [2, "es", "ES"],
    "exostosis" => [2, "es", "ES"],
    "expelling" => [0, "", ""],
    "experienceless" => [0, "", ""],
    "expressionless" => [0, "", ""],
    "expressway" => [0, "s", "S"],
    "extolling" => [0, "", ""],
    "extremum" => [2, "a", "A"],
    "exuvia" => [0, "e", "E"],
    "exuvium" => [2, "a", "A"],
    "eyelash" => [0, "es", "ES"],
    "eyeless" => [0, "", ""],
    "eyepatch" => [0, "es", "ES"],
    "eyetooth" => [4, "eeth", "EETH"],
    "eyewash" => [0, "es", "ES"],
    "fabling" => [0, "", ""],
    "faceless" => [0, "", ""],
    "fadeaway" => [0, "s", "S"],
    "fadeless" => [0, "", ""],
    "fagotto" => [1, "i", "I"],
    "fairway" => [0, "s", "S"],
    "faithless" => [0, "", ""],
    "fallaway" => [0, "s", "S"],
    "fallfish" => [0, "", ""],
    "fameless" => [0, "", ""],
    "fangless" => [0, "", ""],
    "fantastico" => [0, "es", "ES"],
    "faraday" => [0, "s", "S"],
    "farmstay" => [0, "s", "S"],
    "farmwife" => [2, "ves", "VES"],
    "farrago" => [0, "es", "ES"],
    "farthingless" => [0, "", ""],
    "fasciculus" => [2, "i", "I"],
    "fascioliasis" => [2, "es", "ES"],
    "fatherless" => [0, "", ""],
    "fathomless" => [0, "", ""],
    "fatless" => [0, "", ""],
    "fatling" => [0, "", ""],
    "fatso" => [0, "es", "ES"],
    "faultless" => [0, "", ""],
    "faux" => [1, "ces", "CES"],
    "favorless" => [0, "", ""],
    "favourless" => [0, "", ""],
    "fay" => [0, "s", "S"],
    "fearless" => [0, "", ""],
    "featherless" => [0, "", ""],
    "featureless" => [0, "", ""],
    "feckless" => [0, "", ""],
    "fecula" => [0, "e", "E"],
    "feeless" => [0, "", ""],
    "feeling" => [0, "", ""],
    "feelingless" => [0, "", ""],
    "feetless" => [0, "", ""],
    "feis" => [2, "es", "ES"],
    "fellon" => [2, "a", "A"],
    "fenceless" => [0, "", ""],
    "fenderless" => [0, "", ""],
    "fernless" => [0, "", ""],
    "ferrelling" => [0, "", ""],
    "ferroalloy" => [0, "s", "S"],
    "fetch" => [0, "es", "ES"],
    "fetialis" => [2, "es", "ES"],
    "fetich" => [0, "es", "ES"],
    "fetish" => [0, "es", "ES"],
    "fetterbush" => [0, "es", "ES"],
    "fetterless" => [0, "", ""],
    "fez" => [0, "zes", "ZES"],
    "fiasco" => [0, "es", "ES"],
    "fiberless" => [0, "", ""],
    "fibreless" => [0, "", ""],
    "fibrilla" => [0, "e", "E"],
    "fibrinolysis" => [2, "es", "ES"],
    "fibrosis" => [2, "es", "ES"],
    "fibula" => [0, "e", "E"],
    "fico" => [0, "es", "ES"],
    "ficus" => [0, "", ""],
    "fiddley" => [0, "s", "S"],
    "fieldmouse" => [4, "ice", "ICE"],
    "filaria" => [0, "e", "E"],
    "filariasis" => [2, "es", "ES"],
    "filefish" => [0, "", ""],
    "filling" => [0, "", ""],
    "filopodium" => [2, "a", "A"],
    "filterless" => [0, "", ""],
    "filum" => [2, "a", "A"],
    "finch" => [0, "es", "ES"],
    "fineless" => [0, "", ""],
    "finfish" => [0, "", ""],
    "fingerless" => [0, "", ""],
    "fingerling" => [0, "", ""],
    "finish" => [0, "es", "ES"],
    "finless" => [0, "", ""],
    "fireclay" => [0, "s", "S"],
    "fireless" => [0, "", ""],
    "firman" => [0, "s", "S"],
    "firmless" => [0, "", ""],
    "firstborn" => [0, "", ""],
    "firstling" => [0, "", ""],
    "fish" => [0, "", ""],
    "fisherfolk" => [0, "", ""],
    "fishless" => [0, "", ""],
    "fishway" => [0, "s", "S"],
    "fishwife" => [2, "ves", "VES"],
    "fitch" => [0, "es", "ES"],
    "fizzling" => [0, "", ""],
    "flagellum" => [2, "a", "A"],
    "flagfish" => [0, "", ""],
    "flagless" => [0, "", ""],
    "flak" => [0, "", ""],
    "flamefish" => [0, "", ""],
    "flameless" => [0, "", ""],
    "flannelling" => [0, "", ""],
    "flapless" => [0, "", ""],
    "flash" => [0, "es", "ES"],
    "flatfish" => [0, "", ""],
    "flatling" => [0, "", ""],
    "flatwash" => [0, "es", "ES"],
    "flaunch" => [0, "es", "ES"],
    "flavorless" => [0, "", ""],
    "flavourless" => [0, "", ""],
    "flawless" => [0, "", ""],
    "fleckless" => [0, "", ""],
    "fledgeless" => [0, "", ""],
    "fledgeling" => [0, "", ""],
    "fleeceless" => [0, "", ""],
    "flesh" => [0, "es", "ES"],
    "fleshless" => [0, "", ""],
    "fleshling" => [0, "", ""],
    "flightless" => [0, "", ""],
    "flinch" => [0, "es", "ES"],
    "flitch" => [0, "es", "ES"],
    "flocculus" => [2, "i", "I"],
    "floccus" => [2, "i", "I"],
    "floodway" => [0, "s", "S"],
    "florilegium" => [2, "a", "A"],
    "flosh" => [0, "es", "ES"],
    "flounder" => [0, "", ""],
    "flourish" => [0, "es", "ES"],
    "flourless" => [0, "", ""],
    "flowerless" => [0, "", ""],
    "flunkey" => [0, "s", "S"],
    "fluorosis" => [2, "es", "ES"],
    "flush" => [0, "es", "ES"],
    "flyaway" => [0, "s", "S"],
    "flyboy" => [0, "s", "S"],
    "flyby" => [0, "s", "S"],
    "flyleaf" => [1, "ves", "VES"],
    "flyless" => [0, "", ""],
    "flypitch" => [0, "es", "ES"],
    "flysch" => [0, "es", "ES"],
    "flyway" => [0, "s", "S"],
    "foamless" => [0, "", ""],
    "focusless" => [0, "", ""],
    "fogey" => [0, "s", "S"],
    "fogless" => [0, "", ""],
    "foisonless" => [0, "", ""],
    "foldaway" => [0, "s", "S"],
    "folklife" => [2, "ves", "VES"],
    "folkway" => [0, "s", "S"],
    "follis" => [2, "es", "ES"],
    "fondling" => [0, "", ""],
    "foodless" => [0, "", ""],
    "foolfish" => [0, "", ""],
    "fooling" => [0, "", ""],
    "foot" => [3, "eet", "EET"],
    "footboy" => [0, "s", "S"],
    "footless" => [0, "", ""],
    "footling" => [0, "", ""],
    "footway" => [0, "s", "S"],
    "fopling" => [0, "", ""],
    "foray" => [0, "s", "S"],
    "forceless" => [0, "", ""],
    "forceps" => [0, "", ""],
    "fordless" => [0, "", ""],
    "fordo" => [0, "es", "ES"],
    "forebay" => [0, "s", "S"],
    "foreday" => [0, "s", "S"],
    "foredo" => [0, "es", "ES"],
    "forefoot" => [3, "eet", "EET"],
    "foreland" => [0, "", ""],
    "foreperson" => [4, "ople", "OPLE"],
    "foreplay" => [0, "s", "S"],
    "foresightless" => [0, "", ""],
    "forestalling" => [0, "", ""],
    "forestay" => [0, "s", "S"],
    "foretooth" => [4, "eeth", "EETH"],
    "forkless" => [0, "", ""],
    "formicarium" => [2, "a", "A"],
    "formless" => [0, "", ""],
    "fortis" => [2, "es", "ES"],
    "fortuneless" => [0, "", ""],
    "fosterling" => [0, "", ""],
    "fouling" => [0, "", ""],
    "foundationless" => [0, "", ""],
    "foundling" => [0, "", ""],
    "fountainless" => [0, "", ""],
    "fowl" => [0, "", ""],
    "foxfish" => [0, "", ""],
    "foy" => [0, "s", "S"],
    "fractus" => [2, "i", "I"],
    "frangipanis" => [2, "es", "ES"],
    "fras" => [0, "ses", "SES"],
    "fratch" => [0, "es", "ES"],
    "fray" => [0, "s", "S"],
    "freeway" => [0, "s", "S"],
    "fresco" => [0, "es", "ES"],
    "fresh" => [0, "es", "ES"],
    "fretless" => [0, "", ""],
    "fricando" => [0, "es", "ES"],
    "frictionless" => [0, "", ""],
    "friendless" => [0, "", ""],
    "frijol" => [0, "es", "ES"],
    "fringeless" => [0, "", ""],
    "frivolling" => [0, "", ""],
    "friz" => [0, "zes", "ZES"],
    "frizzling" => [0, "", ""],
    "frockless" => [0, "", ""],
    "frogfish" => [0, "", ""],
    "frogling" => [0, "", ""],
    "frontless" => [0, "", ""],
    "frontogenesis" => [2, "es", "ES"],
    "frontolysis" => [2, "es", "ES"],
    "frosh" => [0, "", ""],
    "frostfish" => [0, "", ""],
    "frostless" => [0, "", ""],
    "frothless" => [0, "", ""],
    "fruitless" => [0, "", ""],
    "frutex" => [2, "ices", "ICES"],
    "fry" => [0, "", ""],
    "fuelling" => [0, "", ""],
    "fugling" => [0, "", ""],
    "fulfilling" => [0, "", ""],
    "fumado" => [0, "es", "ES"],
    "fumeless" => [0, "", ""],
    "fumulus" => [2, "i", "I"],
    "functionless" => [0, "", ""],
    "fundless" => [0, "", ""],
    "fundus" => [2, "i", "I"],
    "fungo" => [0, "es", "ES"],
    "fungus" => [2, "i", "I"],
    "funiculus" => [2, "i", "I"],
    "funnelling" => [0, "", ""],
    "furculum" => [2, "a", "A"],
    "furless" => [0, "", ""],
    "furling" => [0, "", ""],
    "furunculosis" => [2, "es", "ES"],
    "fusarium" => [2, "a", "A"],
    "fuseless" => [0, "", ""],
    "fusionless" => [0, "", ""],
    "futureless" => [0, "", ""],
    "fuzz" => [0, "", ""],
    "gabling" => [0, "", ""],
    "gadis" => [2, "es", "ES"],
    "gadling" => [0, "", ""],
    "gainless" => [0, "", ""],
    "gairfowl" => [0, "", ""],
    "galactopoiesis" => [2, "es", "ES"],
    "galactosis" => [2, "es", "ES"],
    "galley" => [0, "s", "S"],
    "galling" => [0, "", ""],
    "gallows" => [0, "", ""],
    "galosh" => [0, "es", "ES"],
    "gamash" => [0, "es", "ES"],
    "gambado" => [0, "es", "ES"],
    "gambling" => [0, "", ""],
    "gamboling" => [0, "", ""],
    "gambolling" => [0, "", ""],
    "gameless" => [0, "", ""],
    "gametangium" => [2, "a", "A"],
    "gametogenesis" => [2, "es", "ES"],
    "gamines" => [0, "ses", "SES"],
    "gamogenesis" => [2, "es", "ES"],
    "gangling" => [0, "", ""],
    "ganglion" => [2, "a", "A"],
    "gangway" => [0, "s", "S"],
    "gansey" => [0, "s", "S"],
    "gapless" => [0, "", ""],
    "garbless" => [0, "", ""],
    "garbling" => [0, "", ""],
    "garefowl" => [0, "", ""],
    "garfish" => [0, "", ""],
    "garganey" => [0, "s", "S"],
    "garlandless" => [0, "", ""],
    "garmentless" => [0, "", ""],
    "garnish" => [0, "es", "ES"],
    "garvey" => [0, "s", "S"],
    "gash" => [0, "es", "ES"],
    "gasless" => [0, "", ""],
    "gastritis" => [1, "des", "DES"],
    "gastrocnemius" => [2, "i", "I"],
    "gastroenteritis" => [1, "des", "DES"],
    "gateless" => [0, "", ""],
    "gateway" => [0, "s", "S"],
    "gaumless" => [0, "", ""],
    "gaveling" => [0, "", ""],
    "gavelling" => [0, "", ""],
    "gay" => [0, "s", "S"],
    "gazabo" => [0, "es", "ES"],
    "gazeless" => [0, "", ""],
    "gearless" => [0, "", ""],
    "geisha" => [0, "", ""],
    "gelatis" => [2, "es", "ES"],
    "gelling" => [0, "", ""],
    "gemfish" => [0, "", ""],
    "gemless" => [0, "", ""],
    "gemma" => [0, "e", "E"],
    "genderless" => [0, "", ""],
    "generatrix" => [1, "ces", "CES"],
    "genesis" => [2, "es", "ES"],
    "gentiles" => [0, "ses", "SES"],
    "gentling" => [0, "", ""],
    "genus" => [2, "era", "ERA"],
    "geotaxis" => [2, "es", "ES"],
    "gerontomorphosis" => [2, "es", "ES"],
    "gesso" => [0, "es", "ES"],
    "getaway" => [0, "s", "S"],
    "getgo" => [0, "es", "ES"],
    "ghostfish" => [0, "", ""],
    "giardiasis" => [2, "es", "ES"],
    "gibberish" => [0, "es", "ES"],
    "gif" => [1, "ves", "VES"],
    "giftless" => [0, "", ""],
    "gigahertz" => [0, "", ""],
    "gimballing" => [0, "", ""],
    "gingeley" => [0, "s", "S"],
    "gingiva" => [0, "e", "E"],
    "gingko" => [0, "es", "ES"],
    "ginkgo" => [0, "es", "ES"],
    "ginzo" => [0, "es", "ES"],
    "girdling" => [0, "", ""],
    "girsh" => [0, "es", "ES"],
    "giveaway" => [0, "s", "S"],
    "glabella" => [0, "e", "E"],
    "glabellum" => [2, "a", "A"],
    "gladiolus" => [2, "i", "I"],
    "glamourless" => [0, "", ""],
    "glandless" => [0, "", ""],
    "glans" => [1, "des", "DES"],
    "glassfish" => [0, "", ""],
    "glassines" => [0, "ses", "SES"],
    "glassless" => [0, "", ""],
    "gleba" => [0, "e", "E"],
    "gleis" => [2, "es", "ES"],
    "gliosis" => [2, "es", "ES"],
    "glissando" => [1, "i", "I"],
    "glitch" => [0, "es", "ES"],
    "globefish" => [0, "", ""],
    "globigerina" => [0, "e", "E"],
    "glochidium" => [2, "a", "A"],
    "glomerulonephritis" => [1, "des", "DES"],
    "glomerulus" => [2, "i", "I"],
    "gloveless" => [0, "", ""],
    "gluconeogenesis" => [2, "es", "ES"],
    "glutaeus" => [2, "i", "I"],
    "gluteus" => [2, "i", "I"],
    "glycogenesis" => [2, "es", "ES"],
    "glycogenolysis" => [2, "es", "ES"],
    "glycolysis" => [2, "es", "ES"],
    "gnarling" => [0, "", ""],
    "gnash" => [0, "es", "ES"],
    "gnatling" => [0, "", ""],
    "gnosis" => [2, "es", "ES"],
    "gnu" => [0, "", ""],
    "goaling" => [0, "", ""],
    "goalless" => [0, "", ""],
    "goatfish" => [0, "", ""],
    "goatling" => [0, "", ""],
    "gobbo" => [1, "i", "I"],
    "gobo" => [0, "es", "ES"],
    "godchild" => [0, "ren", "REN"],
    "godless" => [0, "", ""],
    "godling" => [0, "", ""],
    "goldfinch" => [0, "es", "ES"],
    "goldfish" => [0, "", ""],
    "goldless" => [0, "", ""],
    "golosh" => [0, "es", "ES"],
    "gomphosis" => [2, "es", "ES"],
    "gonidium" => [2, "a", "A"],
    "gonium" => [2, "a", "A"],
    "gonococcus" => [2, "i", "I"],
    "goodby" => [0, "s", "S"],
    "goodwife" => [2, "ves", "VES"],
    "googling" => [0, "", ""],
    "gooley" => [0, "s", "S"],
    "goombay" => [0, "s", "S"],
    "gooney" => [0, "s", "S"],
    "goose" => [4, "eese", "EESE"],
    "goosefish" => [0, "", ""],
    "gooseflesh" => [0, "es", "ES"],
    "goosey" => [0, "s", "S"],
    "gorblimey" => [0, "s", "S"],
    "gorgoneion" => [2, "a", "A"],
    "gormless" => [0, "", ""],
    "gosh" => [0, "es", "ES"],
    "gosling" => [0, "", ""],
    "gospelling" => [0, "", ""],
    "goulash" => [0, "es", "ES"],
    "gownboy" => [0, "s", "S"],
    "goy" => [0, "s", "S"],
    "graceless" => [0, "", ""],
    "gracilis" => [2, "es", "ES"],
    "gradeless" => [0, "", ""],
    "gradino" => [1, "i", "I"],
    "graffito" => [1, "i", "I"],
    "gramash" => [0, "es", "ES"],
    "grand" => [0, "", ""],
    "grandchild" => [0, "ren", "REN"],
    "granulocytopoiesis" => [2, "es", "ES"],
    "granulosis" => [2, "es", "ES"],
    "granum" => [2, "a", "A"],
    "grapeless" => [0, "", ""],
    "graspless" => [0, "", ""],
    "grassless" => [0, "", ""],
    "gratis" => [2, "es", "ES"],
    "graveless" => [0, "", ""],
    "graveling" => [0, "", ""],
    "gravelling" => [0, "", ""],
    "grayfish" => [0, "", ""],
    "grayling" => [0, "", ""],
    "greaseless" => [0, "", ""],
    "greenfinch" => [0, "es", "ES"],
    "greenling" => [0, "", ""],
    "greenway" => [0, "s", "S"],
    "grey" => [0, "s", "S"],
    "griefless" => [0, "", ""],
    "grinch" => [0, "es", "ES"],
    "gripless" => [0, "", ""],
    "gritless" => [0, "", ""],
    "gross" => [0, "", ""],
    "grotto" => [0, "es", "ES"],
    "grouch" => [0, "es", "ES"],
    "groundfish" => [0, "", ""],
    "groundless" => [0, "", ""],
    "groundling" => [0, "", ""],
    "grouse" => [0, "", ""],
    "groveling" => [0, "", ""],
    "grovelling" => [0, "", ""],
    "growling" => [0, "", ""],
    "grueling" => [0, "", ""],
    "gruelling" => [0, "", ""],
    "gruntling" => [0, "", ""],
    "gruppetto" => [1, "i", "I"],
    "guacharo" => [0, "es", "ES"],
    "guanay" => [0, "s", "S"],
    "guardless" => [0, "", ""],
    "gubernaculum" => [2, "a", "A"],
    "guideless" => [0, "", ""],
    "guideway" => [0, "s", "S"],
    "guileless" => [0, "", ""],
    "guiltless" => [0, "", ""],
    "guitarfish" => [0, "", ""],
    "gulch" => [0, "es", "ES"],
    "gulley" => [0, "s", "S"],
    "gulling" => [0, "", ""],
    "gumless" => [0, "", ""],
    "gummosis" => [2, "es", "ES"],
    "gunless" => [0, "", ""],
    "gunplay" => [0, "s", "S"],
    "gurney" => [0, "s", "S"],
    "gursh" => [0, "es", "ES"],
    "gus" => [2, "i", "I"],
    "gush" => [0, "es", "ES"],
    "gustless" => [0, "", ""],
    "gusto" => [0, "es", "ES"],
    "gutless" => [0, "", ""],
    "guttersnipe" => [0, "", ""],
    "gynaeceum" => [2, "a", "A"],
    "gynaecium" => [2, "a", "A"],
    "gynecium" => [2, "a", "A"],
    "gynogenesis" => [2, "es", "ES"],
    "gytrash" => [0, "es", "ES"],
    "hackling" => [0, "", ""],
    "hadj" => [0, "es", "ES"],
    "hadjis" => [2, "es", "ES"],
    "haemodialysis" => [2, "es", "ES"],
    "hagbush" => [0, "es", "ES"],
    "hagfish" => [0, "", ""],
    "haiku" => [0, "", ""],
    "hairbrush" => [0, "es", "ES"],
    "hairless" => [0, "", ""],
    "hairspray" => [0, "s", "S"],
    "haj" => [0, "es", "ES"],
    "hajis" => [2, "es", "ES"],
    "hajj" => [0, "es", "ES"],
    "hajjis" => [2, "es", "ES"],
    "hake" => [0, "", ""],
    "halalling" => [0, "", ""],
    "half" => [1, "ves", "VES"],
    "halflife" => [2, "ves", "VES"],
    "halfling" => [0, "", ""],
    "halfpenny" => [2, "ce", "CE"],
    "halibut" => [0, "", ""],
    "haling" => [0, "", ""],
    "halitosis" => [2, "es", "ES"],
    "hallalling" => [0, "", ""],
    "hallucinosis" => [2, "es", "ES"],
    "hallux" => [1, "ces", "CES"],
    "hallway" => [0, "s", "S"],
    "halobacterium" => [2, "a", "A"],
    "haltless" => [0, "", ""],
    "hammerfish" => [0, "", ""],
    "hammerless" => [0, "", ""],
    "hamulus" => [2, "i", "I"],
    "handleless" => [0, "", ""],
    "handless" => [0, "", ""],
    "handling" => [0, "", ""],
    "handplay" => [0, "s", "S"],
    "handselling" => [0, "", ""],
    "handshake" => [0, "", ""],
    "hanseling" => [0, "", ""],
    "hanselling" => [0, "", ""],
    "hanuman" => [0, "s", "S"],
    "hapless" => [0, "", ""],
    "haplosis" => [2, "es", "ES"],
    "harborless" => [0, "", ""],
    "harbourless" => [0, "", ""],
    "harman" => [0, "s", "S"],
    "harmless" => [0, "", ""],
    "haruspex" => [2, "ices", "ICES"],
    "harvestfish" => [0, "", ""],
    "hash" => [0, "es", "ES"],
    "hasheesh" => [0, "es", "ES"],
    "hashish" => [0, "es", "ES"],
    "hatbrush" => [0, "es", "ES"],
    "hatch" => [0, "es", "ES"],
    "hatchelling" => [0, "", ""],
    "hatchling" => [0, "", ""],
    "hatchway" => [0, "s", "S"],
    "hateless" => [0, "", ""],
    "hatless" => [0, "", ""],
    "haunch" => [0, "es", "ES"],
    "haustellum" => [2, "a", "A"],
    "haustorium" => [2, "a", "A"],
    "hautboy" => [0, "s", "S"],
    "hawfinch" => [0, "es", "ES"],
    "hawkey" => [0, "s", "S"],
    "hay" => [0, "s", "S"],
    "hazeless" => [0, "", ""],
    "headfish" => [0, "", ""],
    "headless" => [0, "", ""],
    "headscarf" => [1, "ves", "VES"],
    "headshake" => [0, "", ""],
    "headstay" => [0, "s", "S"],
    "headway" => [0, "s", "S"],
    "healthless" => [0, "", ""],
    "hearsay" => [0, "s", "S"],
    "heartless" => [0, "", ""],
    "heartling" => [0, "", ""],
    "heathfowl" => [0, "", ""],
    "heathless" => [0, "", ""],
    "heatless" => [0, "", ""],
    "heckling" => [0, "", ""],
    "hectocotylus" => [2, "i", "I"],
    "heedless" => [0, "", ""],
    "heelless" => [0, "", ""],
    "heirless" => [0, "", ""],
    "heling" => [0, "", ""],
    "heliotaxis" => [2, "es", "ES"],
    "helis" => [2, "es", "ES"],
    "helix" => [1, "ces", "CES"],
    "helminthiasis" => [2, "es", "ES"],
    "helmless" => [0, "", ""],
    "helpless" => [0, "", ""],
    "hemapheresis" => [2, "es", "ES"],
    "hematogenesis" => [2, "es", "ES"],
    "hematopoiesis" => [2, "es", "ES"],
    "hematozoon" => [2, "a", "A"],
    "hemelytron" => [2, "a", "A"],
    "hemochromatosis" => [2, "es", "ES"],
    "hemodialysis" => [2, "es", "ES"],
    "hemolysis" => [2, "es", "ES"],
    "hemopoiesis" => [2, "es", "ES"],
    "hemoptysis" => [2, "es", "ES"],
    "hemostasis" => [2, "es", "ES"],
    "hempbush" => [0, "es", "ES"],
    "hemstitch" => [0, "es", "ES"],
    "henley" => [0, "s", "S"],
    "hepatitis" => [1, "des", "DES"],
    "herbless" => [0, "", ""],
    "herdboy" => [0, "s", "S"],
    "hereaway" => [0, "s", "S"],
    "herling" => [0, "", ""],
    "herma" => [0, "e", "E"],
    "hero" => [0, "es", "ES"],
    "herring" => [0, "", ""],
    "hertz" => [0, "", ""],
    "heterogenesis" => [2, "es", "ES"],
    "heterokaryosis" => [2, "es", "ES"],
    "heterolysis" => [2, "es", "ES"],
    "heterosis" => [2, "es", "ES"],
    "heterotaxis" => [2, "es", "ES"],
    "heterozygosis" => [2, "es", "ES"],
    "hetman" => [0, "s", "S"],
    "heyday" => [0, "s", "S"],
    "heydey" => [0, "s", "S"],
    "hibernaculum" => [2, "a", "A"],
    "hickey" => [0, "s", "S"],
    "hideaway" => [0, "s", "S"],
    "hideless" => [0, "", ""],
    "hidling" => [0, "", ""],
    "hidrosis" => [2, "es", "ES"],
    "hielaman" => [0, "s", "S"],
    "hieron" => [2, "a", "A"],
    "highboy" => [0, "s", "S"],
    "highway" => [0, "s", "S"],
    "hiltless" => [0, "", ""],
    "hilum" => [2, "a", "A"],
    "hilus" => [2, "i", "I"],
    "hipless" => [0, "", ""],
    "hippocampus" => [2, "i", "I"],
    "hireling" => [0, "", ""],
    "hirselling" => [0, "", ""],
    "his" => [0, "ses", "SES"],
    "histodialysis" => [2, "es", "ES"],
    "histogenesis" => [2, "es", "ES"],
    "histolysis" => [2, "es", "ES"],
    "histoplasmosis" => [2, "es", "ES"],
    "hitch" => [0, "es", "ES"],
    "hitless" => [0, "", ""],
    "hiveless" => [0, "", ""],
    "hobblebush" => [0, "es", "ES"],
    "hobbledehoy" => [0, "s", "S"],
    "hobbyless" => [0, "", ""],
    "hockey" => [0, "s", "S"],
    "hogfish" => [0, "", ""],
    "hogmenay" => [0, "s", "S"],
    "hogwash" => [0, "es", "ES"],
    "hoistway" => [0, "s", "S"],
    "hokeypokey" => [0, "s", "S"],
    "holeless" => [0, "", ""],
    "holiday" => [0, "s", "S"],
    "hollo" => [0, "es", "ES"],
    "holyday" => [0, "s", "S"],
    "homeboy" => [0, "s", "S"],
    "homefolk" => [0, "", ""],
    "homeless" => [0, "", ""],
    "homeostasis" => [2, "es", "ES"],
    "homestay" => [0, "s", "S"],
    "homestretch" => [0, "es", "ES"],
    "homey" => [0, "s", "S"],
    "homines" => [0, "ses", "SES"],
    "homolysis" => [2, "es", "ES"],
    "homotaxis" => [2, "es", "ES"],
    "homozygosis" => [2, "es", "ES"],
    "homunculus" => [2, "i", "I"],
    "hondling" => [0, "", ""],
    "honey" => [0, "s", "S"],
    "honeybunch" => [0, "es", "ES"],
    "honeyless" => [0, "", ""],
    "honkey" => [0, "s", "S"],
    "honorless" => [0, "", ""],
    "honourless" => [0, "", ""],
    "hooch" => [0, "es", "ES"],
    "hoodless" => [0, "", ""],
    "hooey" => [0, "s", "S"],
    "hoofless" => [0, "", ""],
    "hookey" => [0, "s", "S"],
    "hookless" => [0, "", ""],
    "hooley" => [0, "s", "S"],
    "hoopless" => [0, "", ""],
    "hooray" => [0, "s", "S"],
    "hootch" => [0, "es", "ES"],
    "hopeless" => [0, "", ""],
    "hopscotch" => [0, "es", "ES"],
    "hordeolum" => [2, "a", "A"],
    "horizonless" => [0, "", ""],
    "hormogonium" => [2, "a", "A"],
    "hornless" => [0, "", ""],
    "horsefish" => [0, "", ""],
    "horseflesh" => [0, "", ""],
    "horseleech" => [0, "es", "ES"],
    "horseless" => [0, "", ""],
    "horseplay" => [0, "s", "S"],
    "horsepower" => [0, "", ""],
    "horseradish" => [0, "es", "ES"],
    "horseway" => [0, "s", "S"],
    "hostelling" => [0, "", ""],
    "hotchpotch" => [0, "es", "ES"],
    "hoteling" => [0, "", ""],
    "houndfish" => [0, "", ""],
    "hourless" => [0, "", ""],
    "houseboy" => [0, "s", "S"],
    "houseless" => [0, "", ""],
    "houseling" => [0, "", ""],
    "houselling" => [0, "", ""],
    "housewife" => [2, "ves", "VES"],
    "hoveling" => [0, "", ""],
    "hovelling" => [0, "", ""],
    "hovercraft" => [0, "", ""],
    "howling" => [0, "", ""],
    "hoy" => [0, "s", "S"],
    "hueless" => [0, "", ""],
    "hui" => [0, "es", "ES"],
    "human" => [0, "s", "S"],
    "humerus" => [2, "i", "I"],
    "humorless" => [0, "", ""],
    "humourless" => [0, "", ""],
    "humpless" => [0, "", ""],
    "hunch" => [0, "es", "ES"],
    "huntaway" => [0, "s", "S"],
    "hurley" => [0, "s", "S"],
    "hurray" => [0, "s", "S"],
    "hurricano" => [0, "es", "ES"],
    "hurtless" => [0, "", ""],
    "hurtling" => [0, "", ""],
    "husbandless" => [0, "", ""],
    "hush" => [0, "es", "ES"],
    "hutch" => [0, "es", "ES"],
    "hydrocephali" => [0, "es", "ES"],
    "hydrocephalus" => [2, "i", "I"],
    "hydrogenolysis" => [2, "es", "ES"],
    "hydrolysis" => [2, "es", "ES"],
    "hydrosoma" => [0, "ta", "TA"],
    "hydrotaxis" => [2, "es", "ES"],
    "hymnless" => [0, "", ""],
    "hypercatalexis" => [2, "es", "ES"],
    "hyperhidrosis" => [2, "es", "ES"],
    "hyperkeratosis" => [2, "es", "ES"],
    "hyperkinesis" => [2, "es", "ES"],
    "hyperostosis" => [2, "es", "ES"],
    "hypervitaminosis" => [2, "es", "ES"],
    "hypha" => [0, "e", "E"],
    "hyphenless" => [0, "", ""],
    "hypnoanalysis" => [2, "es", "ES"],
    "hypnogenesis" => [2, "es", "ES"],
    "hypnosis" => [2, "es", "ES"],
    "hypochondriasis" => [2, "es", "ES"],
    "hypochondrium" => [2, "a", "A"],
    "hypogeum" => [2, "a", "A"],
    "hypopharynx" => [1, "ges", "GES"],
    "hypophysis" => [2, "es", "ES"],
    "hypotaxis" => [2, "es", "ES"],
    "hypothalamus" => [2, "i", "I"],
    "hypothesis" => [2, "es", "ES"],
    "hysteresis" => [2, "es", "ES"],
    "ibex" => [0, "", ""],
    "ibis" => [0, "", ""],
    "icefish" => [0, "", ""],
    "iceless" => [0, "", ""],
    "ichthyosis" => [2, "es", "ES"],
    "iconostasis" => [2, "es", "ES"],
    "icositetrahedron" => [2, "a", "A"],
    "idealess" => [0, "", ""],
    "idealless" => [0, "", ""],
    "idles" => [0, "ses", "SES"],
    "idling" => [0, "", ""],
    "ignaro" => [0, "es", "ES"],
    "ileitis" => [1, "des", "DES"],
    "ileum" => [2, "a", "A"],
    "ilium" => [2, "a", "A"],
    "illuminato" => [1, "i", "I"],
    "illuminatus" => [2, "i", "I"],
    "imageless" => [0, "", ""],
    "imago" => [0, "es", "ES"],
    "imbrex" => [2, "ices", "ICES"],
    "immunoassay" => [0, "s", "S"],
    "immunodiagnosis" => [2, "es", "ES"],
    "immunoelectrophoresis" => [2, "es", "ES"],
    "immunogenesis" => [2, "es", "ES"],
    "impanelling" => [0, "", ""],
    "impatiens" => [0, "", ""],
    "impelling" => [0, "", ""],
    "imperilling" => [0, "", ""],
    "impluvium" => [2, "a", "A"],
    "importless" => [0, "", ""],
    "inch" => [0, "es", "ES"],
    "incunabulum" => [2, "a", "A"],
    "indexless" => [0, "", ""],
    "indusium" => [2, "a", "A"],
    "inflectionless" => [0, "", ""],
    "infrahuman" => [0, "s", "S"],
    "infula" => [0, "e", "E"],
    "infundibulum" => [2, "a", "A"],
    "ingo" => [0, "es", "ES"],
    "initialling" => [0, "", ""],
    "inkfish" => [0, "", ""],
    "inkless" => [0, "", ""],
    "inkling" => [0, "", ""],
    "inlay" => [0, "s", "S"],
    "innless" => [0, "", ""],
    "inrush" => [0, "es", "ES"],
    "insigne" => [1, "ia", "IA"],
    "installing" => [0, "", ""],
    "instilling" => [0, "", ""],
    "interambulacrum" => [2, "a", "A"],
    "interkinesis" => [2, "es", "ES"],
    "interleaf" => [1, "ves", "VES"],
    "intermaxilla" => [0, "e", "E"],
    "intermissionless" => [0, "", ""],
    "interplay" => [0, "s", "S"],
    "interradius" => [2, "i", "I"],
    "interreligious" => [0, "", ""],
    "interstimulus" => [2, "i", "I"],
    "intervalley" => [0, "s", "S"],
    "inthralling" => [0, "", ""],
    "into" => [1, "i", "I"],
    "iontophoresis" => [2, "es", "ES"],
    "ireless" => [0, "", ""],
    "ischium" => [2, "a", "A"],
    "ish" => [0, "es", "ES"],
    "isleless" => [0, "", ""],
    "isling" => [0, "", ""],
    "isodomum" => [2, "a", "A"],
    "issueless" => [0, "", ""],
    "itch" => [0, "es", "ES"],
    "ithyphallus" => [2, "i", "I"],
    "jacketless" => [0, "", ""],
    "jackfish" => [0, "", ""],
    "jackknife" => [2, "ves", "VES"],
    "jacksnipe" => [0, "", ""],
    "jackstay" => [0, "s", "S"],
    "jagless" => [0, "", ""],
    "jambeau" => [0, "x", "X"],
    "jansky" => [0, "s", "S"],
    "jarless" => [0, "", ""],
    "jarvey" => [0, "s", "S"],
    "jasey" => [0, "s", "S"],
    "jawfish" => [0, "", ""],
    "jawless" => [0, "", ""],
    "jay" => [0, "s", "S"],
    "jeepney" => [0, "s", "S"],
    "jejunum" => [2, "a", "A"],
    "jellyfish" => [0, "", ""],
    "jetway" => [0, "s", "S"],
    "jeu" => [0, "x", "X"],
    "jewelfish" => [0, "", ""],
    "jewelling" => [0, "", ""],
    "jewfish" => [0, "", ""],
    "jingko" => [0, "es", "ES"],
    "jingo" => [0, "es", "ES"],
    "jitney" => [0, "s", "S"],
    "jobless" => [0, "", ""],
    "jockey" => [0, "s", "S"],
    "jodelling" => [0, "", ""],
    "joey" => [0, "s", "S"],
    "jointless" => [0, "", ""],
    "jointures" => [0, "ses", "SES"],
    "jokeless" => [0, "", ""],
    "joling" => [0, "", ""],
    "josh" => [0, "es", "ES"],
    "journalling" => [0, "", ""],
    "journey" => [0, "s", "S"],
    "joy" => [0, "s", "S"],
    "joyless" => [0, "", ""],
    "jugulum" => [2, "a", "A"],
    "juiceless" => [0, "", ""],
    "juryless" => [0, "", ""],
    "justling" => [0, "", ""],
    "kaffeeklatch" => [0, "es", "ES"],
    "kalewife" => [2, "ves", "VES"],
    "kalis" => [2, "es", "ES"],
    "karyokinesis" => [2, "es", "ES"],
    "katabasis" => [2, "es", "ES"],
    "katharsis" => [2, "es", "ES"],
    "kavas" => [0, "ses", "SES"],
    "kay" => [0, "s", "S"],
    "kazatski" => [0, "es", "ES"],
    "keckling" => [0, "", ""],
    "keech" => [0, "es", "ES"],
    "keelless" => [0, "", ""],
    "keeperless" => [0, "", ""],
    "kegling" => [0, "", ""],
    "kench" => [0, "es", "ES"],
    "kennelling" => [0, "", ""],
    "kenosis" => [2, "es", "ES"],
    "keratitis" => [1, "des", "DES"],
    "keratosis" => [2, "es", "ES"],
    "kerneling" => [0, "", ""],
    "kernelling" => [0, "", ""],
    "kersey" => [0, "s", "S"],
    "ketch" => [0, "es", "ES"],
    "ketogenesis" => [2, "es", "ES"],
    "ketosis" => [2, "es", "ES"],
    "key" => [0, "s", "S"],
    "keyless" => [0, "", ""],
    "keypunch" => [0, "es", "ES"],
    "keyway" => [0, "s", "S"],
    "kibbis" => [2, "es", "ES"],
    "kibbutz" => [0, "im", "IM"],
    "kibosh" => [0, "es", "ES"],
    "kickless" => [0, "", ""],
    "kiddush" => [0, "es", "ES"],
    "kidling" => [0, "", ""],
    "kidney" => [0, "s", "S"],
    "kiley" => [0, "s", "S"],
    "killifish" => [0, "es", "ES"],
    "killjoy" => [0, "s", "S"],
    "kilobaud" => [0, "", ""],
    "kilohertz" => [0, "", ""],
    "kin" => [0, "", ""],
    "kindless" => [0, "", ""],
    "kindling" => [0, "", ""],
    "kinesis" => [2, "es", "ES"],
    "kinesthesis" => [2, "es", "ES"],
    "kingdomless" => [0, "", ""],
    "kingfish" => [0, "", ""],
    "kingless" => [0, "", ""],
    "kingling" => [0, "", ""],
    "kinless" => [0, "", ""],
    "kip" => [0, "", ""],
    "kirsch" => [0, "es", "ES"],
    "kish" => [0, "es", "ES"],
    "kitling" => [0, "", ""],
    "kitsch" => [0, "es", "ES"],
    "klatch" => [0, "es", "ES"],
    "klatsch" => [0, "es", "ES"],
    "kloochman" => [0, "s", "S"],
    "klootchman" => [0, "s", "S"],
    "kneeling" => [0, "", ""],
    "knife" => [2, "ves", "VES"],
    "knifeless" => [0, "", ""],
    "knightless" => [0, "", ""],
    "knish" => [0, "es", "ES"],
    "knitch" => [0, "es", "ES"],
    "knotless" => [0, "", ""],
    "knurling" => [0, "", ""],
    "kohlrabi" => [0, "es", "ES"],
    "kohlrabies" => [0, "", ""],
    "kolinski" => [0, "es", "ES"],
    "kon" => [2, "a", "A"],
    "koori" => [0, "es", "ES"],
    "kouprey" => [0, "s", "S"],
    "krona" => [1, "ur", "UR"],
    "krone" => [0, "r", "R"],
    "kuchen" => [0, "", ""],
    "kumis" => [0, "ses", "SES"],
    "kurtosis" => [2, "es", "ES"],
    "kurus" => [2, "i", "I"],
    "kutch" => [0, "es", "ES"],
    "kvetch" => [0, "es", "ES"],
    "kylix" => [1, "ces", "CES"],
    "kyphosis" => [2, "es", "ES"],
    "labelling" => [0, "", ""],
    "labellum" => [2, "a", "A"],
    "labium" => [2, "a", "A"],
    "laceless" => [0, "", ""],
    "lackaday" => [0, "s", "S"],
    "lackey" => [0, "s", "S"],
    "lacteal" => [0, "", ""],
    "lactobacillus" => [2, "i", "I"],
    "lacuna" => [0, "e", "E"],
    "ladling" => [0, "", ""],
    "ladyfish" => [0, "", ""],
    "ladyless" => [0, "", ""],
    "lambling" => [0, "", ""],
    "lamina" => [0, "e", "E"],
    "lampless" => [0, "", ""],
    "lamprey" => [0, "s", "S"],
    "lancetfish" => [0, "", ""],
    "landamman" => [0, "s", "S"],
    "landless" => [0, "", ""],
    "laneway" => [0, "s", "S"],
    "langley" => [0, "s", "S"],
    "languageless" => [0, "", ""],
    "lanternfish" => [0, "", ""],
    "lapillus" => [2, "i", "I"],
    "laqueus" => [2, "i", "I"],
    "larch" => [0, "es", "ES"],
    "larges" => [0, "ses", "SES"],
    "laris" => [2, "es", "ES"],
    "larva" => [0, "e", "E"],
    "laryngitis" => [1, "des", "DES"],
    "larynx" => [1, "ges", "GES"],
    "lash" => [0, "es", "ES"],
    "lassus" => [2, "i", "I"],
    "latch" => [0, "es", "ES"],
    "latchkey" => [0, "s", "S"],
    "lateralling" => [0, "", ""],
    "latex" => [2, "ices", "ICES"],
    "lathis" => [2, "es", "ES"],
    "latifundium" => [2, "a", "A"],
    "latigo" => [0, "es", "ES"],
    "latticino" => [1, "i", "I"],
    "launch" => [0, "es", "ES"],
    "laurelling" => [0, "", ""],
    "lawless" => [0, "", ""],
    "lay" => [0, "s", "S"],
    "layaway" => [0, "s", "S"],
    "layperson" => [4, "ople", "OPLE"],
    "leach" => [0, "es", "ES"],
    "leaderless" => [0, "", ""],
    "leadfoot" => [3, "eet", "EET"],
    "leadless" => [0, "", ""],
    "leaf" => [1, "ves", "VES"],
    "leafless" => [0, "", ""],
    "leakless" => [0, "", ""],
    "leash" => [0, "es", "ES"],
    "leatherfish" => [0, "", ""],
    "leatherleaf" => [1, "ves", "VES"],
    "lecythus" => [2, "i", "I"],
    "leech" => [0, "es", "ES"],
    "leeway" => [0, "s", "S"],
    "legless" => [0, "", ""],
    "leis" => [2, "es", "ES"],
    "leishmaniasis" => [2, "es", "ES"],
    "leishmaniosis" => [2, "es", "ES"],
    "lekythus" => [2, "i", "I"],
    "leman" => [0, "s", "S"],
    "lemniscus" => [2, "i", "I"],
    "lemonfish" => [0, "", ""],
    "lenis" => [2, "es", "ES"],
    "lensless" => [0, "", ""],
    "lenvoy" => [0, "s", "S"],
    "lepidopteron" => [2, "a", "A"],
    "lepton" => [2, "a", "A"],
    "leptospirosis" => [2, "es", "ES"],
    "less" => [0, "", ""],
    "letterless" => [0, "", ""],
    "leucocytosis" => [2, "es", "ES"],
    "leucosis" => [2, "es", "ES"],
    "leukaemogenesis" => [2, "es", "ES"],
    "leukemogenesis" => [2, "es", "ES"],
    "leukocytosis" => [2, "es", "ES"],
    "leukopoiesis" => [2, "es", "ES"],
    "leukosis" => [2, "es", "ES"],
    "leveling" => [0, "", ""],
    "levelling" => [0, "", ""],
    "ley" => [0, "s", "S"],
    "lez" => [0, "zes", "ZES"],
    "libelling" => [0, "", ""],
    "lich" => [0, "es", "ES"],
    "lichis" => [2, "es", "ES"],
    "lidless" => [0, "", ""],
    "lied" => [0, "er", "ER"],
    "liegeless" => [0, "", ""],
    "life" => [2, "ves", "VES"],
    "lifebuoy" => [0, "s", "S"],
    "lifeless" => [0, "", ""],
    "lifeway" => [0, "s", "S"],
    "liftboy" => [0, "s", "S"],
    "lightless" => [0, "", ""],
    "liman" => [0, "s", "S"],
    "limbless" => [0, "", ""],
    "limeless" => [0, "", ""],
    "limitless" => [0, "", ""],
    "linch" => [0, "es", "ES"],
    "lineless" => [0, "", ""],
    "linerless" => [0, "", ""],
    "ling" => [0, "", ""],
    "lingo" => [0, "es", "ES"],
    "linguine" => [0, "", ""],
    "linguini" => [0, "", ""],
    "linguinis" => [2, "es", "ES"],
    "linhay" => [0, "s", "S"],
    "linkboy" => [0, "s", "S"],
    "linsey" => [0, "s", "S"],
    "lintless" => [0, "", ""],
    "lionfish" => [0, "", ""],
    "lipless" => [0, "", ""],
    "lipogenesis" => [2, "es", "ES"],
    "lipolysis" => [2, "es", "ES"],
    "lira" => [1, "e", "E"],
    "lis" => [0, "ses", "SES"],
    "listeriosis" => [2, "es", "ES"],
    "listless" => [0, "", ""],
    "literato" => [1, "i", "I"],
    "literatus" => [2, "i", "I"],
    "lithiasis" => [2, "es", "ES"],
    "lithophysa" => [0, "e", "E"],
    "liverleaf" => [1, "ves", "VES"],
    "lizardfish" => [0, "", ""],
    "loach" => [0, "es", "ES"],
    "loadless" => [0, "", ""],
    "loaf" => [1, "ves", "VES"],
    "loamless" => [0, "", ""],
    "lobster" => [0, "", ""],
    "lobulus" => [2, "i", "I"],
    "lobus" => [2, "i", "I"],
    "localing" => [0, "", ""],
    "localling" => [0, "", ""],
    "lockless" => [0, "", ""],
    "lockstitch" => [0, "es", "ES"],
    "loculus" => [2, "i", "I"],
    "locus" => [2, "i", "I"],
    "locusta" => [0, "e", "E"],
    "loftless" => [0, "", ""],
    "logway" => [0, "s", "S"],
    "longleaf" => [1, "ves", "VES"],
    "looey" => [0, "s", "S"],
    "looney" => [0, "s", "S"],
    "lordless" => [0, "", ""],
    "lordling" => [0, "", ""],
    "lordosis" => [2, "es", "ES"],
    "loreless" => [0, "", ""],
    "lorica" => [0, "e", "E"],
    "losh" => [0, "es", "ES"],
    "louse" => [4, "ice", "ICE"],
    "lovechild" => [0, "ren", "REN"],
    "loveless" => [0, "", ""],
    "loverless" => [0, "", ""],
    "lovey" => [0, "s", "S"],
    "lowboy" => [0, "s", "S"],
    "lox" => [0, "", ""],
    "loy" => [0, "s", "S"],
    "luckless" => [0, "", ""],
    "lumpfish" => [0, "", ""],
    "lunch" => [0, "es", "ES"],
    "lungfish" => [0, "es", "ES"],
    "lungis" => [2, "es", "ES"],
    "lurch" => [0, "es", "ES"],
    "lush" => [0, "es", "ES"],
    "lusterless" => [0, "", ""],
    "lustless" => [0, "", ""],
    "lustreless" => [0, "", ""],
    "luteum" => [2, "a", "A"],
    "lych" => [0, "es", "ES"],
    "lymphocytosis" => [2, "es", "ES"],
    "lymphogranulomatosis" => [2, "es", "ES"],
    "lymphomatosis" => [2, "es", "ES"],
    "lymphopoiesis" => [2, "es", "ES"],
    "lynx" => [0, "", ""],
    "lyolysis" => [2, "es", "ES"],
    "lysis" => [2, "es", "ES"],
    "maccaboy" => [0, "s", "S"],
    "maccoboy" => [0, "s", "S"],
    "machineless" => [0, "", ""],
    "macintosh" => [0, "es", "ES"],
    "mackerel" => [0, "", ""],
    "mackintosh" => [0, "es", "ES"],
    "mackling" => [0, "", ""],
    "macroaxis" => [2, "es", "ES"],
    "macrocytosis" => [2, "es", "ES"],
    "macronucleus" => [2, "i", "I"],
    "macrosporangium" => [2, "a", "A"],
    "madame" => [5, "esdames", "ESDAMES"],
    "madling" => [0, "", ""],
    "magnetotaxis" => [2, "es", "ES"],
    "magnifico" => [0, "es", "ES"],
    "maguey" => [0, "s", "S"],
    "mailcoach" => [0, "es", "ES"],
    "mailless" => [0, "", ""],
    "mainstay" => [0, "s", "S"],
    "makeless" => [0, "", ""],
    "malarkey" => [0, "s", "S"],
    "malis" => [2, "es", "ES"],
    "malleolus" => [2, "i", "I"],
    "malling" => [0, "", ""],
    "mamey" => [0, "s", "S"],
    "mamilla" => [0, "e", "E"],
    "mammatus" => [2, "i", "I"],
    "mammey" => [0, "s", "S"],
    "mammilla" => [0, "e", "E"],
    "mammitis" => [1, "des", "DES"],
    "maneless" => [0, "", ""],
    "mangabey" => [0, "s", "S"],
    "mangling" => [0, "", ""],
    "mango" => [0, "es", "ES"],
    "manless" => [0, "", ""],
    "mannerless" => [0, "", ""],
    "manservant" => [9, "enservants", "ENSERVANTS"],
    "mantelshelf" => [1, "ves", "VES"],
    "marcelling" => [0, "", ""],
    "margay" => [0, "s", "S"],
    "marish" => [0, "es", "ES"],
    "markka" => [0, "a", "A"],
    "marlin" => [0, "", ""],
    "marling" => [0, "", ""],
    "marri" => [0, "es", "ES"],
    "marrowless" => [0, "", ""],
    "marsh" => [0, "es", "ES"],
    "marsupium" => [2, "a", "A"],
    "marum" => [2, "a", "A"],
    "marvelling" => [0, "", ""],
    "mash" => [0, "es", "ES"],
    "massless" => [0, "", ""],
    "masterless" => [0, "", ""],
    "mastitis" => [1, "des", "DES"],
    "mastless" => [0, "", ""],
    "mastoiditis" => [1, "des", "DES"],
    "match" => [0, "es", "ES"],
    "matchless" => [0, "", ""],
    "mateless" => [0, "", ""],
    "matey" => [0, "s", "S"],
    "matless" => [0, "", ""],
    "matrix" => [1, "ces", "CES"],
    "matterless" => [0, "", ""],
    "matzo" => [0, "th", "TH"],
    "maxilla" => [0, "e", "E"],
    "maxis" => [2, "es", "ES"],
    "maybush" => [0, "es", "ES"],
    "mayfish" => [0, "", ""],
    "mazaedium" => [2, "a", "A"],
    "mealless" => [0, "", ""],
    "meaningless" => [0, "", ""],
    "measureless" => [0, "", ""],
    "meatless" => [0, "", ""],
    "meatloaf" => [1, "ves", "VES"],
    "meconopsis" => [2, "es", "ES"],
    "medalling" => [0, "", ""],
    "mediastinum" => [2, "a", "A"],
    "medium" => [2, "a", "A"],
    "medley" => [0, "s", "S"],
    "megahertz" => [0, "", ""],
    "megasporangium" => [2, "a", "A"],
    "megasporogenesis" => [2, "es", "ES"],
    "meiosis" => [2, "es", "ES"],
    "melanogenesis" => [2, "es", "ES"],
    "melanosis" => [2, "es", "ES"],
    "mellay" => [0, "s", "S"],
    "melling" => [0, "", ""],
    "memberless" => [0, "", ""],
    "menhaden" => [0, "", ""],
    "meningitis" => [1, "des", "DES"],
    "meningococcus" => [2, "i", "I"],
    "meningoencephalitis" => [1, "des", "DES"],
    "meninx" => [1, "ges", "GES"],
    "meniscus" => [2, "i", "I"],
    "mensch" => [0, "es", "ES"],
    "menseless" => [0, "", ""],
    "mensh" => [0, "es", "ES"],
    "mericarp" => [0, "", ""],
    "merisis" => [2, "es", "ES"],
    "meritless" => [0, "", ""],
    "mesh" => [0, "es", "ES"],
    "mesogastrium" => [2, "a", "A"],
    "mesothelium" => [2, "a", "A"],
    "mesteso" => [0, "es", "ES"],
    "mestino" => [0, "es", "ES"],
    "metabasis" => [2, "es", "ES"],
    "metacarpus" => [2, "i", "I"],
    "metacercaria" => [0, "e", "E"],
    "metagenesis" => [2, "es", "ES"],
    "metalepsis" => [2, "es", "ES"],
    "metaling" => [0, "", ""],
    "metamorphosis" => [2, "es", "ES"],
    "metanalysis" => [2, "es", "ES"],
    "metaphrasis" => [2, "es", "ES"],
    "metasomatosis" => [2, "es", "ES"],
    "metastasis" => [2, "es", "ES"],
    "metatarsus" => [2, "i", "I"],
    "metathesis" => [2, "es", "ES"],
    "metempsychosis" => [2, "es", "ES"],
    "metis" => [0, "ses", "SES"],
    "mewling" => [0, "", ""],
    "microanalysis" => [2, "es", "ES"],
    "micrococcus" => [2, "i", "I"],
    "microelectrophoresis" => [2, "es", "ES"],
    "microfiche" => [0, "", ""],
    "microfungus" => [2, "i", "I"],
    "microinch" => [0, "es", "ES"],
    "micronucleus" => [2, "i", "I"],
    "microsporangium" => [2, "a", "A"],
    "microsporogenesis" => [2, "es", "ES"],
    "microswitch" => [0, "es", "ES"],
    "microvillus" => [2, "i", "I"],
    "midday" => [0, "s", "S"],
    "midlife" => [2, "ves", "VES"],
    "midwatch" => [0, "es", "ES"],
    "midway" => [0, "s", "S"],
    "midwife" => [2, "ves", "VES"],
    "military" => [0, "", ""],
    "milium" => [2, "a", "A"],
    "milkfish" => [0, "", ""],
    "milkless" => [0, "", ""],
    "milkshake" => [0, "", ""],
    "milling" => [0, "", ""],
    "millionaires" => [0, "ses", "SES"],
    "milsey" => [0, "s", "S"],
    "mimesis" => [2, "es", "ES"],
    "mindless" => [0, "", ""],
    "mingling" => [0, "", ""],
    "minis" => [2, "es", "ES"],
    "miniseries" => [0, "", ""],
    "ministerium" => [2, "a", "A"],
    "mink" => [0, "", ""],
    "minutia" => [0, "e", "E"],
    "miosis" => [2, "es", "ES"],
    "miracidium" => [2, "a", "A"],
    "mirthless" => [0, "", ""],
    "misanalysis" => [2, "es", "ES"],
    "mischannelling" => [0, "", ""],
    "miscounselling" => [0, "", ""],
    "misdiagnosis" => [2, "es", "ES"],
    "misdialling" => [0, "", ""],
    "misemphasis" => [2, "es", "ES"],
    "misenrolling" => [0, "", ""],
    "misfuelling" => [0, "", ""],
    "misgo" => [0, "es", "ES"],
    "mishmash" => [0, "es", "ES"],
    "mishmosh" => [0, "es", "ES"],
    "mislabelling" => [0, "", ""],
    "mismatch" => [0, "es", "ES"],
    "misplay" => [0, "s", "S"],
    "mistling" => [0, "", ""],
    "mistressless" => [0, "", ""],
    "mistrustless" => [0, "", ""],
    "mitochondrion" => [2, "a", "A"],
    "mitosis" => [2, "es", "ES"],
    "mizzling" => [0, "", ""],
    "mockado" => [0, "es", "ES"],
    "modeling" => [0, "", ""],
    "modelling" => [0, "", ""],
    "modius" => [2, "i", "I"],
    "modulo" => [1, "i", "I"],
    "modulus" => [2, "i", "I"],
    "modus" => [2, "i", "I"],
    "moiling" => [0, "", ""],
    "moistureless" => [0, "", ""],
    "mojo" => [0, "es", "ES"],
    "molas" => [0, "ses", "SES"],
    "molluscum" => [2, "a", "A"],
    "molossus" => [2, "i", "I"],
    "momento" => [0, "es", "ES"],
    "momentum" => [2, "a", "A"],
    "money" => [0, "s", "S"],
    "moneyless" => [0, "", ""],
    "mongo" => [0, "es", "ES"],
    "moniliasis" => [2, "es", "ES"],
    "monkey" => [0, "s", "S"],
    "monkfish" => [0, "", ""],
    "monocarp" => [0, "", ""],
    "monochasium" => [2, "a", "A"],
    "monocytosis" => [2, "es", "ES"],
    "monogenesis" => [2, "es", "ES"],
    "monokinis" => [2, "es", "ES"],
    "mononucleosis" => [2, "es", "ES"],
    "monseigneur" => [10, "esseigneurs", "ESSEIGNEURS"],
    "monsieur" => [7, "essieurs", "ESSIEURS"],
    "mooch" => [0, "es", "ES"],
    "mooley" => [0, "s", "S"],
    "mooncalf" => [1, "ves", "VES"],
    "moonfish" => [0, "", ""],
    "moonless" => [0, "", ""],
    "moorfowl" => [0, "", ""],
    "moose" => [0, "", ""],
    "moralling" => [0, "", ""],
    "moras" => [0, "ses", "SES"],
    "moray" => [0, "s", "S"],
    "morceau" => [0, "x", "X"],
    "morgay" => [0, "s", "S"],
    "morling" => [0, "", ""],
    "mornay" => [0, "s", "S"],
    "morphallaxis" => [2, "es", "ES"],
    "morphogenesis" => [2, "es", "ES"],
    "morphosis" => [2, "es", "ES"],
    "morseling" => [0, "", ""],
    "morselling" => [0, "", ""],
    "mortarless" => [0, "", ""],
    "mortling" => [0, "", ""],
    "mosasaurus" => [2, "i", "I"],
    "mosquito" => [0, "es", "ES"],
    "mosquitofish" => [0, "", ""],
    "motherless" => [0, "", ""],
    "motionless" => [0, "", ""],
    "motiveless" => [0, "", ""],
    "motley" => [0, "s", "S"],
    "motorless" => [0, "", ""],
    "motorway" => [0, "s", "S"],
    "motoscafo" => [1, "i", "I"],
    "mottling" => [0, "", ""],
    "motto" => [0, "es", "ES"],
    "mouse" => [4, "ice", "ICE"],
    "mousling" => [0, "", ""],
    "mouthless" => [0, "", ""],
    "mouthwash" => [0, "es", "ES"],
    "moveless" => [0, "", ""],
    "much" => [0, "es", "ES"],
    "mucoviscidosis" => [2, "es", "ES"],
    "mudfish" => [0, "", ""],
    "muffling" => [0, "", ""],
    "mulatto" => [0, "es", "ES"],
    "mulch" => [0, "es", "ES"],
    "muley" => [0, "s", "S"],
    "muling" => [0, "", ""],
    "mulley" => [0, "s", "S"],
    "multipara" => [0, "e", "E"],
    "multireligious" => [0, "", ""],
    "multiton" => [0, "", ""],
    "mungo" => [0, "es", "ES"],
    "murray" => [0, "s", "S"],
    "murrey" => [0, "s", "S"],
    "musca" => [0, "e", "E"],
    "mush" => [0, "es", "ES"],
    "muskellunge" => [0, "", ""],
    "muskox" => [0, "en", "EN"],
    "musquash" => [0, "es", "ES"],
    "mutagenesis" => [2, "es", "ES"],
    "mutch" => [0, "es", "ES"],
    "muttonfish" => [0, "", ""],
    "my" => [0, "s", "S"],
    "myasis" => [2, "es", "ES"],
    "mycelium" => [2, "a", "A"],
    "mycobacterium" => [2, "a", "A"],
    "mycodomatium" => [2, "a", "A"],
    "mycosis" => [2, "es", "ES"],
    "mydriasis" => [2, "es", "ES"],
    "myelitis" => [1, "des", "DES"],
    "myelofibrosis" => [2, "es", "ES"],
    "myiasis" => [2, "es", "ES"],
    "myosis" => [2, "es", "ES"],
    "mythopoesis" => [2, "es", "ES"],
    "myxobacterium" => [2, "a", "A"],
    "myxomatosis" => [2, "es", "ES"],
    "nabis" => [2, "es", "ES"],
    "nach" => [0, "es", "ES"],
    "naevus" => [2, "i", "I"],
    "nailbrush" => [0, "es", "ES"],
    "nailless" => [0, "", ""],
    "nameless" => [0, "", ""],
    "napless" => [0, "", ""],
    "narcissus" => [0, "", ""],
    "narcoanalysis" => [2, "es", "ES"],
    "narcosis" => [2, "es", "ES"],
    "narcosynthesis" => [2, "es", "ES"],
    "naris" => [2, "es", "ES"],
    "natch" => [0, "es", "ES"],
    "nationless" => [0, "", ""],
    "natriuresis" => [2, "es", "ES"],
    "nauplius" => [2, "i", "I"],
    "nautch" => [0, "es", "ES"],
    "nay" => [0, "s", "S"],
    "nazis" => [2, "es", "ES"],
    "neat" => [0, "", ""],
    "nebbich" => [0, "es", "ES"],
    "nebbish" => [0, "es", "ES"],
    "nebish" => [0, "es", "ES"],
    "nebula" => [0, "e", "E"],
    "neckless" => [0, "", ""],
    "necrobiosis" => [2, "es", "ES"],
    "necrosis" => [2, "es", "ES"],
    "nectocalyx" => [1, "ces", "CES"],
    "needlefish" => [0, "", ""],
    "needless" => [0, "", ""],
    "needling" => [0, "", ""],
    "neighborless" => [0, "", ""],
    "neighbourless" => [0, "", ""],
    "nemesis" => [2, "es", "ES"],
    "neocortex" => [2, "ices", "ICES"],
    "neogenesis" => [2, "es", "ES"],
    "nephritis" => [1, "des", "DES"],
    "nephrosis" => [2, "es", "ES"],
    "nerveless" => [0, "", ""],
    "nervines" => [0, "ses", "SES"],
    "nestling" => [0, "", ""],
    "netless" => [0, "", ""],
    "nettlefish" => [0, "", ""],
    "nettling" => [0, "", ""],
    "neuritis" => [1, "des", "DES"],
    "neurofibromatosis" => [2, "es", "ES"],
    "neurogenesis" => [2, "es", "ES"],
    "neurohypophysis" => [2, "es", "ES"],
    "neurosis" => [2, "es", "ES"],
    "neutrinoless" => [0, "", ""],
    "nevelling" => [0, "", ""],
    "nevus" => [2, "i", "I"],
    "newsboy" => [0, "s", "S"],
    "newsflash" => [0, "es", "ES"],
    "newsless" => [0, "", ""],
    "newsperson" => [4, "ople", "OPLE"],
    "nickelling" => [0, "", ""],
    "nickling" => [0, "", ""],
    "niggerling" => [0, "", ""],
    "nightfowl" => [0, "", ""],
    "nightless" => [0, "", ""],
    "nilgaus" => [2, "i", "I"],
    "nilghaus" => [2, "i", "I"],
    "nilling" => [0, "", ""],
    "nimbostratus" => [2, "i", "I"],
    "nimbus" => [2, "i", "I"],
    "nis" => [0, "ses", "SES"],
    "nitrobacterium" => [2, "a", "A"],
    "nobles" => [0, "ses", "SES"],
    "nodus" => [2, "i", "I"],
    "noesis" => [2, "es", "ES"],
    "noiseless" => [0, "", ""],
    "non" => [2, "a", "A"],
    "noncrisis" => [2, "es", "ES"],
    "nonelect" => [0, "", ""],
    "nonesuch" => [0, "es", "ES"],
    "nongay" => [0, "s", "S"],
    "nonhero" => [0, "es", "ES"],
    "nonlife" => [2, "ves", "VES"],
    "nonmilitary" => [0, "", ""],
    "nonplay" => [0, "s", "S"],
    "nonpolice" => [0, "", ""],
    "nonreligious" => [0, "", ""],
    "nonself" => [1, "ves", "VES"],
    "nonsuch" => [0, "es", "ES"],
    "noonday" => [0, "s", "S"],
    "normless" => [0, "", ""],
    "nosegay" => [0, "s", "S"],
    "noseless" => [0, "", ""],
    "nosey" => [0, "s", "S"],
    "nosh" => [0, "es", "ES"],
    "notandum" => [2, "a", "A"],
    "notch" => [0, "es", "ES"],
    "notchelling" => [0, "", ""],
    "noteless" => [0, "", ""],
    "notturno" => [1, "i", "I"],
    "noumenon" => [2, "a", "A"],
    "nounless" => [0, "", ""],
    "nousling" => [0, "", ""],
    "novum" => [2, "a", "A"],
    "noway" => [0, "s", "S"],
    "noy" => [0, "s", "S"],
    "nubecula" => [0, "e", "E"],
    "nucha" => [0, "e", "E"],
    "nucleolus" => [2, "i", "I"],
    "nucleosynthesis" => [2, "es", "ES"],
    "nucleus" => [2, "i", "I"],
    "numberless" => [0, "", ""],
    "numbfish" => [0, "", ""],
    "nurdling" => [0, "", ""],
    "nurling" => [0, "", ""],
    "nurseling" => [0, "", ""],
    "nursling" => [0, "", ""],
    "nuthatch" => [0, "es", "ES"],
    "nylghaus" => [2, "i", "I"],
    "nympha" => [0, "e", "E"],
    "oakling" => [0, "", ""],
    "oarfish" => [0, "", ""],
    "oarless" => [0, "", ""],
    "oasis" => [2, "es", "ES"],
    "obelus" => [2, "i", "I"],
    "obis" => [2, "es", "ES"],
    "objectless" => [0, "", ""],
    "obo" => [0, "es", "ES"],
    "obolus" => [2, "i", "I"],
    "ocellus" => [2, "i", "I"],
    "ochrea" => [0, "e", "E"],
    "ocrea" => [0, "e", "E"],
    "octonarius" => [2, "i", "I"],
    "oculus" => [2, "i", "I"],
    "odorless" => [0, "", ""],
    "odourless" => [0, "", ""],
    "odyssey" => [0, "s", "S"],
    "oesophagus" => [2, "i", "I"],
    "ofay" => [0, "s", "S"],
    "offenceless" => [0, "", ""],
    "offenseless" => [0, "", ""],
    "offish" => [0, "", ""],
    "offspring" => [0, "", ""],
    "ogres" => [0, "ses", "SES"],
    "oidium" => [2, "a", "A"],
    "oilfish" => [0, "", ""],
    "oiling" => [0, "", ""],
    "oilway" => [0, "s", "S"],
    "ois" => [2, "es", "ES"],
    "okay" => [0, "s", "S"],
    "oldwife" => [2, "ves", "VES"],
    "omasum" => [2, "a", "A"],
    "ommateum" => [2, "a", "A"],
    "ommatidium" => [2, "a", "A"],
    "omphaloskepsis" => [2, "es", "ES"],
    "omphalus" => [2, "i", "I"],
    "onchocerciasis" => [2, "es", "ES"],
    "oncogenesis" => [2, "es", "ES"],
    "onomatopoesis" => [2, "es", "ES"],
    "onomatopoiesis" => [2, "es", "ES"],
    "onrush" => [0, "es", "ES"],
    "ontogenesis" => [2, "es", "ES"],
    "onychium" => [2, "a", "A"],
    "onycholysis" => [2, "es", "ES"],
    "oogenesis" => [2, "es", "ES"],
    "ootheca" => [0, "e", "E"],
    "operatorless" => [0, "", ""],
    "opposeless" => [0, "", ""],
    "optimum" => [2, "a", "A"],
    "opus" => [2, "era", "ERA"],
    "opusculum" => [2, "a", "A"],
    "orach" => [0, "es", "ES"],
    "orbicular" => [0, "es", "ES"],
    "orbicularis" => [2, "es", "ES"],
    "orbless" => [0, "", ""],
    "orderless" => [0, "", ""],
    "orfray" => [0, "s", "S"],
    "organogenesis" => [2, "es", "ES"],
    "oribis" => [0, "", ""],
    "ornithosis" => [2, "es", "ES"],
    "orogenesis" => [2, "es", "ES"],
    "orphrey" => [0, "s", "S"],
    "orthoaxis" => [2, "es", "ES"],
    "orthogenesis" => [2, "es", "ES"],
    "orthopraxis" => [2, "es", "ES"],
    "orthosis" => [2, "es", "ES"],
    "orthotonesis" => [2, "es", "ES"],
    "osmeterium" => [2, "a", "A"],
    "osmosis" => [2, "es", "ES"],
    "osprey" => [0, "s", "S"],
    "osteal" => [0, "", ""],
    "osteitis" => [1, "des", "DES"],
    "ostensorium" => [2, "a", "A"],
    "osteoarthritis" => [1, "des", "DES"],
    "osteoclasis" => [2, "es", "ES"],
    "osteogenesis" => [2, "es", "ES"],
    "osteomyelitis" => [1, "des", "DES"],
    "osteoporosis" => [2, "es", "ES"],
    "osteosis" => [2, "es", "ES"],
    "ostium" => [2, "a", "A"],
    "ostosis" => [2, "es", "ES"],
    "ostracon" => [2, "a", "A"],
    "ostrakon" => [2, "a", "A"],
    "ostrich" => [0, "es", "ES"],
    "otitis" => [1, "des", "DES"],
    "otosclerosis" => [2, "es", "ES"],
    "ouch" => [0, "es", "ES"],
    "ourself" => [1, "ves", "VES"],
    "ous" => [2, "i", "I"],
    "outcavilling" => [0, "", ""],
    "outduelling" => [0, "", ""],
    "outgeneralling" => [0, "", ""],
    "outgo" => [0, "es", "ES"],
    "outlash" => [0, "es", "ES"],
    "outlay" => [0, "s", "S"],
    "outparish" => [0, "es", "ES"],
    "outreach" => [0, "es", "ES"],
    "outrivalling" => [0, "", ""],
    "outtravelling" => [0, "", ""],
    "outwash" => [0, "es", "ES"],
    "outwrestling" => [0, "", ""],
    "ovaritis" => [1, "des", "DES"],
    "overanalysis" => [2, "es", "ES"],
    "overcontrolling" => [0, "", ""],
    "overemphasis" => [2, "es", "ES"],
    "overflush" => [0, "es", "ES"],
    "overgo" => [0, "es", "ES"],
    "overhandling" => [0, "", ""],
    "overlay" => [0, "s", "S"],
    "overmuch" => [0, "es", "ES"],
    "overneat" => [0, "", ""],
    "overpedalling" => [0, "", ""],
    "overwash" => [0, "es", "ES"],
    "ovotestis" => [2, "es", "ES"],
    "ovum" => [2, "a", "A"],
    "owling" => [0, "", ""],
    "ownerless" => [0, "", ""],
    "ox" => [0, "en", "EN"],
    "oxygenless" => [0, "", ""],
    "oxymoron" => [2, "a", "A"],
    "oxyuriasis" => [2, "es", "ES"],
    "oysterfish" => [0, "", ""],
    "packway" => [0, "s", "S"],
    "paddlefish" => [0, "", ""],
    "padless" => [0, "", ""],
    "paduasoy" => [0, "s", "S"],
    "paedogenesis" => [2, "es", "ES"],
    "paedomorphosis" => [2, "es", "ES"],
    "pageboy" => [0, "s", "S"],
    "painch" => [0, "es", "ES"],
    "painless" => [0, "", ""],
    "paintbrush" => [0, "es", "ES"],
    "palama" => [0, "e", "E"],
    "palay" => [0, "s", "S"],
    "palea" => [0, "e", "E"],
    "palfrey" => [0, "s", "S"],
    "palingenesis" => [2, "es", "ES"],
    "palisado" => [0, "es", "ES"],
    "palla" => [0, "e", "E"],
    "palling" => [0, "", ""],
    "palpus" => [2, "i", "I"],
    "pancreatitis" => [1, "des", "DES"],
    "paneling" => [0, "", ""],
    "panelling" => [0, "", ""],
    "panfish" => [0, "", ""],
    "pangenesis" => [2, "es", "ES"],
    "pangless" => [0, "", ""],
    "panino" => [1, "i", "I"],
    "paolo" => [1, "i", "I"],
    "paparazzo" => [1, "i", "I"],
    "paperboy" => [0, "s", "S"],
    "paperknife" => [2, "ves", "VES"],
    "paperless" => [0, "", ""],
    "papilla" => [0, "e", "E"],
    "papish" => [0, "es", "ES"],
    "pappi" => [0, "es", "ES"],
    "papula" => [0, "e", "E"],
    "papyrus" => [2, "i", "I"],
    "parabasis" => [2, "es", "ES"],
    "parabema" => [0, "ta", "TA"],
    "parabiosis" => [2, "es", "ES"],
    "paracentesis" => [2, "es", "ES"],
    "paragenesis" => [2, "es", "ES"],
    "paraglossa" => [0, "e", "E"],
    "paraleipsis" => [2, "es", "ES"],
    "paralepsis" => [2, "es", "ES"],
    "paralipomenon" => [2, "a", "A"],
    "paralipsis" => [2, "es", "ES"],
    "parallelling" => [0, "", ""],
    "paralysis" => [2, "es", "ES"],
    "paramecium" => [2, "a", "A"],
    "paramoecium" => [2, "a", "A"],
    "paranthelion" => [2, "a", "A"],
    "paraparesis" => [2, "es", "ES"],
    "paraphrasis" => [2, "es", "ES"],
    "paraphysis" => [2, "es", "ES"],
    "parapodium" => [2, "a", "A"],
    "parapophysis" => [2, "es", "ES"],
    "parapraxis" => [2, "es", "ES"],
    "parascenium" => [2, "a", "A"],
    "parasitosis" => [2, "es", "ES"],
    "parasynthesis" => [2, "es", "ES"],
    "parasyntheton" => [2, "a", "A"],
    "parataxis" => [2, "es", "ES"],
    "parcelling" => [0, "", ""],
    "pardonless" => [0, "", ""],
    "parenthesis" => [2, "es", "ES"],
    "parentless" => [0, "", ""],
    "paresis" => [2, "es", "ES"],
    "parflesh" => [0, "es", "ES"],
    "parhelion" => [2, "a", "A"],
    "parish" => [0, "es", "ES"],
    "parkway" => [0, "s", "S"],
    "parlay" => [0, "s", "S"],
    "parley" => [0, "s", "S"],
    "parling" => [0, "", ""],
    "parritch" => [0, "es", "ES"],
    "parrotfish" => [0, "", ""],
    "parsley" => [0, "s", "S"],
    "parthenogenesis" => [2, "es", "ES"],
    "parti" => [0, "es", "ES"],
    "partnerless" => [0, "", ""],
    "passado" => [0, "es", "ES"],
    "passageway" => [0, "s", "S"],
    "passerby" => [2, "sby", "SBY"],
    "passionless" => [0, "", ""],
    "passkey" => [0, "s", "S"],
    "passless" => [0, "", ""],
    "pastless" => [0, "", ""],
    "pastureless" => [0, "", ""],
    "patagium" => [2, "a", "A"],
    "patch" => [0, "es", "ES"],
    "patera" => [0, "e", "E"],
    "paterfamilias" => [10, "resfamilias", "RESFAMILIAS"],
    "pathless" => [0, "", ""],
    "pathogenesis" => [2, "es", "ES"],
    "pathway" => [0, "s", "S"],
    "patois" => [0, "", ""],
    "patrico" => [0, "es", "ES"],
    "patrolling" => [0, "", ""],
    "patronless" => [0, "", ""],
    "patternless" => [0, "", ""],
    "paunch" => [0, "es", "ES"],
    "pauseless" => [0, "", ""],
    "pay" => [0, "s", "S"],
    "payday" => [0, "s", "S"],
    "peaceless" => [0, "", ""],
    "peach" => [0, "es", "ES"],
    "peakless" => [0, "", ""],
    "pealing" => [0, "", ""],
    "pearlash" => [0, "es", "ES"],
    "pearlfish" => [0, "", ""],
    "pearling" => [0, "", ""],
    "peavey" => [0, "s", "S"],
    "peccadillo" => [0, "es", "ES"],
    "pedalling" => [0, "", ""],
    "pedalo" => [0, "es", "ES"],
    "pedestalling" => [0, "", ""],
    "pedicellaria" => [0, "e", "E"],
    "pediculosis" => [2, "es", "ES"],
    "pedogenesis" => [2, "es", "ES"],
    "pedomorphosis" => [2, "es", "ES"],
    "pedrero" => [0, "es", "ES"],
    "peeling" => [0, "", ""],
    "peeoy" => [0, "s", "S"],
    "peerless" => [0, "", ""],
    "pegless" => [0, "", ""],
    "pel" => [0, "es", "ES"],
    "pelon" => [2, "a", "A"],
    "peloton" => [2, "a", "A"],
    "peltless" => [0, "", ""],
    "pencilling" => [0, "", ""],
    "penknife" => [2, "ves", "VES"],
    "penna" => [0, "e", "E"],
    "penniless" => [0, "", ""],
    "pensionless" => [0, "", ""],
    "pentimento" => [1, "i", "I"],
    "penuchis" => [2, "es", "ES"],
    "penumbra" => [0, "e", "E"],
    "peopleless" => [0, "", ""],
    "perch" => [0, "", ""],
    "pereion" => [2, "a", "A"],
    "pereon" => [2, "a", "A"],
    "perfay" => [0, "s", "S"],
    "perfumeless" => [0, "", ""],
    "pericarditis" => [1, "des", "DES"],
    "pericardium" => [2, "a", "A"],
    "pericarp" => [0, "", ""],
    "periegesis" => [2, "es", "ES"],
    "perihelion" => [2, "a", "A"],
    "perikaryon" => [2, "a", "A"],
    "periling" => [0, "", ""],
    "perilling" => [0, "", ""],
    "perineum" => [2, "a", "A"],
    "periosteum" => [2, "a", "A"],
    "periphrasis" => [2, "es", "ES"],
    "peris" => [2, "es", "ES"],
    "peristalsis" => [2, "es", "ES"],
    "perithecium" => [2, "a", "A"],
    "peritus" => [2, "i", "I"],
    "permalloy" => [0, "s", "S"],
    "perradius" => [2, "i", "I"],
    "person" => [4, "ople", "OPLE"],
    "persona" => [0, "e", "E"],
    "pessimaling" => [0, "", ""],
    "pessimum" => [2, "a", "A"],
    "pestling" => [0, "", ""],
    "petalless" => [0, "", ""],
    "petechia" => [0, "e", "E"],
    "petrogenesis" => [2, "es", "ES"],
    "petrolling" => [0, "", ""],
    "petrosa" => [0, "e", "E"],
    "petto" => [1, "i", "I"],
    "phaenomenon" => [2, "a", "A"],
    "phagocytosis" => [2, "es", "ES"],
    "phallus" => [2, "i", "I"],
    "phantasma" => [0, "ta", "TA"],
    "pharyngitis" => [1, "des", "DES"],
    "pharynx" => [1, "ges", "GES"],
    "phaseless" => [0, "", ""],
    "phasis" => [2, "es", "ES"],
    "pheresis" => [2, "es", "ES"],
    "phialling" => [0, "", ""],
    "philtrum" => [2, "a", "A"],
    "phimosis" => [2, "es", "ES"],
    "phiz" => [0, "zes", "ZES"],
    "phlebitis" => [1, "des", "DES"],
    "phlebosclerosis" => [2, "es", "ES"],
    "phlox" => [0, "", ""],
    "phlyctaena" => [0, "e", "E"],
    "phlyctena" => [0, "e", "E"],
    "phoney" => [0, "s", "S"],
    "phooey" => [0, "s", "S"],
    "phosphorolysis" => [2, "es", "ES"],
    "photoflash" => [0, "es", "ES"],
    "photokinesis" => [2, "es", "ES"],
    "photolysis" => [2, "es", "ES"],
    "photomorphogenesis" => [2, "es", "ES"],
    "photoplay" => [0, "s", "S"],
    "photosynthesis" => [2, "es", "ES"],
    "phototaxis" => [2, "es", "ES"],
    "phraseless" => [0, "", ""],
    "phthiriasis" => [2, "es", "ES"],
    "phthisis" => [2, "es", "ES"],
    "phyla" => [0, "e", "E"],
    "phylesis" => [2, "es", "ES"],
    "phyllodium" => [2, "a", "A"],
    "phyllotaxis" => [2, "es", "ES"],
    "phylogenesis" => [2, "es", "ES"],
    "phylon" => [2, "a", "A"],
    "phylum" => [2, "a", "A"],
    "physis" => [2, "es", "ES"],
    "phytogenesis" => [2, "es", "ES"],
    "phytosis" => [2, "es", "ES"],
    "pickerel" => [0, "", ""],
    "pickling" => [0, "", ""],
    "pieceless" => [0, "", ""],
    "piedish" => [0, "es", "ES"],
    "pierogi" => [0, "es", "ES"],
    "pifferaro" => [1, "i", "I"],
    "pigfish" => [0, "", ""],
    "pigling" => [0, "", ""],
    "pigsney" => [0, "s", "S"],
    "pigwash" => [0, "es", "ES"],
    "pikeperch" => [0, "", ""],
    "pikis" => [2, "es", "ES"],
    "pilch" => [0, "es", "ES"],
    "pileless" => [0, "", ""],
    "pileum" => [2, "a", "A"],
    "pileus" => [2, "i", "I"],
    "pilis" => [2, "es", "ES"],
    "pillarless" => [0, "", ""],
    "pilotfish" => [0, "", ""],
    "pilotless" => [0, "", ""],
    "pilum" => [2, "a", "A"],
    "pilus" => [2, "i", "I"],
    "pinch" => [0, "es", "ES"],
    "pineland" => [0, "", ""],
    "pinetum" => [2, "a", "A"],
    "pinfish" => [0, "", ""],
    "pingling" => [0, "", ""],
    "pingo" => [0, "es", "ES"],
    "pinkey" => [0, "s", "S"],
    "pinocytosis" => [2, "es", "ES"],
    "pintado" => [0, "es", "ES"],
    "pinyin" => [0, "", ""],
    "pioy" => [0, "s", "S"],
    "pipefish" => [0, "", ""],
    "pipeless" => [0, "", ""],
    "pipis" => [2, "es", "ES"],
    "pipless" => [0, "", ""],
    "piranha" => [0, "", ""],
    "pirogi" => [0, "es", "ES"],
    "piroplasma" => [0, "ta", "TA"],
    "pistolling" => [0, "", ""],
    "pitch" => [0, "es", "ES"],
    "pithecanthropus" => [2, "i", "I"],
    "pithless" => [0, "", ""],
    "pitman" => [0, "s", "S"],
    "pityriasis" => [2, "es", "ES"],
    "pizzaz" => [0, "zes", "ZES"],
    "pizzicato" => [1, "i", "I"],
    "placeless" => [0, "", ""],
    "plackless" => [0, "", ""],
    "plaintless" => [0, "", ""],
    "planless" => [0, "", ""],
    "plantless" => [0, "", ""],
    "plantling" => [0, "", ""],
    "planula" => [0, "e", "E"],
    "plash" => [0, "es", "ES"],
    "plasmapheresis" => [2, "es", "ES"],
    "plasmolysis" => [2, "es", "ES"],
    "platy" => [0, "s", "S"],
    "platyfish" => [0, "", ""],
    "play" => [0, "s", "S"],
    "playboy" => [0, "s", "S"],
    "playday" => [0, "s", "S"],
    "playless" => [0, "", ""],
    "pleasureless" => [0, "", ""],
    "pleatless" => [0, "", ""],
    "plectrum" => [2, "a", "A"],
    "plench" => [0, "es", "ES"],
    "plenipo" => [0, "es", "ES"],
    "plesh" => [0, "es", "ES"],
    "pleura" => [0, "e", "E"],
    "pleurapophysis" => [2, "es", "ES"],
    "pleuron" => [2, "a", "A"],
    "plica" => [0, "e", "E"],
    "plotless" => [0, "", ""],
    "ploughboy" => [0, "s", "S"],
    "plowboy" => [0, "s", "S"],
    "ploy" => [0, "s", "S"],
    "plugless" => [0, "", ""],
    "plumbless" => [0, "", ""],
    "plumeless" => [0, "", ""],
    "plumula" => [0, "e", "E"],
    "plush" => [0, "es", "ES"],
    "pneumatolysis" => [2, "es", "ES"],
    "pneumobacillus" => [2, "i", "I"],
    "pneumococcus" => [2, "i", "I"],
    "pneumoconiosis" => [2, "es", "ES"],
    "pneumonitis" => [1, "des", "DES"],
    "pocketknife" => [2, "ves", "VES"],
    "pocketless" => [0, "", ""],
    "podetium" => [2, "a", "A"],
    "podley" => [0, "s", "S"],
    "poetless" => [0, "", ""],
    "pogey" => [0, "s", "S"],
    "poi" => [0, "", ""],
    "pointless" => [0, "", ""],
    "pokey" => [0, "s", "S"],
    "poleless" => [0, "", ""],
    "police" => [0, "", ""],
    "poliomyelitis" => [1, "des", "DES"],
    "polis" => [2, "es", "ES"],
    "polish" => [0, "es", "ES"],
    "pollenosis" => [2, "es", "ES"],
    "pollex" => [2, "ices", "ICES"],
    "polling" => [0, "", ""],
    "pollinium" => [2, "a", "A"],
    "pollinosis" => [2, "es", "ES"],
    "pollyfish" => [0, "", ""],
    "poltfoot" => [3, "eet", "EET"],
    "polygenesis" => [2, "es", "ES"],
    "polyhedrosis" => [2, "es", "ES"],
    "polyneuritis" => [1, "des", "DES"],
    "polyparium" => [2, "a", "A"],
    "polyposis" => [2, "es", "ES"],
    "pomato" => [0, "es", "ES"],
    "pommelling" => [0, "", ""],
    "pompano" => [0, "", ""],
    "pontifex" => [2, "ices", "ICES"],
    "poo" => [1, "i", "I"],
    "pooch" => [0, "es", "ES"],
    "pooling" => [0, "", ""],
    "poorboy" => [0, "s", "S"],
    "popeless" => [0, "", ""],
    "popeling" => [0, "", ""],
    "popinjay" => [0, "s", "S"],
    "popliteus" => [2, "i", "I"],
    "porch" => [0, "es", "ES"],
    "porcino" => [1, "i", "I"],
    "porcupinefish" => [0, "", ""],
    "porgy" => [0, "", ""],
    "porkfish" => [0, "", ""],
    "porkling" => [0, "", ""],
    "porosis" => [2, "es", "ES"],
    "porpoise" => [0, "", ""],
    "portico" => [0, "es", "ES"],
    "portionless" => [0, "", ""],
    "portless" => [0, "", ""],
    "possessionless" => [0, "", ""],
    "postbourgeois" => [0, "", ""],
    "postboy" => [0, "s", "S"],
    "postcava" => [0, "e", "E"],
    "postcrisis" => [2, "es", "ES"],
    "postilling" => [0, "", ""],
    "potash" => [0, "es", "ES"],
    "potato" => [0, "es", "ES"],
    "potboy" => [0, "s", "S"],
    "potlach" => [0, "es", "ES"],
    "pouch" => [0, "es", "ES"],
    "powderless" => [0, "", ""],
    "powerless" => [0, "", ""],
    "praiseless" => [0, "", ""],
    "prankling" => [0, "", ""],
    "prattling" => [0, "", ""],
    "prayerless" => [0, "", ""],
    "precalculus" => [2, "i", "I"],
    "precancelling" => [0, "", ""],
    "precava" => [0, "e", "E"],
    "precis" => [0, "", ""],
    "prediabetes" => [0, "", ""],
    "prehuman" => [0, "s", "S"],
    "prelates" => [0, "ses", "SES"],
    "prelife" => [2, "ves", "VES"],
    "premaxilla" => [0, "e", "E"],
    "prepubes" => [0, "", ""],
    "prepubis" => [2, "es", "ES"],
    "prepupa" => [0, "e", "E"],
    "pressureless" => [0, "", ""],
    "pretensionless" => [0, "", ""],
    "prey" => [0, "s", "S"],
    "priceless" => [0, "", ""],
    "prickling" => [0, "", ""],
    "prideless" => [0, "", ""],
    "priestling" => [0, "", ""],
    "primipara" => [0, "e", "E"],
    "princeling" => [0, "", ""],
    "princes" => [0, "ses", "SES"],
    "principium" => [2, "a", "A"],
    "printless" => [0, "", ""],
    "procarp" => [0, "", ""],
    "proctodeum" => [2, "a", "A"],
    "procures" => [0, "ses", "SES"],
    "prodromus" => [2, "i", "I"],
    "profitless" => [0, "", ""],
    "proglottis" => [1, "des", "DES"],
    "prognosis" => [2, "es", "ES"],
    "prolegomenon" => [2, "a", "A"],
    "prolepsis" => [2, "es", "ES"],
    "promiseless" => [0, "", ""],
    "pronotum" => [2, "a", "A"],
    "pronucleus" => [2, "i", "I"],
    "pronunciamento" => [0, "es", "ES"],
    "proofless" => [0, "", ""],
    "propelling" => [0, "", ""],
    "propertyless" => [0, "", ""],
    "prophylaxis" => [2, "es", "ES"],
    "proportionless" => [0, "", ""],
    "propositus" => [2, "i", "I"],
    "proptosis" => [2, "es", "ES"],
    "propylaeum" => [2, "a", "A"],
    "prosciutto" => [1, "i", "I"],
    "proseucha" => [0, "e", "E"],
    "prosthesis" => [2, "es", "ES"],
    "protasis" => [2, "es", "ES"],
    "protectorless" => [0, "", ""],
    "proteolysis" => [2, "es", "ES"],
    "prothalamion" => [2, "a", "A"],
    "prothalamium" => [2, "a", "A"],
    "prothesis" => [2, "es", "ES"],
    "protocolling" => [0, "", ""],
    "protohuman" => [0, "s", "S"],
    "protozoon" => [2, "a", "A"],
    "prowling" => [0, "", ""],
    "prytaneum" => [2, "a", "A"],
    "psalterium" => [2, "a", "A"],
    "pseudaxis" => [2, "es", "ES"],
    "pseudepigraphon" => [2, "a", "A"],
    "pseudocarp" => [0, "", ""],
    "pseudocyesis" => [2, "es", "ES"],
    "pseudopodium" => [2, "a", "A"],
    "pseudotuberculosis" => [2, "es", "ES"],
    "psilosis" => [2, "es", "ES"],
    "psittacosis" => [2, "es", "ES"],
    "psoriasis" => [2, "es", "ES"],
    "psychoanalysis" => [2, "es", "ES"],
    "psychogenesis" => [2, "es", "ES"],
    "psychokinesis" => [2, "es", "ES"],
    "psychoneurosis" => [2, "es", "ES"],
    "psychosis" => [2, "es", "ES"],
    "psychosynthesis" => [2, "es", "ES"],
    "ptarmigan" => [0, "", ""],
    "pterion" => [2, "a", "A"],
    "pteryla" => [0, "e", "E"],
    "ptosis" => [2, "es", "ES"],
    "pubes" => [0, "", ""],
    "pubis" => [2, "es", "ES"],
    "pudendum" => [2, "a", "A"],
    "puerpera" => [0, "e", "E"],
    "pulis" => [2, "es", "ES"],
    "pulley" => [0, "s", "S"],
    "pulling" => [0, "", ""],
    "pulpless" => [0, "", ""],
    "pulseless" => [0, "", ""],
    "pulvillus" => [2, "i", "I"],
    "pulvinus" => [2, "i", "I"],
    "pummelling" => [0, "", ""],
    "pumpless" => [0, "", ""],
    "punch" => [0, "es", "ES"],
    "punchless" => [0, "", ""],
    "punctum" => [2, "a", "A"],
    "punctureless" => [0, "", ""],
    "pundonor" => [0, "es", "ES"],
    "pungling" => [0, "", ""],
    "punkey" => [0, "s", "S"],
    "pupa" => [0, "e", "E"],
    "puparium" => [2, "a", "A"],
    "pupfish" => [0, "", ""],
    "puris" => [2, "es", "ES"],
    "purling" => [0, "", ""],
    "purportless" => [0, "", ""],
    "purposeless" => [0, "", ""],
    "push" => [0, "es", "ES"],
    "pusley" => [0, "s", "S"],
    "pussley" => [0, "s", "S"],
    "putsch" => [0, "es", "ES"],
    "putto" => [1, "i", "I"],
    "puttyless" => [0, "", ""],
    "puy" => [0, "s", "S"],
    "pycnosis" => [2, "es", "ES"],
    "pyelonephritis" => [1, "des", "DES"],
    "pyknosis" => [2, "es", "ES"],
    "pylorus" => [2, "i", "I"],
    "pyogenesis" => [2, "es", "ES"],
    "pyosis" => [2, "es", "ES"],
    "pyrolysis" => [2, "es", "ES"],
    "pyrosis" => [2, "es", "ES"],
    "pyxidium" => [2, "a", "A"],
    "pyxis" => [2, "es", "ES"],
    "quackling" => [0, "", ""],
    "quadriennium" => [2, "a", "A"],
    "quadriga" => [0, "e", "E"],
    "quadrivium" => [2, "a", "A"],
    "quaich" => [0, "es", "ES"],
    "quail" => [0, "", ""],
    "quailing" => [0, "", ""],
    "quamash" => [0, "es", "ES"],
    "quantum" => [2, "a", "A"],
    "quarterstaff" => [2, "ves", "VES"],
    "quartodeciman" => [0, "s", "S"],
    "quay" => [0, "s", "S"],
    "queenfish" => [0, "", ""],
    "queenless" => [0, "", ""],
    "quenchless" => [0, "", ""],
    "questionless" => [0, "", ""],
    "quey" => [0, "s", "S"],
    "quid" => [0, "", ""],
    "quiz" => [0, "zes", "ZES"],
    "qursh" => [0, "es", "ES"],
    "qurush" => [0, "es", "ES"],
    "qwerty" => [0, "s", "S"],
    "rabbitbrush" => [0, "es", "ES"],
    "rabbitfish" => [0, "", ""],
    "rabies" => [0, "", ""],
    "raceway" => [0, "s", "S"],
    "rach" => [0, "es", "ES"],
    "rachitis" => [1, "des", "DES"],
    "radiationless" => [0, "", ""],
    "radioimmunoassay" => [0, "s", "S"],
    "radiolabelling" => [0, "", ""],
    "radiolysis" => [2, "es", "ES"],
    "radish" => [0, "es", "ES"],
    "radius" => [2, "i", "I"],
    "raffling" => [0, "", ""],
    "ragfish" => [0, "", ""],
    "raggling" => [0, "", ""],
    "ragis" => [2, "es", "ES"],
    "railing" => [0, "", ""],
    "railless" => [0, "", ""],
    "railway" => [0, "s", "S"],
    "raimentless" => [0, "", ""],
    "rainless" => [0, "", ""],
    "rakis" => [2, "es", "ES"],
    "rakus" => [2, "i", "I"],
    "ramentum" => [2, "a", "A"],
    "ramulus" => [2, "i", "I"],
    "ramus" => [2, "i", "I"],
    "ranch" => [0, "es", "ES"],
    "rangeland" => [0, "", ""],
    "rankless" => [0, "", ""],
    "rankling" => [0, "", ""],
    "ransomless" => [0, "", ""],
    "raphis" => [2, "es", "ES"],
    "rapinis" => [2, "es", "ES"],
    "rappelling" => [0, "", ""],
    "raptureless" => [0, "", ""],
    "rash" => [0, "es", "ES"],
    "ratch" => [0, "es", "ES"],
    "ratfish" => [0, "", ""],
    "raunch" => [0, "es", "ES"],
    "raveling" => [0, "", ""],
    "ravelling" => [0, "", ""],
    "ray" => [0, "s", "S"],
    "rayless" => [0, "", ""],
    "razorfish" => [0, "", ""],
    "reach" => [0, "es", "ES"],
    "reachless" => [0, "", ""],
    "realmless" => [0, "", ""],
    "reanalysis" => [2, "es", "ES"],
    "reapparelling" => [0, "", ""],
    "rearmouse" => [4, "ice", "ICE"],
    "reasonless" => [0, "", ""],
    "rebato" => [0, "es", "ES"],
    "rebelling" => [0, "", ""],
    "receptaculum" => [2, "a", "A"],
    "rechannelling" => [0, "", ""],
    "reckless" => [0, "", ""],
    "reckling" => [0, "", ""],
    "recoilless" => [0, "", ""],
    "recomfortless" => [0, "", ""],
    "recoupling" => [0, "", ""],
    "rectrix" => [1, "ces", "CES"],
    "rectus" => [2, "i", "I"],
    "recureless" => [0, "", ""],
    "redbay" => [0, "s", "S"],
    "reddendum" => [2, "a", "A"],
    "reddling" => [0, "", ""],
    "redeemless" => [0, "", ""],
    "redeless" => [0, "", ""],
    "redfish" => [0, "", ""],
    "redialing" => [0, "", ""],
    "redialling" => [0, "", ""],
    "redistilling" => [0, "", ""],
    "redux" => [1, "ces", "CES"],
    "reedling" => [0, "", ""],
    "reeling" => [0, "", ""],
    "reemphasis" => [2, "es", "ES"],
    "reexpelling" => [0, "", ""],
    "refelling" => [0, "", ""],
    "reflectionless" => [0, "", ""],
    "reformado" => [0, "es", "ES"],
    "refuelling" => [0, "", ""],
    "refugium" => [2, "a", "A"],
    "regardless" => [0, "", ""],
    "regma" => [0, "ta", "TA"],
    "regnum" => [2, "a", "A"],
    "rego" => [0, "es", "ES"],
    "regula" => [0, "e", "E"],
    "regulo" => [1, "i", "I"],
    "rehash" => [0, "es", "ES"],
    "reindeer" => [0, "", ""],
    "reinless" => [0, "", ""],
    "rejoneador" => [0, "es", "ES"],
    "relabelling" => [0, "", ""],
    "relationless" => [0, "", ""],
    "relay" => [0, "s", "S"],
    "relentless" => [0, "", ""],
    "reliefless" => [0, "", ""],
    "religionless" => [0, "", ""],
    "religious" => [0, "", ""],
    "relish" => [0, "es", "ES"],
    "rematch" => [0, "es", "ES"],
    "remodelling" => [0, "", ""],
    "remorseless" => [0, "", ""],
    "rendezvous" => [0, "", ""],
    "renegado" => [0, "es", "ES"],
    "renvoy" => [0, "s", "S"],
    "repanelling" => [0, "", ""],
    "repelling" => [0, "", ""],
    "replay" => [0, "s", "S"],
    "replum" => [2, "a", "A"],
    "reproach" => [0, "es", "ES"],
    "reproachless" => [0, "", ""],
    "reptilium" => [2, "a", "A"],
    "reputeless" => [0, "", ""],
    "research" => [0, "es", "ES"],
    "resh" => [0, "es", "ES"],
    "residuum" => [2, "a", "A"],
    "resistless" => [0, "", ""],
    "resourceless" => [0, "", ""],
    "respectless" => [0, "", ""],
    "responseless" => [0, "", ""],
    "responsum" => [2, "a", "A"],
    "restless" => [0, "", ""],
    "restyling" => [0, "", ""],
    "resultless" => [0, "", ""],
    "resurvey" => [0, "s", "S"],
    "resynthesis" => [2, "es", "ES"],
    "retackling" => [0, "", ""],
    "retch" => [0, "es", "ES"],
    "retchless" => [0, "", ""],
    "retinaculum" => [2, "a", "A"],
    "retinitis" => [1, "des", "DES"],
    "retotalling" => [0, "", ""],
    "retouch" => [0, "es", "ES"],
    "returnless" => [0, "", ""],
    "revelling" => [0, "", ""],
    "revengeless" => [0, "", ""],
    "revers" => [0, "", ""],
    "reverseless" => [0, "", ""],
    "reversis" => [2, "es", "ES"],
    "revictualling" => [0, "", ""],
    "rewardless" => [0, "", ""],
    "rewon" => [0, "", ""],
    "rhaphis" => [2, "es", "ES"],
    "rheotaxis" => [2, "es", "ES"],
    "rhexis" => [2, "es", "ES"],
    "rhinitis" => [1, "des", "DES"],
    "rhinopharyngitis" => [1, "des", "DES"],
    "rhizobium" => [2, "a", "A"],
    "rhizoma" => [0, "ta", "TA"],
    "rhomboideus" => [2, "i", "I"],
    "rhonchus" => [2, "i", "I"],
    "rhymeless" => [0, "", ""],
    "rhythmless" => [0, "", ""],
    "ribbonfish" => [0, "", ""],
    "ribless" => [0, "", ""],
    "rich" => [0, "es", "ES"],
    "rickey" => [0, "s", "S"],
    "riderless" => [0, "", ""],
    "ridgeling" => [0, "", ""],
    "ridgeway" => [0, "s", "S"],
    "ridley" => [0, "s", "S"],
    "rifacimento" => [1, "i", "I"],
    "rife" => [2, "ves", "VES"],
    "riffling" => [0, "", ""],
    "rifling" => [0, "", ""],
    "riftless" => [0, "", ""],
    "rigatoni" => [0, "", ""],
    "rightless" => [0, "", ""],
    "rigling" => [0, "", ""],
    "rima" => [0, "e", "E"],
    "rimeless" => [0, "", ""],
    "rimless" => [0, "", ""],
    "rindless" => [0, "", ""],
    "ringless" => [0, "", ""],
    "riskless" => [0, "", ""],
    "riteless" => [0, "", ""],
    "rivaless" => [0, "", ""],
    "rivaling" => [0, "", ""],
    "rivalless" => [0, "", ""],
    "rivalling" => [0, "", ""],
    "rivelling" => [0, "", ""],
    "riverless" => [0, "", ""],
    "riverway" => [0, "s", "S"],
    "roach" => [0, "es", "ES"],
    "roadless" => [0, "", ""],
    "roadway" => [0, "s", "S"],
    "rockaway" => [0, "s", "S"],
    "rockfish" => [0, "", ""],
    "rocklay" => [0, "s", "S"],
    "rockless" => [0, "", ""],
    "rockling" => [0, "", ""],
    "rodless" => [0, "", ""],
    "roe" => [0, "", ""],
    "rokelay" => [0, "s", "S"],
    "rollaway" => [0, "s", "S"],
    "rollway" => [0, "s", "S"],
    "rondeau" => [0, "x", "X"],
    "roofless" => [0, "", ""],
    "rootless" => [0, "", ""],
    "rootling" => [0, "", ""],
    "ropeway" => [0, "s", "S"],
    "rosebay" => [0, "s", "S"],
    "rosebush" => [0, "es", "ES"],
    "rosefish" => [0, "", ""],
    "roseless" => [0, "", ""],
    "rotch" => [0, "es", "ES"],
    "rotis" => [2, "es", "ES"],
    "roundelay" => [0, "s", "S"],
    "roundfish" => [0, "", ""],
    "routeway" => [0, "s", "S"],
    "rowelling" => [0, "", ""],
    "rubbish" => [0, "es", "ES"],
    "ruckling" => [0, "", ""],
    "rudderfish" => [0, "", ""],
    "rudderless" => [0, "", ""],
    "ruddling" => [0, "", ""],
    "ruffling" => [0, "", ""],
    "ruga" => [0, "e", "E"],
    "ruleless" => [0, "", ""],
    "rumpless" => [0, "", ""],
    "rumpling" => [0, "", ""],
    "runaway" => [0, "s", "S"],
    "runch" => [0, "es", "ES"],
    "rungless" => [0, "", ""],
    "runless" => [0, "", ""],
    "runway" => [0, "s", "S"],
    "rush" => [0, "es", "ES"],
    "rustless" => [0, "", ""],
    "rustling" => [0, "", ""],
    "ruthless" => [0, "", ""],
    "sable" => [0, "", ""],
    "sablefish" => [0, "", ""],
    "sabling" => [0, "", ""],
    "sacculus" => [2, "i", "I"],
    "sacellum" => [2, "a", "A"],
    "sackless" => [0, "", ""],
    "sacless" => [0, "", ""],
    "sacrum" => [2, "a", "A"],
    "saddleless" => [0, "", ""],
    "sadis" => [2, "es", "ES"],
    "saganash" => [0, "es", "ES"],
    "sagebrush" => [0, "es", "ES"],
    "sagenes" => [0, "ses", "SES"],
    "sagum" => [2, "a", "A"],
    "sailfish" => [0, "", ""],
    "sailing" => [0, "", ""],
    "sailless" => [0, "", ""],
    "sailorless" => [0, "", ""],
    "saintling" => [0, "", ""],
    "sakis" => [2, "es", "ES"],
    "salesperson" => [4, "ople", "OPLE"],
    "salix" => [1, "ces", "CES"],
    "salmon" => [0, "", ""],
    "salmonella" => [0, "e", "E"],
    "salmonellosis" => [2, "es", "ES"],
    "saltbush" => [0, "es", "ES"],
    "saltfish" => [0, "", ""],
    "saltines" => [0, "ses", "SES"],
    "saltless" => [0, "", ""],
    "samitis" => [2, "es", "ES"],
    "sampling" => [0, "", ""],
    "samurai" => [0, "", ""],
    "sanctionless" => [0, "", ""],
    "sandalling" => [0, "", ""],
    "sandboy" => [0, "s", "S"],
    "sanderling" => [0, "", ""],
    "sandfish" => [0, "", ""],
    "sandgrouse" => [0, "", ""],
    "sandless" => [0, "", ""],
    "sandling" => [0, "", ""],
    "sandwich" => [0, "es", "ES"],
    "saphena" => [0, "e", "E"],
    "sapidless" => [0, "", ""],
    "sapless" => [0, "", ""],
    "sapling" => [0, "", ""],
    "sarcocystis" => [2, "es", "ES"],
    "sarcoidosis" => [2, "es", "ES"],
    "sarcomatosis" => [2, "es", "ES"],
    "sarcophagus" => [2, "i", "I"],
    "sarmentum" => [2, "a", "A"],
    "sarpanch" => [0, "es", "ES"],
    "sartorius" => [2, "i", "I"],
    "sash" => [0, "es", "ES"],
    "sashay" => [0, "s", "S"],
    "sashless" => [0, "", ""],
    "satay" => [0, "s", "S"],
    "sateless" => [0, "", ""],
    "satis" => [2, "es", "ES"],
    "satyriasis" => [2, "es", "ES"],
    "saveloy" => [0, "s", "S"],
    "savorless" => [0, "", ""],
    "savourless" => [0, "", ""],
    "savoy" => [0, "s", "S"],
    "sawbones" => [0, "", ""],
    "sawfish" => [0, "", ""],
    "sawtooth" => [4, "eeth", "EETH"],
    "say" => [0, "s", "S"],
    "sbirro" => [1, "i", "I"],
    "scabbardless" => [0, "", ""],
    "scala" => [0, "e", "E"],
    "scaldfish" => [0, "", ""],
    "scaldino" => [1, "i", "I"],
    "scalefish" => [0, "", ""],
    "scaleless" => [0, "", ""],
    "scalenus" => [2, "i", "I"],
    "scaloppinis" => [2, "es", "ES"],
    "scalpless" => [0, "", ""],
    "scampi" => [0, "", ""],
    "scampo" => [1, "i", "I"],
    "scandalling" => [0, "", ""],
    "scantling" => [0, "", ""],
    "scapegallows" => [0, "", ""],
    "scapeless" => [0, "", ""],
    "scapula" => [0, "e", "E"],
    "scapus" => [2, "i", "I"],
    "scaramouch" => [0, "es", "ES"],
    "scarf" => [1, "ves", "VES"],
    "scarless" => [0, "", ""],
    "scatch" => [0, "es", "ES"],
    "scatheless" => [0, "", ""],
    "scatterling" => [0, "", ""],
    "scattermouch" => [0, "es", "ES"],
    "scentless" => [0, "", ""],
    "scepsis" => [2, "es", "ES"],
    "scepterless" => [0, "", ""],
    "schema" => [0, "ta", "TA"],
    "schistosomiasis" => [2, "es", "ES"],
    "schizocarp" => [0, "", ""],
    "schizogenesis" => [2, "es", "ES"],
    "schmo" => [0, "es", "ES"],
    "schnapps" => [0, "", ""],
    "schnaps" => [0, "", ""],
    "scholion" => [2, "a", "A"],
    "schoolboy" => [0, "s", "S"],
    "schoolchild" => [0, "ren", "REN"],
    "schoolday" => [0, "s", "S"],
    "schrod" => [0, "", ""],
    "sclerosis" => [2, "es", "ES"],
    "sclerotium" => [2, "a", "A"],
    "scolex" => [2, "ices", "ICES"],
    "scolion" => [2, "a", "A"],
    "scoliosis" => [2, "es", "ES"],
    "scorch" => [0, "es", "ES"],
    "scoreless" => [0, "", ""],
    "scoria" => [0, "e", "E"],
    "scorpionfish" => [0, "", ""],
    "scowling" => [0, "", ""],
    "scratch" => [0, "es", "ES"],
    "scratchless" => [0, "", ""],
    "scrawling" => [0, "", ""],
    "scray" => [0, "s", "S"],
    "screech" => [0, "es", "ES"],
    "screenplay" => [0, "s", "S"],
    "scrod" => [0, "", ""],
    "scrotum" => [2, "a", "A"],
    "scrumpling" => [0, "", ""],
    "scrunch" => [0, "es", "ES"],
    "scudo" => [1, "i", "I"],
    "scuffling" => [0, "", ""],
    "sculch" => [0, "es", "ES"],
    "sculling" => [0, "", ""],
    "scultch" => [0, "es", "ES"],
    "scumless" => [0, "", ""],
    "scutellum" => [2, "a", "A"],
    "scutum" => [2, "a", "A"],
    "scybalum" => [2, "a", "A"],
    "scyphus" => [2, "i", "I"],
    "seabeach" => [0, "es", "ES"],
    "seafolk" => [0, "", ""],
    "seafowl" => [0, "", ""],
    "sealing" => [0, "", ""],
    "seamless" => [0, "", ""],
    "search" => [0, "es", "ES"],
    "searchless" => [0, "", ""],
    "seasonless" => [0, "", ""],
    "seatless" => [0, "", ""],
    "seaway" => [0, "s", "S"],
    "secondo" => [1, "i", "I"],
    "sedilium" => [2, "a", "A"],
    "seedless" => [0, "", ""],
    "seedling" => [0, "", ""],
    "seeling" => [0, "", ""],
    "seemless" => [0, "", ""],
    "seiling" => [0, "", ""],
    "self" => [1, "ves", "VES"],
    "selfish" => [0, "", ""],
    "selfless" => [0, "", ""],
    "selling" => [0, "", ""],
    "semantron" => [2, "a", "A"],
    "semeion" => [2, "a", "A"],
    "semiosis" => [2, "es", "ES"],
    "semireligious" => [0, "", ""],
    "senarius" => [2, "i", "I"],
    "senseless" => [0, "", ""],
    "sensilla" => [0, "e", "E"],
    "sensillum" => [2, "a", "A"],
    "sensum" => [2, "a", "A"],
    "sententia" => [0, "e", "E"],
    "sentinelling" => [0, "", ""],
    "sepoy" => [0, "s", "S"],
    "sepsis" => [2, "es", "ES"],
    "septarium" => [2, "a", "A"],
    "septennium" => [2, "a", "A"],
    "septum" => [2, "a", "A"],
    "sequela" => [0, "e", "E"],
    "seraphim" => [0, "", ""],
    "serfish" => [0, "", ""],
    "sergeantfish" => [0, "", ""],
    "sericterium" => [2, "a", "A"],
    "serodiagnosis" => [2, "es", "ES"],
    "serpigo" => [0, "es", "ES"],
    "servantless" => [0, "", ""],
    "serviceless" => [0, "", ""],
    "serviceperson" => [4, "ople", "OPLE"],
    "sestertium" => [2, "a", "A"],
    "seta" => [0, "e", "E"],
    "settling" => [0, "", ""],
    "sexless" => [0, "", ""],
    "sextarius" => [2, "i", "I"],
    "sey" => [0, "s", "S"],
    "sgraffito" => [1, "i", "I"],
    "shackling" => [0, "", ""],
    "shacko" => [0, "es", "ES"],
    "shad" => [0, "", ""],
    "shadbush" => [0, "es", "ES"],
    "shadeless" => [0, "", ""],
    "shadowless" => [0, "", ""],
    "shaftless" => [0, "", ""],
    "shako" => [0, "es", "ES"],
    "shaman" => [0, "s", "S"],
    "shameless" => [0, "", ""],
    "shantey" => [0, "s", "S"],
    "shapeless" => [0, "", ""],
    "shash" => [0, "es", "ES"],
    "shaveling" => [0, "", ""],
    "shawling" => [0, "", ""],
    "shawlless" => [0, "", ""],
    "shay" => [0, "s", "S"],
    "sheaf" => [1, "ves", "VES"],
    "shealing" => [0, "", ""],
    "shearling" => [0, "", ""],
    "sheatfish" => [0, "es", "ES"],
    "sheathfish" => [0, "", ""],
    "sheathless" => [0, "", ""],
    "sheeney" => [0, "s", "S"],
    "sheep" => [0, "", ""],
    "shelf" => [1, "ves", "VES"],
    "shellfish" => [0, "", ""],
    "shelterless" => [0, "", ""],
    "shepherdless" => [0, "", ""],
    "shepherdling" => [0, "", ""],
    "shieldless" => [0, "", ""],
    "shieldling" => [0, "", ""],
    "shiftless" => [0, "", ""],
    "shigellosis" => [2, "es", "ES"],
    "shillingless" => [0, "", ""],
    "shineless" => [0, "", ""],
    "shinleaf" => [1, "ves", "VES"],
    "shipless" => [0, "", ""],
    "shipway" => [0, "s", "S"],
    "shirtless" => [0, "", ""],
    "shitless" => [0, "", ""],
    "shmo" => [0, "es", "ES"],
    "shoeless" => [0, "", ""],
    "shooling" => [0, "", ""],
    "shopboy" => [0, "s", "S"],
    "shoreless" => [0, "", ""],
    "shoveling" => [0, "", ""],
    "shovelling" => [0, "", ""],
    "showbiz" => [0, "zes", "ZES"],
    "showerless" => [0, "", ""],
    "shredless" => [0, "", ""],
    "shrewmouse" => [4, "ice", "ICE"],
    "shrimp" => [0, "", ""],
    "shrimpfish" => [0, "", ""],
    "shriveling" => [0, "", ""],
    "shrivelling" => [0, "", ""],
    "shroudless" => [0, "", ""],
    "shrubless" => [0, "", ""],
    "shufti" => [0, "es", "ES"],
    "shunless" => [0, "", ""],
    "shutterless" => [0, "", ""],
    "shuttleless" => [0, "", ""],
    "sibling" => [0, "", ""],
    "sickbay" => [0, "s", "S"],
    "sickling" => [0, "", ""],
    "sideling" => [0, "", ""],
    "siderosis" => [2, "es", "ES"],
    "sideway" => [0, "s", "S"],
    "sighless" => [0, "", ""],
    "sightless" => [0, "", ""],
    "sightlines" => [0, "ses", "SES"],
    "siglum" => [2, "a", "A"],
    "signalling" => [0, "", ""],
    "signiori" => [0, "es", "ES"],
    "signless" => [0, "", ""],
    "signore" => [1, "i", "I"],
    "signori" => [0, "es", "ES"],
    "silicosis" => [2, "es", "ES"],
    "siling" => [0, "", ""],
    "silverfish" => [0, "", ""],
    "silverling" => [0, "", ""],
    "simpling" => [0, "", ""],
    "sinamay" => [0, "s", "S"],
    "sinewless" => [0, "", ""],
    "singling" => [0, "", ""],
    "sinless" => [0, "", ""],
    "sireless" => [0, "", ""],
    "siriasis" => [2, "es", "ES"],
    "siris" => [2, "es", "ES"],
    "sisterless" => [0, "", ""],
    "situla" => [0, "e", "E"],
    "sixpence" => [0, "", ""],
    "sizzling" => [0, "", ""],
    "sketch" => [0, "es", "ES"],
    "skidway" => [0, "s", "S"],
    "skiffling" => [0, "", ""],
    "skilletfish" => [0, "", ""],
    "skinless" => [0, "", ""],
    "skirmish" => [0, "es", "ES"],
    "skirtless" => [0, "", ""],
    "skolion" => [2, "a", "A"],
    "skosh" => [0, "es", "ES"],
    "skyway" => [0, "s", "S"],
    "slakeless" => [0, "", ""],
    "slapdash" => [0, "es", "ES"],
    "slash" => [0, "es", "ES"],
    "slatch" => [0, "es", "ES"],
    "slaveless" => [0, "", ""],
    "slavey" => [0, "s", "S"],
    "sleech" => [0, "es", "ES"],
    "sleepless" => [0, "", ""],
    "sleevefish" => [0, "", ""],
    "sleeveless" => [0, "", ""],
    "sley" => [0, "s", "S"],
    "slideway" => [0, "s", "S"],
    "slipless" => [0, "", ""],
    "slipway" => [0, "s", "S"],
    "slitless" => [0, "", ""],
    "sloebush" => [0, "es", "ES"],
    "slosh" => [0, "es", "ES"],
    "slouch" => [0, "es", "ES"],
    "slowcoach" => [0, "es", "ES"],
    "sluiceway" => [0, "s", "S"],
    "slumberless" => [0, "", ""],
    "slush" => [0, "es", "ES"],
    "smartypants" => [0, "", ""],
    "smash" => [0, "es", "ES"],
    "smileless" => [0, "", ""],
    "smiley" => [0, "s", "S"],
    "smirch" => [0, "es", "ES"],
    "smogless" => [0, "", ""],
    "smokeless" => [0, "", ""],
    "smooch" => [0, "es", "ES"],
    "snailfish" => [0, "", ""],
    "snakefish" => [0, "", ""],
    "snapless" => [0, "", ""],
    "snatch" => [0, "es", "ES"],
    "sneesh" => [0, "es", "ES"],
    "sniffling" => [0, "", ""],
    "snipe" => [0, "", ""],
    "snipefish" => [0, "", ""],
    "snirtling" => [0, "", ""],
    "snitch" => [0, "es", "ES"],
    "snivelling" => [0, "", ""],
    "snobling" => [0, "", ""],
    "snorkelling" => [0, "", ""],
    "snowbrush" => [0, "es", "ES"],
    "snowbush" => [0, "es", "ES"],
    "snowless" => [0, "", ""],
    "snuffling" => [0, "", ""],
    "soakaway" => [0, "s", "S"],
    "soapfish" => [0, "", ""],
    "soapless" => [0, "", ""],
    "sockless" => [0, "", ""],
    "sodaless" => [0, "", ""],
    "sodless" => [0, "", ""],
    "softling" => [0, "", ""],
    "soilless" => [0, "", ""],
    "solarium" => [2, "a", "A"],
    "solatium" => [2, "a", "A"],
    "soldierfish" => [0, "", ""],
    "soldo" => [1, "i", "I"],
    "sole" => [0, "", ""],
    "soleless" => [0, "", ""],
    "solidus" => [2, "i", "I"],
    "soling" => [0, "", ""],
    "solus" => [2, "i", "I"],
    "solventless" => [0, "", ""],
    "solvolysis" => [2, "es", "ES"],
    "someway" => [0, "s", "S"],
    "songless" => [0, "", ""],
    "sonless" => [0, "", ""],
    "sonobuoy" => [0, "s", "S"],
    "sootless" => [0, "", ""],
    "sordino" => [1, "i", "I"],
    "soredium" => [2, "a", "A"],
    "sorosis" => [2, "es", "ES"],
    "sorrowless" => [0, "", ""],
    "sorus" => [2, "i", "I"],
    "soulless" => [0, "", ""],
    "soundless" => [0, "", ""],
    "soupless" => [0, "", ""],
    "soupling" => [0, "", ""],
    "sourceless" => [0, "", ""],
    "sowling" => [0, "", ""],
    "soy" => [0, "s", "S"],
    "spaceless" => [0, "", ""],
    "spadefish" => [0, "", ""],
    "spadix" => [1, "ces", "CES"],
    "spado" => [0, "es", "ES"],
    "spaewife" => [2, "ves", "VES"],
    "spancelling" => [0, "", ""],
    "spangling" => [0, "", ""],
    "spanielling" => [0, "", ""],
    "spanless" => [0, "", ""],
    "spareless" => [0, "", ""],
    "sparkless" => [0, "", ""],
    "sparkling" => [0, "", ""],
    "sparling" => [0, "", ""],
    "spatterdash" => [0, "es", "ES"],
    "spaz" => [0, "zes", "ZES"],
    "spearfish" => [0, "", ""],
    "speckless" => [0, "", ""],
    "speckling" => [0, "", ""],
    "spectrum" => [2, "a", "A"],
    "speech" => [0, "es", "ES"],
    "speechless" => [0, "", ""],
    "speedless" => [0, "", ""],
    "speedway" => [0, "s", "S"],
    "spermagonium" => [2, "a", "A"],
    "spermarium" => [2, "a", "A"],
    "spermatium" => [2, "a", "A"],
    "spermatogenesis" => [2, "es", "ES"],
    "spermatozoon" => [2, "a", "A"],
    "spermiogenesis" => [2, "es", "ES"],
    "spermogonium" => [2, "a", "A"],
    "spetch" => [0, "es", "ES"],
    "sphaeridium" => [2, "a", "A"],
    "sphereless" => [0, "", ""],
    "spicebush" => [0, "es", "ES"],
    "spiceless" => [0, "", ""],
    "spiculum" => [2, "a", "A"],
    "spikefish" => [0, "", ""],
    "spillway" => [0, "s", "S"],
    "spinach" => [0, "es", "ES"],
    "spineless" => [0, "", ""],
    "spinless" => [0, "", ""],
    "spinney" => [0, "s", "S"],
    "spinula" => [0, "e", "E"],
    "spiraculum" => [2, "a", "A"],
    "spiralling" => [0, "", ""],
    "spireless" => [0, "", ""],
    "spirillum" => [2, "a", "A"],
    "spiritless" => [0, "", ""],
    "spirochetosis" => [2, "es", "ES"],
    "splash" => [0, "es", "ES"],
    "splay" => [0, "s", "S"],
    "splayfoot" => [3, "eet", "EET"],
    "spleenless" => [0, "", ""],
    "splinterless" => [0, "", ""],
    "splotch" => [0, "es", "ES"],
    "spokesperson" => [4, "ople", "OPLE"],
    "spondylosis" => [2, "es", "ES"],
    "spooney" => [0, "s", "S"],
    "sporangiolum" => [2, "a", "A"],
    "sporangium" => [2, "a", "A"],
    "sporidium" => [2, "a", "A"],
    "sporogenesis" => [2, "es", "ES"],
    "sporotrichosis" => [2, "es", "ES"],
    "sporozoon" => [2, "a", "A"],
    "sportless" => [0, "", ""],
    "spotless" => [0, "", ""],
    "spouseless" => [0, "", ""],
    "spoutless" => [0, "", ""],
    "sprackling" => [0, "", ""],
    "sprangling" => [0, "", ""],
    "spray" => [0, "s", "S"],
    "springbok" => [0, "", ""],
    "springless" => [0, "", ""],
    "spumonis" => [2, "es", "ES"],
    "spurless" => [0, "", ""],
    "spurling" => [0, "", ""],
    "spurrey" => [0, "s", "S"],
    "sputum" => [2, "a", "A"],
    "squab" => [0, "", ""],
    "squama" => [0, "e", "E"],
    "squash" => [0, "es", "ES"],
    "squawfish" => [0, "", ""],
    "squelch" => [0, "es", "ES"],
    "squid" => [0, "", ""],
    "squinch" => [0, "es", "ES"],
    "squireling" => [0, "", ""],
    "squires" => [0, "ses", "SES"],
    "squirrelfish" => [0, "", ""],
    "squirrelling" => [0, "", ""],
    "squish" => [0, "es", "ES"],
    "squitch" => [0, "es", "ES"],
    "squiz" => [0, "zes", "ZES"],
    "stableboy" => [0, "s", "S"],
    "stabling" => [0, "", ""],
    "stagecoach" => [0, "es", "ES"],
    "staggerbush" => [0, "es", "ES"],
    "stairway" => [0, "s", "S"],
    "stalkless" => [0, "", ""],
    "stalko" => [0, "es", "ES"],
    "stampless" => [0, "", ""],
    "stanch" => [0, "es", "ES"],
    "stanchelling" => [0, "", ""],
    "stanchless" => [0, "", ""],
    "standardless" => [0, "", ""],
    "standby" => [0, "s", "S"],
    "standish" => [0, "es", "ES"],
    "staphylococcus" => [2, "i", "I"],
    "stapling" => [0, "", ""],
    "starch" => [0, "es", "ES"],
    "starchless" => [0, "", ""],
    "starfish" => [0, "", ""],
    "starless" => [0, "", ""],
    "starling" => [0, "", ""],
    "startling" => [0, "", ""],
    "starveling" => [0, "", ""],
    "stash" => [0, "es", "ES"],
    "stasimon" => [2, "a", "A"],
    "stasis" => [2, "es", "ES"],
    "stateless" => [0, "", ""],
    "statesperson" => [4, "ople", "OPLE"],
    "staunch" => [0, "es", "ES"],
    "stay" => [0, "s", "S"],
    "stayless" => [0, "", ""],
    "steatolysis" => [2, "es", "ES"],
    "steeplebush" => [0, "es", "ES"],
    "steerageway" => [0, "s", "S"],
    "steerling" => [0, "", ""],
    "stelis" => [2, "es", "ES"],
    "stemless" => [0, "", ""],
    "stench" => [0, "es", "ES"],
    "stenosis" => [2, "es", "ES"],
    "stepchild" => [0, "ren", "REN"],
    "stepney" => [0, "s", "S"],
    "stereopsis" => [2, "es", "ES"],
    "stereotaxis" => [2, "es", "ES"],
    "sternway" => [0, "s", "S"],
    "steroidogenesis" => [2, "es", "ES"],
    "sticcado" => [0, "es", "ES"],
    "stichidium" => [2, "a", "A"],
    "stickling" => [0, "", ""],
    "stimulus" => [2, "i", "I"],
    "stingfish" => [0, "", ""],
    "stingless" => [0, "", ""],
    "stingray" => [0, "s", "S"],
    "stintless" => [0, "", ""],
    "stirless" => [0, "", ""],
    "stitch" => [0, "es", "ES"],
    "stockfish" => [0, "", ""],
    "stockingless" => [0, "", ""],
    "stockless" => [0, "", ""],
    "stogey" => [0, "s", "S"],
    "stomachless" => [0, "", ""],
    "stonefish" => [0, "", ""],
    "stoneless" => [0, "", ""],
    "stopless" => [0, "", ""],
    "stopwatch" => [0, "es", "ES"],
    "storey" => [0, "s", "S"],
    "stormless" => [0, "", ""],
    "stornello" => [1, "i", "I"],
    "stowaway" => [0, "s", "S"],
    "stracchino" => [1, "i", "I"],
    "straightaway" => [0, "s", "S"],
    "straightway" => [0, "s", "S"],
    "strandwolf" => [0, "", ""],
    "strangling" => [0, "", ""],
    "strathspey" => [0, "s", "S"],
    "stratocumulus" => [2, "i", "I"],
    "stratovolcano" => [0, "es", "ES"],
    "stratum" => [2, "a", "A"],
    "stratus" => [2, "i", "I"],
    "strawless" => [0, "", ""],
    "stray" => [0, "s", "S"],
    "strayling" => [0, "", ""],
    "streamless" => [0, "", ""],
    "streamling" => [0, "", ""],
    "streetway" => [0, "s", "S"],
    "strengthless" => [0, "", ""],
    "streptobacillus" => [2, "i", "I"],
    "streptococcus" => [2, "i", "I"],
    "stressless" => [0, "", ""],
    "stretch" => [0, "es", "ES"],
    "stria" => [0, "e", "E"],
    "strickling" => [0, "", ""],
    "stridling" => [0, "", ""],
    "strifeless" => [0, "", ""],
    "striga" => [0, "e", "E"],
    "stringless" => [0, "", ""],
    "stripeless" => [0, "", ""],
    "stripling" => [0, "", ""],
    "strobila" => [0, "e", "E"],
    "strobilus" => [2, "i", "I"],
    "stroma" => [0, "ta", "TA"],
    "strongyloidiasis" => [2, "es", "ES"],
    "strongyloidosis" => [2, "es", "ES"],
    "strongylosis" => [2, "es", "ES"],
    "structureless" => [0, "", ""],
    "stucco" => [0, "es", "ES"],
    "studfish" => [0, "", ""],
    "stuffless" => [0, "", ""],
    "sturgeon" => [0, "", ""],
    "styleless" => [0, "", ""],
    "styling" => [0, "", ""],
    "subbranch" => [0, "es", "ES"],
    "subcortex" => [2, "ices", "ICES"],
    "subecho" => [0, "es", "ES"],
    "subgenus" => [2, "era", "ERA"],
    "subhuman" => [0, "s", "S"],
    "subimago" => [1, "ines", "INES"],
    "subjectless" => [0, "", ""],
    "submaxilla" => [0, "e", "E"],
    "subphylum" => [2, "a", "A"],
    "subsellium" => [2, "a", "A"],
    "subspecies" => [0, "", ""],
    "substanceless" => [0, "", ""],
    "substratum" => [2, "a", "A"],
    "subtotalling" => [0, "", ""],
    "subway" => [0, "s", "S"],
    "succes" => [0, "ses", "SES"],
    "successionless" => [0, "", ""],
    "successless" => [0, "", ""],
    "succotash" => [0, "es", "ES"],
    "succourless" => [0, "", ""],
    "succus" => [0, "ses", "SES"],
    "suckerfish" => [0, "", ""],
    "suckfish" => [0, "", ""],
    "suckless" => [0, "", ""],
    "suckling" => [0, "", ""],
    "sudsless" => [0, "", ""],
    "sugarbush" => [0, "es", "ES"],
    "sugarless" => [0, "", ""],
    "sugarloaf" => [1, "ves", "VES"],
    "sulcus" => [2, "i", "I"],
    "sumless" => [0, "", ""],
    "summitless" => [0, "", ""],
    "sunless" => [0, "", ""],
    "sunporch" => [0, "es", "ES"],
    "sunray" => [0, "s", "S"],
    "superalloy" => [0, "s", "S"],
    "superbitch" => [0, "es", "ES"],
    "supercargo" => [0, "es", "ES"],
    "superchurch" => [0, "es", "ES"],
    "superhelix" => [1, "ces", "CES"],
    "superhero" => [0, "es", "ES"],
    "superhighway" => [0, "s", "S"],
    "superhuman" => [0, "s", "S"],
    "superphenomenon" => [2, "a", "A"],
    "superstratum" => [2, "a", "A"],
    "superwife" => [2, "ves", "VES"],
    "suppedaneum" => [2, "a", "A"],
    "supperless" => [0, "", ""],
    "supportless" => [0, "", ""],
    "surfaceless" => [0, "", ""],
    "surffish" => [0, "", ""],
    "surfperch" => [0, "", ""],
    "surgeless" => [0, "", ""],
    "surgeonfish" => [0, "", ""],
    "surrey" => [0, "s", "S"],
    "surveilling" => [0, "", ""],
    "survey" => [0, "s", "S"],
    "suspectless" => [0, "", ""],
    "suspenseless" => [0, "", ""],
    "suspicionless" => [0, "", ""],
    "svaraj" => [0, "es", "ES"],
    "swaraj" => [0, "es", "ES"],
    "swash" => [0, "es", "ES"],
    "swatch" => [0, "es", "ES"],
    "sway" => [0, "s", "S"],
    "sweeney" => [0, "s", "S"],
    "sweetfish" => [0, "", ""],
    "sweetiewife" => [2, "ves", "VES"],
    "swellfish" => [0, "", ""],
    "swerveless" => [0, "", ""],
    "swine" => [0, "", ""],
    "swingby" => [0, "s", "S"],
    "swingling" => [0, "", ""],
    "swinney" => [0, "s", "S"],
    "swish" => [0, "es", "ES"],
    "switch" => [0, "es", "ES"],
    "swiveling" => [0, "", ""],
    "swivelling" => [0, "", ""],
    "swiz" => [0, "zes", "ZES"],
    "swizzling" => [0, "", ""],
    "swoosh" => [0, "es", "ES"],
    "swordfish" => [0, "", ""],
    "swordless" => [0, "", ""],
    "swordplay" => [0, "s", "S"],
    "sybo" => [0, "es", "ES"],
    "sycosis" => [2, "es", "ES"],
    "syllepsis" => [2, "es", "ES"],
    "symbiosis" => [2, "es", "ES"],
    "symbolling" => [0, "", ""],
    "symphysis" => [2, "es", "ES"],
    "sympodium" => [2, "a", "A"],
    "symptomless" => [0, "", ""],
    "synaeresis" => [2, "es", "ES"],
    "synaesthesis" => [2, "es", "ES"],
    "synapsis" => [2, "es", "ES"],
    "synarthrosis" => [2, "es", "ES"],
    "synaxis" => [2, "es", "ES"],
    "syncarp" => [0, "", ""],
    "synchondrosis" => [2, "es", "ES"],
    "synchoresis" => [2, "es", "ES"],
    "synchroflash" => [0, "es", "ES"],
    "synchromesh" => [0, "es", "ES"],
    "syndesis" => [2, "es", "ES"],
    "syndesmosis" => [2, "es", "ES"],
    "synechia" => [0, "e", "E"],
    "synedrion" => [2, "a", "A"],
    "synedrium" => [2, "a", "A"],
    "syneresis" => [2, "es", "ES"],
    "synesis" => [2, "es", "ES"],
    "syngenesis" => [2, "es", "ES"],
    "synizesis" => [2, "es", "ES"],
    "synkinesis" => [2, "es", "ES"],
    "synoeciosis" => [2, "es", "ES"],
    "synopsis" => [2, "es", "ES"],
    "synostosis" => [2, "es", "ES"],
    "synovium" => [2, "a", "A"],
    "syntenosis" => [2, "es", "ES"],
    "synthesis" => [2, "es", "ES"],
    "synura" => [0, "e", "E"],
    "syrtis" => [2, "es", "ES"],
    "syssarcosis" => [2, "es", "ES"],
    "systemless" => [0, "", ""],
    "tabis" => [2, "es", "ES"],
    "tableau" => [0, "x", "X"],
    "tabling" => [0, "", ""],
    "tabooley" => [0, "s", "S"],
    "tabula" => [0, "e", "E"],
    "tabus" => [2, "i", "I"],
    "tach" => [0, "es", "ES"],
    "tackless" => [0, "", ""],
    "tackling" => [0, "", ""],
    "tactless" => [0, "", ""],
    "taeniasis" => [2, "es", "ES"],
    "tagma" => [0, "ta", "TA"],
    "taigling" => [0, "", ""],
    "tailing" => [0, "", ""],
    "tailless" => [0, "", ""],
    "taintless" => [0, "", ""],
    "taisch" => [0, "es", "ES"],
    "taish" => [0, "es", "ES"],
    "taj" => [0, "es", "ES"],
    "takeaway" => [0, "s", "S"],
    "talentless" => [0, "", ""],
    "talisman" => [0, "s", "S"],
    "tallboy" => [0, "s", "S"],
    "talus" => [2, "i", "I"],
    "tameless" => [0, "", ""],
    "tangling" => [0, "", ""],
    "tankless" => [0, "", ""],
    "tanling" => [0, "", ""],
    "tanto" => [1, "i", "I"],
    "tapeless" => [0, "", ""],
    "tapetum" => [2, "a", "A"],
    "taplash" => [0, "es", "ES"],
    "tarboosh" => [0, "es", "ES"],
    "tarboush" => [0, "es", "ES"],
    "tarboy" => [0, "s", "S"],
    "tarbrush" => [0, "es", "ES"],
    "tarbush" => [0, "es", "ES"],
    "tariffless" => [0, "", ""],
    "tarnish" => [0, "es", "ES"],
    "tarpon" => [0, "", ""],
    "tarsometatarsus" => [2, "i", "I"],
    "tarsus" => [2, "i", "I"],
    "tas" => [0, "ses", "SES"],
    "taskless" => [0, "", ""],
    "tasseling" => [0, "", ""],
    "tasteless" => [0, "", ""],
    "tatami" => [0, "", ""],
    "tatouay" => [0, "s", "S"],
    "tattling" => [0, "", ""],
    "taus" => [2, "i", "I"],
    "tawney" => [0, "s", "S"],
    "taxis" => [2, "es", "ES"],
    "taxiway" => [0, "s", "S"],
    "taxless" => [0, "", ""],
    "taxus" => [2, "i", "I"],
    "teach" => [0, "es", "ES"],
    "teacherless" => [0, "", ""],
    "teachless" => [0, "", ""],
    "teal" => [0, "", ""],
    "teapoy" => [0, "s", "S"],
    "tearaway" => [0, "s", "S"],
    "tearless" => [0, "", ""],
    "teaseling" => [0, "", ""],
    "teaselling" => [0, "", ""],
    "teazeling" => [0, "", ""],
    "teazelling" => [0, "", ""],
    "tectrix" => [1, "ces", "CES"],
    "teemless" => [0, "", ""],
    "teetotalling" => [0, "", ""],
    "tegmentum" => [2, "a", "A"],
    "tegula" => [0, "e", "E"],
    "tela" => [0, "e", "E"],
    "telangiectasis" => [2, "es", "ES"],
    "telekinesis" => [2, "es", "ES"],
    "teleplay" => [0, "s", "S"],
    "telesis" => [2, "es", "ES"],
    "telium" => [2, "a", "A"],
    "telling" => [0, "", ""],
    "telotaxis" => [2, "es", "ES"],
    "telpherway" => [0, "s", "S"],
    "tenantless" => [0, "", ""],
    "tench" => [0, "es", "ES"],
    "tenderling" => [0, "", ""],
    "teniasis" => [2, "es", "ES"],
    "tenseless" => [0, "", ""],
    "tensionless" => [0, "", ""],
    "tentaculum" => [2, "a", "A"],
    "tentless" => [0, "", ""],
    "tenuis" => [2, "es", "ES"],
    "tepoy" => [0, "s", "S"],
    "teratogenesis" => [2, "es", "ES"],
    "tergum" => [2, "a", "A"],
    "terminus" => [2, "i", "I"],
    "termless" => [0, "", ""],
    "terpeneless" => [0, "", ""],
    "terrorless" => [0, "", ""],
    "tessella" => [0, "e", "E"],
    "tessera" => [0, "e", "E"],
    "testatrix" => [1, "ces", "CES"],
    "testis" => [2, "es", "ES"],
    "tetrasporangium" => [2, "a", "A"],
    "textless" => [0, "", ""],
    "textureless" => [0, "", ""],
    "thalamus" => [2, "i", "I"],
    "thanatosis" => [2, "es", "ES"],
    "thankless" => [0, "", ""],
    "thatch" => [0, "es", "ES"],
    "thatchless" => [0, "", ""],
    "thawless" => [0, "", ""],
    "theca" => [0, "e", "E"],
    "thema" => [0, "ta", "TA"],
    "themeless" => [0, "", ""],
    "theologoumenon" => [2, "a", "A"],
    "therapeusis" => [2, "es", "ES"],
    "thermogenesis" => [2, "es", "ES"],
    "thermolysis" => [2, "es", "ES"],
    "thermotaxis" => [2, "es", "ES"],
    "thesis" => [2, "es", "ES"],
    "thewless" => [0, "", ""],
    "thief" => [1, "ves", "VES"],
    "thigmotaxis" => [2, "es", "ES"],
    "thirling" => [0, "", ""],
    "thirstless" => [0, "", ""],
    "tholing" => [0, "", ""],
    "tholus" => [2, "i", "I"],
    "thornbush" => [0, "es", "ES"],
    "thornless" => [0, "", ""],
    "thoughtless" => [0, "", ""],
    "thoughtway" => [0, "s", "S"],
    "thrash" => [0, "es", "ES"],
    "threadfish" => [0, "", ""],
    "threadless" => [0, "", ""],
    "threepence" => [0, "", ""],
    "thresh" => [0, "es", "ES"],
    "thriftless" => [0, "", ""],
    "thriveless" => [0, "", ""],
    "thro" => [0, "es", "ES"],
    "throatlatch" => [0, "es", "ES"],
    "throbless" => [0, "", ""],
    "thrombolysis" => [2, "es", "ES"],
    "thrombophlebitis" => [1, "des", "DES"],
    "thrombosis" => [2, "es", "ES"],
    "thrombus" => [2, "i", "I"],
    "throneless" => [0, "", ""],
    "throughway" => [0, "s", "S"],
    "throwaway" => [0, "s", "S"],
    "thrush" => [0, "es", "ES"],
    "thruway" => [0, "s", "S"],
    "thumbless" => [0, "", ""],
    "thunderflash" => [0, "es", "ES"],
    "thunderless" => [0, "", ""],
    "thyrotoxicosis" => [2, "es", "ES"],
    "thyrsus" => [2, "i", "I"],
    "tibia" => [0, "e", "E"],
    "tich" => [0, "es", "ES"],
    "ticketless" => [0, "", ""],
    "tickling" => [0, "", ""],
    "tideland" => [0, "", ""],
    "tideless" => [0, "", ""],
    "tideway" => [0, "s", "S"],
    "tieless" => [0, "", ""],
    "tifoso" => [1, "i", "I"],
    "tigerfish" => [0, "", ""],
    "tikis" => [2, "es", "ES"],
    "tilefish" => [0, "", ""],
    "tillerless" => [0, "", ""],
    "tilling" => [0, "", ""],
    "timeless" => [0, "", ""],
    "timelines" => [0, "ses", "SES"],
    "timenoguy" => [0, "s", "S"],
    "timpani" => [0, "", ""],
    "timpano" => [1, "i", "I"],
    "tingling" => [0, "", ""],
    "tinkling" => [0, "", ""],
    "tinselling" => [0, "", ""],
    "tintinnabulum" => [2, "a", "A"],
    "tintless" => [0, "", ""],
    "tipless" => [0, "", ""],
    "tireless" => [0, "", ""],
    "tireling" => [0, "", ""],
    "tis" => [2, "es", "ES"],
    "titch" => [0, "es", "ES"],
    "titleless" => [0, "", ""],
    "titling" => [0, "", ""],
    "titmouse" => [4, "ice", "ICE"],
    "tmesis" => [2, "es", "ES"],
    "toadfish" => [0, "", ""],
    "toadless" => [0, "", ""],
    "tocherless" => [0, "", ""],
    "today" => [0, "s", "S"],
    "toeless" => [0, "", ""],
    "toilless" => [0, "", ""],
    "tolldish" => [0, "es", "ES"],
    "tollway" => [0, "s", "S"],
    "tolsey" => [0, "s", "S"],
    "tomalley" => [0, "s", "S"],
    "toman" => [0, "s", "S"],
    "tomatillo" => [0, "es", "ES"],
    "tomato" => [0, "es", "ES"],
    "tombless" => [0, "", ""],
    "tomboy" => [0, "s", "S"],
    "tomentum" => [2, "a", "A"],
    "tommyto" => [0, "es", "ES"],
    "toneless" => [0, "", ""],
    "tonguefish" => [0, "", ""],
    "tongueless" => [0, "", ""],
    "tooling" => [0, "", ""],
    "toolless" => [0, "", ""],
    "tooth" => [4, "eeth", "EETH"],
    "toothbrush" => [0, "es", "ES"],
    "toothless" => [0, "", ""],
    "toothwash" => [0, "es", "ES"],
    "tootling" => [0, "", ""],
    "tophus" => [2, "i", "I"],
    "topis" => [2, "es", "ES"],
    "topless" => [0, "", ""],
    "topoi" => [0, "", ""],
    "torch" => [0, "es", "ES"],
    "tori" => [0, "es", "ES"],
    "toriis" => [2, "es", "ES"],
    "tornado" => [0, "es", "ES"],
    "torpedo" => [0, "es", "ES"],
    "torus" => [2, "i", "I"],
    "tosh" => [0, "es", "ES"],
    "totalling" => [0, "", ""],
    "touch" => [0, "es", "ES"],
    "touchless" => [0, "", ""],
    "tourney" => [0, "s", "S"],
    "tovarich" => [0, "es", "ES"],
    "tovarisch" => [0, "es", "ES"],
    "tovarish" => [0, "es", "ES"],
    "towaway" => [0, "s", "S"],
    "towelling" => [0, "", ""],
    "towerless" => [0, "", ""],
    "townfolk" => [0, "", ""],
    "townless" => [0, "", ""],
    "townling" => [0, "", ""],
    "townsfolk" => [0, "", ""],
    "toxicosis" => [2, "es", "ES"],
    "toxoplasmosis" => [2, "es", "ES"],
    "toy" => [0, "s", "S"],
    "toyless" => [0, "", ""],
    "traceless" => [0, "", ""],
    "trachea" => [0, "e", "E"],
    "trackless" => [0, "", ""],
    "trackway" => [0, "s", "S"],
    "tractrix" => [1, "ces", "CES"],
    "trad" => [0, "es", "ES"],
    "tradeless" => [0, "", ""],
    "tradesperson" => [4, "ople", "OPLE"],
    "traditionless" => [0, "", ""],
    "trafficless" => [0, "", ""],
    "tragus" => [2, "i", "I"],
    "trailless" => [0, "", ""],
    "trainless" => [0, "", ""],
    "trainway" => [0, "s", "S"],
    "tramelling" => [0, "", ""],
    "tramless" => [0, "", ""],
    "trammelling" => [0, "", ""],
    "trampling" => [0, "", ""],
    "tramway" => [0, "s", "S"],
    "trash" => [0, "es", "ES"],
    "traveling" => [0, "", ""],
    "travelling" => [0, "", ""],
    "trawley" => [0, "s", "S"],
    "tray" => [0, "s", "S"],
    "treadless" => [0, "", ""],
    "treadling" => [0, "", ""],
    "treeless" => [0, "", ""],
    "tremorless" => [0, "", ""],
    "trench" => [0, "es", "ES"],
    "treponematosis" => [2, "es", "ES"],
    "trey" => [0, "s", "S"],
    "trialling" => [0, "", ""],
    "tribeless" => [0, "", ""],
    "triceps" => [0, "", ""],
    "triceratops" => [0, "", ""],
    "trichiasis" => [2, "es", "ES"],
    "trichina" => [0, "e", "E"],
    "trichinosis" => [2, "es", "ES"],
    "trichomoniasis" => [2, "es", "ES"],
    "trichosis" => [2, "es", "ES"],
    "trichuriasis" => [2, "es", "ES"],
    "trickless" => [0, "", ""],
    "trickling" => [0, "", ""],
    "triforium" => [2, "a", "A"],
    "triggerfish" => [0, "", ""],
    "trillo" => [0, "es", "ES"],
    "tripewife" => [2, "ves", "VES"],
    "tripling" => [0, "", ""],
    "tripsis" => [2, "es", "ES"],
    "triquetrum" => [2, "a", "A"],
    "trivia" => [0, "", ""],
    "trivium" => [2, "a", "A"],
    "trolley" => [0, "s", "S"],
    "trombiculiasis" => [2, "es", "ES"],
    "trombidiasis" => [2, "es", "ES"],
    "troparion" => [2, "a", "A"],
    "trophallaxis" => [2, "es", "ES"],
    "trophi" => [0, "es", "ES"],
    "tropotaxis" => [2, "es", "ES"],
    "trothless" => [0, "", ""],
    "trousseau" => [0, "x", "X"],
    "trout" => [0, "", ""],
    "troutless" => [0, "", ""],
    "troutling" => [0, "", ""],
    "troutperch" => [0, "", ""],
    "trowelling" => [0, "", ""],
    "truceless" => [0, "", ""],
    "truckling" => [0, "", ""],
    "trumeau" => [0, "x", "X"],
    "trumpetfish" => [0, "", ""],
    "trunkfish" => [0, "", ""],
    "trustless" => [0, "", ""],
    "truthless" => [0, "", ""],
    "tryma" => [0, "ta", "TA"],
    "trypanosomiasis" => [2, "es", "ES"],
    "tsadis" => [2, "es", "ES"],
    "tsarevich" => [0, "es", "ES"],
    "tsarevitch" => [0, "es", "ES"],
    "tsoris" => [2, "es", "ES"],
    "tuba" => [0, "e", "E"],
    "tubeless" => [0, "", ""],
    "tuberculosis" => [2, "es", "ES"],
    "tubfish" => [0, "", ""],
    "tugless" => [0, "", ""],
    "tumorigenesis" => [2, "es", "ES"],
    "tuna" => [0, "", ""],
    "tundish" => [0, "es", "ES"],
    "tuneless" => [0, "", ""],
    "tunica" => [0, "e", "E"],
    "tunnelling" => [0, "", ""],
    "turfless" => [0, "", ""],
    "turkey" => [0, "s", "S"],
    "turnkey" => [0, "s", "S"],
    "tush" => [0, "es", "ES"],
    "tuskless" => [0, "", ""],
    "twangling" => [0, "", ""],
    "twankay" => [0, "s", "S"],
    "tway" => [0, "s", "S"],
    "tweedling" => [0, "", ""],
    "tweeling" => [0, "", ""],
    "twigless" => [0, "", ""],
    "twinkling" => [0, "", ""],
    "twinleaf" => [1, "ves", "VES"],
    "twinling" => [0, "", ""],
    "twitch" => [0, "es", "ES"],
    "twopence" => [0, "", ""],
    "tylosis" => [2, "es", "ES"],
    "tympani" => [0, "", ""],
    "tympano" => [1, "i", "I"],
    "tzarevitch" => [0, "es", "ES"],
    "tzitzis" => [2, "es", "ES"],
    "udderless" => [0, "", ""],
    "uey" => [0, "s", "S"],
    "ulna" => [0, "e", "E"],
    "umbilicus" => [2, "i", "I"],
    "unaus" => [2, "i", "I"],
    "unbirthday" => [0, "s", "S"],
    "uncharnelling" => [0, "", ""],
    "uncia" => [0, "e", "E"],
    "uncinariasis" => [2, "es", "ES"],
    "uncinus" => [2, "i", "I"],
    "uncleless" => [0, "", ""],
    "uncus" => [2, "i", "I"],
    "undead" => [0, "", ""],
    "underbrush" => [0, "es", "ES"],
    "underclay" => [0, "s", "S"],
    "underdo" => [0, "es", "ES"],
    "underemphasis" => [2, "es", "ES"],
    "underlay" => [0, "s", "S"],
    "underling" => [0, "", ""],
    "undersealing" => [0, "", ""],
    "understratum" => [2, "a", "A"],
    "unguentum" => [2, "a", "A"],
    "unguis" => [2, "es", "ES"],
    "ungula" => [0, "e", "E"],
    "unkennelling" => [0, "", ""],
    "unless" => [0, "", ""],
    "unlevelling" => [0, "", ""],
    "unmilitary" => [0, "", ""],
    "unpanelling" => [0, "", ""],
    "unperson" => [4, "ople", "OPLE"],
    "unravelling" => [0, "", ""],
    "unreligious" => [0, "", ""],
    "untackling" => [0, "", ""],
    "unwon" => [0, "", ""],
    "unyoung" => [0, "", ""],
    "upgo" => [0, "es", "ES"],
    "upgush" => [0, "es", "ES"],
    "uraris" => [2, "es", "ES"],
    "uredinium" => [2, "a", "A"],
    "uredium" => [2, "a", "A"],
    "uresis" => [2, "es", "ES"],
    "urethra" => [0, "e", "E"],
    "urinalysis" => [2, "es", "ES"],
    "urman" => [0, "s", "S"],
    "urolithiasis" => [2, "es", "ES"],
    "ursa" => [0, "e", "E"],
    "useless" => [0, "", ""],
    "uterus" => [2, "i", "I"],
    "utriculus" => [2, "i", "I"],
    "utterless" => [0, "", ""],
    "vacationless" => [0, "", ""],
    "vagina" => [0, "e", "E"],
    "vaginitis" => [1, "des", "DES"],
    "vaginula" => [0, "e", "E"],
    "vagus" => [2, "i", "I"],
    "vallecula" => [0, "e", "E"],
    "valley" => [0, "s", "S"],
    "valueless" => [0, "", ""],
    "valveless" => [0, "", ""],
    "valvula" => [0, "e", "E"],
    "vaneless" => [0, "", ""],
    "vanish" => [0, "es", "ES"],
    "vantageless" => [0, "", ""],
    "varicosis" => [2, "es", "ES"],
    "varix" => [1, "ces", "CES"],
    "varnish" => [0, "es", "ES"],
    "vasculitis" => [1, "des", "DES"],
    "veejay" => [0, "s", "S"],
    "veg" => [0, "es", "ES"],
    "veilless" => [0, "", ""],
    "veinless" => [0, "", ""],
    "velum" => [2, "a", "A"],
    "vena" => [0, "e", "E"],
    "veney" => [0, "s", "S"],
    "ventless" => [0, "", ""],
    "ventriculus" => [2, "i", "I"],
    "venturis" => [2, "es", "ES"],
    "verballing" => [0, "", ""],
    "verbless" => [0, "", ""],
    "verdureless" => [0, "", ""],
    "vermicelli" => [0, "", ""],
    "vermin" => [0, "", ""],
    "verruca" => [0, "e", "E"],
    "vertebra" => [0, "e", "E"],
    "vertigo" => [0, "es", "ES"],
    "vesica" => [0, "e", "E"],
    "vesicula" => [0, "e", "E"],
    "vestigium" => [2, "a", "A"],
    "vestless" => [0, "", ""],
    "vetch" => [0, "es", "ES"],
    "vetchling" => [0, "", ""],
    "veto" => [0, "es", "ES"],
    "vetturino" => [1, "i", "I"],
    "vexillum" => [2, "a", "A"],
    "vialing" => [0, "", ""],
    "vialling" => [0, "", ""],
    "vibex" => [2, "ices", "ICES"],
    "vibracularium" => [2, "a", "A"],
    "vibraculum" => [2, "a", "A"],
    "vibrationless" => [0, "", ""],
    "vibratoless" => [0, "", ""],
    "vibriosis" => [2, "es", "ES"],
    "vibrissa" => [0, "e", "E"],
    "viceless" => [0, "", ""],
    "viceroy" => [0, "s", "S"],
    "vicomtes" => [0, "ses", "SES"],
    "victimless" => [0, "", ""],
    "victoryless" => [0, "", ""],
    "victualless" => [0, "", ""],
    "victualling" => [0, "", ""],
    "videndum" => [2, "a", "A"],
    "viewless" => [0, "", ""],
    "vigorish" => [0, "es", "ES"],
    "villus" => [2, "i", "I"],
    "vinas" => [0, "ses", "SES"],
    "virago" => [0, "es", "ES"],
    "virelay" => [0, "s", "S"],
    "virginium" => [2, "a", "A"],
    "virosis" => [2, "es", "ES"],
    "virtueless" => [0, "", ""],
    "viscus" => [2, "era", "ERA"],
    "visionless" => [0, "", ""],
    "visorless" => [0, "", ""],
    "vistaless" => [0, "", ""],
    "vita" => [0, "e", "E"],
    "vitellogenesis" => [2, "es", "ES"],
    "vitriolling" => [0, "", ""],
    "vitta" => [0, "e", "E"],
    "voiceless" => [0, "", ""],
    "volcano" => [0, "es", "ES"],
    "volitionless" => [0, "", ""],
    "volkslied" => [0, "er", "ER"],
    "volley" => [0, "s", "S"],
    "vorago" => [0, "es", "ES"],
    "voteless" => [0, "", ""],
    "vouch" => [0, "es", "ES"],
    "vowelless" => [0, "", ""],
    "vowelling" => [0, "", ""],
    "vowless" => [0, "", ""],
    "vox" => [1, "ces", "CES"],
    "vulsella" => [0, "e", "E"],
    "vulsellum" => [2, "a", "A"],
    "vulva" => [0, "e", "E"],
    "vulvovaginitis" => [1, "des", "DES"],
    "wadis" => [2, "es", "ES"],
    "waffling" => [0, "", ""],
    "wageless" => [0, "", ""],
    "waistless" => [0, "", ""],
    "waitperson" => [4, "ople", "OPLE"],
    "wakeless" => [0, "", ""],
    "waldo" => [0, "es", "ES"],
    "walis" => [2, "es", "ES"],
    "walkaway" => [0, "s", "S"],
    "walkway" => [0, "s", "S"],
    "walleye" => [0, "", ""],
    "wallless" => [0, "", ""],
    "wangling" => [0, "", ""],
    "wantless" => [0, "", ""],
    "wardless" => [0, "", ""],
    "wareless" => [0, "", ""],
    "warless" => [0, "", ""],
    "warling" => [0, "", ""],
    "warrantless" => [0, "", ""],
    "warsling" => [0, "", ""],
    "warstling" => [0, "", ""],
    "wartless" => [0, "", ""],
    "warwolf" => [1, "ves", "VES"],
    "wash" => [0, "es", "ES"],
    "washday" => [0, "s", "S"],
    "wasteland" => [0, "", ""],
    "wasteway" => [0, "s", "S"],
    "watch" => [0, "es", "ES"],
    "watercannon" => [0, "", ""],
    "watercraft" => [0, "", ""],
    "waterfowl" => [0, "", ""],
    "waterless" => [0, "", ""],
    "waterthrush" => [0, "es", "ES"],
    "waterway" => [0, "s", "S"],
    "wattless" => [0, "", ""],
    "wattling" => [0, "", ""],
    "waveless" => [0, "", ""],
    "wavey" => [0, "s", "S"],
    "wawling" => [0, "", ""],
    "way" => [0, "s", "S"],
    "wayless" => [0, "", ""],
    "weakfish" => [0, "", ""],
    "weakling" => [0, "", ""],
    "weanling" => [0, "", ""],
    "weaponless" => [0, "", ""],
    "weaselling" => [0, "", ""],
    "webfoot" => [3, "eet", "EET"],
    "webless" => [0, "", ""],
    "weedless" => [0, "", ""],
    "weekday" => [0, "s", "S"],
    "weetless" => [0, "", ""],
    "weightless" => [0, "", ""],
    "weldless" => [0, "", ""],
    "welladay" => [0, "s", "S"],
    "wellaway" => [0, "s", "S"],
    "wench" => [0, "es", "ES"],
    "wendigo" => [0, "es", "ES"],
    "werewolf" => [1, "ves", "VES"],
    "werwolf" => [1, "ves", "VES"],
    "wey" => [0, "s", "S"],
    "whacko" => [0, "es", "ES"],
    "whaling" => [0, "", ""],
    "wharf" => [1, "ves", "VES"],
    "wheatsheaf" => [1, "ves", "VES"],
    "wheeling" => [0, "", ""],
    "wheelless" => [0, "", ""],
    "wheepling" => [0, "", ""],
    "whereabouts" => [0, "", ""],
    "whey" => [0, "s", "S"],
    "whiffling" => [0, "", ""],
    "whimsey" => [0, "s", "S"],
    "whiplash" => [0, "es", "ES"],
    "whipray" => [0, "s", "S"],
    "whipstitch" => [0, "es", "ES"],
    "whirling" => [0, "", ""],
    "whiskerless" => [0, "", ""],
    "whiskey" => [0, "s", "S"],
    "whistlefish" => [0, "", ""],
    "whistling" => [0, "", ""],
    "whitefish" => [0, "", ""],
    "whitewash" => [0, "es", "ES"],
    "whitling" => [0, "", ""],
    "whiz" => [0, "zes", "ZES"],
    "whoosh" => [0, "es", "ES"],
    "why" => [0, "s", "S"],
    "wich" => [0, "es", "ES"],
    "wickless" => [0, "", ""],
    "widthway" => [0, "s", "S"],
    "wife" => [2, "ves", "VES"],
    "wifeless" => [0, "", ""],
    "wigless" => [0, "", ""],
    "wildfowl" => [0, "", ""],
    "wildling" => [0, "", ""],
    "wimpling" => [0, "", ""],
    "wincey" => [0, "s", "S"],
    "winch" => [0, "es", "ES"],
    "windigo" => [0, "es", "ES"],
    "windless" => [0, "", ""],
    "windling" => [0, "", ""],
    "windowless" => [0, "", ""],
    "windshake" => [0, "", ""],
    "windway" => [0, "s", "S"],
    "wineless" => [0, "", ""],
    "wingless" => [0, "", ""],
    "winkling" => [0, "", ""],
    "winless" => [0, "", ""],
    "wireway" => [0, "s", "S"],
    "wiseguy" => [0, "s", "S"],
    "wiseling" => [0, "", ""],
    "wish" => [0, "es", "ES"],
    "wishless" => [0, "", ""],
    "wishtonwish" => [0, "es", "ES"],
    "witch" => [0, "es", "ES"],
    "witeless" => [0, "", ""],
    "witless" => [0, "", ""],
    "witling" => [0, "", ""],
    "witney" => [0, "s", "S"],
    "wiz" => [0, "zes", "ZES"],
    "wolf" => [1, "ves", "VES"],
    "wolffish" => [0, "", ""],
    "wolfling" => [0, "", ""],
    "womanless" => [0, "", ""],
    "won" => [0, "", ""],
    "wontless" => [0, "", ""],
    "woodgrouse" => [0, "", ""],
    "woodless" => [0, "", ""],
    "woodmouse" => [4, "ice", "ICE"],
    "woodrush" => [0, "es", "ES"],
    "woodthrush" => [0, "es", "ES"],
    "woolsey" => [0, "s", "S"],
    "wordless" => [0, "", ""],
    "wordplay" => [0, "s", "S"],
    "workbench" => [0, "es", "ES"],
    "workday" => [0, "s", "S"],
    "workless" => [0, "", ""],
    "worldling" => [0, "", ""],
    "wormfish" => [0, "", ""],
    "worshipless" => [0, "", ""],
    "worthless" => [0, "", ""],
    "woundless" => [0, "", ""],
    "wrangling" => [0, "", ""],
    "wreakless" => [0, "", ""],
    "wreathless" => [0, "", ""],
    "wreckfish" => [0, "", ""],
    "wrench" => [0, "es", "ES"],
    "wrestling" => [0, "", ""],
    "wretch" => [0, "es", "ES"],
    "wrinkleless" => [0, "", ""],
    "wristwatch" => [0, "es", "ES"],
    "wus" => [0, "ses", "SES"],
    "wych" => [0, "es", "ES"],
    "xanthomatosis" => [2, "es", "ES"],
    "xenium" => [2, "a", "A"],
    "xenodiagnosis" => [2, "es", "ES"],
    "xenogenesis" => [2, "es", "ES"],
    "xerosis" => [2, "es", "ES"],
    "xoanon" => [2, "a", "A"],
    "yarraman" => [0, "s", "S"],
    "yawling" => [0, "", ""],
    "yay" => [0, "s", "S"],
    "yealing" => [0, "", ""],
    "yeanling" => [0, "", ""],
    "yearling" => [0, "", ""],
    "yersinia" => [0, "e", "E"],
    "yersiniosis" => [2, "es", "ES"],
    "yesterday" => [0, "s", "S"],
    "yobbo" => [0, "es", "ES"],
    "yodeling" => [0, "", ""],
    "yodelling" => [0, "", ""],
    "yodling" => [0, "", ""],
    "yokeless" => [0, "", ""],
    "yon" => [2, "a", "A"],
    "young" => [0, "", ""],
    "youngling" => [0, "", ""],
    "yourself" => [1, "ves", "VES"],
    "yowley" => [0, "s", "S"],
    "yowling" => [0, "", ""],
    "yuan" => [0, "", ""],
    "yum" => [2, "a", "A"],
    "zealless" => [0, "", ""],
    "zebras" => [0, "ses", "SES"],
    "zelatrix" => [1, "ces", "CES"],
    "zestless" => [0, "", ""],
    "zilch" => [0, "es", "ES"],
    "zipless" => [0, "", ""],
    "zircoloy" => [0, "s", "S"],
    "zizzling" => [0, "", ""],
    "zoecium" => [2, "a", "A"],
    "zona" => [0, "e", "E"],
    "zoneless" => [0, "", ""],
    "zoocytium" => [2, "a", "A"],
    "zooecium" => [2, "a", "A"],
    "zoogonidium" => [2, "a", "A"],
    "zoonosis" => [2, "es", "ES"],
    "zoothecium" => [2, "a", "A"],
    "zooxanthella" => [0, "e", "E"],
    "zygapophysis" => [2, "es", "ES"],
    "zygobranch" => [0, "es", "ES"],
    "zygogenesis" => [2, "es", "ES"],
    "zygosis" => [2, "es", "ES"],
    "zymogenesis" => [2, "es", "ES"],
    "zymolysis" => [2, "es", "ES"],
    "zymosis" => [2, "es", "ES"],
  }
end
